#include <r5f10pgj.h>
#include <unilib.h>

#define LED_RED PORT_8,4
#define LED_GREEN PORT_8,2

#define SWITCH PORT_1,2

#define PAUSE_TIME 200000		//blink
#define MAXTIME 30000			//float blink
#define PCYCLES 8

#define CLOCK_SETTING CLOCK_I_16
#define KHZ 16000

#define DEFAULT_UART UART0
#define DEFAULT_UART_INIT uart0_enable
#define DEFAULT_UART_OUTPUT OUTPUT_UART0
#define BAUD_DIVIDER 1667		//9K6
#define DEFAULT_UART_SEND uart0_send
#define DEFAULT_UART_RECEIVE recv_uart0

#define ADC_MASK 0x01		//1 channel
#define DEFAULT_ADC_CHANNEL 0

#define DEFAULT_SPI_INIT spi0_enable_master(5,0,PORT_3,0);
#define DEFAULT_SPI_OUTPUT OUTPUT_SPI0
#define DEFAULT_SPI_COMM spi0_comm
#define DEFAULT_SPI_PORT SPI0_SS_PORT
#define DEFAULT_SPI_CSEL SPI0_SS_PIN

#define DEFAULT_PWM_INIT pwm0_enable
#define DEFAULT_PWM_SET pwm0_set

#define STEPPER_PORT PORT_8
#define STEPPER_PIN1 4
#define STEPPER_PIN2 5
#define STEPPER_PIN3 6
#define STEPPER_PIN4 7

#define CC2500_RX_PAUSE 100
#define MLX90363_SPI_INIT spi0_enable_master(5,1,PORT_3,0);
#define MLX90363_CSPORT PORT_3
#define MLX90363_CSPIN 0

#define F25x16_SPI_INIT spi0_enable_master(3,0,PORT_3,0);
#define F25x16_CSPORT PORT_3
#define F25x16_CSPIN 0

#define F25x128_SPI_INIT spi0_enable_master(3,0,PORT_3,0);
#define F25x128_CSPORT PORT_3
#define F25x128_CSPIN 0

#define DATAFLASH_SPI_INIT spi0_enable_master(3,0,PORT_3,0);
#define DATAFLASH_CSPORT PORT_3
#define DATAFLASH_CSPIN 0

#define SDCARD_SPI_INIT_FAST spi0_enable_master(3,0,PORT_3,0);
#define SDCARD_SPI_INIT_SLOW spi0_enable_master(6,0,PORT_3,0);
#define SDCARD_CSPORT PORT_3
#define SDCARD_CSPIN 0

#define DEFAULT_GLCD128A PORT_0,PORT_1,0,1,2,3
#define DEFAULT_GLCD128B PORT_0,PORT_1,0,1,2,3,4
#define DEFAULT_GLCD128C PORT_0,PORT_1,0,1,2,3

#define DEFAULT_TLCD161 PORT_0,PORT_1,0,1
#define DEFAULT_TLCD202 PORT_0,PORT_1,0,1

#define DEFAULT_GLCD128CA PORT_0,PORT_1,0,1,2,3,4

#define EXTINT0_PIN 0	//unused
#define EXTINT1_PIN 0	//unused

#define DEFAULT_CAN_INIT can0_enable(CANCLOCK_16_500k);
#define DEFAULT_CAN_SEND can0_send
#define DEFAULT_CAN_GET can0_get
#define DEFAULT_CAN_RXCHECK can0_check_rx
#define DEFAULT_CAN_RXFILTER can0_rxfilter
#define DEFAULT_CAN_INT_ENABLE can0_enable_rxint()


