
#define PI 3.1415926536

#define size_t unsigned int

#define TAB_TYPE const __attribute__ ((section(".libs")))
#define FDATA_TYPE const
#define PORT_SIZE 8

#define FKT1_TYPE
#define FKT2_TYPE
#define FKT3_TYPE
#define FKT4_TYPE

//nop

typedef struct
{
	int quot;
	int rem;
} div_t;

typedef struct
{
	long quot;
	long rem;
} ldiv_t;

//pri


#define CLOCK_I_32	0x2030
#define CLOCK_I_16	0x1031
#define CLOCK_I_8	0x0832
#define CLOCK_I_4	0x0433
#define CLOCK_I_2	0x0234
#define CLOCK_I_1	0x0135

#define CLOCK_8_32	0x2090
#define CLOCK_8_16	0x1091
#define CLOCK_8_8	0x0808
#define CLOCK_8_4	0x0493
#define CLOCK_8_2	0x0294
#define CLOCK_8_1	0x0195

#define CLOCK_8_24	0x1880
#define CLOCK_8_12	0x0c81
#define CLOCK_8_6	0x0682
#define CLOCK_8_3	0x0383

#define CLOCK_4_32	0x2050
#define CLOCK_4_16	0x1051
#define CLOCK_4_8	0x0852
#define CLOCK_4_4	0x0408
#define CLOCK_4_2	0x0254
#define CLOCK_4_1	0x0155

#define CLOCK_4_24	0x1840
#define CLOCK_4_12	0x0c41
#define CLOCK_4_6	0x0642
#define CLOCK_4_3	0x0343

#define CLOCK_16_16	0x1008

#define CLOCK_L		0x40

#ifdef UART0
#define OUTPUT_UART0 uart0_send
#endif

#ifdef UART1
#define OUTPUT_UART1 uart1_send
#endif

#ifndef OUTPUT_UART0
#define OUTPUT_UART0 OUTPUT_NONE
#endif

#ifdef SPI0
#define OUTPUT_SPI0 spi0_comm
#endif

#ifdef SPI1
#define OUTPUT_SPI1 spi1_comm
#endif

void unilib_outchar(unsigned char);
#define putc unilib_outchar

#define ISR __attribute__((interrupt))

#define BGR565_BLACK	0x0000
#define BGR565_BLUE	0xf800
#define BGR565_RED	0x001f
#define BGR565_MAGENTA	0xf81f
#define BGR565_GREEN	0x07e0
#define BGR565_CYAN	0xffe0
#define BGR565_YELLOW	0x07ff
#define BGR565_WHITE	0xffff

#ifndef _UNILIB_CAN_FRAME
#define _UNILIB_CAN_FRAME
typedef struct _unilib_can_frame{
	unsigned long id;
	unsigned char mode;
	unsigned char len;
	unsigned char data[8];
	unsigned long timestamp;
}unilib_can_frame;
#endif

#ifndef _UNILIB_DATETIME
#define _UNILIB_DATETIME
typedef struct _unilib_date_time{
	unsigned short year;
	unsigned char month;
	unsigned char day;
	unsigned char hour;
	unsigned char min;
	unsigned char sec;
}unilib_date_time;
#endif

//#######################################################################
//#									#
//#	init crc16							#
//#									#
//#######################################################################
void FKT2_TYPE crc16_init(unsigned short startvalue,unsigned short polynom, unsigned char input_reflect, unsigned char output_reflect, unsigned short xor);

//#######################################################################
//#									#
//#	update crc16 with byte						#
//#									#
//#######################################################################
void FKT2_TYPE crc16_update(unsigned char val);

//#######################################################################
//#									#
//#	update crc16 with byte array					#
//#									#
//#######################################################################
void FKT2_TYPE crc16_block(unsigned char *buffer, unsigned short len);

//#######################################################################
//#									#
//#	get crc16 value							#
//#									#
//#######################################################################
unsigned short FKT2_TYPE crc16_get(void);

//#######################################################################
//#									#
//#	init crc32							#
//#									#
//#######################################################################
void FKT2_TYPE crc32_init(unsigned long startvalue,unsigned long polynom, unsigned char input_reflect, unsigned char output_reflect, unsigned long xor);

//#######################################################################
//#									#
//#	update crc32 with byte						#
//#									#
//#######################################################################
void FKT2_TYPE crc32_update(unsigned char val);

//#######################################################################
//#									#
//#	update crc32 with byte array					#
//#									#
//#######################################################################
void FKT2_TYPE crc32_block(unsigned char *buffer, unsigned short len);

//#######################################################################
//#									#
//#	get crc32 value							#
//#									#
//#######################################################################
unsigned long FKT2_TYPE crc32_get(void);

//#######################################################################
//#									#
//#	init crc8							#
//#									#
//#######################################################################
void FKT2_TYPE crc8_init(unsigned char startvalue,unsigned char polynom, unsigned char input_reflect, unsigned char output_reflect, unsigned char xor);

//#######################################################################
//#									#
//#	update crc8 with byte						#
//#									#
//#######################################################################
void FKT2_TYPE crc8_update(unsigned char val);

//#######################################################################
//#									#
//#	update crc8 with byte array					#
//#									#
//#######################################################################
void FKT2_TYPE crc8_block(unsigned char *buffer, unsigned short len);

//#######################################################################
//#									#
//#	get crc8 value							#
//#									#
//#######################################################################
unsigned char FKT2_TYPE crc8_get(void);

//#######################################################################
//#                                                                     #
//# fft integer routine for 1024 samples window size                    #
//#                                                                     #
//# window_type:   0 = uniform                                          #
//#                1 = Hann                                             #
//#                2 = Hamming                                          #
//#                                                                     #
//# output_mode:   0 = magnitude                                        #
//#                1 = power                                            #
//#                2 = re/im                                            #
//#                                                                     #
//#######################################################################
void FKT2_TYPE fft1024(short *data, int window_type, int output_mode);

extern long fft1024_values_re[1024];

extern long fft1024_values_im[1024];

//#######################################################################
//#                                                                     #
//# fft integer routine for 1024 samples window size                    #
//#                                                                     #
//# window_type:   0 = uniform                                          #
//#                1 = Hann                                             #
//#                2 = Hamming                                          #
//#                                                                     #
//# output_mode:   0 = magnitude                                        #
//#                1 = power                                            #
//#                2 = re/im                                            #
//#                                                                     #
//#######################################################################
void FKT2_TYPE fft1024_gvar(short *data, int window_type, int output_mode);

//#######################################################################
//#                                                                     #
//# fft integer routine for 1024 samples window size                    #
//#                                                                     #
//# window_type:   0 = uniform                                          #
//#                1 = Hann                                             #
//#                2 = Hamming                                          #
//#                                                                     #
//# output_mode:   0 = magnitude                                        #
//#                1 = power                                            #
//#                2 = re/im                                            #
//#                                                                     #
//#######################################################################
void FKT2_TYPE fft1024f(short *data, int window_type, int output_mode);

extern float fft1024f_values_re[1024];

extern float fft1024f_values_im[1024];

//#######################################################################
//#                                                                     #
//# fft integer routine for 1024 samples window size                    #
//#                                                                     #
//# window_type:   0 = uniform                                          #
//#                1 = Hann                                             #
//#                2 = Hamming                                          #
//#                                                                     #
//# output_mode:   0 = magnitude                                        #
//#                1 = power                                            #
//#                2 = re/im                                            #
//#                                                                     #
//#######################################################################
void FKT2_TYPE fft1024f_gvar(short *data, int window_type, int output_mode);

//#######################################################################
//#                                                                     #
//# fft integer routine for 1024 samples window size                    #
//#                                                                     #
//# window_type:   0 = uniform                                          #
//#                1 = Hann                                             #
//#                2 = Hamming                                          #
//#                                                                     #
//# output_mode:   0 = magnitude                                        #
//#                1 = power                                            #
//#                2 = re/im                                            #
//#                                                                     #
//#######################################################################
void FKT2_TYPE fft1024s(short *data, int window_type, int output_mode);

//#######################################################################
//#                                                                     #
//# fft integer routine for 1024 samples window size                    #
//#                                                                     #
//# window_type:   0 = uniform                                          #
//#                1 = Hann                                             #
//#                2 = Hamming                                          #
//#                                                                     #
//# output_mode:   0 = magnitude                                        #
//#                1 = power                                            #
//#                2 = re/im                                            #
//#                                                                     #
//#######################################################################
void FKT2_TYPE fft1024s_gvar(short *data, int window_type, int output_mode);

//#######################################################################
//#                                                                     #
//# fft integer routine for   16 samples window size                    #
//#                                                                     #
//# window_type:   0 = uniform                                          #
//#                1 = Hann                                             #
//#                2 = Hamming                                          #
//#                                                                     #
//# output_mode:   0 = magnitude                                        #
//#                1 = power                                            #
//#                2 = re/im                                            #
//#                                                                     #
//#######################################################################
void FKT2_TYPE fft16(short *data, int window_type, int output_mode);

extern long fft16_values_re[16];

extern long fft16_values_im[16];

//#######################################################################
//#                                                                     #
//# fft integer routine for   16 samples window size                    #
//#                                                                     #
//# window_type:   0 = uniform                                          #
//#                1 = Hann                                             #
//#                2 = Hamming                                          #
//#                                                                     #
//# output_mode:   0 = magnitude                                        #
//#                1 = power                                            #
//#                2 = re/im                                            #
//#                                                                     #
//#######################################################################
void FKT2_TYPE fft16_gvar(short *data, int window_type, int output_mode);

//#######################################################################
//#                                                                     #
//# fft integer routine for   16 samples window size                    #
//#                                                                     #
//# window_type:   0 = uniform                                          #
//#                1 = Hann                                             #
//#                2 = Hamming                                          #
//#                                                                     #
//# output_mode:   0 = magnitude                                        #
//#                1 = power                                            #
//#                2 = re/im                                            #
//#                                                                     #
//#######################################################################
void FKT2_TYPE fft16f(short *data, int window_type, int output_mode);

extern float fft16f_values_re[16];

extern float fft16f_values_im[16];

//#######################################################################
//#                                                                     #
//# fft integer routine for   16 samples window size                    #
//#                                                                     #
//# window_type:   0 = uniform                                          #
//#                1 = Hann                                             #
//#                2 = Hamming                                          #
//#                                                                     #
//# output_mode:   0 = magnitude                                        #
//#                1 = power                                            #
//#                2 = re/im                                            #
//#                                                                     #
//#######################################################################
void FKT2_TYPE fft16f_gvar(short *data, int window_type, int output_mode);

//#######################################################################
//#                                                                     #
//# fft integer routine for   16 samples window size                    #
//#                                                                     #
//# window_type:   0 = uniform                                          #
//#                1 = Hann                                             #
//#                2 = Hamming                                          #
//#                                                                     #
//# output_mode:   0 = magnitude                                        #
//#                1 = power                                            #
//#                2 = re/im                                            #
//#                                                                     #
//#######################################################################
void FKT2_TYPE fft16s(short *data, int window_type, int output_mode);

//#######################################################################
//#                                                                     #
//# fft integer routine for   16 samples window size                    #
//#                                                                     #
//# window_type:   0 = uniform                                          #
//#                1 = Hann                                             #
//#                2 = Hamming                                          #
//#                                                                     #
//# output_mode:   0 = magnitude                                        #
//#                1 = power                                            #
//#                2 = re/im                                            #
//#                                                                     #
//#######################################################################
void FKT2_TYPE fft16s_gvar(short *data, int window_type, int output_mode);

//#######################################################################
//#                                                                     #
//# fft integer routine for  256 samples window size                    #
//#                                                                     #
//# window_type:   0 = uniform                                          #
//#                1 = Hann                                             #
//#                2 = Hamming                                          #
//#                                                                     #
//# output_mode:   0 = magnitude                                        #
//#                1 = power                                            #
//#                2 = re/im                                            #
//#                                                                     #
//#######################################################################
void FKT2_TYPE fft256(short *data, int window_type, int output_mode);

extern long fft256_values_re[256];

extern long fft256_values_im[256];

//#######################################################################
//#                                                                     #
//# fft integer routine for  256 samples window size                    #
//#                                                                     #
//# window_type:   0 = uniform                                          #
//#                1 = Hann                                             #
//#                2 = Hamming                                          #
//#                                                                     #
//# output_mode:   0 = magnitude                                        #
//#                1 = power                                            #
//#                2 = re/im                                            #
//#                                                                     #
//#######################################################################
void FKT2_TYPE fft256_gvar(short *data, int window_type, int output_mode);

//#######################################################################
//#                                                                     #
//# fft integer routine for  256 samples window size                    #
//#                                                                     #
//# window_type:   0 = uniform                                          #
//#                1 = Hann                                             #
//#                2 = Hamming                                          #
//#                                                                     #
//# output_mode:   0 = magnitude                                        #
//#                1 = power                                            #
//#                2 = re/im                                            #
//#                                                                     #
//#######################################################################
void FKT2_TYPE fft256f(short *data, int window_type, int output_mode);

extern float fft256f_values_re[256];

extern float fft256f_values_im[256];

//#######################################################################
//#                                                                     #
//# fft integer routine for  256 samples window size                    #
//#                                                                     #
//# window_type:   0 = uniform                                          #
//#                1 = Hann                                             #
//#                2 = Hamming                                          #
//#                                                                     #
//# output_mode:   0 = magnitude                                        #
//#                1 = power                                            #
//#                2 = re/im                                            #
//#                                                                     #
//#######################################################################
void FKT2_TYPE fft256f_gvar(short *data, int window_type, int output_mode);

//#######################################################################
//#                                                                     #
//# fft integer routine for  256 samples window size                    #
//#                                                                     #
//# window_type:   0 = uniform                                          #
//#                1 = Hann                                             #
//#                2 = Hamming                                          #
//#                                                                     #
//# output_mode:   0 = magnitude                                        #
//#                1 = power                                            #
//#                2 = re/im                                            #
//#                                                                     #
//#######################################################################
void FKT2_TYPE fft256s(short *data, int window_type, int output_mode);

//#######################################################################
//#                                                                     #
//# fft integer routine for  256 samples window size                    #
//#                                                                     #
//# window_type:   0 = uniform                                          #
//#                1 = Hann                                             #
//#                2 = Hamming                                          #
//#                                                                     #
//# output_mode:   0 = magnitude                                        #
//#                1 = power                                            #
//#                2 = re/im                                            #
//#                                                                     #
//#######################################################################
void FKT2_TYPE fft256s_gvar(short *data, int window_type, int output_mode);

//#######################################################################
//#                                                                     #
//# fft integer routine for   64 samples window size                    #
//#                                                                     #
//# window_type:   0 = uniform                                          #
//#                1 = Hann                                             #
//#                2 = Hamming                                          #
//#                                                                     #
//# output_mode:   0 = magnitude                                        #
//#                1 = power                                            #
//#                2 = re/im                                            #
//#                                                                     #
//#######################################################################
void FKT2_TYPE fft64(short *data, int window_type, int output_mode);

extern long fft64_values_re[64];

extern long fft64_values_im[64];

//#######################################################################
//#                                                                     #
//# fft integer routine for   64 samples window size                    #
//#                                                                     #
//# window_type:   0 = uniform                                          #
//#                1 = Hann                                             #
//#                2 = Hamming                                          #
//#                                                                     #
//# output_mode:   0 = magnitude                                        #
//#                1 = power                                            #
//#                2 = re/im                                            #
//#                                                                     #
//#######################################################################
void FKT2_TYPE fft64_gvar(short *data, int window_type, int output_mode);

//#######################################################################
//#                                                                     #
//# fft integer routine for   64 samples window size                    #
//#                                                                     #
//# window_type:   0 = uniform                                          #
//#                1 = Hann                                             #
//#                2 = Hamming                                          #
//#                                                                     #
//# output_mode:   0 = magnitude                                        #
//#                1 = power                                            #
//#                2 = re/im                                            #
//#                                                                     #
//#######################################################################
void FKT2_TYPE fft64f(short *data, int window_type, int output_mode);

extern float fft64f_values_re[64];

extern float fft64f_values_im[64];

//#######################################################################
//#                                                                     #
//# fft integer routine for   64 samples window size                    #
//#                                                                     #
//# window_type:   0 = uniform                                          #
//#                1 = Hann                                             #
//#                2 = Hamming                                          #
//#                                                                     #
//# output_mode:   0 = magnitude                                        #
//#                1 = power                                            #
//#                2 = re/im                                            #
//#                                                                     #
//#######################################################################
void FKT2_TYPE fft64f_gvar(short *data, int window_type, int output_mode);

//#######################################################################
//#                                                                     #
//# fft integer routine for   64 samples window size                    #
//#                                                                     #
//# window_type:   0 = uniform                                          #
//#                1 = Hann                                             #
//#                2 = Hamming                                          #
//#                                                                     #
//# output_mode:   0 = magnitude                                        #
//#                1 = power                                            #
//#                2 = re/im                                            #
//#                                                                     #
//#######################################################################
void FKT2_TYPE fft64s(short *data, int window_type, int output_mode);

//#######################################################################
//#                                                                     #
//# fft integer routine for   64 samples window size                    #
//#                                                                     #
//# window_type:   0 = uniform                                          #
//#                1 = Hann                                             #
//#                2 = Hamming                                          #
//#                                                                     #
//# output_mode:   0 = magnitude                                        #
//#                1 = power                                            #
//#                2 = re/im                                            #
//#                                                                     #
//#######################################################################
void FKT2_TYPE fft64s_gvar(short *data, int window_type, int output_mode);

//#######################################################################
//#									#
//#	fast sine amp * sin(angle)					#
//#	1024 = 360deg							#
//#									#
//#######################################################################
long FKT2_TYPE fast_sine(long amp, long angle);

//#######################################################################
//#									#
//#	fast sine amp * cos(angle)					#
//#	1024 = 360deg							#
//#									#
//#######################################################################
long FKT2_TYPE fast_cosine(long amp, long angle);

//#######################################################################
//#									#
//#	hamming encode							#
//#									#
//#######################################################################
unsigned int hamm4_encode (unsigned char value);

//#######################################################################
//#									#
//#	hamming decode	(results error count in upper byte)		#
//#									#
//#######################################################################
unsigned int hamm4_decode (unsigned int value);

//#######################################################################
//#                                                                     #
//# logfreq routine                                                     #
//#                                                                     #
//# input:      128 words power result from FFT256 (data)               #
//#                                                                     #
//# output:     1 Word type (0=silent, 1=voiceless, 2=voiced)           #
//#             1 Word Maximum                                          #
//#             4 Words spectral power                                  #
//#                                                                     #
//#######################################################################
void FKT2_TYPE logfreq128(short *data, short *result);

//#######################################################################
//#									#
//#	bit mirror of a 8 bit type					#
//#									#
//#######################################################################
unsigned char FKT2_TYPE bitmirror8(unsigned char val);

//#######################################################################
//#									#
//#	bit mirror of a 16 bit type					#
//#									#
//#######################################################################
unsigned short FKT2_TYPE bitmirror16(unsigned short val);

//#######################################################################
//#									#
//#	bit mirror of a 32 bit type					#
//#									#
//#######################################################################
unsigned long FKT2_TYPE bitmirror32(unsigned long val);

//#######################################################################
//#									#
//#	convert RGB to HSV (float mode)					#
//#									#
//#######################################################################
void FKT2_TYPE rgb_to_hsv_float(float *rgb, float *hsv);

//#######################################################################
//#									#
//#	convert HSV to RGB (float mode)					#
//#									#
//#######################################################################
void FKT2_TYPE hsv_to_rgb_float(float *hsv, float *rgb);

//#######################################################################
//#									#
//#	convert RGB to HSV (unsigned char mode)				#
//#									#
//#######################################################################
void FKT2_TYPE rgb_to_hsv_uchar(unsigned char *rgb, unsigned char *hsv);

//#######################################################################
//#									#
//#	convert HSV to RGB (unsigned char mode)				#
//#									#
//#######################################################################
void FKT2_TYPE hsv_to_rgb_uchar(unsigned char *hsv, unsigned char *rgb);

//#######################################################################
//#									#
//#	convert RGB to HSV (unsigned short mode)			#
//#									#
//#######################################################################
void FKT2_TYPE rgb_to_hsv_ushort(unsigned short *rgb, unsigned short *hsv);

//#######################################################################
//#									#
//#	convert HSV to RGB (unsigned short mode)			#
//#									#
//#######################################################################
void FKT2_TYPE hsv_to_rgb_ushort(unsigned short *hsv, unsigned short *rgb);

//#######################################################################
//#									#
//#	get ccurrent unilib version (0.47)				#
//#									#
//#######################################################################
int FKT2_TYPE unilib_get_version(void);

//############################################################################
//#                                                                          #
//# encrypt with AES128 (data is little endian)                              #
//#                                                                          #
//############################################################################
void FKT2_TYPE aes128_encrypt(unsigned char* data, unsigned char* key);

//############################################################################
//#                                                                          #
//# decrypt with AES128 (data is little endian)                              #
//#                                                                          #
//############################################################################
void FKT2_TYPE aes128_decrypt(unsigned char* data, unsigned char* key);

//############################################################################
//#                                                                          #
//# encrypt with AES256 (data is little endian)                              #
//#                                                                          #
//############################################################################
void FKT2_TYPE aes256_encrypt(unsigned char* data, unsigned char* key);

//############################################################################
//#                                                                          #
//# decrypt with AES256 (data is little endian)                              #
//#                                                                          #
//############################################################################
void FKT2_TYPE aes256_decrypt(unsigned char* data, unsigned char* key);

//##############################################################################
//#                                                                            #
//# init the hash                                                              #
//#                                                                            #
//##############################################################################
void FKT2_TYPE sha256_init(void);

//##############################################################################
//#                                                                            #
//# update the hash with data                                                  #
//#                                                                            #
//##############################################################################
void FKT2_TYPE sha256_update(unsigned char *data, unsigned long len);

//##############################################################################
//#                                                                            #
//# output the hash                                                            #
//#                                                                            #
//##############################################################################
void FKT2_TYPE sha256_final(unsigned char *hash);

//##############################################################################
//#                                                                            #
//# HMAC with SHA256                                                           #
//#                                                                            #
//##############################################################################
int FKT2_TYPE hmac256(unsigned char *key, unsigned long keylen, unsigned char *data, unsigned long datalen, unsigned char *hmac);

//#######################################################################
//#									#
//#	xtea encrypt							#
//#									#
//#######################################################################
void FKT2_TYPE xtea_encrypt (unsigned int num_cycles, unsigned char *data, unsigned char *key);

//#######################################################################
//#									#
//#	xtea decrypt							#
//#									#
//#######################################################################
void FKT2_TYPE xtea_decrypt (unsigned int num_cycles, unsigned char *data, unsigned char *key);

//#######################################################################
//# power down (signed mode = HIGH-Z)					#
//#######################################################################
void ad5062_pdown(void);

//#######################################################################
//# write data (signed mode)						#
//#######################################################################
void ad5062_signed(int value);

//#######################################################################
//# write data (unsigned mode)						#
//#######################################################################
void ad5062_unsigned(unsigned short value);

//#######################################################################
//# init the ad5062             					#
//#######################################################################
void ad5062_init(PORT_TYPE sync_port, unsigned char sync_pin);

//#######################################################################
//# power down (signed mode = HIGH-Z)					#
//#######################################################################
void ad53x2_signed_pdown(void);

//#######################################################################
//# write both channels (signed mode)					#
//#######################################################################
void ad53x2_signed_ab(int value_a,int value_b);

//#######################################################################
//# write channel a (signed mode)					#
//#######################################################################
void ad53x2_signed_a(int value);

//#######################################################################
//# write channel b (signed mode)					#
//#######################################################################
void ad53x2_signed_b(int value);

//#######################################################################
//# init the ad53x2 (signed mode)					#
//#######################################################################
void ad53x2_init_signed(PORT_TYPE sync_port, unsigned char sync_pin,PORT_TYPE ldac_port, unsigned char ldac_pin);

//#######################################################################
//# power down (unsigned mode)	PULL-DOWN 1K				#
//#######################################################################
void ad53x2_unsigned_pdown(void);

//#######################################################################
//# write both channels (unsigned mode)					#
//#######################################################################
void ad53x2_unsigned_ab(unsigned int value_a,unsigned int value_b);

//#######################################################################
//# write channel a (unsigned mode)					#
//#######################################################################
void ad53x2_unsigned_a(unsigned int value);

//#######################################################################
//# write channel b (unsigned mode)					#
//#######################################################################
void ad53x2_unsigned_b(unsigned int value);

//#######################################################################
//# init the ad53x2 (unsigned mode)					#
//#######################################################################
void ad53x2_init_unsigned(PORT_TYPE sync_port, unsigned char sync_pin,PORT_TYPE ldac_port, unsigned char ldac_pin);

extern volatile unsigned char unilib_debounce_state;

//#######################################################################
//#									#
//#	init debounce							#
//#									#
//#######################################################################
void debounce_enable(unsigned char s);

//#######################################################################
//#									#
//#	add a debounce pin						#
//#									#
//#######################################################################
unsigned char debounce_add(PORT_TYPE debounce_port,int debounce_pin);

//#######################################################################
//#									#
//#	get debounce pin value						#
//#									#
//#######################################################################
unsigned char debounce_get(unsigned char num);

//#######################################################################
//#									#
//#	this must be called periodicly (in interrupt)			#
//#									#
//#######################################################################
void serve_debounce(void);

extern volatile PORT_SIZE_TYPE unilib_debounce2_state;

//#######################################################################
//#									#
//#	init debounce2							#
//#									#
//#######################################################################
void debounce2_enable(PORT_TYPE port,unsigned char speed);

//#######################################################################
//#									#
//#	get debounce2 pin value						#
//#									#
//#######################################################################
//#######################################################################
//#									#
//#	this must be called periodicly (in interrupt)			#
//#									#
//#######################################################################
void serve_debounce2(void);

//#######################################################################
//#									#
//#	set encoder1 pins (2 consecutive pins at the same port)		#
//#	0 = OK								#
//#	1 = invalid state						#
//#									#
//#######################################################################
char encoder1_enable(PORT_TYPE port,unsigned char pin,int vmin, int vmax, int vstart);

//#######################################################################
//#									#
//#	get encoder1 value						#
//#									#
//#######################################################################
void encoder1_disable(void);

//#######################################################################
//#									#
//#	get encoder1 value						#
//#									#
//#######################################################################
int encoder1_get(void);

//#######################################################################
//#									#
//#	reset encoder1 value						#
//#									#
//#######################################################################
void encoder1_set(int val);

//#######################################################################
//#									#
//#	this must be called periodicly (in interrupt)			#
//#	only a single encoder will be served				#
//#									#
//#######################################################################
void serve_encoder1(void);

//#######################################################################
//#									#
//#	init encoder4							#
//#									#
//#######################################################################
void encoder4_init(void);

//#######################################################################
//#									#
//#	add a encoder4 pin (2 consecutive pins at the same port)	#
//#	0 = OK								#
//#	1 = invalid state						#
//#									#
//#######################################################################
char encoder4_enable(unsigned char num,PORT_TYPE port,unsigned char pin, int vmin, int vmax, int vstart);

//#######################################################################
//#									#
//#	remove a encoder4 channel					#
//#									#
//#######################################################################
void encoder4_disable(unsigned char num);

//#######################################################################
//#									#
//#	get encoder4 value						#
//#									#
//#######################################################################
int encoder4_get(unsigned char num);

//#######################################################################
//#									#
//#	reset encoder4 value						#
//#									#
//#######################################################################
void encoder4_set(unsigned char num,int value);

//#######################################################################
//#									#
//#	this must be called periodicly (in interrupt)			#
//#	all encoders will be served					#
//#									#
//#######################################################################
void serve_encoder4(void);

//#######################################################################
//#									#
//#	this must be called periodicly (in interrupt)			#
//#	only a single encoder will be served				#
//#									#
//#######################################################################
void serve_encoder4_single(unsigned char num);

//#######################################################################
//#									#
//#	float: break float into normalized fraction and power of 2	#
//#									#
//#######################################################################
float frexpf(float x, int *eptr);

//#######################################################################
//#									#
//# 	float: absolute value						#
//#									#
//#######################################################################
float fabsf(float x);

//#######################################################################
//#									#
//#	float: arcus cosinus						#
//#									#
//#######################################################################
float acosf(float x);

//#######################################################################
//#									#
//#	float: arcus cosinus						#
//#									#
//#######################################################################
float asinf(float x);

//#######################################################################
//#                                                    			#
//#	float: arcus tangens 						#
//#                                                    			#
//#######################################################################
float atanf(float x);

//#######################################################################
//#                                                    			#
//#	float: arcus tangens with 2 arguments				#
//#                                                    			#
//#######################################################################
float atan2f(float y, float x);

//#######################################################################
//#									#
//#	float: round towards +inf					#
//#									#
//#######################################################################
float ceilf(float x);

//#######################################################################
//#                                                    			#
//#	float: calculate cosinus (radians arg)				#
//#                                                    			#
//#######################################################################
float cosf(float x);

//#######################################################################
//#									#
//#	float: cosinus hyperbolicus					#
//#									#
//#######################################################################
float cosh(float x);

//#######################################################################
//#									#
//#	float: cotangens						#
//#									#
//#######################################################################
float cotf(float x);

//##################################################################
//#                                                                #
//#	float: e^x                                                 #
//#                                                                #
//##################################################################
float expf(float x);

//#######################################################################
//#									#
//#	float: round towards -inf					#
//#									#
//#######################################################################
float floorf(float x);

//##################################################################
//# 								   #
//#	float: ln(x)                                               #
//# 								   #
//##################################################################
float logf(float x);

//#######################################################################
//#									#
//#	float:	log10(x)						#
//#									#
//#######################################################################
float log10f(float x);

//#######################################################################
//#									#
//#	float:	x^y							#
//#									#
//#######################################################################
float powf(float x, float y);

//#######################################################################
//#                                                    			#
//#	float: calculate sinus (radians arg)				#
//#                                                    			#
//#######################################################################
float sinf(float x);

//#######################################################################
//#									#
//#	float: sinus hyperbolicus					#
//#									#
//#######################################################################
float sinh(float x);

//#######################################################################
//#									#
//#	float: square root						#
//#									#
//#######################################################################
float sqrtf(float x);

//#######################################################################
//#                                                    			#
//#	float: calculate tangens (radians arg)				#
//#                                                    			#
//#######################################################################
float tanf(float x);

//#######################################################################
//#									#
//#	float: tangens hyperbolicus					#
//#									#
//#######################################################################
float tanhf(float x);

//#######################################################################
//#									#
//#	set active window						#
//#									#
//#######################################################################
void glcd128ca_setwin(unsigned char x1,unsigned char y1,unsigned char x2,unsigned char y2);

//#######################################################################
//#									#
//#	fill window						#
//#									#
//#######################################################################
void glcd128ca_fillwin(unsigned char dx,unsigned char dy,unsigned int color);

//#######################################################################
//#									#
//#	set background color						#
//#									#
//#######################################################################
void glcd128ca_set_bgcolor(unsigned int color);

//#######################################################################
//#									#
//#	set foreground color						#
//#									#
//#######################################################################
void glcd128ca_set_fgcolor(unsigned int color);

//#######################################################################
//#									#
//#	set background color						#
//#									#
//#######################################################################
void glcd128ca_set_bgcolor_rgb(unsigned char red,unsigned char green, unsigned char blue);

//#######################################################################
//#									#
//#	set foreground color						#
//#									#
//#######################################################################
void glcd128ca_set_fgcolor_rgb(unsigned char red,unsigned char green, unsigned char blue);

//#######################################################################
//#									#
//#	clear screen							#
//#									#
//#######################################################################
void glcd128ca_clrscr(void);

//#######################################################################
//#									#
//#	enable display							#
//#									#
//#######################################################################
void enable_glcd128ca(PORT_TYPE dataport,PORT_TYPE ctrlport,unsigned char wrpin,unsigned char rdpin,unsigned char cdpin,unsigned char cspin,unsigned char rspin);

//#######################################################################
//#									#
//#	set display contrast						#
//#									#
//#######################################################################
void glcd128ca_set_contrast(unsigned char contrast);

//#######################################################################
//#									#
//#	set screen position						#
//#									#
//#######################################################################
void glcd128ca_gotoxy(unsigned char x,unsigned char y);

//#######################################################################
//#									#
//#	new line							#
//#									#
//#######################################################################
void glcd128ca_newline(void);

//#######################################################################
//#									#
//#	output char (opaque)						#
//#									#
//#######################################################################
void glcd128ca_char(unsigned char c);

//#######################################################################
//#									#
//#	output big char (opaque)					#
//#									#
//#######################################################################
void glcd128ca_bchar(unsigned char c);

//#######################################################################
//#									#
//#	get current x coordinate					#
//#									#
//#######################################################################
unsigned int glcd128ca_get_drawpos_x(void);

//#######################################################################
//#									#
//#	get current y coordinate					#
//#									#
//#######################################################################
unsigned int glcd128ca_get_drawpos_y(void);

//#######################################################################
//#									#
//#	get current x coordinate					#
//#									#
//#######################################################################
unsigned int glcd128ca_get_textpos_x(void);

//#######################################################################
//#									#
//#	get current y coordinate					#
//#									#
//#######################################################################
unsigned int glcd128ca_get_textpos_y(void);

//#######################################################################
//#									#
//#	draw pixel							#
//#									#
//#######################################################################
void glcd128ca_plot(unsigned int x,unsigned int y);

//#######################################################################
//#									#
//#	draw line							#
//#									#
//#######################################################################
void glcd128ca_draw(unsigned int x1,unsigned int y1,unsigned int x2,unsigned int y2);

//#######################################################################
//#									#
//#	draw line to							#
//#									#
//#######################################################################
void glcd128ca_drawto(unsigned int x2,unsigned int y2);

//#######################################################################
//#									#
//#	draw box							#
//#									#
//#######################################################################
void glcd128ca_box(unsigned int x1,unsigned int y1,unsigned int dx,unsigned int dy);

//#######################################################################
//#									#
//#	draw filled box							#
//#									#
//#######################################################################
void glcd128ca_fbox(unsigned char x1,unsigned char y1,unsigned char dx,unsigned char dy);

//#######################################################################
//#									#
//#	draw sprite							#
//#									#
//#######################################################################
void glcd128ca_draw_sprite(unsigned char x,unsigned char y,unsigned char dx,unsigned char dy,unsigned int *buffer);

//#######################################################################
//#									#
//#	draw 8x8 sprite with bg						#
//#									#
//#######################################################################
void glcd128ca_draw_sprite_bg(unsigned char x,unsigned char y,unsigned int transp,unsigned int *buffer,unsigned int *background);

//#######################################################################
//#									#
//#	undraw 8x8 sprite with bg					#
//#									#
//#######################################################################
void glcd128ca_undraw_sprite_bg(unsigned char x,unsigned char y,unsigned int *background);

//#######################################################################
//#									#
//#	undraw 8x8 sprite with bg					#
//#									#
//#######################################################################
void glcd128ca_set_bg(unsigned char x,unsigned char y,unsigned char dx,unsigned char dy,unsigned int *background);

extern volatile unsigned char *unilib_gs4lcd_sdata;

//#######################################################################
//#									#
//#	select font (0=8x12  1=6x10)					#
//#									#
//#######################################################################
void gs4lcd_set_font(char font);

//#######################################################################
//#									#
//#	set color normal						#
//#									#
//#######################################################################
void gs4lcd_set_textcolor(unsigned char fgcolor,unsigned char bgcolor);

//#######################################################################
//#									#
//#	wait for screeen sync						#
//#									#
//#######################################################################
void gs4lcd_waitsync(void);

//#######################################################################
//#									#
//#	clear screen							#
//#									#
//#######################################################################
void gs4lcd_clrscr(char color);

//#######################################################################
//#									#
//#	set screen position						#
//#									#
//#######################################################################
void gs4lcd_gotoxy(unsigned char x,unsigned char y);

//#######################################################################
//#									#
//#	new line							#
//#									#
//#######################################################################
void gs4lcd_newline(void);

//#######################################################################
//#									#
//#	set wrapmode							#
//#									#
//#######################################################################
void gs4lcd_wrapmode(void);

//#######################################################################
//#									#
//#	set scrollmode							#
//#									#
//#######################################################################
void gs4lcd_scrollmode(void);

//#######################################################################
//#									#
//#	get maximal x coordinate					#
//#									#
//#######################################################################
unsigned int gs4lcd_get_drawsize_x(void);

//#######################################################################
//#									#
//#	get maximal y coordinate					#
//#									#
//#######################################################################
unsigned int gs4lcd_get_drawsize_y(void);

//#######################################################################
//#									#
//#	get maximal x coordinate					#
//#									#
//#######################################################################
unsigned int gs4lcd_get_textsize_x(void);

//#######################################################################
//#									#
//#	get maximal y coordinate					#
//#									#
//#######################################################################
unsigned int gs4lcd_get_textsize_y(void);

//#######################################################################
//#									#
//#	get current x coordinate					#
//#									#
//#######################################################################
unsigned int gs4lcd_get_drawpos_x(void);

//#######################################################################
//#									#
//#	get current y coordinate					#
//#									#
//#######################################################################
unsigned int gs4lcd_get_drawpos_y(void);

//#######################################################################
//#									#
//#	get current x coordinate					#
//#									#
//#######################################################################
unsigned int gs4lcd_get_textpos_x(void);

//#######################################################################
//#									#
//#	get current y coordinate					#
//#									#
//#######################################################################
unsigned int gs4lcd_get_textpos_y(void);

//#######################################################################
//#									#
//#	write char							#
//#									#
//#######################################################################
void gs4lcd_char(unsigned char data);

//#######################################################################
//#									#
//#	write char (raw mode)						#
//#									#
//#######################################################################
void gs4lcd_char_raw(unsigned char data);

//#######################################################################
//#									#
//#	draw pixel with color						#
//#									#
//#######################################################################
void gs4lcd_plot(unsigned int x,unsigned int y,char color);

//#######################################################################
//#									#
//#	draw line							#
//#									#
//#######################################################################
void gs4lcd_draw(unsigned int x1,unsigned int y1,unsigned int x2,unsigned int y2,char color);

//#######################################################################
//#									#
//#	draw line to							#
//#									#
//#######################################################################
void gs4lcd_drawto(unsigned int x2,unsigned int y2,char color);

//#######################################################################
//#									#
//#	draw box							#
//#									#
//#######################################################################
void gs4lcd_box(unsigned int x1,unsigned int y1,unsigned int dx,unsigned int dy,char color);

//#######################################################################
//#									#
//#	draw filled box							#
//#									#
//#######################################################################
void gs4lcd_fbox(unsigned int x1,unsigned int y1,unsigned int dx,unsigned int dy,char color);

//#######################################################################
//#									#
//#	draw 8x8 sprite							#
//#									#
//#######################################################################
void gs4lcd_sprite(unsigned int px,unsigned int py,unsigned char *sdata);

//#######################################################################
//#									#
//# draw XBM image from flash array					#
//#									#
//#######################################################################
void gs4lcd_image(unsigned char *pixbuf,unsigned int px,unsigned int py,unsigned int dx,unsigned int dy, unsigned char fcolor,unsigned char bcolor);

//#######################################################################
//#									#
//#	init 480x64 monochrome GLCD 					#
//#									#
//#	ctrlport	= port with control signals			#
//#	flm_pin		= ctrlport pin for FLM signal			#
//#	lp_pin		= ctrlport pin for LP signal			#
//#	m_pin		= ctrlport pin for M signal			#
//#									#
//#######################################################################
void init_gs4lcd480a(PORT_TYPE ctrlport,unsigned char flm_pin,unsigned char lp_pin,unsigned char m_pin);

//#######################################################################
//#									#
//#	service	routine (per pixel line, should be > 4KHz)		#
//#									#
//#######################################################################
void serve_gs4lcd480a(void);

extern volatile unsigned char unilib_glcd_sync;

extern volatile unsigned char unilib_glcd_dirty;

extern volatile unsigned char *unilib_glcd_sdata;

extern volatile unsigned char *unilib_glcd_vdata;

extern volatile unsigned char *unilib_glcd_pattern;

//#######################################################################
//#									#
//#	set pointers							#
//#									#
//#######################################################################
void FKT1_TYPE glcd_set_pointer(unsigned char *drawpointer, unsigned char *viewpointer);

//#######################################################################
//#									#
//#	set pattern pointer						#
//#									#
//#######################################################################
void FKT1_TYPE glcd_set_pattern(unsigned char *ptr);

//#######################################################################
//#									#
//#	select font (0=8x12  1=6x10  2=4x8)				#
//#									#
//#######################################################################
void FKT1_TYPE glcd_set_font(char font);

//#######################################################################
//#									#
//#	set text color							#
//#									#
//#######################################################################
void FKT1_TYPE glcd_set_textcolor(unsigned char color);

//#######################################################################
//#									#
//#	wait for screeen sync						#
//#									#
//#######################################################################
void FKT1_TYPE glcd_waitsync(void);

//#######################################################################
//#									#
//#	clear screen							#
//#									#
//#######################################################################
void FKT1_TYPE glcd_clrscr(unsigned char color);

//#######################################################################
//#									#
//#	set screen position						#
//#									#
//#######################################################################
void FKT1_TYPE glcd_gotoxy(unsigned char x,unsigned char y);

//#######################################################################
//#									#
//#	new line							#
//#									#
//#######################################################################
void FKT1_TYPE glcd_newline(void);

//#######################################################################
//#									#
//#	set wrapmode							#
//#									#
//#######################################################################
void FKT1_TYPE glcd_wrapmode(void);

//#######################################################################
//#									#
//#	set scrollmode							#
//#									#
//#######################################################################
void FKT1_TYPE glcd_scrollmode(void);

//#######################################################################
//#									#
//#	get maximal x coordinate					#
//#									#
//#######################################################################
unsigned int FKT1_TYPE glcd_get_drawsize_x(void);

//#######################################################################
//#									#
//#	get maximal y coordinate					#
//#									#
//#######################################################################
unsigned int FKT1_TYPE glcd_get_drawsize_y(void);

//#######################################################################
//#									#
//#	get maximal x coordinate					#
//#									#
//#######################################################################
unsigned int FKT1_TYPE glcd_get_textsize_x(void);

//#######################################################################
//#									#
//#	get maximal y coordinate					#
//#									#
//#######################################################################
unsigned int FKT1_TYPE glcd_get_textsize_y(void);

//#######################################################################
//#									#
//#	get current x coordinate					#
//#									#
//#######################################################################
unsigned int FKT1_TYPE glcd_get_drawpos_x(void);

//#######################################################################
//#									#
//#	get current y coordinate					#
//#									#
//#######################################################################
unsigned int FKT1_TYPE glcd_get_drawpos_y(void);

//#######################################################################
//#									#
//#	get current x coordinate					#
//#									#
//#######################################################################
unsigned int FKT1_TYPE glcd_get_textpos_x(void);

//#######################################################################
//#									#
//#	get current y coordinate					#
//#									#
//#######################################################################
unsigned int FKT1_TYPE glcd_get_textpos_y(void);

//#######################################################################
//#									#
//#	write char							#
//#									#
//#######################################################################
void FKT1_TYPE glcd_char(unsigned char data);

//#######################################################################
//#									#
//#	write char (raw mode)						#
//#									#
//#######################################################################
void FKT1_TYPE glcd_char_raw(unsigned char data);

//#######################################################################
//#									#
//#	draw pixel with color						#
//#									#
//#	0	= undraw						#
//#	1	= draw							#
//#	2	= invert						#
//#	8	= pattern						#
//#	9	= inverse pattern					#
//#									#
//#######################################################################
void FKT1_TYPE glcd_plot(int x,int y,char color);

//#######################################################################
//#									#
//#	draw line							#
//#									#
//#	0	= undraw						#
//#	1	= draw							#
//#	2	= invert						#
//#	8	= pattern						#
//#	9	= inverse pattern					#
//#									#
//#######################################################################
void FKT1_TYPE glcd_draw(int x1,int y1,int x2,int y2,char color);

//#######################################################################
//#									#
//#	draw line to							#
//#									#
//#	0	= undraw						#
//#	1	= draw							#
//#	2	= invert						#
//#	8	= pattern						#
//#	9	= inverse pattern					#
//#									#
//#######################################################################
void FKT1_TYPE glcd_drawto(int x2,int y2,char color);

//#######################################################################
//#									#
//#	draw box							#
//#									#
//#	0	= undraw						#
//#	1	= draw							#
//#	2	= invert						#
//#	8	= pattern						#
//#	9	= inverse pattern					#
//#									#
//#######################################################################
void FKT1_TYPE glcd_box(int x1,int y1,int dx,int dy,char color);

//#######################################################################
//#									#
//#	draw filled box							#
//#									#
//#	0	= undraw						#
//#	1	= draw							#
//#	2	= invert						#
//#	8	= pattern						#
//#	9	= inverse pattern					#
//#									#
//#######################################################################
void FKT1_TYPE glcd_fbox(int x1,int y1,int dx,int dy,char color);

//#######################################################################
//#									#
//#	draw 8x8 sprite							#
//#									#
//#######################################################################
void FKT1_TYPE glcd_sprite(int px,int py,unsigned char *sdata);

//#######################################################################
//#									#
//# draw XBM image from flash array					#
//#									#
//# pcolor 0:	inverse							#
//#	   1:	normal							#
//#	   2:	toogle							#
//#	   3:	transparent						#
//#									#
//#######################################################################
void FKT1_TYPE glcd_image(const unsigned char *pixbuf,int px,int py,int dx,int dy, unsigned char pcolor);

//#######################################################################
//#									#
//#	enable GLCD (KS010x, negative CS1/CS2)				#
//#	extended version with delay and multibuffer support		#
//#									#
//#######################################################################
void glcd128ax_init(PORT_TYPE dataport,PORT_TYPE ctrlport,unsigned char cs1pin,unsigned char cs2pin,unsigned char dipin,unsigned char epin,unsigned char delay,unsigned char *drawpointer, unsigned char *viewpointer);

//#######################################################################
//#									#
//#	set display contrast (dummy)					#
//#									#
//#######################################################################
void glcd128ax_set_contrast(unsigned char contrast);

//#######################################################################
//#									#
//#	service	(2 blocks) always					#
//#									#
//#######################################################################
void serve_glcd128ax(void);

//#######################################################################
//#									#
//#	service	(1 block) always					#
//#									#
//#######################################################################
void serve_glcd128ax_fast(void);

//#######################################################################
//#									#
//#	service	(2 blocks) ondemand					#
//#									#
//#######################################################################
void serve_glcd128ax_ondemand(void);

//#######################################################################
//#									#
//#	service	(1 block) ondemand					#
//#									#
//#######################################################################
void serve_glcd128ax_ondemand_fast(void);

//#######################################################################
//#									#
//#	enable GLCD (KS010x, negative CS1/CS2)				#
//#	extended version with delay and multibuffer support		#
//#									#
//#######################################################################
void glcd128ay_init(PORT_TYPE dataport,PORT_TYPE ctrlport,unsigned char cs1pin,unsigned char cs2pin,unsigned char dipin,unsigned char epin,unsigned char delay,unsigned char *drawpointer, unsigned char *viewpointer);

//#######################################################################
//#									#
//#	set display contrast (dummy)					#
//#									#
//#######################################################################
void glcd128ay_set_contrast(unsigned char contrast);

//#######################################################################
//#									#
//#	service	(2 blocks) always					#
//#									#
//#######################################################################
void serve_glcd128ay(void);

//#######################################################################
//#									#
//#	service	(1 block) always					#
//#									#
//#######################################################################
void serve_glcd128ay_fast(void);

//#######################################################################
//#									#
//#	service	(2 blocks) ondemand					#
//#									#
//#######################################################################
void serve_glcd128ay_ondemand(void);

//#######################################################################
//#									#
//#	service	(1 block) ondemand					#
//#									#
//#######################################################################
void serve_glcd128ay_ondemand_fast(void);

//#######################################################################
//#									#
//#	init display ((S6B0721 controller without cs/rd)		#
//#	extended version with delay and multi buffer support		#
//#	/CS1 fixed to LOW						#
//#	/RS fixed to HIGH						#
//#									#
//#######################################################################
void glcd128bx_init(PORT_TYPE dataport,PORT_TYPE ctrlport,unsigned char resetpin,unsigned char rspin,unsigned char wrpin,unsigned char delay,unsigned char *drawpointer, unsigned char *viewpointer);

//#######################################################################
//#									#
//#	set display contrast						#
//#									#
//#######################################################################
void glcd128bx_set_contrast(unsigned char contrast);

//#######################################################################
//#									#
//#	switch display on						#
//#									#
//#######################################################################
void glcd128bx_on(void);

//#######################################################################
//#									#
//#	switch display off						#
//#									#
//#######################################################################
void glcd128bx_off(void);

//#######################################################################
//#									#
//#	service	(2 blocks) always					#
//#									#
//#######################################################################
void serve_glcd128bx(void);

//#######################################################################
//#									#
//#	service	(1 block) always					#
//#									#
//#######################################################################
void serve_glcd128bx_fast(void);

//#######################################################################
//#									#
//#	service	(2 blocks) ondemand					#
//#									#
//#######################################################################
void serve_glcd128bx_ondemand(void);

//#######################################################################
//#									#
//#	service	(1 block) ondemand					#
//#									#
//#######################################################################
void serve_glcd128bx_ondemand_fast(void);

//#######################################################################
//#									#
//#	init display ((S6B0721 controller without cs/rd)		#
//#	extended version with delay and multi buffer support		#
//#	/CS1 fixed to LOW						#
//#	/RS fixed to HIGH						#
//#									#
//#######################################################################
void glcd128by_init(PORT_TYPE dataport,PORT_TYPE ctrlport,unsigned char resetpin,unsigned char rspin,unsigned char wrpin,unsigned char delay,unsigned char *drawpointer, unsigned char *viewpointer);

//#######################################################################
//#									#
//#	set display contrast						#
//#									#
//#######################################################################
void glcd128by_set_contrast(unsigned char contrast);

//#######################################################################
//#									#
//#	switch display on						#
//#									#
//#######################################################################
void glcd128by_on(void);

//#######################################################################
//#									#
//#	switch display off						#
//#									#
//#######################################################################
void glcd128by_off(void);

//#######################################################################
//#									#
//#	service	(2 blocks) always					#
//#									#
//#######################################################################
void serve_glcd128by(void);

//#######################################################################
//#									#
//#	service	(1 block) always					#
//#									#
//#######################################################################
void serve_glcd128by_fast(void);

//#######################################################################
//#									#
//#	service	(2 blocks) ondemand					#
//#									#
//#######################################################################
void serve_glcd128by_ondemand(void);

//#######################################################################
//#									#
//#	service	(1 block) ondemand					#
//#									#
//#######################################################################
void serve_glcd128by_ondemand_fast(void);

//#######################################################################
//#									#
//#	init LCD (positive CS)						#
//#									#
//#######################################################################
void glcd128cx_init(PORT_TYPE dataport,PORT_TYPE ctrlport,unsigned char cs1pin,unsigned char cs2pin,unsigned char dipin,unsigned char epin,unsigned char delay,unsigned char *drawpointer, unsigned char *viewpointer);

//#######################################################################
//#									#
//#	set display contrast						#
//#									#
//#######################################################################
void glcd128cx_set_contrast(unsigned char contrast);

//#######################################################################
//#									#
//#	service (2 blocks) always					#
//#									#
//#######################################################################
void serve_glcd128cx(void);

//#######################################################################
//#									#
//#	service (1 block) always					#
//#									#
//#######################################################################
void serve_glcd128cx_fast(void);

//#######################################################################
//#									#
//#	service (2 blocks) ondemand					#
//#									#
//#######################################################################
void serve_glcd128cx_ondemand(void);

//#######################################################################
//#									#
//#	service (1 block) ondemand					#
//#									#
//#######################################################################
void serve_glcd128cx_ondemand_fast(void);

//#######################################################################
//#									#
//#	init LCD (positive CS)						#
//#									#
//#######################################################################
void glcd128cy_init(PORT_TYPE dataport,PORT_TYPE ctrlport,unsigned char cs1pin,unsigned char cs2pin,unsigned char dipin,unsigned char epin,unsigned char delay,unsigned char *drawpointer, unsigned char *viewpointer);

//#######################################################################
//#									#
//#	set display contrast						#
//#									#
//#######################################################################
void glcd128cy_set_contrast(unsigned char contrast);

//#######################################################################
//#									#
//#	service (2 blocks) always					#
//#									#
//#######################################################################
void serve_glcd128cy(void);

//#######################################################################
//#									#
//#	service (1 block) always					#
//#									#
//#######################################################################
void serve_glcd128cy_fast(void);

//#######################################################################
//#									#
//#	service (2 blocks) ondemand					#
//#									#
//#######################################################################
void serve_glcd128cy_ondemand(void);

//#######################################################################
//#									#
//#	service (1 block) ondemand					#
//#									#
//#######################################################################
void serve_glcd128cy_ondemand_fast(void);

extern volatile unsigned char unilib_glcd320_sed1335_delay;

extern volatile unsigned char unilib_glcd320_sed1335_dpos;

extern unsigned char unilib_glcd320_sed1335_sdata[9600];

//#######################################################################
//#									#
//#	init GLCD 320x240 (SED1335)					#
//#									#
//#	CTRLPORT							#
//#	0	= A0							#
//#	1	= WR							#
//#	2	= RD							#
//#	3	= CS							#
//#	4	= RESET							#
//#	5	= LP (input)						#
//#	6	= unused (input)					#
//#	7	= unused (input)					#
//#									#
//#######################################################################
void glcd320_sed1335_init(PORT_TYPE dataport,PORT_TYPE ctrlport,int msize,unsigned char delay);

//#######################################################################
//#									#
//#	set display contrast (dummy)					#
//#									#
//#######################################################################
void glcd320_sed1335_set_contrast(unsigned char contrast);

//#######################################################################
//#									#
//#	int service routine (normal)					#
//#									#
//#######################################################################
void serve_glcd320_sed1335(void);

//#######################################################################
//#									#
//#	int service routine (normal)					#
//#									#
//#######################################################################
void serve_glcd320_sed1335_sync(void);

//#######################################################################
//#									#
//#	int service routine (invers)					#
//#									#
//#######################################################################
void serve_glcd320_sed1335_inv(void);

//#######################################################################
//#									#
//#	init 320x240 monochrome GLCD 					#
//#									#
//#	dataport	= port with data signals in D0-D3  		#
//#	ctrlport	= port with control signals			#
//#	flm_pin		= ctrlport pin for FLM signal			#
//#	lp_pin		= ctrlport pin for LP signal			#
//#	m_pin		= ctrlport pin for M signal			#
//#									#
//#######################################################################
void glcd320a_init_n0(PORT_TYPE dataport,PORT_TYPE ctrlport,unsigned char cp_pin,unsigned char lp_pin,unsigned char flm_pin);

//#######################################################################
//#									#
//#	service	routine (per pixel line, should be > 4KHz)		#
//#									#	
//#######################################################################
void serve_glcd320a_n0(void);

//#######################################################################
//#									#
//#	service	routine (per pixel line, should be > 4KHz)		#
//#									#
//#######################################################################
void serve_glcd320a_n0_inv(void);

//#######################################################################
//#									#
//#	init 320x240 monochrome GLCD 					#
//#									#
//#	dataport	= port with data signals in D4-D7  		#
//#	ctrlport	= port with control signals			#
//#	flm_pin		= ctrlport pin for FLM signal			#
//#	lp_pin		= ctrlport pin for LP signal			#
//#	m_pin		= ctrlport pin for M signal			#
//#									#
//#######################################################################
void glcd320a_init_n1(PORT_TYPE dataport,PORT_TYPE ctrlport,unsigned char cp_pin,unsigned char lp_pin,unsigned char flm_pin);

//#######################################################################
//#									#
//#	service	routine (per pixel line, should be > 4KHz)		#
//#									#	
//#######################################################################
void serve_glcd320a_n1(void);

//#######################################################################
//#									#
//#	service	routine (per pixel line, should be > 4KHz)		#
//#									#
//#######################################################################
void serve_glcd320a_n1_inv(void);

//#######################################################################
//#									#
//#	init 320x240 monochrome GLCD 					#
//#									#
//#	dataport	= port with data signals in D8-D11 		#
//#	ctrlport	= port with control signals			#
//#	flm_pin		= ctrlport pin for FLM signal			#
//#	lp_pin		= ctrlport pin for LP signal			#
//#	m_pin		= ctrlport pin for M signal			#
//#									#
//#######################################################################
void glcd320a_init_n2(PORT_TYPE dataport,PORT_TYPE ctrlport,unsigned char cp_pin,unsigned char lp_pin,unsigned char flm_pin);

//#######################################################################
//#									#
//#	service	routine (per pixel line, should be > 4KHz)		#
//#									#	
//#######################################################################
void serve_glcd320a_n2(void);

//#######################################################################
//#									#
//#	service	routine (per pixel line, should be > 4KHz)		#
//#									#
//#######################################################################
void serve_glcd320a_n2_inv(void);

//#######################################################################
//#									#
//#	init 320x240 monochrome GLCD 					#
//#									#
//#	dataport	= port with data signals in D12-D15		#
//#	ctrlport	= port with control signals			#
//#	flm_pin		= ctrlport pin for FLM signal			#
//#	lp_pin		= ctrlport pin for LP signal			#
//#	m_pin		= ctrlport pin for M signal			#
//#									#
//#######################################################################
void glcd320a_init_n3(PORT_TYPE dataport,PORT_TYPE ctrlport,unsigned char cp_pin,unsigned char lp_pin,unsigned char flm_pin);

//#######################################################################
//#									#
//#	service	routine (per pixel line, should be > 4KHz)		#
//#									#	
//#######################################################################
void serve_glcd320a_n3(void);

//#######################################################################
//#									#
//#	service	routine (per pixel line, should be > 4KHz)		#
//#									#
//#######################################################################
void serve_glcd320a_n3_inv(void);

extern unsigned char unilib_glcd480a_sdata[3840];

//#######################################################################
//#									#
//#	init 480x64 monochrome GLCD 					#
//#									#
//#	ctrlport	= port with control signals			#
//#	flm_pin		= ctrlport pin for FLM signal			#
//#	lp_pin		= ctrlport pin for LP signal			#
//#	m_pin		= ctrlport pin for M signal			#
//#									#
//#######################################################################
void glcd480a_init(PORT_TYPE ctrlport,unsigned char flm_pin,unsigned char lp_pin,unsigned char m_pin);

//#######################################################################
//#									#
//#	service	routine (per pixel line, should be > 4KHz)		#
//#									#
//#######################################################################
void glcd480a_serve(void);

//#######################################################################
//#									#
//#	draw a circe/ellipse						#
//#									#
//#	mx/my	middle point coordinates				#
//#	rx,ry	radius	(should be less than 128)			#
//#									#
//#######################################################################
void FKT1_TYPE glcd_ellipse(int mx,int my,unsigned char rx,unsigned char ry,char color);

//#######################################################################
//#									#
//#	draw a filled circe/ellipse					#
//#									#
//#	mx/my	middle point coordinates				#
//#	rx,ry	radius	(should be less than 128)			#
//#									#
//#######################################################################
void FKT1_TYPE glcd_fellipse(int mx,int my,unsigned char rx,unsigned char ry,char color);

//#######################################################################
//#									#
//#	draw a circe/ellipse arc					#
//#									#
//#	mx/my	middle point coordinates				#
//#	rx,ry	radius	(should be less than 128)			#
//#	astart	start in degrees					#
//#	asize	size in degrees (CW)					#
//#									#
//#######################################################################
void FKT1_TYPE glcd_arc(int mx,int my,unsigned char rx,unsigned char ry,int astart,int asize,char color);

//#######################################################################
//# draw single digit                                                   #
//#                                                                     #
//# 0123456789ABCDEF+-*/:                                               #
//#                                                                     #
//#                                                                     #
//# result 0=OK, 1=out of area                                          #
//#######################################################################
int FKT1_TYPE glcd_segm3260_digit(int x,int y, unsigned char digit);

//#######################################################################
//# draw two digits number                                              #
//#                                                                     #
//# result 0=OK, 1=out of area                                          #
//#######################################################################
int FKT1_TYPE glcd_segm3260_num2(int x,int y, unsigned char value);

//#######################################################################
//# draw two digits number with sign                                    #
//#                                                                     #
//# result 0=OK, 1=out of area                                          #
//#######################################################################
int FKT1_TYPE glcd_segm3260_snum2(int x,int y, char value);

//#######################################################################
//# draw three digits number                                            #
//#                                                                     #
//# result 0=OK, 1=out of area                                          #
//#######################################################################
int FKT1_TYPE glcd_segm3260_num3(int x,int y, int value);

//#######################################################################
//# draw three digits number with sign                                  #
//#                                                                     #
//# result 0=OK, 1=out of area                                          #
//#######################################################################
int FKT1_TYPE glcd_segm3260_snum3(int x,int y, int value);

//#######################################################################
//# draw two digits hexadecimal number                                  #
//#                                                                     #
//# result 0=OK, 1=out of area                                          #
//#######################################################################
int FKT1_TYPE glcd_segm3260_hex2(int x,int y, unsigned char value);

//#######################################################################
//# draw four digits hexadecimal number                                 #
//#                                                                     #
//# result 0=OK, 1=out of area                                          #
//#######################################################################
int FKT1_TYPE glcd_segm3260_hex4(int x,int y, unsigned short value);

//#######################################################################
//#									#
//#	set position (4 pixel units)					#
//#									#
//#######################################################################
void FKT1_TYPE glcd_f1220_gotoxy(unsigned char x,unsigned char y);

//#######################################################################
//#									#
//#	write char (raw mode)						#
//#									#
//#######################################################################
void FKT1_TYPE glcd_f1220_char(unsigned char data);

//#######################################################################
//#									#
//#	set position (4 pixel units)					#
//#									#
//#######################################################################
void FKT1_TYPE glcd_f1624_gotoxy(unsigned char x,unsigned char y);

//#######################################################################
//#									#
//#	write char (raw mode)						#
//#									#
//#######################################################################
void FKT1_TYPE glcd_f1624_char(unsigned char data);

//#######################################################################
//#									#
//#	set position (4 pixel units)					#
//#									#
//#######################################################################
void FKT1_TYPE glcd_f2432_gotoxy(unsigned char x,unsigned char y);

//#######################################################################
//#									#
//#	write char (raw mode)						#
//#									#
//#######################################################################
void FKT1_TYPE glcd_f2432_char(unsigned char data);

//#######################################################################
//#									#
//#	set position (4 pixel units)					#
//#									#
//#######################################################################
void FKT1_TYPE glcd_v0812_gotoxy(unsigned char x,unsigned char y);

//#######################################################################
//#									#
//#	write char (raw mode)						#
//#									#
//#######################################################################
void FKT1_TYPE glcd_v0812_char(unsigned char data);

//#######################################################################
//#									#
//#	set position (4 pixel units)					#
//#									#
//#######################################################################
void FKT1_TYPE glcd_v1220_gotoxy(unsigned char x,unsigned char y);

//#######################################################################
//#									#
//#	write char (raw mode)						#
//#									#
//#######################################################################
void FKT1_TYPE glcd_v1220_char(unsigned char data);

//#######################################################################
//#									#
//#	set position (4 pixel units)					#
//#									#
//#######################################################################
void FKT1_TYPE glcd_v1624_gotoxy(unsigned char x,unsigned char y);

//#######################################################################
//#									#
//#	write char (raw mode)						#
//#									#
//#######################################################################
void FKT1_TYPE glcd_v1624_char(unsigned char data);

//#######################################################################
//#									#
//#	set position (4 pixel units)					#
//#									#
//#######################################################################
void FKT1_TYPE glcd_v2432_gotoxy(unsigned char x,unsigned char y);

//#######################################################################
//#									#
//#	write char (raw mode)						#
//#									#
//#######################################################################
void FKT1_TYPE glcd_v2432_char(unsigned char data);

//#######################################################################
//# ckeck presence							#
//#######################################################################
unsigned char eep_24c01_check(unsigned char devaddr);

//#######################################################################
//# read bytes								#
//#######################################################################
unsigned char eep_24c01_read(unsigned char *buffer,unsigned int addr, int len, unsigned char devaddr);

//#######################################################################
//# write bytes								#
//#######################################################################
unsigned char eep_24c01_write(unsigned char *buffer,unsigned int addr, int len, unsigned char devaddr);

//#######################################################################
//# ckeck presence							#
//#######################################################################
unsigned char eep_24c02_check(unsigned char devaddr);

//#######################################################################
//# read bytes								#
//#######################################################################
unsigned char eep_24c02_read(unsigned char *buffer,unsigned int addr, int len, unsigned char devaddr);

//#######################################################################
//# write bytes								#
//#######################################################################
unsigned char eep_24c02_write(unsigned char *buffer,unsigned int addr, int len, unsigned char devaddr);

//#######################################################################
//# ckeck presence							#
//#######################################################################
unsigned char eep_24c04_check(unsigned char devaddr);

//#######################################################################
//# read bytes								#
//#######################################################################
unsigned char eep_24c04_read(unsigned char *buffer,unsigned int addr, int len, unsigned char devaddr);

//#######################################################################
//# write bytes								#
//#######################################################################
unsigned char eep_24c04_write(unsigned char *buffer,unsigned int addr, int len, unsigned char devaddr);

//#######################################################################
//# ckeck presence							#
//#######################################################################
unsigned char eep_24c08_check(unsigned char devaddr);

//#######################################################################
//# read bytes								#
//#######################################################################
unsigned char eep_24c08_read(unsigned char *buffer,unsigned int addr, int len, unsigned char devaddr);

//#######################################################################
//# write bytes								#
//#######################################################################
unsigned char eep_24c08_write(unsigned char *buffer,unsigned int addr, int len, unsigned char devaddr);

//#######################################################################
//# ckeck presence							#
//#######################################################################
unsigned char eep_24c128_check(unsigned char devaddr);

//#######################################################################
//# read bytes								#
//#######################################################################
unsigned char eep_24c128_read(unsigned char *buffer,unsigned int addr, int len, unsigned char devaddr);

//#######################################################################
//# write bytes								#
//#######################################################################
unsigned char eep_24c128_write(unsigned char *buffer,unsigned int addr, int len, unsigned char devaddr);

//#######################################################################
//# ckeck presence							#
//#######################################################################
unsigned char eep_24c16_check(unsigned char devaddr);

//#######################################################################
//# read bytes								#
//#######################################################################
unsigned char eep_24c16_read(unsigned char *buffer,unsigned int addr, int len, unsigned char devaddr);

//#######################################################################
//# write bytes								#
//#######################################################################
unsigned char eep_24c16_write(unsigned char *buffer,unsigned int addr, int len, unsigned char devaddr);

//#######################################################################
//# ckeck presence							#
//#######################################################################
unsigned char eep_24c256_check(unsigned char devaddr);

//#######################################################################
//# read bytes								#
//#######################################################################
unsigned char eep_24c256_read(unsigned char *buffer,unsigned int addr, int len, unsigned char devaddr);

//#######################################################################
//# write bytes								#
//#######################################################################
unsigned char eep_24c256_write(unsigned char *buffer,unsigned int addr, int len, unsigned char devaddr);

//#######################################################################
//# ckeck presence							#
//#######################################################################
unsigned char eep_24c32_check(unsigned char devaddr);

//#######################################################################
//# read bytes								#
//#######################################################################
unsigned char eep_24c32_read(unsigned char *buffer,unsigned int addr, int len, unsigned char devaddr);

//#######################################################################
//# write bytes								#
//#######################################################################
unsigned char eep_24c32_write(unsigned char *buffer,unsigned int addr, int len, unsigned char devaddr);

//#######################################################################
//# ckeck presence							#
//#######################################################################
unsigned char eep_24c512_check(unsigned char devaddr);

//#######################################################################
//# read bytes								#
//#######################################################################
unsigned char eep_24c512_read(unsigned char *buffer,unsigned int addr, int len, unsigned char devaddr);

//#######################################################################
//# write bytes								#
//#######################################################################
unsigned char eep_24c512_write(unsigned char *buffer,unsigned int addr, int len, unsigned char devaddr);

//#######################################################################
//# ckeck presence							#
//#######################################################################
unsigned char eep_24c64_check(unsigned char devaddr);

//#######################################################################
//# read bytes								#
//#######################################################################
unsigned char eep_24c64_read(unsigned char *buffer,unsigned int addr, int len, unsigned char devaddr);

//#######################################################################
//# write bytes								#
//#######################################################################
unsigned char eep_24c64_write(unsigned char *buffer,unsigned int addr, int len, unsigned char devaddr);

//#######################################################################
//# ckeck presence of device with addr devaddr				#
//#######################################################################
unsigned char color8_check(unsigned char devaddr);

//#######################################################################
//# read ambient,red,green,blue values					#
//#######################################################################
int color8_read(unsigned char devaddr,unsigned short *ptr);

//#######################################################################
//# set sensor to power-down						#
//#######################################################################
unsigned char color8_disable(unsigned char devaddr);

//#######################################################################
//# power-up sensor							#
//#######################################################################
unsigned char color8_enable(unsigned char devaddr);

extern unsigned char _iclcd_font;

extern unsigned char _iclcd_lwidth;

//###############################################################################
//#										#
//#	test if display is available (0/1)					#
//#										#
//###############################################################################
int iclcd_test(void);

//###############################################################################
//#										#
//#	clear screen with actual background color				#
//#										#
//###############################################################################
void iclcd_clear(void);

//###############################################################################
//#										#
//#	set color (foregroundg, background)					#
//#										#
//###############################################################################
void iclcd_set_color(unsigned char fg, unsigned char bg);

//###############################################################################
//#										#
//#	set text position							#
//#										#
//###############################################################################
void iclcd_set_textpos(unsigned char row, unsigned char col);

//###############################################################################
//#										#
//#	set last point								#
//#										#
//###############################################################################
void iclcd_set_graphpos(unsigned char y, unsigned char x);

//###############################################################################
//#										#
//#	plot a point								#
//#										#
//###############################################################################
void iclcd_plot(unsigned char y, unsigned char x);

//###############################################################################
//#										#
//#	draw line								#
//#										#
//###############################################################################
void iclcd_draw(unsigned char y1, unsigned char x1,unsigned char y2, unsigned char x2);

//###############################################################################
//#										#
//#	draw line from last point						#
//#										#
//###############################################################################
void iclcd_drawto(unsigned char y, unsigned char x);

//###############################################################################
//#										#
//#	draw filled box								#
//#										#
//###############################################################################
void iclcd_fbox(unsigned char y1, unsigned char x1,unsigned char y2, unsigned char x2);

//###############################################################################
//#										#
//#	draw ellipse								#
//#										#
//###############################################################################
void iclcd_ellipse(unsigned char y, unsigned char x,unsigned char ry, unsigned char rx);

//###############################################################################
//#										#
//#	set lcd font size (0..3)						#
//#										#
//###############################################################################
void iclcd_set_font(unsigned char font);

//###############################################################################
//#										#
//#	set line width for drawing (1..3)					#
//#										#
//###############################################################################
void iclcd_set_linewidth(unsigned char width);

//###############################################################################
//#										#
//#	lcd wakeup (display and backlight on)					#
//#										#
//###############################################################################
void iclcd_wake(void);

//###############################################################################
//#										#
//#	lcd sleep (display and backlight off)					#
//#										#
//###############################################################################
void iclcd_sleep(void);

//###############################################################################
//#										#
//#	my little printf							#
//#										#
//###############################################################################
void iclcd_printf (const char *format, ...);

//###############################################################################
//#										#
//#	output packed greyscale data line from buffer				#
//#										#
//###############################################################################
void iclcd_greyline(unsigned char line_number,unsigned char *buffer);

//###############################################################################
//#										#
//#	output packed color data line from buffer				#
//#										#
//###############################################################################
void iclcd_colorline(unsigned char line_number,unsigned char *buffer);

//###############################################################################
//#										#
//#	output rgb data line							#
//#										#
//###############################################################################
void iclcd_rgbline(unsigned char line_number,unsigned char *buffer);

//###############################################################################
//#										#
//#	set tile pattern							#
//#										#
//###############################################################################
void iclcd_tile_set(unsigned char tile_number,unsigned char *buffer);

//###############################################################################
//#										#
//#	fill tile solid								#
//#										#
//###############################################################################
void iclcd_tile_set_solid(unsigned char tile_number,unsigned char color);

//###############################################################################
//#										#
//#	add pre-defined pattern to tile						#
//#										#
//###############################################################################
void iclcd_tile_add_pattern(unsigned char tile_number,unsigned char pattern,unsigned char color);

//###############################################################################
//#										#
//#	add character from charset to tile					#
//#										#
//###############################################################################
void iclcd_tile_add_char(unsigned char tile_number,unsigned char tchar,unsigned char color);

//###############################################################################
//#										#
//#	copy a tile								#
//#										#
//###############################################################################
void iclcd_tile_copy(unsigned char dst_tile,unsigned char src_tile);

//###############################################################################
//#										#
//#	X-mirror a tile								#
//#										#
//###############################################################################
void iclcd_tile_mirror_x(unsigned char tile);

//###############################################################################
//#										#
//#	Y-mirror a tile								#
//#										#
//###############################################################################
void iclcd_tile_mirror_y(unsigned char tile);

//###############################################################################
//#										#
//#	rotate a tile CW							#
//#										#
//###############################################################################
void iclcd_tile_rotate_cw(unsigned char tile);

//###############################################################################
//#										#
//#	rotate a tile CCW							#
//#										#
//###############################################################################
void iclcd_tile_rotate_ccw(unsigned char tile);

//###############################################################################
//#										#
//#	invert a tile (negative color)						#
//#										#
//###############################################################################
void iclcd_tile_invert(unsigned char tile);

//###############################################################################
//#										#
//#	draw a sprite								#
//#										#
//###############################################################################
void iclcd_sprite_draw(	unsigned char tile,unsigned char backup_tile,unsigned char posy,unsigned char posx,unsigned char transp_color);

//###############################################################################
//#										#
//#	undraw a sprite (restore background)					#
//#										#
//###############################################################################
void iclcd_sprite_restore(unsigned char backup_tile,unsigned char posy,unsigned char posx);

//###############################################################################
//#										#
//#										#
//#										#
//###############################################################################
void iclcd_bigsprite_draw(unsigned char tile,unsigned char backup_tile,unsigned char posy,unsigned char posx,unsigned char transp_color);

//###############################################################################
//#										#
//#										#
//#										#
//###############################################################################
void iclcd_bigsprite_restore(unsigned char backup_tile,unsigned char posy,unsigned char posx);

//##################################################################################
//#
//#	get current key or 0xff if none pressed
//#
//##################################################################################
unsigned char ickbd12_getkey(void);

//##################################################################################
//#
//#	wait for key pressed
//#
//##################################################################################
unsigned char ickbd12_waitkey(void);

//##################################################################################
//#
//#	wait for no key is pressed
//#
//##################################################################################
void ickbd12_waitnokey(void);

//#######################################################################
//#									#
//#	comm block							#
//#									#
//#	return: 0 = OK		1 = ERROR				#
//#									#
//#######################################################################
int i2c_master_comm(unsigned char addr,unsigned char *dataptr,int count);

//#######################################################################
//#									#
//# check if device is available					#
//#									#
//# 0=OK	1=ERROR							#
//#									#
//#######################################################################
unsigned char LDC3114_check(void);

//#######################################################################
//#									#
//# init device for raw output						#
//#									#
//# mask: bitmask for channel 0..3					#
//#									#
//# channel CFG:							#
//# ------------							#
//# 0...1F	sampling window						#
//# +0x00	1..3,3 MHz						#						
//# +0x20	3,3..10MHz						#
//# +0x40	10..30MHz						#
//#									#
//#######################################################################
void LDC3114_init_raw(unsigned char mask,unsigned char ch0_cfg,unsigned char ch1_cfg,unsigned char ch2_cfg,unsigned char ch3_cfg);

//#######################################################################
//#									#
//# disable								#
//#									#
//#######################################################################
void LDC3114_disable(void);

//#######################################################################
//#									#
//# read raw values (16 bit)						#
//#									#
//#######################################################################
void LDC3114_read_raw(unsigned char mask,int *values );

//#######################################################################
//# ckeck presence of device with addr devaddr				#
//#######################################################################
unsigned char lm73_check(unsigned char devaddr);

//#######################################################################
//# read temperature as integer (grad * 100)				#
//#######################################################################
int lm73_read_int(unsigned char devaddr);

//#######################################################################
//# read temperature as float with current resolution			#
//#######################################################################
float lm73_read_float(unsigned char devaddr);

//#######################################################################
//# set sensor resolution						#
//#									#
//# 0 = 11 Bits (0,25°C resolution)					#
//# 1 = 12 Bits (0,125°C resolution)					#
//# 2 = 13 Bits (0,0625°C resolution)					#
//# 3 = 14 Bits (0,031625°C resolution)					#
//#									#
//#######################################################################
unsigned char lm73_set_resolution(unsigned char devaddr,unsigned char resolution);

//#######################################################################
//# set sensor to power-down						#
//#######################################################################
unsigned char lm73_pwr_down(unsigned char devaddr);

//#######################################################################
//# power-up sensor							#
//#######################################################################
unsigned char lm73_pwr_up(unsigned char devaddr);

//#######################################################################
//# ckeck presence							#
//#######################################################################
unsigned char lm75_check(unsigned char devaddr);

//#######################################################################
//# read temperature (grad * 10)					#
//#######################################################################
int lm75_read_int(unsigned char devaddr);

//#######################################################################
//# read temperature (grad)						#
//#######################################################################
float lm75_read_float(unsigned char devaddr);

//#######################################################################
//# set sensor to power-down						#
//#######################################################################
unsigned char lm75_pwr_down(unsigned char devaddr);

//#######################################################################
//# power-up sensor							#
//#######################################################################
unsigned char lm75_pwr_up(unsigned char devaddr);

//#######################################################################
//# ckeck presence of device with addr devaddr				#
//#######################################################################
unsigned char lp25h_check(unsigned char devaddr);

//#######################################################################
//# ckeck presence of device with addr devaddr				#
//#######################################################################
unsigned char lp25h_enable(unsigned char devaddr);

//#######################################################################
//# ckeck presence of device with addr devaddr				#
//#######################################################################
unsigned char lp25h_disable(unsigned char devaddr);

//#######################################################################
//# read temperature as integer (grad * 100)				#
//#######################################################################
float lp25h_read_pressure(unsigned char devaddr);

//#######################################################################
//# read temperature as integer (grad * 100)				#
//#######################################################################
float lp25h_read_temperature(unsigned char devaddr);

//#######################################################################
//# ckeck presence of device with addr devaddr (0/1)			#
//# result is 0 (OK) or error code					#
//#######################################################################
unsigned char lsm6dsl_check(unsigned char devaddr);

//#######################################################################
//# init accelerometer			 				#
//# 									#
//# Speed:	 0 = off						#
//# 		 1 = 12,5 Hz						#
//# 		 2 = 26 Hz						#
//# 		 3 = 52 Hz						#
//# 		 4 = 104 Hz						#
//# 		 5 = 208 Hz						#
//# 		 6 = 416 Hz						#
//# 		 7 = 833 Hz						#
//# 		 8 = 1,66 KHz						#
//# 		 9 = 3,33 KHz						#
//# 		10 = 6,66 KHz						#
//# 		11 = 1,6 Hz						#
//# 									#
//# Range:	2 = +- 2g						#
//#		4 = +- 4g						#
//#		8 = +- 8g						#
//#		default	+- 16g						#
//#######################################################################
void lsm6dsl_enable_accel(unsigned char devaddr, unsigned char speed, unsigned char range);

//#######################################################################
//# init gyroscope			 				#
//# 									#
//# Speed:	 0 = off						#
//# 		 1 = 12,5 Hz						#
//# 		 2 = 26 Hz						#
//# 		 3 = 52 Hz						#
//# 		 4 = 104 Hz						#
//# 		 5 = 208 Hz						#
//# 		 6 = 416 Hz						#
//# 		 7 = 833 Hz						#
//# 		 8 = 1,66 KHz						#
//# 		 9 = 3,33 KHz						#
//# 		10 = 6,66 KHz						#
//# 									#
//# Range:	1 = +- 125dps						#
//#		2 = +- 250dps						#
//#		3 = +- 500dps						#
//#		4 = +- 1000dps						#
//#		default	+- 2000dps					#
//#######################################################################
void lsm6dsl_enable_gyro(unsigned char devaddr, unsigned char speed, unsigned char range);

//#######################################################################
//# set pedometer fct 0/1			 			#
//#######################################################################
void lsm6dsl_set_pedometer(unsigned char devaddr, unsigned char active);

//#######################################################################
//# get temperature				 			#
//#######################################################################
int lsm6dsl_get_temperature(unsigned char devaddr);

//#######################################################################
//# get gyro X					 			#
//#######################################################################
long lsm6dsl_get_gyro_x(unsigned char devaddr);

//#######################################################################
//# get gyro Y					 			#
//#######################################################################
long lsm6dsl_get_gyro_y(unsigned char devaddr);

//#######################################################################
//# get gyro Z					 			#
//#######################################################################
long lsm6dsl_get_gyro_z(unsigned char devaddr);

//#######################################################################
//# get accel X					 			#
//#######################################################################
long lsm6dsl_get_accel_x(unsigned char devaddr);

//#######################################################################
//# get accel Y					 			#
//#######################################################################
long lsm6dsl_get_accel_y(unsigned char devaddr);

//#######################################################################
//# get accel Z					 			#
//#######################################################################
long lsm6dsl_get_accel_z(unsigned char devaddr);

//#######################################################################
//# get step counter				 			#
//#######################################################################
unsigned short lsm6dsl_get_steps(unsigned char devaddr);

//#######################################################################
//# ckeck presence of device with addr devaddr				#
//#######################################################################
unsigned char ov7431_check(void);

//#######################################################################
//# set gain (0-127)							#
//#######################################################################
unsigned char ov7431_set_gain(unsigned char gain);

//#######################################################################
//# set brightness (0-255)						#
//#######################################################################
unsigned char ov7431_set_brightness(unsigned char brightness);

//#######################################################################
//# set edge enhancement (0/1)						#
//#######################################################################
unsigned char ov7431_set_edge_enhancement(unsigned char eh);

//#######################################################################
//# set analog boost (0/1)						#
//#######################################################################
unsigned char ov7431_set_boost(unsigned char boost);

//#######################################################################
//# set exposure time (0-82)						#
//#######################################################################
unsigned char ov7431_set_exposure(unsigned char time);

//#######################################################################
//# set AGC/AEC (0=manual / 1=auto)					#
//#######################################################################
unsigned char ov7431_set_mode(unsigned char mode);

//#######################################################################
//# default init for OV7431						#
//#######################################################################
unsigned char ov7431_init(void);

//#######################################################################
//# enable (configure)							#
//#									#
//#	dgain:	1 / 2 / 4						#
//#	gain:	0 (0,5) / 1 / 2 / 4					#
//#	sens:	1 / 3 (1/3)						#
//#	it:	50 / 100 / 200 / 400 ms					#
//#									#
//#######################################################################
unsigned char veml3328_config(char dgain, char gain, char sens, int it);

//#######################################################################
//# ckeck presence of device (should be 0x28)				#
//#######################################################################
unsigned char veml3328_get_id(void);

//#######################################################################
//# start single measurement cycle					#
//#######################################################################
unsigned char veml3328_start(void);

//#######################################################################
//# ckeck status of conversion						#
//#									#
//#	0 = ready							#
//#	1 = busy							#
//#									#
//#######################################################################
unsigned char veml3328_check(void);

//#######################################################################
//# get 16 bit unsigned color values					#
//#									#
//#	[0] = red							#
//#	[1] = green							#
//#	[2] = blue							#
//#	[3] = clear							#
//#	[4] = IR							#
//#									#
//#######################################################################
unsigned char veml3328_read(unsigned short *ptr);

//#######################################################################
//# set sensor to power-down						#
//#######################################################################
unsigned char veml3328_disable(void);

extern volatile unsigned char unilib_matrix_c57_data[16];

//#######################################################################
//#									#
//#	init 7x5 red/green matrix (landscape)				#
//#									#
//#	row_port	= pport with ROW signals			#
//#	red_port	= pport with RED COLUMN signals			#
//#	green_port	= pport with GREEN COLUMN signals		#
//#	polarity	= bit0=ROW, bit1=COL				#
//#									#
//#######################################################################
void matrix_c57_init(PORT_TYPE row_port,PORT_TYPE red_port,PORT_TYPE green_port,char polarity);

//#######################################################################
//#									#
//#	brightness control						#
//#									#
//#	bright	= 1..4							#
//#									#
//#######################################################################
void matrix_c57_bright(char bright);

//#######################################################################
//#									#
//#	plot into 7x5 red/green matrix 					#
//#									#
//#	x		= X coordinate (0..7)				#
//#	y		= Y coordinate (0..7)				#
//#	color:								#
//#	0		= black						#
//#	1		= red						#
//#	2		= green						#
//#	3		= yellow					#
//#									#
//#######################################################################
void matrix_c57_plot(char x,char y,char color);

//#######################################################################
//#									#
//#	draw 7x5 red/green matrix from flash (landscape)		#
//#									#
//#######################################################################
void matrix_c57_romimage(FDATA_TYPE unsigned char *data);

//#######################################################################
//#									#
//#	draw 7x5 red/green matrix from ram (landscape)			#
//#									#
//#######################################################################
void matrix_c57_ramimage(unsigned char data[35]);

//#######################################################################
//#									#
//#	scroll				 				#
//#	dir:								#
//#	0		= up						#
//#	1		= right						#
//#	2		= down						#
//#	3		= left						#
//#	shift in color:							#
//#	0		= off						#
//#	1		= one						#
//#									#
//#######################################################################
void matrix_c57_scroll(char dir,char color);

//#######################################################################
//#									#
//#	service	routine (per row, should be > 16KHz)			#
//#	rows high active, cols high_active, msb first			#
//#									#
//#######################################################################
void serve_matrix_c57_hh(void);

//#######################################################################
//#									#
//#	service	routine (per row, should be > 16KHz)			#
//#	rows high active, cols high_active, lsb first			#
//#									#
//#######################################################################
void serve_matrix_c57_hh_mirrored(void);

//#######################################################################
//#									#
//#	service	routine (per row, should be > 16KHz)			#
//#	rows high active, cols high_active, msb first			#
//#									#
//#######################################################################
void serve_matrix_c57_hl(void);

//#######################################################################
//#									#
//#	service	routine (per row, should be > 16KHz)			#
//#	rows high active, cols high_active, lsb first			#
//#									#
//#######################################################################
void serve_matrix_c57_hl_mirrored(void);

//#######################################################################
//#									#
//#	service	routine (per row, should be > 16KHz)			#
//#	rows high active, cols high_active, msb first			#
//#									#
//#######################################################################
void serve_matrix_c57_lh(void);

//#######################################################################
//#									#
//#	service	routine (per row, should be > 16KHz)			#
//#	rows high active, cols high_active, lsb first			#
//#									#
//#######################################################################
void serve_matrix_c57_lh_mirrored(void);

//#######################################################################
//#									#
//#	service	routine (per row, should be > 16KHz)			#
//#	rows high active, cols high_active, msb first			#
//#									#
//#######################################################################
void serve_matrix_c57_ll(void);

//#######################################################################
//#									#
//#	service	routine (per row, should be > 16KHz)			#
//#	rows high active, cols high_active, lsb first			#
//#									#
//#######################################################################
void serve_matrix_c57_ll_mirrored(void);

extern volatile unsigned char unilib_matrix_c75_data[16];

//#######################################################################
//#									#
//#	init 7x5 red/green matrix 					#
//#									#
//#	row_port	= pport with ROW signals			#
//#	red_port	= pport with RED COLUMN signals			#
//#	green_port	= pport with GREEN COLUMN signals		#
//#	polarity	= bit0=ROW, bit1=COL				#
//#									#
//#######################################################################
void matrix_c75_init(PORT_TYPE row_port,PORT_TYPE red_port,PORT_TYPE green_port,char polarity);

//#######################################################################
//#									#
//#	brightness control 						#
//#									#
//#	bright	= 1..4							#
//#									#
//#######################################################################
void matrix_c75_bright(char bright);

//#######################################################################
//#									#
//#	plot into 7x5 red/green matrix 					#
//#									#
//#	x		= X coordinate (0..7)				#
//#	y		= Y coordinate (0..7)				#
//#	color:								#
//#	0		= black						#
//#	1		= red						#
//#	2		= green						#
//#	3		= yellow					#
//#									#
//#######################################################################
void matrix_c75_plot(char x,char y,char color);

//#######################################################################
//#									#
//#	draw 7x5 red/green matrix from flash				#
//#									#
//#######################################################################
void matrix_c75_romimage(FDATA_TYPE unsigned char *data);

//#######################################################################
//#									#
//#	draw 7x5 red/green matrix from ram				#
//#									#
//#######################################################################
void matrix_c75_ramimage(unsigned char data[35]);

//#######################################################################
//#									#
//#	scroll				 				#
//#	dir:								#
//#	0		= up						#
//#	1		= right						#
//#	2		= down						#
//#	3		= left						#
//#	shift in color:							#
//#	0		= off						#
//#	1		= one						#
//#									#
//#######################################################################
void matrix_c75_scroll(char dir,char color);

//#######################################################################
//#									#
//#	service	routine (per row, should be > 16KHz)			#
//#	rows high active, cols high_active, msb first			#
//#									#
//#######################################################################
void serve_matrix_c75_hh(void);

//#######################################################################
//#									#
//#	service	routine (per row, should be > 16KHz)			#
//#	rows high active, cols high_active, lsb first			#
//#									#
//#######################################################################
void serve_matrix_c75_hh_mirrored(void);

//#######################################################################
//#									#
//#	service	routine (per row, should be > 16KHz)			#
//#	rows high active, cols high_active, msb first			#
//#									#
//#######################################################################
void serve_matrix_c75_hl(void);

//#######################################################################
//#									#
//#	service	routine (per row, should be > 16KHz)			#
//#	rows high active, cols high_active, lsb first			#
//#									#
//#######################################################################
void serve_matrix_c75_hl_mirrored(void);

//#######################################################################
//#									#
//#	service	routine (per row, should be > 16KHz)			#
//#	rows high active, cols high_active, msb first			#
//#									#
//#######################################################################
void serve_matrix_c75_lh(void);

//#######################################################################
//#									#
//#	service	routine (per row, should be > 16KHz)			#
//#	rows high active, cols high_active, lsb first			#
//#									#
//#######################################################################
void serve_matrix_c75_lh_mirrored(void);

//#######################################################################
//#									#
//#	service	routine (per row, should be > 16KHz)			#
//#	rows high active, cols high_active, msb first			#
//#									#
//#######################################################################
void serve_matrix_c75_ll(void);

//#######################################################################
//#									#
//#	service	routine (per row, should be > 16KHz)			#
//#	rows high active, cols high_active, lsb first			#
//#									#
//#######################################################################
void serve_matrix_c75_ll_mirrored(void);

extern volatile unsigned char unilib_matrix_g16_data[48];

//#######################################################################
//#									#
//#	init 8x16 greyscale matrix 					#
//#									#
//#	row_port	= pport with ROW signals			#
//#	col1_port	= pport with COLUMN signals (left)		#
//#	col2_port	= pport with COLUMN signals (right)		#
//#	num_rows	= rows to serve (1..8)				#
//#	polarity	= bit0=ROW, bit1=COL				#
//#									#
//#######################################################################
void matrix_g16_init(PORT_TYPE row_port,PORT_TYPE col1_port,PORT_TYPE col2_port,char num_rows,char polarity);

//#######################################################################
//#									#
//#	plot into 8x16 greyscale matrix 				#
//#									#
//#	x		= X coordinate (0..15)				#
//#	y		= Y coordinate (0..7)				#
//#	color		= brightness (0..3)				#
//#									#
//#######################################################################
void matrix_g16_plot(char x,char y,char color);

//#######################################################################
//#									#
//#	write two chars			 				#
//#									#
//#	x		= X coordinate (0..7)				#
//#	y		= Y coordinate (0..7)				#
//#	color		= brightness (0..3)				#
//#	side		= 0 (left) / 1 (right)				#
//#									#
//#######################################################################
void matrix_g16_text(char c1,char c2,char color,char side);

//#######################################################################
//#									#
//#	scroll				 				#
//#	dir:								#
//#	0		= up						#
//#	1		= right						#
//#	2		= down						#
//#	3		= left						#
//#	shift in color:							#
//#	0..3		= brightness					#
//#									#
//#######################################################################
void matrix_g16_scroll(char dir,char color);

//#######################################################################
//#									#
//#	service	routine (per row, should be > 16KHz)			#
//#	rows high active, columns high active, msb left			#
//#									#
//#######################################################################
void serve_matrix_g16_hh(void);

//#######################################################################
//#									#
//#	service	routine (per row, should be > 16KHz)			#
//#	rows high active, columns high active, lsb left			#
//#									#
//#######################################################################
void serve_matrix_g16_hh_mirrored(void);

//#######################################################################
//#									#
//#	service	routine (per row, should be > 16KHz)			#
//#	rows high active, columns low active, msb left			#
//#									#
//#######################################################################
void serve_matrix_g16_hl(void);

//#######################################################################
//#									#
//#	service	routine (per row, should be > 16KHz)			#
//#	rows high active, columns low active, lsb left			#
//#									#
//#######################################################################
void serve_matrix_g16_hl_mirrored(void);

//#######################################################################
//#									#
//#	service	routine (per row, should be > 16KHz)			#
//#	rows low active, columns high active, msb left			#
//#									#
//#######################################################################
void serve_matrix_g16_lh(void);

//#######################################################################
//#									#
//#	service	routine (per row, should be > 16KHz)			#
//#	rows low active, columns high active, lsb left			#
//#									#
//#######################################################################
void serve_matrix_g16_lh_mirrored(void);

//#######################################################################
//#									#
//#	service	routine (per row, should be > 16KHz)			#
//#	rows low active, columns low active, msb left			#
//#									#
//#######################################################################
void serve_matrix_g16_ll(void);

//#######################################################################
//#									#
//#	service	routine (per row, should be > 16KHz)			#
//#	rows low active, columns low active, lsb left			#
//#									#
//#######################################################################
void serve_matrix_g16_ll_mirrored(void);

//#######################################################################
//#									#
//#	service	routine (per row, should be > 16KHz)			#
//#	rows high active, columns high active, msb left			#
//#									#
//#######################################################################
void serve_matrix_g16a_hh(void);

//#######################################################################
//#									#
//#	service	routine (per row, should be > 16KHz)			#
//#	rows high active, columns high active, lsb left			#
//#									#
//#######################################################################
void serve_matrix_g16a_hhm(void);

//#######################################################################
//#									#
//#	service	routine (per row, should be > 16KHz)			#
//#	rows high active, columns low active, msb left			#
//#									#
//#######################################################################
void serve_matrix_g16a_hl(void);

//#######################################################################
//#									#
//#	service	routine (per row, should be > 16KHz)			#
//#	rows high active, columns low active, lsb left			#
//#									#
//#######################################################################
void serve_matrix_g16a_hlm(void);

//#######################################################################
//#									#
//#	service	routine (per row, should be > 16KHz)			#
//#	rows low active, columns high active, msb left			#
//#									#
//#######################################################################
void serve_matrix_g16a_lh(void);

//#######################################################################
//#									#
//#	service	routine (per row, should be > 16KHz)			#
//#	rows low active, columns high active, lsb left			#
//#									#
//#######################################################################
void serve_matrix_g16a_lhm(void);

//#######################################################################
//#									#
//#	service	routine (per row, should be > 16KHz)			#
//#	rows low active, columns low active, msb left			#
//#									#
//#######################################################################
void serve_matrix_g16a_ll(void);

//#######################################################################
//#									#
//#	service	routine (per row, should be > 16KHz)			#
//#	rows low active, columns low active, lsb left			#
//#									#
//#######################################################################
void serve_matrix_g16a_llm(void);

extern volatile unsigned char unilib_matrix_g8_data[24];

//#######################################################################
//#									#
//#	init 8x8 greyscale matrix 					#
//#									#
//#	row_port	= pport with ROW signals			#
//#	col1_port	= pport with COLUMN signals			#
//#	num_rows	= rows to serve (1..8)				#
//#	polarity	= bit0=COLS, bit1=ROWS, 0=low_act		#
//#									#
//#######################################################################
void matrix_g8_init(PORT_TYPE row_port,PORT_TYPE col1_port,char num_rows,char polarity);

//#######################################################################
//#									#
//#	plot into 8x8 greyscale matrix 					#
//#									#
//#	x		= X coordinate (0..7)				#
//#	y		= Y coordinate (0..7)				#
//#	color		= brightness (0..3)				#
//#									#
//#######################################################################
void matrix_g8_plot(char x,char y,char color);

//#######################################################################
//#									#
//#	write two chars			 				#
//#									#
//#	x		= X coordinate (0..7)				#
//#	y		= Y coordinate (0..7)				#
//#	color		= brightness (0..3)				#
//#									#
//#######################################################################
void matrix_g8_text(char c1,char c2,char color);

//#######################################################################
//#									#
//#	scroll				 				#
//#	dir:								#
//#	0		= up						#
//#	1		= right						#
//#	2		= down						#
//#	3		= left						#
//#	shift in color:							#
//#	0		= off						#
//#	1		= one						#
//#									#
//#######################################################################
void matrix_g8_scroll(char dir,char color);

//#######################################################################
//#									#
//#	service	routine (per row, should be > 16KHz)			#
//#	rows high active, columns high active, msb left			#
//#									#
//#######################################################################
void serve_matrix_g8_hh(void);

//#######################################################################
//#									#
//#	service	routine (per row, should be > 16KHz)			#
//#	rows high active, columns high active, lsb left			#
//#									#
//#######################################################################
void serve_matrix_g8_hh_mirrored(void);

//#######################################################################
//#									#
//#	service	routine (per row, should be > 16KHz)			#
//#	rows high active, columns low active, msb left			#
//#									#
//#######################################################################
void serve_matrix_g8_hl(void);

//#######################################################################
//#									#
//#	service	routine (per row, should be > 16KHz)			#
//#	rows high active, columns low active, lsb left			#
//#									#
//#######################################################################
void serve_matrix_g8_hl_mirrored(void);

//#######################################################################
//#									#
//#	service	routine (per row, should be > 16KHz)			#
//#	rows low active, columns high active, msb left			#
//#									#
//#######################################################################
void serve_matrix_g8_lh(void);

//#######################################################################
//#									#
//#	service	routine (per row, should be > 16KHz)			#
//#	rows low active, columns high active, lsb left			#
//#									#
//#######################################################################
void serve_matrix_g8_lh_mirrored(void);

//#######################################################################
//#									#
//#	service	routine (per row, should be > 16KHz)			#
//#	rows low active, columns low active, msb left			#
//#									#
//#######################################################################
void serve_matrix_g8_ll(void);

//#######################################################################
//#									#
//#	service	routine (per row, should be > 16KHz)			#
//#	rows low active, columns low active, lsb left			#
//#									#
//#######################################################################
void serve_matrix_g8_ll_mirrored(void);

//#######################################################################
//#									#
//#	service	routine (per row, should be > 16KHz)			#
//#	rows high active, columns high active, msb left			#
//#									#
//#######################################################################
void serve_matrix_g8a_hh(void);

//#######################################################################
//#									#
//#	service	routine (per row, should be > 16KHz)			#
//#	rows high active, columns high active, lsb left			#
//#									#
//#######################################################################
void serve_matrix_g8a_hhm(void);

//#######################################################################
//#									#
//#	service	routine (per row, should be > 16KHz)			#
//#	rows high active, columns low active, msb left			#
//#									#
//#######################################################################
void serve_matrix_g8a_hl(void);

//#######################################################################
//#									#
//#	service	routine (per row, should be > 16KHz)			#
//#	rows high active, columns low active, lsb left			#
//#									#
//#######################################################################
void serve_matrix_g8a_hlm(void);

//#######################################################################
//#									#
//#	service	routine (per row, should be > 16KHz)			#
//#	rows low active, columns high active, msb left			#
//#									#
//#######################################################################
void serve_matrix_g8a_lh(void);

//#######################################################################
//#									#
//#	service	routine (per row, should be > 16KHz)			#
//#	rows low active, columns high active, lsb left			#
//#									#
//#######################################################################
void serve_matrix_g8a_lhm(void);

//#######################################################################
//#									#
//#	service	routine (per row, should be > 16KHz)			#
//#	rows low active, columns low active, msb left			#
//#									#
//#######################################################################
void serve_matrix_g8a_ll(void);

//#######################################################################
//#									#
//#	service	routine (per row, should be > 16KHz)			#
//#	rows low active, columns low active, lsb left			#
//#									#
//#######################################################################
void serve_matrix_g8a_llm(void);

extern volatile unsigned char unilib_matrix_m16_data[16];

//#######################################################################
//#									#
//#	init 8x16 monochrome matrix 					#
//#									#
//#	row_port	= pport with ROW signals			#
//#	col1_port	= pport with COLUMN signals (left)		#
//#	col2_port	= pport with COLUMN signals (right)		#
//#	num_rows	= rows to serve (1..8)				#
//#	polarity	= bit0=ROW, bit1=COL				#
//#									#
//#######################################################################
void matrix_m16_init(PORT_TYPE row_port,PORT_TYPE col1_port,PORT_TYPE col2_port,char num_rows,char polarity);

//#######################################################################
//#									#
//#	brightness control						#
//#									#
//#	bright	= 1..4							#
//#									#
//#######################################################################
void matrix_m16_bright(char bright);

//#######################################################################
//#									#
//#	plot into 8x8 monochrome matrix 				#
//#									#
//#	x		= X coordinate (0..7)				#
//#	y		= Y coordinate (0..7)				#
//#	color:								#
//#	0		= set dark					#
//#	1		= set bright					#
//#	2...		= toggle					#
//#									#
//#######################################################################
void matrix_m16_plot(char x,char y,char color);

//#######################################################################
//#									#
//#	write two chars			 				#
//#									#
//#	c1		= left char					#
//#	c2		= right char					#
//#	side		= side (0=left, 1=right)			#
//#	color:								#
//#	0		= inverse					#
//#	1		= normal					#
//#	2...		= toggle					#
//#									#
//#######################################################################
void matrix_m16_text(char c1,char c2,char side,char color);

//#######################################################################
//#									#
//#	scroll				 				#
//#	dir:								#
//#	0		= up						#
//#	1		= right						#
//#	2		= down						#
//#	3		= left						#
//#	shift in color:							#
//#	0		= off						#
//#	1		= one						#
//#									#
//#######################################################################
void matrix_m16_scroll(char dir,char color);

//#######################################################################
//#									#
//#	service	routine (per row, should be > 16KHz)			#
//#	rows high active, cols high_active, msb first			#
//#									#
//#######################################################################
void serve_matrix_m16_hh(void);

//#######################################################################
//#									#
//#	service	routine (per row, should be > 16KHz)			#
//#	rows high active, cols high_active, lsb first			#
//#									#
//#######################################################################
void serve_matrix_m16_hh_mirrored(void);

//#######################################################################
//#									#
//#	service	routine (per row, should be > 16KHz)			#
//#	rows high active, cols low_active, msb first			#
//#									#
//#######################################################################
void serve_matrix_m16_hl(void);

//#######################################################################
//#									#
//#	service	routine (per row, should be > 16KHz)			#
//#	rows high active, cols low_active, lsb first			#
//#									#
//#######################################################################
void serve_matrix_m16_hl_mirrored(void);

//#######################################################################
//#									#
//#	service	routine (per row, should be > 16KHz)			#
//#	rows low active, cols high_active, msb first			#
//#									#
//#######################################################################
void serve_matrix_m16_lh(void);

//#######################################################################
//#									#
//#	service	routine (per row, should be > 16KHz)			#
//#	rows low active, cols high_active, lsb first			#
//#									#
//#######################################################################
void serve_matrix_m16_lh_mirrored(void);

//#######################################################################
//#									#
//#	service	routine (per row, should be > 500Hz)			#
//#	rows low active, cols low_active, msb left			#
//#									#
//#######################################################################
void serve_matrix_m16_ll(void);

//#######################################################################
//#									#
//#	service	routine (per row, should be > 500Hz)			#
//#	rows low active, cols low_active, lsb left			#
//#									#
//#######################################################################
void serve_matrix_m16_ll_mirrored(void);

extern volatile unsigned char unilib_matrix_m8_data[8];

//#######################################################################
//#									#
//#	init 8x8 monochrome matrix 					#
//#									#
//#	row_port	= pport with ROW signals			#
//#	col1_port	= pport with COLUMN signals			#
//#	num_rows	= rows to serve (1..8)				#
//#	polarity	= bit0=ROW, bit1=COL 0=low active		#
//#									#
//#######################################################################
void matrix_m8_init(PORT_TYPE row_port,PORT_TYPE col1_port,char num_rows, char polarity);

//#######################################################################
//#									#
//#	brightness control			 			#
//#									#
//#	bright	= 1..4							#
//#									#
//#######################################################################
void matrix_m8_bright(char bright);

//#######################################################################
//#									#
//#	plot into 8x8 monochrome matrix 				#
//#									#
//#	x		= X coordinate (0..7)				#
//#	y		= Y coordinate (0..7)				#
//#	color:								#
//#	0		= set dark					#
//#	1		= set bright					#
//#	2...		= toggle					#
//#									#
//#######################################################################
void matrix_m8_plot(char x,char y,char color);

//#######################################################################
//#									#
//#	write two chars			 				#
//#									#
//#	x		= X coordinate (0..7)				#
//#	y		= Y coordinate (0..7)				#
//#	color:								#
//#	0		= inverse					#
//#	1		= normal					#
//#	2...		= toggle					#
//#									#
//#######################################################################
void matrix_m8_text(char c1,char c2,char color);

//#######################################################################
//#									#
//#	scroll				 				#
//#	dir:								#
//#	0		= up						#
//#	1		= right						#
//#	2		= down						#
//#	3		= left						#
//#	shift in color:							#
//#	0		= off						#
//#	1		= one						#
//#									#
//#######################################################################
void matrix_m8_scroll(char dir,char color);

//#######################################################################
//#									#
//#	service	routine (per row, should be > 16KHz)			#
//#	rows high active, cols high_active, msb first			#
//#									#
//#######################################################################
void serve_matrix_m8_hh(void);

//#######################################################################
//#									#
//#	service	routine (per row, should be > 16KHz)			#
//#	rows high active, cols high_active, lsb first			#
//#									#
//#######################################################################
void serve_matrix_m8_hh_mirrored(void);

//#######################################################################
//#									#
//#	service	routine (per row, should be > 500Hz)			#
//#	rows high active, cols low_active, msb first			#
//#									#
//#######################################################################
void serve_matrix_m8_hl(void);

//#######################################################################
//#									#
//#	service	routine (per row, should be > 500Hz)			#
//#	rows high active, cols low_active, lsb first			#
//#									#
//#######################################################################
void serve_matrix_m8_hl_mirrored(void);

//#######################################################################
//#									#
//#	service	routine (per row, should be > 16KHz)			#
//#	rows low active, cols high_active, msb first			#
//#									#
//#######################################################################
void serve_matrix_m8_lh(void);

//#######################################################################
//#									#
//#	service	routine (per row, should be > 16KHz)			#
//#	rows low active, cols high_active, lsb first			#
//#									#
//#######################################################################
void serve_matrix_m8_lh_mirrored(void);

//#######################################################################
//#									#
//#	service	routine (per row, should be > 16KHz)			#
//#	rows low active, cols low_active, msb left			#
//#									#
//#######################################################################
void serve_matrix_m8_ll(void);

//#######################################################################
//#									#
//#	service	routine (per row, should be > 16KHz)			#
//#	rows low active, cols low_active, lsb left			#
//#									#
//#######################################################################
void serve_matrix_m8_ll_mirrored(void);

//#######################################################################
//#									#
//#	enable stepper (unipolar mode)					#
//#									#
//#######################################################################
void stepper_enable(int stepper,PORT_TYPE port,int pina,int pinb,int pinc,int pind);

//#######################################################################
//#									#
//#	reset stepper							#
//#									#
//#######################################################################
void stepper_reset(int stepper);

//#######################################################################
//#									#
//#	move stepper							#
//#									#
//#######################################################################
void stepper_move(int stepper,int stepper_steps,int stepper_scale);

//#######################################################################
//#									#
//#	wait for move end						#
//#									#
//#######################################################################
void stepper_wait(void);

//#######################################################################
//#									#
//#	check stepper (1=move0, 2=move1)				#
//#									#
//#######################################################################
int stepper_check(void);

//#######################################################################
//#									#
//#	this must be called periodicly (in interrupt)			#
//#									#
//#######################################################################
void serve_stepper(void);

//#######################################################################
//#									#
//#	init ENC							#
//#									#
//#######################################################################
int enc28j60_init(unsigned char spi_port,int prescaler,PORT_TYPE sel_port,int sel_pin);

//#######################################################################
//#									#
//#	get a packet							#
//#									#
//#######################################################################
int enc28j60_receive_packet(unsigned char buffer[]);

//#######################################################################
//#									#
//#	send a packet							#
//#									#
//#######################################################################
int enc28j60_send_packet(unsigned char buffer[],int frame_length);

//#######################################################################
//#									#
//#	init lfsr default						#
//#									#
//#######################################################################
void lfsr_init_default(void);

//#######################################################################
//#									#
//#	init lfsr custom						#
//#									#
//#######################################################################
void lfsr_init_custom(unsigned long val32, unsigned long val31);

//#######################################################################
//#									#
//#	init status with random data from ADC				#
//#	resolution in bits to determine LSB				#
//#									#
//#######################################################################
void lfsr_init_adc(int channel, int resolution);

//#######################################################################
//#									#
//#	init status with random data from ring oscillator		#
//#									#
//#######################################################################
void lfsr_init_pin(PORT_TYPE cport, int cpin, long wait);

//#######################################################################
//#									#
//#	get random value						#
//#									#
//#######################################################################
unsigned long lfsr_get_random(void);

//#######################################################################
//#									#
//#	init status with random data from ADC				#
//#	resolution in bits to determine LSB				#
//#									#
//#######################################################################
void well1024_init_adc(int channel, int resolution);

//#######################################################################
//#									#
//#	init status with random data from ring oscillator		#
//#									#
//#######################################################################
void well1024_init_pin(PORT_TYPE cport, int cpin, long wait);

//#######################################################################
//#									#
//#	get random value						#
//#									#
//#######################################################################
unsigned long well1024_get();

//#######################################################################
//#									#
//#	init status with random data from ADC				#
//#	resolution in bits to determine LSB				#
//#									#
//#######################################################################
void well512_init_adc(int channel, int resolution);

//#######################################################################
//#									#
//#	init status with random data from ring oscillator		#
//#									#
//#######################################################################
void well512_init_pin(PORT_TYPE cport, int cpin, long wait);

//#######################################################################
//#									#
//#	get random value						#
//#									#
//#######################################################################
unsigned long well512_get();

//#######################################################################
//# init the avr							#
//# method=0 (FIXED TIME)						#
//# method=1 (POLLING)							#
//# 0 = OK        -1 = FAULT						#
//#######################################################################
int avrprog_init(PORT_TYPE rst_port, unsigned char rst_pin, unsigned char method);

//#######################################################################
//# exit the avr programming						#
//#######################################################################
void avrprog_exit(void);

//#######################################################################
//# get the ID								#
//# 0x00AABBCC								#
//#######################################################################
unsigned long avrprog_getid(void);

//#######################################################################
//# get the low Fuse							#
//# 0xnn								#
//#######################################################################
unsigned char avrprog_get_lf(void);

//#######################################################################
//# get the high Fuse							#
//# 0xnn								#
//#######################################################################
unsigned char avrprog_get_hf(void);

//#######################################################################
//# get the extended Fuse						#
//# 0xnn								#
//#######################################################################
unsigned char avrprog_get_ef(void);

//#######################################################################
//# get the calibration byte						#
//# 0xnn								#
//#######################################################################
unsigned char avrprog_get_cal(void);

//#######################################################################
//# get the lock bits							#
//# 0xnn								#
//#######################################################################
unsigned char avrprog_get_lock(void);

//#######################################################################
//# erase the avr							#
//# 0 = OK        -1 = TIMEOUT						#
//#######################################################################
int avrprog_erase(void);

//#######################################################################
//# write the low Fuse							#
//# 0xnn								#
//#######################################################################
void avrprog_write_lf(unsigned char fuse);

//#######################################################################
//# write the high Fuse							#
//# 0xnn								#
//#######################################################################
void avrprog_write_hf(unsigned char fuse);

//#######################################################################
//# write the extended Fuse						#
//# 0xnn								#
//#######################################################################
void avrprog_write_ef(unsigned char fuse);

//#######################################################################
//# write the lock bits							#
//# 0xnn								#
//#######################################################################
void avrprog_write_lock(unsigned char lockbits);

//#######################################################################
//# write extended address byte						#
//# 0xnn								#
//#######################################################################
void avrprog_ext_addr(unsigned char eaddr);

//#######################################################################
//# program flash page							#
//# 0 = OK        -1 = TIMEOUT						#
//#######################################################################
int avrprog_fprog(unsigned short addr, int words, unsigned char* data);

//#######################################################################
//# read flash								#
//#######################################################################
void avrprog_fread(unsigned short addr, int words, unsigned char* data);

//#######################################################################
//# program eeprom page							#
//# 0 = OK        -1 = TIMEOUT						#
//#######################################################################
int avrprog_eprog(unsigned short addr,  unsigned char* data);

//#######################################################################
//# read eeprom								#
//#######################################################################
void avrprog_eread(unsigned short addr, int bytes, unsigned char* data);

//#######################################################################
//# init the jtag port							#
//# PORTx4		TMS						#
//# PORTx5		TCK						#
//# PORTx6		TDI						#
//# PORTx7		TDO						#
//#######################################################################
void jtag47_init(PORT_TYPE jtag_port);

//#######################################################################
//# do IR SCAN (1-32 bits)						#
//#######################################################################
void jtag47_irscan(unsigned long data, unsigned char len);

//#######################################################################
//# do DR SCAN (1-65536 bits), only write				#
//#######################################################################
void jtag47_drscan(unsigned char *data, long len);

//#######################################################################
//# do DR SCAN (1... bits), read+write					#
//#######################################################################
void jtag47_drscan_rw(unsigned char *rdata, unsigned char *wdata, long len);

//#define CC2500_PKT_BYTES 	33		// packet size 
//#######################################################################
//# set cs pin								#
//#######################################################################
void CC2500_select(PORT_TYPE cs_port, unsigned char cs_pin);

//#######################################################################
//# init the CC2500 without communication setup				#
//#######################################################################
void CC2500_init_minimal(void);

//#######################################################################
//# init the CC2500 (250Kbit/s, compatibility mode with CC2541)		#
//#######################################################################
void CC2500_init_250k(PORT_TYPE cs_port, unsigned char cs_pin);

//#######################################################################
//# init the CC2500 (50Kbit/s)						#
//#######################################################################
void CC2500_init_50k(PORT_TYPE cs_port, unsigned char cs_pin);

//#######################################################################
//# init the CC2500 (2400 Bit/s)					#
//#######################################################################
void CC2500_init_2k4(PORT_TYPE cs_port, unsigned char cs_pin);

//#######################################################################
//# send a packet							#
//#######################################################################
void CC2500_start_tx(unsigned char *txBuffer,unsigned char len,unsigned char addr);

//#######################################################################
//# start RX								#
//#######################################################################
void CC2500_start_rx(unsigned char len,unsigned char addr);

//#######################################################################
//# read a received packet						#
//#######################################################################
void CC2500_get_rxdata(unsigned char *rxBuffer,unsigned char len);

//#######################################################################
//#######################################################################
unsigned char CC2500_get_state(void);

//#######################################################################
//# set channel								#
//#######################################################################
void CC2500_set_channel(unsigned char channel);

//#######################################################################
//# get RSSI								#
//#######################################################################
unsigned char CC2500_get_rssi(void);

//#######################################################################
//# get partnumber							#
//#######################################################################
unsigned short CC2500_get_info(void);

//#######################################################################
//# goto IDLE mode							#
//#######################################################################
void CC2500_idle(void);

//#######################################################################
//# calibrate								#
//#######################################################################
void CC2500_calibrate(void);

//#######################################################################
//# detune								#
//#######################################################################
void CC2500_detune(unsigned long freq);

//#######################################################################
//# get calibration data						#
//#######################################################################
unsigned long CC2500_get_calibration(void);

//#######################################################################
//# set calibration data						#
//#######################################################################
void CC2500_set_calibration(unsigned long cal_val);

//#######################################################################
//# st into power down mode						#
//#######################################################################
void CC2500_sleep(void);

//#######################################################################
//# init the MFRC522 							#
//#######################################################################
void mfrc522_init(PORT_TYPE cs_port, unsigned char cs_pin,PORT_TYPE rst_port, unsigned char rst_pin);

//#######################################################################
//# disable the MFRC522							#
//#######################################################################
void mfrc522_disable(void);

//#######################################################################
//# get version of MFRC522						#
//#######################################################################
unsigned char mfrc522_get_version(void);

//#######################################################################
//# set auth key							#
//#######################################################################
void mfrc522_set_key(unsigned char k0,unsigned char k1,unsigned char k2,unsigned char k3,unsigned char k4,unsigned char k5);

//#######################################################################
//# reset auth key							#
//#######################################################################
void mfrc522_reset_key(void);

//#######################################################################
//# end communicate with this card					#
//#######################################################################
void mfrc522_end(void);

//#######################################################################
//# check if a new card is present					#
//# 									#
//# result:	0 = Card found						#
//# 		3 = Timeout						#
//# 		>0  other errors					#
//# 									#
//#######################################################################
unsigned char mfrc522_check_new_card(void);

//#######################################################################
//# getUID of the card							#
//# 									#
//# result:	0 = OK							#
//# 		3 = Timeout						#
//# 		>0  other errors					#
//#		FF  not supported card					#
//# 									#
//# uid[0]:	number of bytes						#
//# uid[1..10]	uid data bytes						#
//# uid[11]:	SAK							#
//# 									#
//#######################################################################
unsigned char mfrc522_get_uid(unsigned char *uid);

//#######################################################################
//# read a block from mifare card					#
//# 									#
//# result:	0 = OK							#
//# 		1 = ERROR						#
//# 		2 = Collision						#
//# 		3 = Timeout						#
//# 		>3  other errors					#
//#		FE  address out of bound				#
//#		FF  not supported card					#
//# 									#
//#######################################################################
unsigned char mfrc522_mifare_read_block(unsigned char block,unsigned char *buffer);

//#######################################################################
//# read a sector from mifare card					#
//# 									#
//# result:	0 = OK							#
//# 		1 = ERROR						#
//# 		2 = Collision						#
//# 		3 = Timeout						#
//# 		>3  other errors					#
//#		FE  address out of bound				#
//#		FF  not supported card					#
//# 									#
//#######################################################################
unsigned char mfrc522_mifare_read_sector(unsigned char sector,unsigned char *buffer);

//#######################################################################
//# write a block to mifare card					#
//# 									#
//# result:	0 = OK							#
//# 		1 = ERROR						#
//# 		2 = Collision						#
//# 		3 = Timeout						#
//# 		>3  other errors					#
//#		FE  address out of bound				#
//#		FF  not supported card					#
//# 									#
//#######################################################################
unsigned char mfrc522_mifare_write_block(unsigned char block,unsigned char *buffer);

//#######################################################################
//# write a sector to mifare card					#
//# 									#
//# result:	0 = OK							#
//# 		1 = ERROR						#
//# 		2 = Collision						#
//# 		3 = Timeout						#
//# 		>3  other errors					#
//#		FE  address out of bound				#
//#		FF  not supported card					#
//# 									#
//#######################################################################
unsigned char mfrc522_mifare_write_sector(unsigned char sector,unsigned char *buffer);

//#######################################################################
//# write KEY A to mifare card						#
//# 									#
//# result:	0 = OK							#
//# 		1 = ERROR						#
//# 		2 = Collision						#
//# 		3 = Timeout						#
//# 		>3  other errors					#
//#		FE  address out of bound				#
//#		FF  not supported card					#
//# 									#
//#######################################################################
unsigned char mfrc522_mifare_lock_sector(unsigned char sector,unsigned char k0,unsigned char k1,unsigned char k2,unsigned char k3,unsigned char k4,unsigned char k5);

//#######################################################################
//# set channel								#
//#######################################################################
void rfm12_set_channel(int channel);

//#######################################################################
//# send a byte								#
//#######################################################################
void rfm12_byte_send(unsigned char data);

//#######################################################################
//# send a hamming coded byte						#
//#######################################################################
void rfm12_hamm_send(unsigned char data);

//#######################################################################
//# reveive a byte							#
//#######################################################################
unsigned char rfm12_byte_recv(void);

//#######################################################################
//# get hamming coded byte						#
//#######################################################################
unsigned char rfm12_hamm_recv(void);

//#######################################################################
//# change the CS pin							#
//#######################################################################
void rfm12_select(PORT_TYPE cs_port, unsigned char cs_pin);

//#######################################################################
//# init the RFM12 (default 869,4MHz)					#
//#######################################################################
void rfm12_init_433(PORT_TYPE cs_port, unsigned char cs_pin);

//#######################################################################
//# init the RFM12 (default 869,4MHz)					#
//#######################################################################
void rfm12_init_868(PORT_TYPE cs_port, unsigned char cs_pin);

//#######################################################################
//# send a packet							#
//#######################################################################
void rfm12_send(unsigned char *txBuffer,unsigned char len,unsigned char addr);

//#######################################################################
//# receive a packet							#
//#######################################################################
unsigned char rfm12_recv(unsigned char *rxBuffer,unsigned char len,unsigned char addr);

//#######################################################################
//# sleep								#
//#######################################################################
void rfm12_sleep(void);

//#######################################################################
//# wakeup								#
//#######################################################################
void rfm12_wakeup(void);

//#######################################################################
//# set channel								#
//#######################################################################
void rfm12b_set_channel(int channel);

//#######################################################################
//# send a byte								#
//#######################################################################
void rfm12b_byte_send(unsigned char data);

//#######################################################################
//# send a hamming coded byte						#
//#######################################################################
void rfm12b_hamm_send(unsigned char data);

//#######################################################################
//# reveive a byte							#
//#######################################################################
unsigned char rfm12b_byte_recv(void);

//#######################################################################
//# get hamming coded byte						#
//#######################################################################
unsigned char rfm12b_hamm_recv(void);

//#######################################################################
//# change the CS pin							#
//#######################################################################
void rfm12b_select(PORT_TYPE cs_port, unsigned char cs_pin);

//#######################################################################
//# init the RFM12B (default 869,4MHz)					#
//#######################################################################
void rfm12b_init(PORT_TYPE cs_port, unsigned char cs_pin);

//#######################################################################
//# send a packet							#
//#######################################################################
void rfm12b_send(unsigned char *txBuffer,unsigned char len,unsigned char addr);

//#######################################################################
//# receive a packet							#
//#######################################################################
unsigned char rfm12b_recv(unsigned char *rxBuffer,unsigned char len,unsigned char addr);

//#######################################################################
//# sleep								#
//#######################################################################
void rfm12b_sleep(void);

//#######################################################################
//# wakeup								#
//#######################################################################
void rfm12b_wakeup(void);

//#######################################################################
//# ckeck presence							#
//#######################################################################
unsigned char st25dv_check(unsigned char devaddr);

//#######################################################################
//# read 4 bytes block					                #
//#######################################################################
int st25dv_read_block(unsigned char devaddr, unsigned char block, unsigned char* data);

//#######################################################################
//# init the mlx90316							#
//#######################################################################
void ST25R3920_init(PORT_TYPE cs_port, unsigned char cs_pin);

//#######################################################################
//# change CS pin							#
//#######################################################################
void ST25R3920_disable(void);

//#######################################################################
//# get angle								#
//#######################################################################
unsigned char ST25R3920_meas_adc(void);

//#######################################################################
//#                                                                     #
//# cosinus table                                                       #
//#                                                                     #
//#######################################################################
extern TAB_TYPE char cos_table[256];

//######################################################################
//#                                                                    #
//# number of bits in byte                                             #
//#                                                                    #
//######################################################################
extern TAB_TYPE unsigned char byte_bitcount[256];

//######################################################################
//#                                                                    #
//# count 1-bits in byte                                               #
//#                                                                    #
//######################################################################
char get_bitcount8(unsigned char x);

//######################################################################
//#                                                                    #
//# count 1-bits in word                                               #
//#                                                                    #
//######################################################################
char get_bitcount16(unsigned short x);

//######################################################################
//#                                                                    #
//# count 1-bits in long                                               #
//#                                                                    #
//######################################################################
char get_bitcount32(unsigned long x);

//#######################################################################
//#                                                                     #
//# (255^2) - (X^2)                                                     #
//#                                                                     #
//#######################################################################
extern TAB_TYPE char csin_table[256];

//######################################################################
//#                                                                    #
//# charset 4x8 (128 chars, 2 lines per byte 7-4/3-0)                  #
//#                                                                    #
//######################################################################
extern TAB_TYPE unsigned char ctable_04_08[512];

//######################################################################
//#                                                                    #
//# charset 6x10  (128 chars, left aligned)                            #
//#                                                                    #
//######################################################################
extern TAB_TYPE unsigned char ctable_06_10[1280];

//######################################################################
//#                                                                    #
//# charset 8x12 (128 chars)                                           #
//#                                                                    #
//######################################################################
extern TAB_TYPE unsigned char ctable_08_12[1536];

//######################################################################
//#                                                                    #
//# charset 12x20 (128 chars)                                          #
//#                                                                    #
//######################################################################
extern TAB_TYPE unsigned char ctable_12_20[5120];

//######################################################################
//#                                                                    #
//# charset 16x24 (48 segment chars)                                   #
//#                                                                    #
//######################################################################
extern TAB_TYPE unsigned char ctable_16_24[2304];

//######################################################################
//#                                                                    #
//# charset 24x32 (104 chars)                                          #
//#                                                                    #
//######################################################################
extern TAB_TYPE unsigned char ctable_24_32[9984];

//#################################################################################
//#                                                                               #
//#  gamma values for LED PWM, 8 bits                                             #
//#                                                                               #
//#################################################################################
extern TAB_TYPE unsigned char led_gamma8[] ;

//######################################################################
//# 8 bit mask array with lsb first
//######################################################################
extern TAB_TYPE unsigned char unilib_mask8l[8];

//######################################################################
//# 8 bit mask array with lsb first (inverted)
//######################################################################
extern TAB_TYPE unsigned char unilib_imask8l[8];

//######################################################################
//# 16 bit mask array with lsb first
//######################################################################
extern TAB_TYPE unsigned short unilib_mask16l[16];

//######################################################################
//# 16 bit mask array with lsb first (inverted)
//######################################################################
extern TAB_TYPE unsigned short unilib_imask16l[16];

//######################################################################
//# 8 bit mask array with msb first
//######################################################################
extern TAB_TYPE unsigned char unilib_mask8m[8];

//######################################################################
//# 8 bit mask array with msb first (inverted)
//######################################################################
extern TAB_TYPE unsigned char unilib_imask8m[8];

//######################################################################
//# 16 bit mask array with msb first
//######################################################################
extern TAB_TYPE unsigned short unilib_mask16m[16];

//######################################################################
//# 16 bit mask array with msb first (inverted)
//######################################################################
extern TAB_TYPE unsigned short unilib_imask16m[16];

//#################################################################################
//# byte mirror table                                                             #
//#################################################################################
extern TAB_TYPE unsigned char mirror_byte_table[256];

//######################################################################
//# even parity table (parity bit is in bit 0)                         #
//######################################################################
extern TAB_TYPE unsigned char parity_even_table[256];

//######################################################################
//# odd parity table (parity bit is in bit 0)                          #
//######################################################################
extern TAB_TYPE unsigned char parity_odd_table[256];

//#######################################################################
//#                                                                     # 
//# segment diigits for GLCD                                            # 
//#                                                                     # 
//# size is 60 lines a 32 pixel                                         # 
//#                                                                     # 
//#######################################################################
extern TAB_TYPE unsigned char ctable_segm32_60[5040];

//#######################################################################
//#                                                                     #
//# sinus table (16 bits)                                               #
//#                                                                     #
//#######################################################################
extern TAB_TYPE short sin16_table[1024];

//#######################################################################
//#                                                                     #
//# sinus table                                                         #
//#                                                                     #
//#######################################################################
extern TAB_TYPE char sin_table[1024];

//#######################################################################
//#                                                                     #
//# sinus table (float)                                                 #
//#                                                                     #
//#######################################################################
extern TAB_TYPE float sinfloat_table[1024];

//######################################################################
//# bit mirror unsigned short
//######################################################################
unsigned short unilib_bitmirror16(unsigned short x);

//######################################################################
//# bit mirror unsigned long
//######################################################################
unsigned long unilib_bitmirror32(unsigned long x);

//#include "unilib_defs.h"
//#######################################################################
//# convert date/time structure to unix stamp				#
//#######################################################################
unsigned char get_max_day(unsigned short year, unsigned char month);

//#######################################################################
//# convert unix timestamp to date/time structure			#
//#######################################################################
void unix2date(unsigned long stamp, unilib_date_time *tr);

//#######################################################################
//# convert date/time structure to unix stamp				#
//#######################################################################
unsigned long date2unix(unilib_date_time *tr);

//#######################################################################
//# ckeck presence							#
//#######################################################################
unsigned char pcf8583_check(unsigned char devaddr);

//#######################################################################
//# read bytes								#
//#######################################################################
unsigned char pcf8583_read(unsigned char *buffer,unsigned char addr, int len, unsigned char devaddr);

//#######################################################################
//# write bytes								#
//#######################################################################
unsigned char pcf8583_write(unsigned char *buffer,unsigned char addr, int len, unsigned char devaddr);

//#######################################################################
//# read seconds							#
//#######################################################################
int pcf8583_get_sec(unsigned char devaddr);

//#######################################################################
//# read minutes							#
//#######################################################################
int pcf8583_get_min(unsigned char devaddr);

//#######################################################################
//# read hour								#
//#######################################################################
int pcf8583_get_hour(unsigned char devaddr);

//#######################################################################
//# read day								#
//#######################################################################
int pcf8583_get_day(unsigned char devaddr);

//#######################################################################
//# read weekday							#
//#######################################################################
int pcf8583_get_wday(unsigned char devaddr);

//#######################################################################
//# read month								#
//#######################################################################
int pcf8583_get_month(unsigned char devaddr);

//#######################################################################
//# read month								#
//#######################################################################
int pcf8583_get_year(unsigned char devaddr);

//#######################################################################
//# set time								#
//#######################################################################
int pcf8583_set_sec(unsigned char devaddr, unsigned char val);

//#######################################################################
//# set minutes								#
//#######################################################################
int pcf8583_set_min(unsigned char devaddr, unsigned char val);

//#######################################################################
//# set hours								#
//#######################################################################
int pcf8583_set_hour(unsigned char devaddr, unsigned char val);

//#######################################################################
//# set day								#
//#######################################################################
int pcf8583_set_day(unsigned char devaddr, unsigned char val);

//#######################################################################
//# set weekday								#
//#######################################################################
int pcf8583_set_wday(unsigned char devaddr, unsigned char val);

//#######################################################################
//# set month								#
//#######################################################################
int pcf8583_set_month(unsigned char devaddr, unsigned char val);

//#######################################################################
//# set year								#
//#######################################################################
int pcf8583_set_year(unsigned char devaddr, unsigned char val);

//#######################################################################
//# init the RTC interface						#
//#######################################################################
void xrtc_init(PORT_TYPE cport,unsigned char cpin,PORT_TYPE dport,unsigned char dpin);

//#######################################################################
//# get current date/time						#
//# param: regnum (0-15)						#
//# result: 32 bit data							#
//#######################################################################
unsigned long xrtc_read_register(unsigned char reg);

//#######################################################################
//# write register value						#
//# param: regnum (0-15), 32 bit data					#
//#######################################################################
void xrtc_write_register(unsigned char reg,unsigned long value);

//#######################################################################
//# get current date/time						#
//# result: 32 bit timestamp						#
//#######################################################################
unsigned long xrtc_get_date(void);

//#######################################################################
//# set current date/time						#
//# param: 32 bit timestamp						#
//#######################################################################
void xrtc_set_date(unsigned long date);

//#######################################################################
//# send a command							#
//#######################################################################
unsigned char sdcard_cmd(unsigned char cmd, unsigned long addr, unsigned char crc);

//#######################################################################
//# change CS pin							#
//#######################################################################
void sdcard_select(PORT_TYPE cs_port, unsigned char cs_pin);

//#######################################################################
//# init the sdcard							#
//# this must be done with low speed					#
//# 0 = no card / failure						#
//#									# 
//#######################################################################
unsigned char sdcard_init(PORT_TYPE cs_port, unsigned char cs_pin);

//#######################################################################
//# read status								#
//# 0=busy, 1=ready							#
//#######################################################################
unsigned char sdcard_read_status(void);

//#######################################################################
//# read data block							#
//#######################################################################
unsigned char sdcard_read_sector(unsigned char *buffer,unsigned long sector);

//#######################################################################
//# read data block word wise						#
//#######################################################################
unsigned char sdcard_read_sector_ww(unsigned short *buffer,unsigned long sector);

//#######################################################################
//# read data block longword wise					#
//#######################################################################
unsigned char sdcard_read_sector_lw(unsigned long *buffer,unsigned long sector);

//#######################################################################
//# write data block							#
//#######################################################################
unsigned char sdcard_write_sector(unsigned char *buffer,unsigned long sector);

//#######################################################################
//# write data block word wise						#
//#######################################################################
unsigned char sdcard_write_sector_ww(unsigned short *buffer,unsigned long sector);

//#######################################################################
//# write data block word wise						#
//#######################################################################
unsigned char sdcard_write_sector_lw(unsigned long *buffer,unsigned long sector);

//#######################################################################
//# check device ID							#
//#######################################################################
unsigned char dataflash_checkid(void);

//#######################################################################
//# init the dataflash							#
//# ret: 	0=no dataflash						#
//# 	 	1=AT45DB041						#
//# 	 	2=AT45DB081						#
//# 	 	3=AT45DB161						#
//# 	 	4=AT45DB321						#
//# 	 	5=AT45DB642						#
//#######################################################################
unsigned char dataflash_init(PORT_TYPE cs_port, unsigned char cs_pin);

//#######################################################################
//# set select pin							#
//#######################################################################
void dataflash_select(PORT_TYPE cs_port, unsigned char cs_pin);

//#######################################################################
//# read ststus byte							#
//# 1=ready, 0=busy							#
//#######################################################################
unsigned char dataflash_read_status(void);

//#######################################################################
//# wait for device is ready						#
//# 0=ready, 1=timeout							#
//#######################################################################
unsigned char dataflash_wait_ready(unsigned char timeout);

//#######################################################################
//# read from page (byte-wise)						#
//#######################################################################
unsigned char dataflash_read_page(unsigned char *buffer,unsigned short page, unsigned short start, unsigned short bytes);

//#######################################################################
//# read from page (word_wise)						#
//#######################################################################
unsigned char dataflash_read_page_ww(unsigned short *buffer,unsigned short page, unsigned short start, unsigned short words);

//#######################################################################
//# read from page (longword_wise)					#
//#######################################################################
unsigned char dataflash_read_page_lw(unsigned long *buffer,unsigned short page, unsigned short start, unsigned short longs);

//#######################################################################
//# read data from buffer (byte-wise)					#
//# 0 = buffer 1							#
//# 1 = buffer 2							#
//#######################################################################
unsigned char dataflash_read_buffer(unsigned char bufnum,unsigned char *buffer, unsigned short start, unsigned short bytes);

//#######################################################################
//# read data from buffer (word-wise)					#
//# 0 = buffer 1							#
//# 1 = buffer 2							#
//#######################################################################
unsigned char dataflash_read_buffer_ww(unsigned char bufnum,unsigned short *buffer, unsigned short start, unsigned short words);

//#######################################################################
//# read data from buffer (longword-wise)				#
//# 0 = buffer 1							#
//# 1 = buffer 2							#
//#######################################################################
unsigned char dataflash_read_buffer_lw(unsigned char bufnum,unsigned long *buffer, unsigned short start, unsigned short longs);

//#######################################################################
//# write data to buffer (byte-wise)					#
//# 0 = buffer 1							#
//# 1 = buffer 2							#
//#######################################################################
unsigned char dataflash_write_buffer(unsigned char bufnum,unsigned char *buffer,unsigned short start, unsigned short bytes);

//#######################################################################
//# write data to buffer (word-wise)					#
//# 0 = buffer 1							#
//# 1 = buffer 2							#
//#######################################################################
unsigned char dataflash_write_buffer_ww(unsigned char bufnum,unsigned short *buffer,unsigned short start, unsigned short words);

//#######################################################################
//# write data to buffer (longword-wise)				#
//# 0 = buffer 1							#
//# 1 = buffer 2							#
//#######################################################################
unsigned char dataflash_write_buffer_lw(unsigned char bufnum,unsigned long *buffer,unsigned short start, unsigned short longs);

//#######################################################################
//# load buffer 1/2 from flash						#
//#######################################################################
unsigned char dataflash_load_page(unsigned char bufnum,unsigned short page,unsigned char blocked);

//#######################################################################
//# write buffer 1/2 to flash						#
//#######################################################################
unsigned char dataflash_prog_page(unsigned char bufnum,unsigned short page,unsigned char blocked);

//#######################################################################
//# reset								#
//#######################################################################
void F25x128_reset(void);

//#######################################################################
//# check device ID							#
//#######################################################################
unsigned char F25x128_checkid(void);

//#######################################################################
//# init the F25x128							#
//#######################################################################
unsigned char F25x128_init(PORT_TYPE cs_port, unsigned char cs_pin);

//#######################################################################
//# change CS pin							#
//#######################################################################
void F25x128_select(PORT_TYPE cs_port, unsigned char cs_pin);

//#######################################################################
//# read ststus byte							#
//#######################################################################
unsigned char F25x128_read_status(void);

//#######################################################################
//# wait for device is ready						#
//#######################################################################
unsigned char F25x128_wait_ready(unsigned long timeout);

//#######################################################################
//# checx for ready (0=ready  1=busy)					#
//#######################################################################
unsigned char F25x128_check_ready(void);

//#######################################################################
//# read data block							#
//#######################################################################
unsigned char F25x128_read_block(unsigned char *buffer,unsigned long addr, unsigned long len);

//#######################################################################
//# write data block							#
//#######################################################################
unsigned char F25x128_write_page(unsigned char *buffer,unsigned long addr,unsigned char blocked);

//#######################################################################
//# erase 64K sector							#
//#######################################################################
unsigned char F25x128_erase_sector(unsigned long addr, unsigned char blocked);

//#######################################################################
//# erase 4K sector							#
//#######################################################################
unsigned char F25x128_erase_sector4k(unsigned long addr, unsigned char blocked);

//#######################################################################
//# bulk erase								#
//#######################################################################
unsigned char F25x128_erase_bulk(unsigned char blocked);

//#######################################################################
//# sleep								#
//#######################################################################
unsigned char F25x128_sleep(void);

//#######################################################################
//# wakeup								#
//#######################################################################
unsigned char F25x128_wakeup(void);

//#######################################################################
//# check device ID							#
//#######################################################################
unsigned char F25x16_checkid(void);

//#######################################################################
//# init the F25x16							#
//#######################################################################
unsigned char F25x16_init(PORT_TYPE cs_port, unsigned char cs_pin);

//#######################################################################
//# switch CS pin							#
//#######################################################################
void F25x16_select(PORT_TYPE cs_port, unsigned char cs_pin);

//#######################################################################
//# read ststus byte							#
//#######################################################################
unsigned char F25x16_read_status(void);

//#######################################################################
//# wait for device is ready						#
//#######################################################################
unsigned char F25x16_wait_ready(unsigned long timeout);

//#######################################################################
//# checx for ready (0=ready  1=busy)					#
//#######################################################################
unsigned char F25x16_check_ready(void);

//#######################################################################
//# read data block							#
//#######################################################################
unsigned char F25x16_read_block(unsigned char *buffer,unsigned long addr, unsigned long len);

//#######################################################################
//# write data block							#
//#######################################################################
unsigned char F25x16_write_page(unsigned char *buffer,unsigned long addr,unsigned char blocked);

//#######################################################################
//# erase 64K sector							#
//#######################################################################
unsigned char F25x16_erase_sector(unsigned long addr, unsigned char blocked);

//#######################################################################
//# bulk erase								#
//#######################################################################
unsigned char F25x16_erase_bulk(unsigned char blocked);

//#######################################################################
//# sleep								#
//#######################################################################
unsigned char F25x16_sleep(void);

//#######################################################################
//# wakeup								#
//#######################################################################
unsigned char F25x16_wakeup(void);

//#######################################################################
//# check device ID							#
//#######################################################################
unsigned char F25x256_checkid(void);

//#######################################################################
//# init the F25x256							#
//#######################################################################
unsigned char F25x256_init(PORT_TYPE cs_port, unsigned char cs_pin);

//#######################################################################
//# change CS pin							#
//#######################################################################
void F25x256_select(PORT_TYPE cs_port, unsigned char cs_pin);

//#######################################################################
//# read ststus byte							#
//#######################################################################
unsigned char F25x256_read_status(void);

//#######################################################################
//# wait for device is ready						#
//#######################################################################
unsigned char F25x256_wait_ready(unsigned long timeout);

//#######################################################################
//# checx for ready (0=ready  1=busy)					#
//#######################################################################
unsigned char F25x256_check_ready(void);

//#######################################################################
//# read data block							#
//#######################################################################
unsigned char F25x256_read_block(unsigned char *buffer,unsigned long addr, unsigned long len);

//#######################################################################
//# write data block							#
//#######################################################################
unsigned char F25x256_write_page(unsigned char *buffer,unsigned long addr,unsigned char blocked);

//#######################################################################
//# erase 64K sector							#
//#######################################################################
unsigned char F25x256_erase_sector(unsigned long addr, unsigned char blocked);

//#######################################################################
//# erase 4K sector							#
//#######################################################################
unsigned char F25x256_erase_sector4k(unsigned long addr, unsigned char blocked);

//#######################################################################
//# bulk erase								#
//#######################################################################
unsigned char F25x256_erase_bulk(unsigned char blocked);

//#######################################################################
//# sleep								#
//#######################################################################
unsigned char F25x256_sleep(void);

//#######################################################################
//# wakeup								#
//#######################################################################
unsigned char F25x256_wakeup(void);

//#######################################################################
//# check device ID							#
//#######################################################################
unsigned char F25x32_checkid(void);

//#######################################################################
//# init the F25x32							#
//#######################################################################
unsigned char F25x32_init(PORT_TYPE cs_port, unsigned char cs_pin);

//#######################################################################
//# change CS pin							#
//#######################################################################
void F25x32_select(PORT_TYPE cs_port, unsigned char cs_pin);

//#######################################################################
//# read ststus byte							#
//#######################################################################
unsigned char F25x32_read_status(void);

//#######################################################################
//# wait for device is ready						#
//#######################################################################
unsigned char F25x32_wait_ready(unsigned long timeout);

//#######################################################################
//# checx for ready (0=ready  1=busy)					#
//#######################################################################
unsigned char F25x32_check_ready(void);

//#######################################################################
//# read data block							#
//#######################################################################
unsigned char F25x32_read_block(unsigned char *buffer,unsigned long addr, unsigned long len);

//#######################################################################
//# write data block							#
//#######################################################################
unsigned char F25x32_write_page(unsigned char *buffer,unsigned long addr,unsigned char blocked);

//#######################################################################
//# erase 64K sector							#
//#######################################################################
unsigned char F25x32_erase_sector(unsigned long addr, unsigned char blocked);

//#######################################################################
//# bulk erase								#
//#######################################################################
unsigned char F25x32_erase_bulk(unsigned char blocked);

//#######################################################################
//# sleep								#
//#######################################################################
unsigned char F25x32_sleep(void);

//#######################################################################
//# wakeup								#
//#######################################################################
unsigned char F25x32_wakeup(void);

//#######################################################################
//# check device ID							#
//#######################################################################
unsigned char F25x512_checkid(void);

//#######################################################################
//# init the F25x512							#
//#######################################################################
unsigned char F25x512_init(PORT_TYPE cs_port, unsigned char cs_pin);

//#######################################################################
//# change CS pin							#
//#######################################################################
void F25x512_select(PORT_TYPE cs_port, unsigned char cs_pin);

//#######################################################################
//# read ststus byte							#
//#######################################################################
unsigned char F25x512_read_status(void);

//#######################################################################
//# wait for device is ready						#
//#######################################################################
unsigned char F25x512_wait_ready(unsigned long timeout);

//#######################################################################
//# checx for ready (0=ready  1=busy)					#
//#######################################################################
unsigned char F25x512_check_ready(void);

//#######################################################################
//# read data block							#
//#######################################################################
unsigned char F25x512_read_block(unsigned char *buffer,unsigned long addr, unsigned long len);

//#######################################################################
//# write data block							#
//#######################################################################
unsigned char F25x512_write_page(unsigned char *buffer,unsigned long addr,unsigned char blocked);

//#######################################################################
//# erase 64K sector							#
//#######################################################################
unsigned char F25x512_erase_sector(unsigned long addr, unsigned char blocked);

//#######################################################################
//# erase 4K sector							#
//#######################################################################
unsigned char F25x512_erase_sector4k(unsigned long addr, unsigned char blocked);

//#######################################################################
//# bulk erase								#
//#######################################################################
unsigned char F25x512_erase_bulk(unsigned char blocked);

//#######################################################################
//# sleep								#
//#######################################################################
unsigned char F25x512_sleep(void);

//#######################################################################
//# wakeup								#
//#######################################################################
unsigned char F25x512_wakeup(void);

//#######################################################################
//# check device ID							#
//#######################################################################
unsigned char F25x64_checkid(void);

//#######################################################################
//# init the F25x64							#
//#######################################################################
unsigned char F25x64_init(PORT_TYPE cs_port, unsigned char cs_pin);

//#######################################################################
//# change CS pin							#
//#######################################################################
void F25x64_select(PORT_TYPE cs_port, unsigned char cs_pin);

//#######################################################################
//# read ststus byte							#
//#######################################################################
unsigned char F25x64_read_status(void);

//#######################################################################
//# wait for device is ready						#
//#######################################################################
unsigned char F25x64_wait_ready(unsigned long timeout);

//#######################################################################
//# checx for ready (0=ready  1=busy)					#
//#######################################################################
unsigned char F25x64_check_ready(void);

//#######################################################################
//# read data block							#
//#######################################################################
unsigned char F25x64_read_block(unsigned char *buffer,unsigned long addr, unsigned long len);

//#######################################################################
//# write data block							#
//#######################################################################
unsigned char F25x64_write_page(unsigned char *buffer,unsigned long addr,unsigned char blocked);

//#######################################################################
//# erase 64K sector							#
//#######################################################################
unsigned char F25x64_erase_sector(unsigned long addr, unsigned char blocked);

//#######################################################################
//# bulk erase								#
//#######################################################################
unsigned char F25x64_erase_bulk(unsigned char blocked);

//#######################################################################
//# sleep								#
//#######################################################################
unsigned char F25x64_sleep(void);

//#######################################################################
//# wakeup								#
//#######################################################################
unsigned char F25x64_wakeup(void);

//#######################################################################
//# check device ID							#
//#######################################################################
unsigned char F25x80_checkid(void);

//#######################################################################
//# init the F25x80							#
//#######################################################################
unsigned char F25x80_init(PORT_TYPE cs_port, unsigned char cs_pin);

//#######################################################################
//# change CS pin							#
//#######################################################################
void F25x80_select(PORT_TYPE cs_port, unsigned char cs_pin);

//#######################################################################
//# read ststus byte							#
//#######################################################################
unsigned char F25x80_read_status(void);

//#######################################################################
//# wait for device is ready						#
//#######################################################################
unsigned char F25x80_wait_ready(unsigned long timeout);

//#######################################################################
//# checx for ready (0=ready  1=busy)					#
//#######################################################################
unsigned char F25x80_check_ready(void);

//#######################################################################
//# read data block							#
//#######################################################################
unsigned char F25x80_read_block(unsigned char *buffer,unsigned long addr, unsigned long len);

//#######################################################################
//# write data block							#
//#######################################################################
unsigned char F25x80_write_page(unsigned char *buffer,unsigned long addr,unsigned char blocked);

//#######################################################################
//# erase 64K sector							#
//#######################################################################
unsigned char F25x80_erase_sector(unsigned long addr, unsigned char blocked);

//#######################################################################
//# bulk erase								#
//#######################################################################
unsigned char F25x80_erase_bulk(unsigned char blocked);

//#######################################################################
//# sleep								#
//#######################################################################
unsigned char F25x80_sleep(void);

//#######################################################################
//# wakeup								#
//#######################################################################
unsigned char F25x80_wakeup(void);

//#######################################################################
//# init the psram							#
//#######################################################################
void psram_init(PORT_TYPE cs_port, unsigned char cs_pin);

//#######################################################################
//# change CS pin							#
//#######################################################################
void psram_select(PORT_TYPE cs_port, unsigned char cs_pin);

//#######################################################################
//# read data block							#
//#######################################################################
void psram_read_block(unsigned char *buffer,unsigned long addr, unsigned long len);

//#######################################################################
//# write data block							#
//#######################################################################
void psram_write_block(unsigned char *buffer,unsigned long addr, unsigned long len);

//#######################################################################
//# init the xsram							#
//#######################################################################
void xsram_init(PORT_TYPE cs_port, unsigned char cs_pin);

//#######################################################################
//# change CS pin							#
//#######################################################################
void xsram_select(PORT_TYPE cs_port, unsigned char cs_pin);

//#######################################################################
//# read data block							#
//#######################################################################
void xsram_read_block(unsigned char *buffer,unsigned long addr, unsigned long len);

//#######################################################################
//# write data block							#
//#######################################################################
void xsram_write_block(unsigned char *buffer,unsigned long addr, unsigned long len);

//#######################################################################
//# init the mlx90316							#
//#######################################################################
void MLX90316_init(PORT_TYPE cs_port, unsigned char cs_pin);

//#######################################################################
//# change CS pin							#
//#######################################################################
void MLX90316_select(PORT_TYPE cs_port, unsigned char cs_pin);

//#######################################################################
//# get angle								#
//#######################################################################
int MLX90316_read(void);

void MLX90363_comm(void);

//#######################################################################
//# reboot cmd								#
//#######################################################################
void MLX90363_reboot(void);

//#######################################################################
//# reboot cmd								#
//#######################################################################
void MLX90363_sleep(void);

//#######################################################################
//# init the MLX90363							#
//#######################################################################
char MLX90363_init(PORT_TYPE cs_port, unsigned char cs_pin);

//#######################################################################
//# switch the CS pin							#
//#######################################################################
void MLX90363_select(PORT_TYPE cs_port, unsigned char cs_pin);

//#######################################################################
//# read data (non-blocked)						#
//# result: 0=data / 1=no data						#
//#######################################################################
char MLX90363_get_ab(short *aval,short *bval,short *vg);

//#######################################################################
//# wait for data available and read 					#
//# result: 0=data / 1=no data (timeout)				#
//#######################################################################
char MLX90363_wait_ab(short *aval,short *bval,short *vg);

//#######################################################################
//# read data (non-blocked)						#
//# result: 0=data / 1=no data						#
//#######################################################################
char MLX90363_get_xyz(short *xval,short *yval,short *zval);

//#######################################################################
//# wait for data available and read 					#
//# result: 0=data / 1=no data (timeout)				#
//#######################################################################
char MLX90363_wait_xyz(short *xval,short *yval,short *zval);

//#######################################################################
//#									#
//# integer absolute value (magnitude)					#
//#									#
//#######################################################################
int abs (int i);

//#######################################################################
//#									#
//# integer absolute value (magnitude)					#
//#									#
//#######################################################################
long absl(long i);

//#######################################################################
//#									#
//# ascii to long							#
//#									#
//#######################################################################
float atof(const char *s);

//#######################################################################
//#									#
//# ascii to integer							#
//#									#
//#######################################################################
int atoi(const char *s);

//#######################################################################
//#									#
//# ascii to long							#
//#									#
//#######################################################################
long atol(const char *s);

//#######################################################################
//#									#
//# divide two integers							#
//#									#
//#######################################################################
//#######################################################################
//#									#
//# search for character in string					#
//#									#
//#######################################################################
char * index(char *s1, int i);

//#######################################################################
//#									#
//# check if char is a alphabetic letter				#
//#									#
//#######################################################################
int isalpha(char c);

//#######################################################################
//#									#
//# check if char is a digit						#
//#									#
//#######################################################################
int isdigit(char c);

//#######################################################################
//#									#
//# check if char is lowercase						#
//#									#
//#######################################################################
int islower(char c);

//#######################################################################
//#									#
//# check if char is a whitespace					#
//#									#
//#######################################################################
int isspace(char c);

//#######################################################################
//#									#
//# check if char is uppercase						#
//#									#
//#######################################################################
int isupper(char c);

//#######################################################################
//#									#
//# integer to ascii							#
//#									#
//#######################################################################
char * itoa(int value, char *ptr, int base);

//#######################################################################
//#									#
//# divide two long integers						#
//#									#
//#######################################################################
//#######################################################################
//#									#
//# copy memory regions with end-token check				#
//#									#
//#######################################################################
void * memccpy(void * dst0, const void * src0, int endchar0, size_t num);

//#######################################################################
//#									#
//# find character in memory						#
//#									#
//#######################################################################
void * memchr(const void *ptr,int value,size_t num);

//#######################################################################
//#									#
//# compare two memory areas						#
//#									#
//#######################################################################
int memcmp(void *ptr1,void *ptr2,size_t num);

//#######################################################################
//#									#
//# copy memory regions							#
//#									#
//#######################################################################
void * memcpy(void * dst0,const void * src0,size_t num);

//#######################################################################
//#									#
//# compare two strings							#
//#									#
//#######################################################################
void * memmove(void * dst0,const void * src0, size_t num);

//#######################################################################
//#									#
//# set an area of memory						#
//#									#
//#######################################################################
void * memset(void * ptr,int value,size_t num);

//#######################################################################
//#									#
//# reverse search for character in string				#
//#									#
//#######################################################################
char * rindex(char *s1, int i);

//#######################################################################
//#									#
//# copy string	and return a pointer to its end				#
//#									#
//#######################################################################
char* stpcpy(char *dst0, char *src0);

//#######################################################################
//#									#
//# copy string	and return a pointer to its end				#
//#									#
//#######################################################################
char* stpncpy(char *dst0, char *src0,size_t num);

//#######################################################################
//#									#
//# compare two strings and ignore case					#
//#									#
//#######################################################################
int strcasecmp(char *s1, char *s2);

//#######################################################################
//#									#
//# find string segment and ignore case					#
//#									#
//#######################################################################
char * strcasestr(char *haystack, char *needle);

//#######################################################################
//#									#
//# concatenate two strings						#
//#									#
//#######################################################################
char * strcat(char *dst, const char *src);

//#######################################################################
//#									#
//# search for character in string					#
//#									#
//#######################################################################
char * strchr(const char *s1, int i);

//#######################################################################
//#									#
//# compare two strings							#
//#									#
//#######################################################################
int strcmp(const char *s1, const char *s2);

//#######################################################################
//#									#
//# copy string								#
//#									#
//#######################################################################
char* strcpy(char *dst0, const char *src0);

//#######################################################################
//#									#
//# count characters not in string					#
//#									#
//#######################################################################
size_t strcspn(const char *s1,const char *s2);

//#######################################################################
//#									#
//# determine lenght of a string					#
//#									#
//#######################################################################
size_t strlen (const char *str);

//#######################################################################
//#									#
//# force string to lowercase						#
//#									#
//#######################################################################
char * strlwr (char * s);

//#######################################################################
//#									#
//# compare two strings and ignore case					#
//#									#
//#######################################################################
int strncasecmp(char *s1, char *s2, size_t num);

//#######################################################################
//#									#
//# concatenate two strings						#
//#									#
//#######################################################################
char * strncat(char *s1, const char *s2, size_t num);

//#######################################################################
//#									#
//# compare two strings							#
//#									#
//#######################################################################
int strncmp(const char *s1, const char *s2, size_t num);

//#######################################################################
//#									#
//# copy string								#
//#									#
//#######################################################################
char* strncpy(char *dst0, const char *src0, size_t num);

//#######################################################################
//#									#
//# determine lenght of a string					#
//#									#
//#######################################################################
size_t strnlen (const char *str, size_t num);

//#######################################################################
//#									#
//# find characters in string						#
//#									#
//#######################################################################
char * strpbrk(const char *s1, const char *s2);

//#######################################################################
//#									#
//# reverse search for character in string				#
//#									#
//#######################################################################
char * strrchr(const char *s1, int i);

//#######################################################################
//#									#
//# find initial match							#
//#									#
//#######################################################################
size_t strspn(const char *s1, const char *s2);

//#######################################################################
//#									#
//# find string segment							#
//#									#
//#######################################################################
char * strstr(const char *haystack, const char *needle);

//#######################################################################
//#									#
//# Convert a string to a float						#
//#									#
//#######################################################################
float strtof (const char *ptr, char** endptr);

//#######################################################################
//#									#
//# split string into tokens						#
//#									#
//#######################################################################
char * strtok(char *str, const char *delimiters);

//#######################################################################
//#									#
//# Convert a string to a long integer.					#
//#									#
//#######################################################################
long strtol (const char *ptr, char** endptr);

//#######################################################################
//#									#
//# force string to uppercase						#
//#									#
//#######################################################################
char * strupr (char * s);

//#######################################################################
//#									#
//# swap adjacent bytes							#
//#									#
//#######################################################################
void swab(void *src0, void *dst0, size_t num);

//#######################################################################
//#									#
//# convert char to lowercase						#
//#									#
//#######################################################################
char tolower(char c);

//#######################################################################
//#									#
//# convert char to uppercase						#
//#									#
//#######################################################################
char toupper(char c);

//#######################################################################
//#									#
//# unsigned integer to string						#
//#									#
//#######################################################################
char * utoa(unsigned int value, char * str, int base);

//#######################################################################
//#									#
//#	wait for screeen sync						#
//#									#
//#######################################################################
void tlcd_waitsync(void);

//#######################################################################
//#									#
//#	clear screen							#
//#									#
//#######################################################################
void tlcd_clrscr(void);

//#######################################################################
//#									#
//#	set screen position						#
//#									#
//#######################################################################
void tlcd_gotoxy(unsigned char x,unsigned char y);

//#######################################################################
//#									#
//#	new line							#
//#									#
//#######################################################################
void tlcd_newline(void);

//#######################################################################
//#									#
//#	set wrapmode							#
//#									#
//#######################################################################
void tlcd_wrapmode(void);

//#######################################################################
//#									#
//#	set scrollmode							#
//#									#
//#######################################################################
void tlcd_scrollmode(void);

//#######################################################################
//#									#
//#	get maximal x coordinate					#
//#									#
//#######################################################################
unsigned int tlcd_get_textsize_x(void);

//#######################################################################
//#									#
//#	get maximal y coordinate					#
//#									#
//#######################################################################
unsigned int tlcd_get_textsize_y(void);

//#######################################################################
//#									#
//#	get current x coordinate					#
//#									#
//#######################################################################
unsigned int tlcd_get_textpos_x(void);

//#######################################################################
//#									#
//#	get current y coordinate					#
//#									#
//#######################################################################
unsigned int tlcd_get_textpos_y(void);

//#######################################################################
//#									#
//#	write char							#
//#									#
//#######################################################################
void tlcd_char(unsigned char data);

//#######################################################################
//#									#
//#	define user char (0..7)						#
//#									#
//#######################################################################
void tlcd_user_char(unsigned char num,unsigned char* pixline);

//#######################################################################
//#									#
//#	init LCD							#
//#									#
//#######################################################################
void init_tlcd161_n0(PORT_TYPE dataport,PORT_TYPE ctrlport,unsigned char rspin,unsigned char epin)	;

//#######################################################################
//#									#
//#	service								#
//#									#
//#######################################################################
void serve_tlcd161_n0(void);

//#######################################################################
//#									#
//#	init LCD							#
//#									#
//#######################################################################
void init_tlcd161_n1(PORT_TYPE dataport,PORT_TYPE ctrlport,unsigned char rspin,unsigned char epin)	;

//#######################################################################
//#									#
//#	service								#
//#									#
//#######################################################################
void serve_tlcd161_n1(void);

//#######################################################################
//#									#
//#	init LCD							#
//#									#
//#######################################################################
void init_tlcd161_n2(PORT_TYPE dataport,PORT_TYPE ctrlport,unsigned char rspin,unsigned char epin)	;

//#######################################################################
//#									#
//#	service								#
//#									#
//#######################################################################
void serve_tlcd161_n2(void);

//#######################################################################
//#									#
//#	init LCD							#
//#									#
//#######################################################################
void init_tlcd161_n3(PORT_TYPE dataport,PORT_TYPE ctrlport,unsigned char rspin,unsigned char epin)	;

//#######################################################################
//#									#
//#	service								#
//#									#
//#######################################################################
void serve_tlcd161_n3(void);

//#######################################################################
//#									#
//#	init LCD							#
//#									#
//#######################################################################
void init_tlcd161b_n0(PORT_TYPE dataport,PORT_TYPE ctrlport,unsigned char rspin,unsigned char epin)	;

//#######################################################################
//#									#
//#	service								#
//#									#
//#######################################################################
void serve_tlcd161b_n0(void);

//#######################################################################
//#									#
//#	init LCD							#
//#									#
//#######################################################################
void init_tlcd161b_n1(PORT_TYPE dataport,PORT_TYPE ctrlport,unsigned char rspin,unsigned char epin)	;

//#######################################################################
//#									#
//#	service								#
//#									#
//#######################################################################
void serve_tlcd161b_n1(void);

//#######################################################################
//#									#
//#	init LCD							#
//#									#
//#######################################################################
void init_tlcd161b_n2(PORT_TYPE dataport,PORT_TYPE ctrlport,unsigned char rspin,unsigned char epin)	;

//#######################################################################
//#									#
//#	service								#
//#									#
//#######################################################################
void serve_tlcd161b_n2(void);

//#######################################################################
//#									#
//#	init LCD							#
//#									#
//#######################################################################
void init_tlcd161b_n3(PORT_TYPE dataport,PORT_TYPE ctrlport,unsigned char rspin,unsigned char epin)	;

//#######################################################################
//#									#
//#	service								#
//#									#
//#######################################################################
void serve_tlcd161b_n3(void);

//#######################################################################
//#									#
//#	init LCD							#
//#									#
//#######################################################################
void init_tlcd162_n0(PORT_TYPE dataport,PORT_TYPE ctrlport,unsigned char rspin,unsigned char epin)	;

//#######################################################################
//#									#
//#	service								#
//#									#
//#######################################################################
void serve_tlcd162_n0(void);

//#######################################################################
//#									#
//#	init LCD							#
//#									#
//#######################################################################
void init_tlcd162_n1(PORT_TYPE dataport,PORT_TYPE ctrlport,unsigned char rspin,unsigned char epin)	;

//#######################################################################
//#									#
//#	service								#
//#									#
//#######################################################################
void serve_tlcd162_n1(void);

//#######################################################################
//#									#
//#	init LCD							#
//#									#
//#######################################################################
void init_tlcd162_n2(PORT_TYPE dataport,PORT_TYPE ctrlport,unsigned char rspin,unsigned char epin)	;

//#######################################################################
//#									#
//#	service								#
//#									#
//#######################################################################
void serve_tlcd162_n2(void);

//#######################################################################
//#									#
//#	init LCD							#
//#									#
//#######################################################################
void init_tlcd162_n3(PORT_TYPE dataport,PORT_TYPE ctrlport,unsigned char rspin,unsigned char epin)	;

//#######################################################################
//#									#
//#	service								#
//#									#
//#######################################################################
void serve_tlcd162_n3(void);

//#######################################################################
//#									#
//#	init LCD							#
//#									#
//#######################################################################
void init_tlcd202_n0(PORT_TYPE dataport,PORT_TYPE ctrlport,unsigned char rspin,unsigned char epin)	;

//#######################################################################
//#									#
//#	service								#
//#									#
//#######################################################################
void serve_tlcd202_n0(void);

//#######################################################################
//#									#
//#	init LCD							#
//#									#
//#######################################################################
void init_tlcd202_n1(PORT_TYPE dataport,PORT_TYPE ctrlport,unsigned char rspin,unsigned char epin)	;

//#######################################################################
//#									#
//#	service								#
//#									#
//#######################################################################
void serve_tlcd202_n1(void);

//#######################################################################
//#									#
//#	init LCD							#
//#									#
//#######################################################################
void init_tlcd202_n2(PORT_TYPE dataport,PORT_TYPE ctrlport,unsigned char rspin,unsigned char epin)	;

//#######################################################################
//#									#
//#	service								#
//#									#
//#######################################################################
void serve_tlcd202_n2(void);

//#######################################################################
//#									#
//#	init LCD							#
//#									#
//#######################################################################
void init_tlcd202_n3(PORT_TYPE dataport,PORT_TYPE ctrlport,unsigned char rspin,unsigned char epin)	;

//#######################################################################
//#									#
//#	service								#
//#									#
//#######################################################################
void serve_tlcd202_n3(void);

//###############################################################################
//# init the big char table							#
//###############################################################################
void tlcd_init_bigchar(void);

//###############################################################################
//# draw big char								#
//# return:  0 = OK								#
//# return: -1 = out of screen							#
//###############################################################################
int tlcd_bigchar(unsigned char val, unsigned char x, unsigned char y);

extern unsigned char *oc_memptr;

extern unsigned short oc_free;

//#######################################################################
//#									#
//#	set printf channel						#
//#									#
//#######################################################################
void set_outchar_routine(void (*outfunc)(unsigned char));

//#######################################################################
//#									#
//#	dummy output							#
//#									#
//#######################################################################
void OUTPUT_NONE(unsigned char c);

//#######################################################################
//#									#
//#	memory output							#
//#									#
//#######################################################################
void OUTPUT_MEMORY(unsigned char c);

//#######################################################################
//#									#
//#	memory output							#
//#									#
//#######################################################################
void set_outchar_memory(unsigned char *c, unsigned short size);

//#######################################################################
//#									#
//#	get printf channel						#
//#									#
//#######################################################################
void uprintf (const char *format, ...);

//#######################################################################
//#									#
//#	get printf channel						#
//#									#
//#######################################################################
void uxprintf (const char *format, ...);

//#######################################################################
//#									#
//# rotate 8x8 buffer for glcd						#
//#									#
//#######################################################################
void unilib_rotate_buffer8(unsigned char * src,unsigned char *dst);

//#######################################################################
//#									#
//# rotate 8x8 buffer for glcd						#
//#									#
//#######################################################################
void unilib_rotate_buffer8a(unsigned char * src,unsigned char *dst);

//#######################################################################
//#									#
//# rotate 8x8 buffer for glcd	vertical text				#
//#									#
//#######################################################################
void unilib_rotate_buffer8c(unsigned char * src,unsigned char *dst);

extern volatile unsigned char unilib_cpu_freq;

extern volatile unsigned char unilib_cpu_prescaler;

extern volatile unsigned char unilib_ints_enabled;

extern volatile unsigned int unilib_lastclockmode;

//#######################################################################
//#									#
//#									#
//#									#
//#######################################################################
void unilib_init(void);

//#######################################################################
//#									#
//#	set FMPLL for 8/16M crystal					#
//#									#
//#######################################################################
void clock_config(unsigned short mode);

//#######################################################################
//#									#
//#	wait n cycles							#
//#									#
//#######################################################################
void unilib_pause(long cycles);

//#######################################################################
//#									#
//#	wait n msec							#
//#									#
//#######################################################################
void unilib_pause_ms(unsigned int ms);

//#######################################################################
//#									#
//#									#
//#									#
//#######################################################################
void enable_interrupts(void);

//#######################################################################
//#									#
//#									#
//#									#
//#######################################################################
void disable_interrupts(void);

extern volatile unsigned char _unilib_adc_adm0;

//#######################################################################
//#									#
//#	init ADC (VCC=REF)						#
//#									#
//#######################################################################
void adc_enable(unsigned char mask);

//#######################################################################
//#									#
//#	init ADC (external REF)						#
//#									#
//#######################################################################
void adc_enable_extref(unsigned char mask);

//#######################################################################
//#									#
//#	init ADC (internal REF)						#
//#									#
//#######################################################################
void adc_enable_intref(unsigned char mask);

//#######################################################################
//#									#
//#	disable ADC							#
//#									#
//#######################################################################
void adc_disable(void);

//#######################################################################
//#									#
//#	start adc and get value						#
//#									#
//#######################################################################
unsigned int adc_get(unsigned char channel);

//#######################################################################
//#									#
//#	start adc conversion						#
//#									#
//#######################################################################
void adc_start_channel(unsigned char channel);

//#######################################################################
//#									#
//#	check adc state (0=ready, 1=busy)				#
//#									#
//#######################################################################
unsigned char adc_check(void);

//#######################################################################
//#									#
//#	get adc value (if ready)					#
//#									#
//#######################################################################
unsigned int adc_get_value(void);

//#######################################################################
//#									#
//#	enable external interrupt					#
//#									#
//#######################################################################
void enable_ext_int0(unsigned char mode,unsigned char pin);

//#######################################################################
//#									#
//#	disable external interrupt					#
//#									#
//#######################################################################
void disable_ext_int0(void);

//#######################################################################
//#									#
//#	enable external interrupt					#
//#									#
//#######################################################################
void enable_ext_int0(unsigned char mode,unsigned char pin);

//#######################################################################
//#									#
//#	disable external interrupt					#
//#									#
//#######################################################################
void disable_ext_int0(void);

//#######################################################################
//#									#
//#	get rom byte from absolute addr					#
//#									#
//#######################################################################
unsigned char get_rom_byte(const unsigned char *addr);

//#######################################################################
//#									#
//#	get rom word from absolute addr					#
//#									#
//#######################################################################
unsigned short get_rom_word(const unsigned short *addr);

extern unsigned short _i2c_swtiming;

//#######################################################################
//#									#
//#	init I2C (0=slow, 1=fast)					#
//#									#
//#######################################################################
void i2c_enable_master(unsigned char mode);

//#######################################################################
//#									#
//#	disable I2C							#
//#									#
//#######################################################################
void disable_i2c(void);

//#######################################################################
//#									#
//#	send start condition						#
//#									#
//#	return: 0 = OK		1 = ERROR				#
//#									#
//#######################################################################
unsigned char i2c_start(void);

//#######################################################################
//#									#
//#	send stop condition						#
//#									#
//#	return: 0 = OK		1 = ERROR				#
//#									#
//#######################################################################
unsigned char i2c_stop(void);

//#######################################################################
//#									#
//#	repeated send start condition					#
//#									#
//#	return: 0 = OK		1 = ERROR				#
//#									#
//#######################################################################
unsigned char i2c_rstart(void);

//#######################################################################
//#									#
//#	send data							#
//#									#
//#	return: ACK BIT (0/1)						#
//#									#
//#######################################################################
unsigned char i2c_master_send(unsigned char data);

//#######################################################################
//#									#
//#	read data							#
//#									#
//#	return: 0 = OK		1 = ERROR				#
//#									#
//#######################################################################
unsigned char i2c_master_recv(unsigned char ack);

//#######################################################################
//#									#
//#	send address							#
//#									#
//#	return: 0 = OK		1 = ERROR				#
//#									#
//#######################################################################
unsigned char i2c_master_addr(unsigned char address);

//#######################################################################
//#									#
//#	enable i2c interrupt						#
//#									#
//#######################################################################
void enable_i2c_interrupt(void);

//#######################################################################
//#									#
//#	enable i2c interrupt						#
//#									#
//#######################################################################
void disable_i2c_interrupt(void);

//#######################################################################
//#									#
//#	set port pin to output						#
//#									#
//#######################################################################
void portpin_set_output(unsigned char port,unsigned char pin);

//#######################################################################
//#									#
//#	set port pin to open drain io					#
//#									#
//#######################################################################
void portpin_set_odio(unsigned char port,unsigned char pin);

//#######################################################################
//#									#
//#	set port pin to input with pull-up				#
//#									#
//#######################################################################
void portpin_set_input_pullup(unsigned char port,unsigned char pin);

//#######################################################################
//#									#
//#	set port pin to input with no pull-up				#
//#									#
//#######################################################################
void portpin_set_input_nopull(unsigned char port,unsigned char pin);

//#######################################################################
//#									#
//#	set port pin to 0						#
//#									#
//#######################################################################
void portpin_set_low(unsigned char port,unsigned char pin);

//#######################################################################
//#									#
//#	set port pin to 1						#
//#									#
//#######################################################################
void portpin_set_high(unsigned char port,unsigned char pin);

//#######################################################################
//#									#
//#	set port pin status						#
//#									#
//#######################################################################
void portpin_set(unsigned char port,unsigned char pin,unsigned char val);

//#######################################################################
//#									#
//#	set port byte							#
//#									#
//#######################################################################
void port_set(unsigned char port,unsigned char val);

//#######################################################################
//#									#
//#	set port nibble							#
//#									#
//#######################################################################
void port_set_nibble0(unsigned char port,unsigned char val);

//#######################################################################
//#									#
//#	set port nibble							#
//#									#
//#######################################################################
void port_set_nibble1(unsigned char port,unsigned char val);

//#######################################################################
//#									#
//#	set port nibble							#
//#									#
//#######################################################################
void port_set_nibble2(unsigned char port,unsigned char val);

//#######################################################################
//#									#
//#	set port nibble							#
//#									#
//#######################################################################
void port_set_nibble3(unsigned char port,unsigned char val);

//#######################################################################
//#									#
//#	get port pin status						#
//#									#
//#######################################################################
unsigned char portpin_get(unsigned char port,unsigned char pin);

//#######################################################################
//#									#
//#	get port byte status						#
//#									#
//#######################################################################
unsigned char port_get(unsigned char port);

//#######################################################################
//#									#
//#	enable PWM and set output					#
//#									#
//#######################################################################
void pwm0_enable(unsigned int scale,unsigned int value);

//#######################################################################
//#									#
//#	disable PWM							#
//#									#
//#######################################################################
void pwm0_disable(void);

//#######################################################################
//#									#
//#	set PWM value							#
//#									#
//#######################################################################
void pwm0_set(unsigned int value);

//#######################################################################
//#									#
//#	enable interrupt						#
//#									#
//#######################################################################
void pwm0_enable_interrupt(void);

//#######################################################################
//#									#
//#	disable interrupt						#
//#									#
//#######################################################################
void pwm0_disable_interrupt(void);

//#######################################################################
//#									#
//#	enable PWM and set output					#
//#									#
//#######################################################################
void pwm1_enable(unsigned int scale,unsigned int value);

//#######################################################################
//#									#
//#	disable PWM							#
//#									#
//#######################################################################
void pwm1_disable(void);

//#######################################################################
//#									#
//#	set PWM value							#
//#									#
//#######################################################################
void pwm1_set(unsigned int value);

//#######################################################################
//#									#
//#	enable interrupt						#
//#									#
//#######################################################################
void pwm1_enable_interrupt(void);

//#######################################################################
//#									#
//#	disable interrupt						#
//#									#
//#######################################################################
void pwm1_disable_interrupt(void);

//#######################################################################
//#									#
//#	enable PWM and set output					#
//#									#
//#######################################################################
void pwm2_enable(unsigned int scale,unsigned int value);

//#######################################################################
//#									#
//#	disable PWM							#
//#									#
//#######################################################################
void pwm2_disable(void);

//#######################################################################
//#									#
//#	set PWM value							#
//#									#
//#######################################################################
void pwm2_set(unsigned int value);

//#######################################################################
//#									#
//#	enable interrupt						#
//#									#
//#######################################################################
void pwm2_enable_interrupt(void);

//#######################################################################
//#									#
//#	disable interrupt						#
//#									#
//#######################################################################
void pwm2_disable_interrupt(void);

//#######################################################################
//#									#
//#	enable PWM and set output					#
//#									#
//#######################################################################
void pwm3_enable(unsigned int scale,unsigned int value);

//#######################################################################
//#									#
//#	disable PWM							#
//#									#
//#######################################################################
void pwm3_disable(void);

//#######################################################################
//#									#
//#	set PWM value							#
//#									#
//#######################################################################
void pwm3_set(unsigned int value);

//#######################################################################
//#									#
//#	enable interrupt						#
//#									#
//#######################################################################
void pwm1_enable_interrupt(void);

//#######################################################################
//#									#
//#	disable interrupt						#
//#									#
//#######################################################################
void pwm1_disable_interrupt(void);

//#######################################################################
//#									#
//#	scale pwm 0-2							#
//#									#
//#######################################################################
void pwm_scale02(unsigned char scale);

//#######################################################################
//#									#
//#	enable PWM and set output					#
//#									#
//#######################################################################
void pwm0_enable(unsigned int scale,unsigned int value);

//#######################################################################
//#									#
//#	disable PWM							#
//#									#
//#######################################################################
void pwm0_disable(void);

//#######################################################################
//#									#
//#	set PWM value							#
//#									#
//#######################################################################
void pwm0_set(unsigned int value);

//#######################################################################
//#									#
//#	enable PWM and set output					#
//#									#
//#######################################################################
void pwm1_enable(unsigned int scale,unsigned int value);

//#######################################################################
//#									#
//#	disable PWM							#
//#									#
//#######################################################################
void pwm1_disable(void);

//#######################################################################
//#									#
//#	set PWM value							#
//#									#
//#######################################################################
void pwm1_set(unsigned int value);

//#######################################################################
//#									#
//#	enable PWM and set output					#
//#									#
//#######################################################################
void pwm2_enable(unsigned int scale,unsigned int value);

//#######################################################################
//#									#
//#	disable PWM							#
//#									#
//#######################################################################
void pwm2_disable(void);

//#######################################################################
//#									#
//#	set PWM value							#
//#									#
//#######################################################################
void pwm2_set(unsigned int value);

//#######################################################################
//#									#
//#	scale pwm 3-5							#
//#									#
//#######################################################################
void pwm_scale35(unsigned char scale);

//#######################################################################
//#									#
//#	enable PWM and set output					#
//#									#
//#######################################################################
void pwm3_enable(unsigned int scale,unsigned int value);

//#######################################################################
//#									#
//#	disable PWM							#
//#									#
//#######################################################################
void pwm3_disable(void);

//#######################################################################
//#									#
//#	set PWM value							#
//#									#
//#######################################################################
void pwm3_set(unsigned int value);

//#######################################################################
//#									#
//#	enable PWM and set output					#
//#									#
//#######################################################################
void enable_pwm4(unsigned int scale,unsigned int value);

//#######################################################################
//#									#
//#	disable PWM							#
//#									#
//#######################################################################
void disable_pwm4(void);

//#######################################################################
//#									#
//#	set PWM value							#
//#									#
//#######################################################################
void set_pwm4(unsigned int value);

//#######################################################################
//#									#
//#	enable PWM and set output					#
//#									#
//#######################################################################
void enable_pwm5(unsigned int scale,unsigned int value);

//#######################################################################
//#									#
//#	disable PWM							#
//#									#
//#######################################################################
void disable_pwm5(void);

//#######################################################################
//#									#
//#	set PWM value							#
//#									#
//#######################################################################
void set_pwm5(unsigned int value);

//#######################################################################
//#									#
//#	sleep until extint event					#
//#									#
//#######################################################################
void unilib_sleep();

//#######################################################################
//#									#
//#	sleep for approx 10ms						#
//#									#
//#######################################################################
void unilib_sleep10();

//#######################################################################
//#									#
//#	sleep for approx 100ms						#
//#									#
//#######################################################################
void unilib_sleep100();

//#######################################################################
//#									#
//#	sleep for approx 1000ms						#
//#									#
//#######################################################################
void unilib_sleep1000();

//#######################################################################
//#									#
//#	wait a number of ticks						#
//#									#
//#######################################################################
void sleep_ticks(unsigned int ticks);

extern volatile unsigned char spi0_sso_port;

extern volatile unsigned char spi0_sso_pin;

//#######################################################################
//#									#
//#	init SPI as master						#
//#									#
//#######################################################################
void spi0_enable_master(int divider,unsigned char mode,unsigned char sso_port,unsigned char sso_pin);

//#######################################################################
//#									#
//#	init SPI as slave						#
//#									#
//#######################################################################
void spi0_enable_slave(unsigned char mode);

//#######################################################################
//#									#
//#	disable SPI							#
//#									#
//#######################################################################
void disable_spi0(void);

//#######################################################################
//#									#
//#	send/recv byte							#
//#									#
//#######################################################################
unsigned char spi0_comm(unsigned char data);

//#######################################################################
//#									#
//#	send byte							#
//#									#
//#######################################################################
void spi0_send(unsigned char data);

//#######################################################################
//#									#
//#	send byte (fast mode)						#
//#									#
//#######################################################################
void spi0_sendfast(unsigned char data);

//#######################################################################
//#									#
//#	select (SSO-pin=low)						#
//#									#
//#######################################################################
void spi0_select(void);

//#######################################################################
//#									#
//#	de-select (SSO-pin=high)					#
//#									#
//#######################################################################
void spi0_unselect(void);

extern volatile unsigned char spi1_sso_port;

extern volatile unsigned char spi1_sso_pin;

//#######################################################################
//#									#
//#	init SPI as master						#
//#									#
//#######################################################################
void spi1_enable_master(int divider,unsigned char mode,unsigned char sso_port,unsigned char sso_pin);

//#######################################################################
//#									#
//#	disable SPI							#
//#									#
//#######################################################################
void disable_spi1(void);

//#######################################################################
//#									#
//#	send/recv byte							#
//#									#
//#######################################################################
unsigned char spi1_comm(unsigned char data);

//#######################################################################
//#									#
//#	send byte							#
//#									#
//#######################################################################
void spi1_send(unsigned char data);

//#######################################################################
//#									#
//#	send byte (fast mode)						#
//#									#
//#######################################################################
void spi1_sendfast(unsigned char data);

//#######################################################################
//#									#
//#	select (SSO-pin=low)						#
//#									#
//#######################################################################
void spi1_select(void);

//#######################################################################
//#									#
//#	de-select (SSO-pin=high)					#
//#									#
//#######################################################################
void spi1_unselect(void);

extern volatile unsigned int unilib_tick_counter;

extern volatile unsigned int unilib_tick_scale;

//#######################################################################
//#									#
//#	wait a number of ticks						#
//#									#
//#######################################################################
void ticks_wait(unsigned int ticks);

//#######################################################################
//#									#
//#	set number of ticks						#
//#									#
//#######################################################################
void ticks_set(unsigned int ticks);

//#######################################################################
//#									#
//#	ret number of remaining ticks					#
//#									#
//#######################################################################
unsigned int ticks_get(void);

//#######################################################################
//#									#
//#	init tick timer							#
//#									#
//#######################################################################
void tick_enable(unsigned int scale);

//#######################################################################
//#									#
//#	disable tick interrupt						#
//#									#
//#######################################################################
void tick_disable(void);

//#######################################################################
//#									#
//#	init uart							#
//#									#
//#######################################################################
void uart0_enable(unsigned int divider);

//#######################################################################
//#									#
//#	disable UART							#
//#									#
//#######################################################################
void uart0_disable(void);

//#######################################################################
//#									#
//#	send serial byte						#
//#									#
//#######################################################################
void uart0_send(unsigned char data);

//#######################################################################
//#									#
//#	send serial byte						#
//#									#
//#######################################################################
void uart0_send_nonblock(unsigned char data);

//#######################################################################
//#									#
//#	get received byte						#
//#									#
//#######################################################################
unsigned char uart0_get(void);

//#######################################################################
//#									#
//#	check UART receiver (1=char)					#
//#									#
//#######################################################################
unsigned char uart0_check_rx(void);

//#######################################################################
//#									#
//#	check UART transmitter (1=empty)				#
//#									#
//#######################################################################
unsigned char uart0_check_tx(void);

//#######################################################################
//#									#
//#	enable transmit interrupt					#
//#									#
//#######################################################################
void uart0_enable_transmit_interrupt(void);

//#######################################################################
//#									#
//#	disable transmit interrupt					#
//#									#
//#######################################################################
void uart0_disable_transmit_interrupt(void);

//#######################################################################
//#									#
//#	enable receive interrupt					#
//#									#
//#######################################################################
void uart0_enable_receive_interrupt(void);

//#######################################################################
//#									#
//#	disable receive interrupt					#
//#									#
//#######################################################################
void uart0_disable_receive_interrupt(void);

//#######################################################################
//#									#
//#	init uart							#
//#									#
//#######################################################################
void uart0_enable(unsigned int divider);

//#######################################################################
//#									#
//#	disable UART							#
//#									#
//#######################################################################
void uart0_disable(void);

//#######################################################################
//#									#
//#	send serial byte						#
//#									#
//#######################################################################
void uart0_send(unsigned char data);

//#######################################################################
//#									#
//#	send serial byte						#
//#									#
//#######################################################################
void uart0_send_nonblock(unsigned char data);

//#######################################################################
//#									#
//#	get received byte						#
//#									#
//#######################################################################
unsigned char uart0_get(void);

//#######################################################################
//#									#
//#	check UART receiver (1=char)					#
//#									#
//#######################################################################
unsigned char uart0_check_rx(void);

//#######################################################################
//#									#
//#	check UART transmitter (1=empty)				#
//#									#
//#######################################################################
unsigned char uart0_check_tx(void);

//#######################################################################
//#									#
//#	enable transmit interrupt					#
//#									#
//#######################################################################
void uart1_enable_transmit_interrupt(void);

//#######################################################################
//#									#
//#	disable transmit interrupt					#
//#									#
//#######################################################################
void uart1_disable_transmit_interrupt(void);

//#######################################################################
//#									#
//#	enable receive interrupt					#
//#									#
//#######################################################################
void uart1_enable_receive_interrupt(void);

//#######################################################################
//#									#
//#	disable receive interrupt					#
//#									#
//#######################################################################
void uart1_disable_receive_interrupt(void);

