#ifndef _IOHEADER
#define _IOHEADER
typedef unsigned char io_byte;
typedef unsigned int io_word;
typedef unsigned long io_dword;
typedef unsigned long io_dlong[2];
typedef unsigned char PORT_TYPE;
typedef unsigned char PORT_SIZE_TYPE;

/*------------------------------------------------------------------------------------
  Port register 0 
------------------------------------------------------------------------------------*/
typedef union P0_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} P0;
#define		P0		(*(volatile union P0_T *) 0x0FFF00)
/*------------------------------------------------------------------------------------
  Port register 1 
------------------------------------------------------------------------------------*/
typedef union P1_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} P1;
#define		P1		(*(volatile union P1_T *) 0x0FFF01)
/*------------------------------------------------------------------------------------
  Port register 3 
------------------------------------------------------------------------------------*/
typedef union P3_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} P3;
#define		P3		(*(volatile union P3_T *) 0x0FFF03)
/*------------------------------------------------------------------------------------
  Port register 4 
------------------------------------------------------------------------------------*/
typedef union P4_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} P4;
#define		P4		(*(volatile union P4_T *) 0x0FFF04)
/*------------------------------------------------------------------------------------
  Port register 6 
------------------------------------------------------------------------------------*/
typedef union P6_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} P6;
#define		P6		(*(volatile union P6_T *) 0x0FFF06)
/*------------------------------------------------------------------------------------
  Port register 7 
------------------------------------------------------------------------------------*/
typedef union P7_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} P7;
#define		P7		(*(volatile union P7_T *) 0x0FFF07)
/*------------------------------------------------------------------------------------
  Port register 8 
------------------------------------------------------------------------------------*/
typedef union P8_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} P8;
#define		P8		(*(volatile union P8_T *) 0x0FFF08)
/*------------------------------------------------------------------------------------
  Port register 9 
------------------------------------------------------------------------------------*/
typedef union P9_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} P9;
#define		P9		(*(volatile union P9_T *) 0x0FFF09)
/*------------------------------------------------------------------------------------
  Port register 1 
------------------------------------------------------------------------------------*/
typedef union P12_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} P12;
#define		P12		(*(volatile union P12_T *) 0x0FFF0C)
/*------------------------------------------------------------------------------------
  Port register 1 
------------------------------------------------------------------------------------*/
typedef union P13_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} P13;
#define		P13		(*(volatile union P13_T *) 0x0FFF0D)
/*------------------------------------------------------------------------------------
  Port register 1 
------------------------------------------------------------------------------------*/
typedef union P14_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} P14;
#define		P14		(*(volatile union P14_T *) 0x0FFF0E)
/*------------------------------------------------------------------------------------
  Serial data register 00 
------------------------------------------------------------------------------------*/
typedef union SDR00_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} SDR00;
#define		SDR00		(*(volatile union SDR00_T *) 0x0FFF10)
/*------------------------------------------------------------------------------------
  Serial data register 00 
------------------------------------------------------------------------------------*/
typedef union SDR00L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} SDR00L;
#define		SDR00L		(*(volatile union SDR00L_T *) 0x0FFF10)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union SDR01_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} SDR01;
#define		SDR01		(*(volatile union SDR01_T *) 0x0FFF12)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union SDR01L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} SDR01L;
#define		SDR01L		(*(volatile union SDR01L_T *) 0x0FFF12)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union TDR00_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} TDR00;
#define		TDR00		(*(volatile union TDR00_T *) 0x0FFF18)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union TDR01_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} TDR01;
#define		TDR01		(*(volatile union TDR01_T *) 0x0FFF1A)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union TDR01L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} TDR01L;
#define		TDR01L		(*(volatile union TDR01L_T *) 0x0FFF1A)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union TDR01H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} TDR01H;
#define		TDR01H		(*(volatile union TDR01H_T *) 0x0FFF1B)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union ADCR_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} ADCR;
#define		ADCR		(*(volatile union ADCR_T *) 0x0FFF1E)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union ADCRH_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} ADCRH;
#define		ADCRH		(*(volatile union ADCRH_T *) 0x0FFF1F)
/*------------------------------------------------------------------------------------
  Port mode register 0 
------------------------------------------------------------------------------------*/
typedef union PM0_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} PM0;
#define		PM0		(*(volatile union PM0_T *) 0x0FFF20)
/*------------------------------------------------------------------------------------
  Port mode register 1 
------------------------------------------------------------------------------------*/
typedef union PM1_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} PM1;
#define		PM1		(*(volatile union PM1_T *) 0x0FFF21)
/*------------------------------------------------------------------------------------
  Port mode register 3 
------------------------------------------------------------------------------------*/
typedef union PM3_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} PM3;
#define		PM3		(*(volatile union PM3_T *) 0x0FFF23)
/*------------------------------------------------------------------------------------
  Port mode register 4 
------------------------------------------------------------------------------------*/
typedef union PM4_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} PM4;
#define		PM4		(*(volatile union PM4_T *) 0x0FFF24)
/*------------------------------------------------------------------------------------
  Port mode register 6 
------------------------------------------------------------------------------------*/
typedef union PM6_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} PM6;
#define		PM6		(*(volatile union PM6_T *) 0x0FFF26)
/*------------------------------------------------------------------------------------
  Port mode register 7 
------------------------------------------------------------------------------------*/
typedef union PM7_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} PM7;
#define		PM7		(*(volatile union PM7_T *) 0x0FFF27)
/*------------------------------------------------------------------------------------
  Port mode register 8 
------------------------------------------------------------------------------------*/
typedef union PM8_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} PM8;
#define		PM8		(*(volatile union PM8_T *) 0x0FFF28)
/*------------------------------------------------------------------------------------
  Port mode register 9 
------------------------------------------------------------------------------------*/
typedef union PM9_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} PM9;
#define		PM9		(*(volatile union PM9_T *) 0x0FFF29)
/*------------------------------------------------------------------------------------
  Port mode register 1 
------------------------------------------------------------------------------------*/
typedef union PM12_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} PM12;
#define		PM12		(*(volatile union PM12_T *) 0x0FFF2C)
/*------------------------------------------------------------------------------------
  Port mode register 1 
------------------------------------------------------------------------------------*/
typedef union PM14_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} PM14;
#define		PM14		(*(volatile union PM14_T *) 0x0FFF2E)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union ADM0_T
{
	io_byte REG;
	struct
	{
		io_byte ADCE    :1;		/* (BIT)*/
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte ADCS    :1;		/* (BIT)*/
	} BIT;
} ADM0;
#define		ADM0		(*(volatile union ADM0_T *) 0x0FFF30)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union ADS_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} ADS;
#define		ADS		(*(volatile union ADS_T *) 0x0FFF31)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union ADM1_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} ADM1;
#define		ADM1		(*(volatile union ADM1_T *) 0x0FFF32)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union DACS0_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} DACS0;
#define		DACS0		(*(volatile union DACS0_T *) 0x0FFF34)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union DACS1_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} DACS1;
#define		DACS1		(*(volatile union DACS1_T *) 0x0FFF35)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union DAM_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte DACE0   :1;		/* (BIT)*/
		io_byte DACE1   :1;		/* (BIT)*/
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} DAM;
#define		DAM		(*(volatile union DAM_T *) 0x0FFF36)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union KRM_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} KRM;
#define		KRM		(*(volatile union KRM_T *) 0x0FFF37)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union EGP0_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} EGP0;
#define		EGP0		(*(volatile union EGP0_T *) 0x0FFF38)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union EGN0_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} EGN0;
#define		EGN0		(*(volatile union EGN0_T *) 0x0FFF39)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union EGP1_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} EGP1;
#define		EGP1		(*(volatile union EGP1_T *) 0x0FFF3A)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union EGN1_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} EGN1;
#define		EGN1		(*(volatile union EGN1_T *) 0x0FFF3B)
/*------------------------------------------------------------------------------------
  Serial data register 10 
------------------------------------------------------------------------------------*/
typedef union SDR10_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} SDR10;
#define		SDR10		(*(volatile union SDR10_T *) 0x0FFF48)
/*------------------------------------------------------------------------------------
  Serial data register 10 
------------------------------------------------------------------------------------*/
typedef union SDR10L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} SDR10L;
#define		SDR10L		(*(volatile union SDR10L_T *) 0x0FFF48)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union SDR11_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} SDR11;
#define		SDR11		(*(volatile union SDR11_T *) 0x0FFF4A)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union SDR11L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} SDR11L;
#define		SDR11L		(*(volatile union SDR11L_T *) 0x0FFF4A)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union IICA0_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} IICA0;
#define		IICA0		(*(volatile union IICA0_T *) 0x0FFF50)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union IICS0_T
{
	io_byte REG;
	struct
	{
		io_byte SPD0    :1;		/* (BIT)*/
		io_byte STD0    :1;		/* (BIT)*/
		io_byte ACKD0   :1;		/* (BIT)*/
		io_byte TRC0    :1;		/* (BIT)*/
		io_byte COI0    :1;		/* (BIT)*/
		io_byte EXC0    :1;		/* (BIT)*/
		io_byte ALD0    :1;		/* (BIT)*/
		io_byte MSTS0   :1;		/* (BIT)*/
	} BIT;
} IICS0;
#define		IICS0		(*(volatile union IICS0_T *) 0x0FFF51)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union IICF0_T
{
	io_byte REG;
	struct
	{
		io_byte IICRSV0 :1;		/* (BIT)*/
		io_byte STCEN0  :1;		/* (BIT)*/
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte IICBSY0 :1;		/* (BIT)*/
		io_byte STCF0   :1;		/* (BIT)*/
	} BIT;
} IICF0;
#define		IICF0		(*(volatile union IICF0_T *) 0x0FFF52)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union SUBCUDW_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} SUBCUDW;
#define		SUBCUDW		(*(volatile union SUBCUDW_T *) 0x0FFF54)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union TRDGRC0_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} TRDGRC0;
#define		TRDGRC0		(*(volatile union TRDGRC0_T *) 0x0FFF58)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union TRDGRD0_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} TRDGRD0;
#define		TRDGRD0		(*(volatile union TRDGRD0_T *) 0x0FFF5A)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union TRDGRC1_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} TRDGRC1;
#define		TRDGRC1		(*(volatile union TRDGRC1_T *) 0x0FFF5C)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union TRDGRD1_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} TRDGRD1;
#define		TRDGRD1		(*(volatile union TRDGRD1_T *) 0x0FFF5E)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union TDR02_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} TDR02;
#define		TDR02		(*(volatile union TDR02_T *) 0x0FFF64)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union TDR03_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} TDR03;
#define		TDR03		(*(volatile union TDR03_T *) 0x0FFF66)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union TDR03L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} TDR03L;
#define		TDR03L		(*(volatile union TDR03L_T *) 0x0FFF66)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union TDR03H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} TDR03H;
#define		TDR03H		(*(volatile union TDR03H_T *) 0x0FFF67)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union TDR04_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} TDR04;
#define		TDR04		(*(volatile union TDR04_T *) 0x0FFF68)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union TDR05_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} TDR05;
#define		TDR05		(*(volatile union TDR05_T *) 0x0FFF6A)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union TDR06_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} TDR06;
#define		TDR06		(*(volatile union TDR06_T *) 0x0FFF6C)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union TDR07_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} TDR07;
#define		TDR07		(*(volatile union TDR07_T *) 0x0FFF6E)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union TDR10_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} TDR10;
#define		TDR10		(*(volatile union TDR10_T *) 0x0FFF70)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union TDR11_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} TDR11;
#define		TDR11		(*(volatile union TDR11_T *) 0x0FFF72)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union TDR11L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} TDR11L;
#define		TDR11L		(*(volatile union TDR11L_T *) 0x0FFF72)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union TDR11H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} TDR11H;
#define		TDR11H		(*(volatile union TDR11H_T *) 0x0FFF73)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union TDR12_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} TDR12;
#define		TDR12		(*(volatile union TDR12_T *) 0x0FFF74)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union TDR13_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} TDR13;
#define		TDR13		(*(volatile union TDR13_T *) 0x0FFF76)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union TDR13L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} TDR13L;
#define		TDR13L		(*(volatile union TDR13L_T *) 0x0FFF76)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union TDR13H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} TDR13H;
#define		TDR13H		(*(volatile union TDR13H_T *) 0x0FFF77)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union TDR14_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} TDR14;
#define		TDR14		(*(volatile union TDR14_T *) 0x0FFF78)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union TDR15_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} TDR15;
#define		TDR15		(*(volatile union TDR15_T *) 0x0FFF7A)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union TDR16_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} TDR16;
#define		TDR16		(*(volatile union TDR16_T *) 0x0FFF7C)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union TDR17_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} TDR17;
#define		TDR17		(*(volatile union TDR17_T *) 0x0FFF7E)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union FLPMC_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} FLPMC;
#define		FLPMC		(*(volatile union FLPMC_T *) 0x0FFF80)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union FLARS_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} FLARS;
#define		FLARS		(*(volatile union FLARS_T *) 0x0FFF81)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union FLAPL_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} FLAPL;
#define		FLAPL		(*(volatile union FLAPL_T *) 0x0FFF82)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union FLAPH_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} FLAPH;
#define		FLAPH		(*(volatile union FLAPH_T *) 0x0FFF84)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union FSSQ_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte FSSTP   :1;		/* (BIT)*/
		io_byte SQST    :1;		/* (BIT)*/
	} BIT;
} FSSQ;
#define		FSSQ		(*(volatile union FSSQ_T *) 0x0FFF85)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union FLSEDL_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} FLSEDL;
#define		FLSEDL		(*(volatile union FLSEDL_T *) 0x0FFF86)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union FLSEDH_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} FLSEDH;
#define		FLSEDH		(*(volatile union FLSEDH_T *) 0x0FFF88)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union FLRST_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} FLRST;
#define		FLRST		(*(volatile union FLRST_T *) 0x0FFF89)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union FSASTL_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} FSASTL;
#define		FSASTL		(*(volatile union FSASTL_T *) 0x0FFF8A)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union FSASTH_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte SQEND   :1;		/* (BIT)*/
		io_byte ESQEND  :1;		/* (BIT)*/
	} BIT;
} FSASTH;
#define		FSASTH		(*(volatile union FSASTH_T *) 0x0FFF8B)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union FLWL_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} FLWL;
#define		FLWL		(*(volatile union FLWL_T *) 0x0FFF8C)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union FLWH_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} FLWH;
#define		FLWH		(*(volatile union FLWH_T *) 0x0FFF8E)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union ITMC_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} ITMC;
#define		ITMC		(*(volatile union ITMC_T *) 0x0FFF90)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union SEC_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} SEC;
#define		SEC		(*(volatile union SEC_T *) 0x0FFF92)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union MIN_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} MIN;
#define		MIN		(*(volatile union MIN_T *) 0x0FFF93)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union HOUR_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} HOUR;
#define		HOUR		(*(volatile union HOUR_T *) 0x0FFF94)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union WEEK_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} WEEK;
#define		WEEK		(*(volatile union WEEK_T *) 0x0FFF95)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union DAY_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} DAY;
#define		DAY		(*(volatile union DAY_T *) 0x0FFF96)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union MONTH_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} MONTH;
#define		MONTH		(*(volatile union MONTH_T *) 0x0FFF97)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union YEAR_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} YEAR;
#define		YEAR		(*(volatile union YEAR_T *) 0x0FFF98)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union SUBCUD_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} SUBCUD;
#define		SUBCUD		(*(volatile union SUBCUD_T *) 0x0FFF99)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union ALARMWM_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} ALARMWM;
#define		ALARMWM		(*(volatile union ALARMWM_T *) 0x0FFF9A)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union ALARMWH_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} ALARMWH;
#define		ALARMWH		(*(volatile union ALARMWH_T *) 0x0FFF9B)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union ALARMWW_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} ALARMWW;
#define		ALARMWW		(*(volatile union ALARMWW_T *) 0x0FFF9C)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RTCC0_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte RCLOE1  :1;		/* (BIT)*/
		io_byte B6:1;
		io_byte RTCE    :1;		/* (BIT)*/
	} BIT;
} RTCC0;
#define		RTCC0		(*(volatile union RTCC0_T *) 0x0FFF9D)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RTCC1_T
{
	io_byte REG;
	struct
	{
		io_byte RWAIT   :1;		/* (BIT)*/
		io_byte RWST    :1;		/* (BIT)*/
		io_byte B2:1;
		io_byte RIFG    :1;		/* (BIT)*/
		io_byte WAFG    :1;		/* (BIT)*/
		io_byte B5:1;
		io_byte WALIE   :1;		/* (BIT)*/
		io_byte WALE    :1;		/* (BIT)*/
	} BIT;
} RTCC1;
#define		RTCC1		(*(volatile union RTCC1_T *) 0x0FFF9E)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union CMC_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} CMC;
#define		CMC		(*(volatile union CMC_T *) 0x0FFFA0)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union CSC_T
{
	io_byte REG;
	struct
	{
		io_byte HIOSTOP :1;		/* (BIT)*/
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte XTSTOP  :1;		/* (BIT)*/
		io_byte MSTOP   :1;		/* (BIT)*/
	} BIT;
} CSC;
#define		CSC		(*(volatile union CSC_T *) 0x0FFFA1)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union OSTC_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} OSTC;
#define		OSTC		(*(volatile union OSTC_T *) 0x0FFFA2)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union OSTS_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} OSTS;
#define		OSTS		(*(volatile union OSTS_T *) 0x0FFFA3)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union CKC_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte SDIV    :1;		/* (BIT)*/
		io_byte MCM0    :1;		/* (BIT)*/
		io_byte MCS     :1;		/* (BIT)*/
		io_byte CSS     :1;		/* (BIT)*/
		io_byte CLS     :1;		/* (BIT)*/
	} BIT;
} CKC;
#define		CKC		(*(volatile union CKC_T *) 0x0FFFA4)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union CKS0_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte PCLOE0  :1;		/* (BIT)*/
	} BIT;
} CKS0;
#define		CKS0		(*(volatile union CKS0_T *) 0x0FFFA5)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union CKS1_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte PCLOE1  :1;		/* (BIT)*/
	} BIT;
} CKS1;
#define		CKS1		(*(volatile union CKS1_T *) 0x0FFFA6)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RESF_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RESF;
#define		RESF		(*(volatile union RESF_T *) 0x0FFFA8)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union LVIM_T
{
	io_byte REG;
	struct
	{
		io_byte LVIF    :1;		/* (BIT)*/
		io_byte LVIOMSK :1;		/* (BIT)*/
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte LVISEN  :1;		/* (BIT)*/
	} BIT;
} LVIM;
#define		LVIM		(*(volatile union LVIM_T *) 0x0FFFA9)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union LVIS_T
{
	io_byte REG;
	struct
	{
		io_byte LVILV   :1;		/* (BIT)*/
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte LVIMD   :1;		/* (BIT)*/
	} BIT;
} LVIS;
#define		LVIS		(*(volatile union LVIS_T *) 0x0FFFAA)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union WDTE_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} WDTE;
#define		WDTE		(*(volatile union WDTE_T *) 0x0FFFAB)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union CRCIN_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} CRCIN;
#define		CRCIN		(*(volatile union CRCIN_T *) 0x0FFFAC)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RXB_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RXB;
#define		RXB		(*(volatile union RXB_T *) 0x0FFFAD)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union TXS_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} TXS;
#define		TXS		(*(volatile union TXS_T *) 0x0FFFAD)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union MONSTA0_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} MONSTA0;
#define		MONSTA0		(*(volatile union MONSTA0_T *) 0x0FFFAE)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union ASIM_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} ASIM;
#define		ASIM		(*(volatile union ASIM_T *) 0x0FFFAF)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union IF2_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} IF2;
#define		IF2		(*(volatile union IF2_T *) 0x0FFFD0)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union IF2L_T
{
	io_byte REG;
	struct
	{
		io_byte TMIF05  :1;		/* (BIT)*/
		io_byte TMIF06  :1;		/* (BIT)*/
		io_byte TMIF07  :1;		/* (BIT)*/
		io_byte LIN0WUPIF:1;		/* (BIT)*/
		io_byte KRIF    :1;		/* (BIT)*/
		io_byte CAN0ERRIF:1;		/* (BIT)*/
		io_byte CAN0WUPIF:1;		/* (BIT)*/
		io_byte CAN0CFRIF:1;		/* (BIT)*/
	} BIT;
} IF2L;
#define		IF2L		(*(volatile union IF2L_T *) 0x0FFFD0)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union IF2H_T
{
	io_byte REG;
	struct
	{
		io_byte CAN0TRMIF:1;		/* (BIT)*/
		io_byte CANGRFRIF:1;		/* (BIT)*/
		io_byte CANGERRIF:1;		/* (BIT)*/
		io_byte TMIF10  :1;		/* (BIT)*/
		io_byte TMIF11  :1;		/* (BIT)*/
		io_byte TMIF12  :1;		/* (BIT)*/
		io_byte TMIF13  :1;		/* (BIT)*/
		io_byte FLIF    :1;		/* (BIT)*/
	} BIT;
} IF2H;
#define		IF2H		(*(volatile union IF2H_T *) 0x0FFFD1)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union IF3L_T
{
	io_byte REG;
	struct
	{
		io_byte LIN1WUPIF:1;		/* (BIT)*/
		io_byte LIN1TRMIF:1;		/* (BIT)*/
		io_byte LIN1RVCIF:1;		/* (BIT)*/
		io_byte LIN1STAIF:1;		/* (BIT)*/
		io_byte TMIF14  :1;		/* (BIT)*/
		io_byte TMIF15  :1;		/* (BIT)*/
		io_byte TMIF16  :1;		/* (BIT)*/
		io_byte TMIF17  :1;		/* (BIT)*/
	} BIT;
} IF3L;
#define		IF3L		(*(volatile union IF3L_T *) 0x0FFFD2)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union MK2_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} MK2;
#define		MK2		(*(volatile union MK2_T *) 0x0FFFD4)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union MK2L_T
{
	io_byte REG;
	struct
	{
		io_byte TMMK05  :1;		/* (BIT)*/
		io_byte TMMK06  :1;		/* (BIT)*/
		io_byte TMMK07  :1;		/* (BIT)*/
		io_byte LIN0WUPMK:1;		/* (BIT)*/
		io_byte KRMK    :1;		/* (BIT)*/
		io_byte CAN0ERRMK:1;		/* (BIT)*/
		io_byte CAN0WUPMK:1;		/* (BIT)*/
		io_byte CAN0CFRMK:1;		/* (BIT)*/
	} BIT;
} MK2L;
#define		MK2L		(*(volatile union MK2L_T *) 0x0FFFD4)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union MK2H_T
{
	io_byte REG;
	struct
	{
		io_byte CAN0TRMMK:1;		/* (BIT)*/
		io_byte CANGRFRMK:1;		/* (BIT)*/
		io_byte CANGERRMK:1;		/* (BIT)*/
		io_byte TMMK10  :1;		/* (BIT)*/
		io_byte TMMK11  :1;		/* (BIT)*/
		io_byte TMMK12  :1;		/* (BIT)*/
		io_byte TMMK13  :1;		/* (BIT)*/
		io_byte FLMK    :1;		/* (BIT)*/
	} BIT;
} MK2H;
#define		MK2H		(*(volatile union MK2H_T *) 0x0FFFD5)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union MK3L_T
{
	io_byte REG;
	struct
	{
		io_byte LIN1WUPMK:1;		/* (BIT)*/
		io_byte LIN1TRMMK:1;		/* (BIT)*/
		io_byte LIN1RVCMK:1;		/* (BIT)*/
		io_byte LIN1STAMK:1;		/* (BIT)*/
		io_byte TMMK14  :1;		/* (BIT)*/
		io_byte TMMK15  :1;		/* (BIT)*/
		io_byte TMMK16  :1;		/* (BIT)*/
		io_byte TMMK17  :1;		/* (BIT)*/
	} BIT;
} MK3L;
#define		MK3L		(*(volatile union MK3L_T *) 0x0FFFD6)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union PR02_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} PR02;
#define		PR02		(*(volatile union PR02_T *) 0x0FFFD8)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union PR02L_T
{
	io_byte REG;
	struct
	{
		io_byte TMPR005 :1;		/* (BIT)*/
		io_byte TMPR006 :1;		/* (BIT)*/
		io_byte TMPR007 :1;		/* (BIT)*/
		io_byte LIN0WUPPR0:1;		/* (BIT)*/
		io_byte KRPR0   :1;		/* (BIT)*/
		io_byte CAN0ERRPR0:1;		/* (BIT)*/
		io_byte CAN0WUPPR0:1;		/* (BIT)*/
		io_byte CAN0CFRPR0:1;		/* (BIT)*/
	} BIT;
} PR02L;
#define		PR02L		(*(volatile union PR02L_T *) 0x0FFFD8)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union PR02H_T
{
	io_byte REG;
	struct
	{
		io_byte CAN0TRMPR0:1;		/* (BIT)*/
		io_byte CANGRFRPR0:1;		/* (BIT)*/
		io_byte CANGERRPR0:1;		/* (BIT)*/
		io_byte TMPR010 :1;		/* (BIT)*/
		io_byte TMPR011 :1;		/* (BIT)*/
		io_byte TMPR012 :1;		/* (BIT)*/
		io_byte TMPR013 :1;		/* (BIT)*/
		io_byte FLPR0   :1;		/* (BIT)*/
	} BIT;
} PR02H;
#define		PR02H		(*(volatile union PR02H_T *) 0x0FFFD9)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union PR03L_T
{
	io_byte REG;
	struct
	{
		io_byte LIN1WUPPR0:1;		/* (BIT)*/
		io_byte LIN1TRMPR0:1;		/* (BIT)*/
		io_byte LIN1RVCPR0:1;		/* (BIT)*/
		io_byte LIN1STAPR0:1;		/* (BIT)*/
		io_byte TMPR014 :1;		/* (BIT)*/
		io_byte TMPR015 :1;		/* (BIT)*/
		io_byte TMPR016 :1;		/* (BIT)*/
		io_byte TMPR017 :1;		/* (BIT)*/
	} BIT;
} PR03L;
#define		PR03L		(*(volatile union PR03L_T *) 0x0FFFDA)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union PR12_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} PR12;
#define		PR12		(*(volatile union PR12_T *) 0x0FFFDC)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union PR12L_T
{
	io_byte REG;
	struct
	{
		io_byte TMPR105 :1;		/* (BIT)*/
		io_byte TMPR106 :1;		/* (BIT)*/
		io_byte TMPR107 :1;		/* (BIT)*/
		io_byte LIN0WUPPR1:1;		/* (BIT)*/
		io_byte KRPR1   :1;		/* (BIT)*/
		io_byte CAN0ERRPR1:1;		/* (BIT)*/
		io_byte CAN0WUPPR1:1;		/* (BIT)*/
		io_byte CAN0CFRPR1:1;		/* (BIT)*/
	} BIT;
} PR12L;
#define		PR12L		(*(volatile union PR12L_T *) 0x0FFFDC)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union PR12H_T
{
	io_byte REG;
	struct
	{
		io_byte CAN0TRMPR1:1;		/* (BIT)*/
		io_byte CANGRFRPR1:1;		/* (BIT)*/
		io_byte CANGERRPR1:1;		/* (BIT)*/
		io_byte TMPR110 :1;		/* (BIT)*/
		io_byte TMPR111 :1;		/* (BIT)*/
		io_byte TMPR112 :1;		/* (BIT)*/
		io_byte TMPR113 :1;		/* (BIT)*/
		io_byte FLPR1   :1;		/* (BIT)*/
	} BIT;
} PR12H;
#define		PR12H		(*(volatile union PR12H_T *) 0x0FFFDD)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union PR13L_T
{
	io_byte REG;
	struct
	{
		io_byte LIN1WUPPR1:1;		/* (BIT)*/
		io_byte LIN1TRMPR1:1;		/* (BIT)*/
		io_byte LIN1RVCPR1:1;		/* (BIT)*/
		io_byte LIN1STAPR1:1;		/* (BIT)*/
		io_byte TMPR114 :1;		/* (BIT)*/
		io_byte TMPR115 :1;		/* (BIT)*/
		io_byte TMPR116 :1;		/* (BIT)*/
		io_byte TMPR117 :1;		/* (BIT)*/
	} BIT;
} PR13L;
#define		PR13L		(*(volatile union PR13L_T *) 0x0FFFDE)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union IF0_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} IF0;
#define		IF0		(*(volatile union IF0_T *) 0x0FFFE0)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union IF0L_T
{
	io_byte REG;
	struct
	{
		io_byte WDTIIF  :1;		/* (BIT)*/
		io_byte LVIIF   :1;		/* (BIT)*/
		io_byte PIF0    :1;		/* (BIT)*/
		io_byte PIF1    :1;		/* (BIT)*/
		io_byte PIF2    :1;		/* (BIT)*/
		io_byte PIF3    :1;		/* (BIT)*/
		io_byte SPMIF   :1;		/* (BIT)*/
		io_byte PIF5    :1;		/* (BIT)*/
	} BIT;
} IF0L;
#define		IF0L		(*(volatile union IF0L_T *) 0x0FFFE0)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union IF0H_T
{
	io_byte REG;
	struct
	{
		io_byte CLMIF   :1;		/* (BIT)*/
		io_byte STIF0   :1;		/* (BIT)*/
		io_byte SRIF0   :1;		/* (BIT)*/
		io_byte TRDIF0  :1;		/* (BIT)*/
		io_byte TRDIF1  :1;		/* (BIT)*/
		io_byte TRJIF0  :1;		/* (BIT)*/
		io_byte RAMIF   :1;		/* (BIT)*/
		io_byte LIN0TRMIF:1;		/* (BIT)*/
	} BIT;
} IF0H;
#define		IF0H		(*(volatile union IF0H_T *) 0x0FFFE1)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union IF1_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} IF1;
#define		IF1		(*(volatile union IF1_T *) 0x0FFFE2)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union IF1L_T
{
	io_byte REG;
	struct
	{
		io_byte LIN0RVCIF:1;		/* (BIT)*/
		io_byte LIN0STAIF:1;		/* (BIT)*/
		io_byte IICAIF0 :1;		/* (BIT)*/
		io_byte RTCIF   :1;		/* (BIT)*/
		io_byte TMIF00  :1;		/* (BIT)*/
		io_byte TMIF01  :1;		/* (BIT)*/
		io_byte TMIF02  :1;		/* (BIT)*/
		io_byte TMIF03  :1;		/* (BIT)*/
	} BIT;
} IF1L;
#define		IF1L		(*(volatile union IF1L_T *) 0x0FFFE2)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union IF1H_T
{
	io_byte REG;
	struct
	{
		io_byte ADIF    :1;		/* (BIT)*/
		io_byte TMIF11H :1;		/* (BIT)*/
		io_byte TMIF13H :1;		/* (BIT)*/
		io_byte TMIF01H :1;		/* (BIT)*/
		io_byte TMIF03H :1;		/* (BIT)*/
		io_byte STIF1   :1;		/* (BIT)*/
		io_byte SRIF1   :1;		/* (BIT)*/
		io_byte TMIF04  :1;		/* (BIT)*/
	} BIT;
} IF1H;
#define		IF1H		(*(volatile union IF1H_T *) 0x0FFFE3)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union MK0_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} MK0;
#define		MK0		(*(volatile union MK0_T *) 0x0FFFE4)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union MK0L_T
{
	io_byte REG;
	struct
	{
		io_byte WDTIMK  :1;		/* (BIT)*/
		io_byte LVIMK   :1;		/* (BIT)*/
		io_byte PMK0    :1;		/* (BIT)*/
		io_byte PMK1    :1;		/* (BIT)*/
		io_byte PMK2    :1;		/* (BIT)*/
		io_byte PMK3    :1;		/* (BIT)*/
		io_byte SPMMK   :1;		/* (BIT)*/
		io_byte PMK5    :1;		/* (BIT)*/
	} BIT;
} MK0L;
#define		MK0L		(*(volatile union MK0L_T *) 0x0FFFE4)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union MK0H_T
{
	io_byte REG;
	struct
	{
		io_byte CLMMK   :1;		/* (BIT)*/
		io_byte STMK0   :1;		/* (BIT)*/
		io_byte SRMK0   :1;		/* (BIT)*/
		io_byte TRDMK0  :1;		/* (BIT)*/
		io_byte TRDMK1  :1;		/* (BIT)*/
		io_byte TRJMK0  :1;		/* (BIT)*/
		io_byte RAMMK   :1;		/* (BIT)*/
		io_byte LIN0TRMMK:1;		/* (BIT)*/
	} BIT;
} MK0H;
#define		MK0H		(*(volatile union MK0H_T *) 0x0FFFE5)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union MK1_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} MK1;
#define		MK1		(*(volatile union MK1_T *) 0x0FFFE6)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union MK1L_T
{
	io_byte REG;
	struct
	{
		io_byte LIN0RVCMK:1;		/* (BIT)*/
		io_byte LIN0STAMK:1;		/* (BIT)*/
		io_byte IICAMK0 :1;		/* (BIT)*/
		io_byte RTCMK   :1;		/* (BIT)*/
		io_byte TMMK00  :1;		/* (BIT)*/
		io_byte TMMK01  :1;		/* (BIT)*/
		io_byte TMMK02  :1;		/* (BIT)*/
		io_byte TMMK03  :1;		/* (BIT)*/
	} BIT;
} MK1L;
#define		MK1L		(*(volatile union MK1L_T *) 0x0FFFE6)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union MK1H_T
{
	io_byte REG;
	struct
	{
		io_byte ADMK    :1;		/* (BIT)*/
		io_byte TMMK11H :1;		/* (BIT)*/
		io_byte TMMK13H :1;		/* (BIT)*/
		io_byte TMMK01H :1;		/* (BIT)*/
		io_byte TMMK03H :1;		/* (BIT)*/
		io_byte STMK1   :1;		/* (BIT)*/
		io_byte SRMK1   :1;		/* (BIT)*/
		io_byte TMMK04  :1;		/* (BIT)*/
	} BIT;
} MK1H;
#define		MK1H		(*(volatile union MK1H_T *) 0x0FFFE7)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union PR00_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} PR00;
#define		PR00		(*(volatile union PR00_T *) 0x0FFFE8)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union PR00L_T
{
	io_byte REG;
	struct
	{
		io_byte WDTIPR0 :1;		/* (BIT)*/
		io_byte LVIPR0  :1;		/* (BIT)*/
		io_byte PPR00   :1;		/* (BIT)*/
		io_byte PPR01   :1;		/* (BIT)*/
		io_byte PPR02   :1;		/* (BIT)*/
		io_byte PPR03   :1;		/* (BIT)*/
		io_byte SPMPR0  :1;		/* (BIT)*/
		io_byte PPR05   :1;		/* (BIT)*/
	} BIT;
} PR00L;
#define		PR00L		(*(volatile union PR00L_T *) 0x0FFFE8)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union PR00H_T
{
	io_byte REG;
	struct
	{
		io_byte CLMPR0  :1;		/* (BIT)*/
		io_byte STPR00  :1;		/* (BIT)*/
		io_byte SRPR00  :1;		/* (BIT)*/
		io_byte TRDPR00 :1;		/* (BIT)*/
		io_byte TRDPR01 :1;		/* (BIT)*/
		io_byte TRJPR00 :1;		/* (BIT)*/
		io_byte RAMPR0  :1;		/* (BIT)*/
		io_byte LIN0TRMPR0:1;		/* (BIT)*/
	} BIT;
} PR00H;
#define		PR00H		(*(volatile union PR00H_T *) 0x0FFFE9)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union PR01_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} PR01;
#define		PR01		(*(volatile union PR01_T *) 0x0FFFEA)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union PR01L_T
{
	io_byte REG;
	struct
	{
		io_byte LIN0RVCPR0:1;		/* (BIT)*/
		io_byte LIN0STAPR0:1;		/* (BIT)*/
		io_byte IICAPR00:1;		/* (BIT)*/
		io_byte RTCPR0  :1;		/* (BIT)*/
		io_byte TMPR000 :1;		/* (BIT)*/
		io_byte TMPR001 :1;		/* (BIT)*/
		io_byte TMPR002 :1;		/* (BIT)*/
		io_byte TMPR003 :1;		/* (BIT)*/
	} BIT;
} PR01L;
#define		PR01L		(*(volatile union PR01L_T *) 0x0FFFEA)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union PR01H_T
{
	io_byte REG;
	struct
	{
		io_byte ADPR0   :1;		/* (BIT)*/
		io_byte TMPR011H:1;		/* (BIT)*/
		io_byte TMPR013H:1;		/* (BIT)*/
		io_byte TMPR001H:1;		/* (BIT)*/
		io_byte TMPR003H:1;		/* (BIT)*/
		io_byte STPR01  :1;		/* (BIT)*/
		io_byte SRPR01  :1;		/* (BIT)*/
		io_byte TMPR004 :1;		/* (BIT)*/
	} BIT;
} PR01H;
#define		PR01H		(*(volatile union PR01H_T *) 0x0FFFEB)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union PR10_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} PR10;
#define		PR10		(*(volatile union PR10_T *) 0x0FFFEC)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union PR10L_T
{
	io_byte REG;
	struct
	{
		io_byte WDTIPR1 :1;		/* (BIT)*/
		io_byte LVIPR1  :1;		/* (BIT)*/
		io_byte PPR10   :1;		/* (BIT)*/
		io_byte PPR11   :1;		/* (BIT)*/
		io_byte PPR12   :1;		/* (BIT)*/
		io_byte PPR13   :1;		/* (BIT)*/
		io_byte SPMPR1  :1;		/* (BIT)*/
		io_byte PPR15   :1;		/* (BIT)*/
	} BIT;
} PR10L;
#define		PR10L		(*(volatile union PR10L_T *) 0x0FFFEC)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union PR10H_T
{
	io_byte REG;
	struct
	{
		io_byte CLMPR1  :1;		/* (BIT)*/
		io_byte STPR10  :1;		/* (BIT)*/
		io_byte SRPR10  :1;		/* (BIT)*/
		io_byte TRDPR10 :1;		/* (BIT)*/
		io_byte TRDPR11 :1;		/* (BIT)*/
		io_byte TRJPR10 :1;		/* (BIT)*/
		io_byte RAMPR1  :1;		/* (BIT)*/
		io_byte LIN0TRMPR1:1;		/* (BIT)*/
	} BIT;
} PR10H;
#define		PR10H		(*(volatile union PR10H_T *) 0x0FFFED)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union PR11_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} PR11;
#define		PR11		(*(volatile union PR11_T *) 0x0FFFEE)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union PR11L_T
{
	io_byte REG;
	struct
	{
		io_byte LIN0RVCPR1:1;		/* (BIT)*/
		io_byte LIN0STAPR1:1;		/* (BIT)*/
		io_byte IICAPR10:1;		/* (BIT)*/
		io_byte RTCPR1  :1;		/* (BIT)*/
		io_byte TMPR100 :1;		/* (BIT)*/
		io_byte TMPR101 :1;		/* (BIT)*/
		io_byte TMPR102 :1;		/* (BIT)*/
		io_byte TMPR103 :1;		/* (BIT)*/
	} BIT;
} PR11L;
#define		PR11L		(*(volatile union PR11L_T *) 0x0FFFEE)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union PR11H_T
{
	io_byte REG;
	struct
	{
		io_byte ADPR1   :1;		/* (BIT)*/
		io_byte TMPR111H:1;		/* (BIT)*/
		io_byte TMPR113H:1;		/* (BIT)*/
		io_byte TMPR101H:1;		/* (BIT)*/
		io_byte TMPR103H:1;		/* (BIT)*/
		io_byte STPR11  :1;		/* (BIT)*/
		io_byte SRPR11  :1;		/* (BIT)*/
		io_byte TMPR104 :1;		/* (BIT)*/
	} BIT;
} PR11H;
#define		PR11H		(*(volatile union PR11H_T *) 0x0FFFEF)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union MACRL_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} MACRL;
#define		MACRL		(*(volatile union MACRL_T *) 0x0FFFF0)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union MACRH_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word ISP0    :1;		/* (BIT)*/
		io_word ISP1    :1;		/* (BIT)*/
		io_word RBS0    :1;		/* (BIT)*/
		io_word AC      :1;		/* (BIT)*/
		io_word RBS1    :1;		/* (BIT)*/
		io_word Z       :1;		/* (BIT)*/
		io_word IE      :1;		/* (BIT)*/
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} MACRH;
#define		MACRH		(*(volatile union MACRH_T *) 0x0FFFF2)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union MDUC_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} MDUC;
#define		MDUC		(*(volatile union MDUC_T *) 0x0FFFFB)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union PMC_T
{
	io_byte REG;
	struct
	{
		io_byte MAA     :1;		/* (BIT)*/
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} PMC;
#define		PMC		(*(volatile union PMC_T *) 0x0FFFFE)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union HDTCDUM_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} HDTCDUM;
#define		HDTCDUM		(*(volatile union HDTCDUM_T *) 0x0F0000)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union ADM2_T
{
	io_byte REG;
	struct
	{
		io_byte ADTYP   :1;		/* (BIT)*/
		io_byte B1:1;
		io_byte AWC     :1;		/* (BIT)*/
		io_byte ADRCK   :1;		/* (BIT)*/
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} ADM2;
#define		ADM2		(*(volatile union ADM2_T *) 0x0F0010)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union ADUL_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} ADUL;
#define		ADUL		(*(volatile union ADUL_T *) 0x0F0011)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union ADLL_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} ADLL;
#define		ADLL		(*(volatile union ADLL_T *) 0x0F0012)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union ADTES_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} ADTES;
#define		ADTES		(*(volatile union ADTES_T *) 0x0F0013)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union PIOR0_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} PIOR0;
#define		PIOR0		(*(volatile union PIOR0_T *) 0x0F0016)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union PIOR1_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} PIOR1;
#define		PIOR1		(*(volatile union PIOR1_T *) 0x0F0017)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union PIOR4_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} PIOR4;
#define		PIOR4		(*(volatile union PIOR4_T *) 0x0F001A)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union PIOR5_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} PIOR5;
#define		PIOR5		(*(volatile union PIOR5_T *) 0x0F001B)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union PIOR7_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} PIOR7;
#define		PIOR7		(*(volatile union PIOR7_T *) 0x0F001D)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union PITHL1_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} PITHL1;
#define		PITHL1		(*(volatile union PITHL1_T *) 0x0F0021)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union PITHL3_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} PITHL3;
#define		PITHL3		(*(volatile union PITHL3_T *) 0x0F0023)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union PITHL6_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} PITHL6;
#define		PITHL6		(*(volatile union PITHL6_T *) 0x0F0026)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union PITHL7_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} PITHL7;
#define		PITHL7		(*(volatile union PITHL7_T *) 0x0F0027)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union PITHL12_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} PITHL12;
#define		PITHL12		(*(volatile union PITHL12_T *) 0x0F002C)
/*------------------------------------------------------------------------------------
  Port Pull-Up register 0 
------------------------------------------------------------------------------------*/
typedef union PU0_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} PU0;
#define		PU0		(*(volatile union PU0_T *) 0x0F0030)
/*------------------------------------------------------------------------------------
  Port Pull-Up register 1 
------------------------------------------------------------------------------------*/
typedef union PU1_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} PU1;
#define		PU1		(*(volatile union PU1_T *) 0x0F0031)
/*------------------------------------------------------------------------------------
  Port Pull-Up register 3 
------------------------------------------------------------------------------------*/
typedef union PU3_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} PU3;
#define		PU3		(*(volatile union PU3_T *) 0x0F0033)
/*------------------------------------------------------------------------------------
  Port Pull-Up register 4 
------------------------------------------------------------------------------------*/
typedef union PU4_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} PU4;
#define		PU4		(*(volatile union PU4_T *) 0x0F0034)
/*------------------------------------------------------------------------------------
  Port Pull-Up register 6 
------------------------------------------------------------------------------------*/
typedef union PU6_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} PU6;
#define		PU6		(*(volatile union PU6_T *) 0x0F0036)
/*------------------------------------------------------------------------------------
  Port Pull-Up register 7 
------------------------------------------------------------------------------------*/
typedef union PU7_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} PU7;
#define		PU7		(*(volatile union PU7_T *) 0x0F0037)
/*------------------------------------------------------------------------------------
  Port Pull-Up register 1 
------------------------------------------------------------------------------------*/
typedef union PU12_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} PU12;
#define		PU12		(*(volatile union PU12_T *) 0x0F003C)
/*------------------------------------------------------------------------------------
  Port Pull-Up register 1 
------------------------------------------------------------------------------------*/
typedef union PU14_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} PU14;
#define		PU14		(*(volatile union PU14_T *) 0x0F003E)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union PIM1_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} PIM1;
#define		PIM1		(*(volatile union PIM1_T *) 0x0F0041)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union PIM3_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} PIM3;
#define		PIM3		(*(volatile union PIM3_T *) 0x0F0043)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union PIM6_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} PIM6;
#define		PIM6		(*(volatile union PIM6_T *) 0x0F0046)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union PIM7_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} PIM7;
#define		PIM7		(*(volatile union PIM7_T *) 0x0F0047)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union PIM12_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} PIM12;
#define		PIM12		(*(volatile union PIM12_T *) 0x0F004C)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union POM1_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} POM1;
#define		POM1		(*(volatile union POM1_T *) 0x0F0051)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union POM6_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} POM6;
#define		POM6		(*(volatile union POM6_T *) 0x0F0056)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union POM7_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} POM7;
#define		POM7		(*(volatile union POM7_T *) 0x0F0057)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union POM12_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} POM12;
#define		POM12		(*(volatile union POM12_T *) 0x0F005C)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union PMC7_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} PMC7;
#define		PMC7		(*(volatile union PMC7_T *) 0x0F0067)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union PMC12_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} PMC12;
#define		PMC12		(*(volatile union PMC12_T *) 0x0F006C)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union NFEN0_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} NFEN0;
#define		NFEN0		(*(volatile union NFEN0_T *) 0x0F0070)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union NFEN1_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} NFEN1;
#define		NFEN1		(*(volatile union NFEN1_T *) 0x0F0071)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union NFEN2_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} NFEN2;
#define		NFEN2		(*(volatile union NFEN2_T *) 0x0F0072)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union ISC_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} ISC;
#define		ISC		(*(volatile union ISC_T *) 0x0F0073)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union TIS0_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} TIS0;
#define		TIS0		(*(volatile union TIS0_T *) 0x0F0074)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union TIS1_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} TIS1;
#define		TIS1		(*(volatile union TIS1_T *) 0x0F0075)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union ADPC_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} ADPC;
#define		ADPC		(*(volatile union ADPC_T *) 0x0F0076)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union PMS_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} PMS;
#define		PMS		(*(volatile union PMS_T *) 0x0F0077)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union IAWCTL_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} IAWCTL;
#define		IAWCTL		(*(volatile union IAWCTL_T *) 0x0F0078)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union INTFLG0_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} INTFLG0;
#define		INTFLG0		(*(volatile union INTFLG0_T *) 0x0F0079)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union TIS2_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} TIS2;
#define		TIS2		(*(volatile union TIS2_T *) 0x0F007A)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union LCHSEL_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} LCHSEL;
#define		LCHSEL		(*(volatile union LCHSEL_T *) 0x0F007B)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union INTMSK_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} INTMSK;
#define		INTMSK		(*(volatile union INTMSK_T *) 0x0F007C)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union PRDSEL_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} PRDSEL;
#define		PRDSEL		(*(volatile union PRDSEL_T *) 0x0F007E)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union TOOLEN_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} TOOLEN;
#define		TOOLEN		(*(volatile union TOOLEN_T *) 0x0F0080)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union BPAL0_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} BPAL0;
#define		BPAL0		(*(volatile union BPAL0_T *) 0x0F0081)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union BPAH0_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} BPAH0;
#define		BPAH0		(*(volatile union BPAH0_T *) 0x0F0082)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union BPAS0_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} BPAS0;
#define		BPAS0		(*(volatile union BPAS0_T *) 0x0F0083)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union BACDVL0_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} BACDVL0;
#define		BACDVL0		(*(volatile union BACDVL0_T *) 0x0F0084)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union BACDVH0_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} BACDVH0;
#define		BACDVH0		(*(volatile union BACDVH0_T *) 0x0F0085)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union BACDML0_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} BACDML0;
#define		BACDML0		(*(volatile union BACDML0_T *) 0x0F0086)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union BACDMH0_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} BACDMH0;
#define		BACDMH0		(*(volatile union BACDMH0_T *) 0x0F0087)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union MONMOD_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} MONMOD;
#define		MONMOD		(*(volatile union MONMOD_T *) 0x0F0088)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union BPAL1_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} BPAL1;
#define		BPAL1		(*(volatile union BPAL1_T *) 0x0F0089)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union BPAH1_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} BPAH1;
#define		BPAH1		(*(volatile union BPAH1_T *) 0x0F008A)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union BPAS1_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} BPAS1;
#define		BPAS1		(*(volatile union BPAS1_T *) 0x0F008B)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union BACDVL1_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} BACDVL1;
#define		BACDVL1		(*(volatile union BACDVL1_T *) 0x0F008C)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union BACDVH1_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} BACDVH1;
#define		BACDVH1		(*(volatile union BACDVH1_T *) 0x0F008D)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union BACDML1_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} BACDML1;
#define		BACDML1		(*(volatile union BACDML1_T *) 0x0F008E)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union BACDMH1_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} BACDMH1;
#define		BACDMH1		(*(volatile union BACDMH1_T *) 0x0F008F)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union DFLCTL_T
{
	io_byte REG;
	struct
	{
		io_byte DFLEN   :1;		/* (BIT)*/
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} DFLCTL;
#define		DFLCTL		(*(volatile union DFLCTL_T *) 0x0F0090)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union HIOTRM_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} HIOTRM;
#define		HIOTRM		(*(volatile union HIOTRM_T *) 0x0F00A0)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union BECTL_T
{
	io_byte REG;
	struct
	{
		io_byte BRSAM   :1;		/* (BIT)*/
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} BECTL;
#define		BECTL		(*(volatile union BECTL_T *) 0x0F00A1)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union HOCODIV_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} HOCODIV;
#define		HOCODIV		(*(volatile union HOCODIV_T *) 0x0F00A8)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union TEMPCAL0_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} TEMPCAL0;
#define		TEMPCAL0		(*(volatile union TEMPCAL0_T *) 0x0F00AC)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union TEMPCAL1_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} TEMPCAL1;
#define		TEMPCAL1		(*(volatile union TEMPCAL1_T *) 0x0F00AD)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union TEMPCAL2_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} TEMPCAL2;
#define		TEMPCAL2		(*(volatile union TEMPCAL2_T *) 0x0F00AE)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union TEMPCAL3_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} TEMPCAL3;
#define		TEMPCAL3		(*(volatile union TEMPCAL3_T *) 0x0F00AF)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union FLSEC_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} FLSEC;
#define		FLSEC		(*(volatile union FLSEC_T *) 0x0F00B0)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union FLFSWS_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} FLFSWS;
#define		FLFSWS		(*(volatile union FLFSWS_T *) 0x0F00B2)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union FLFSWE_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} FLFSWE;
#define		FLFSWE		(*(volatile union FLFSWE_T *) 0x0F00B4)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union FSSET_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} FSSET;
#define		FSSET		(*(volatile union FSSET_T *) 0x0F00B6)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union FSSE_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte ESQST   :1;		/* (BIT)*/
	} BIT;
} FSSE;
#define		FSSE		(*(volatile union FSSE_T *) 0x0F00B7)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union FLFADL_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} FLFADL;
#define		FLFADL		(*(volatile union FLFADL_T *) 0x0F00B8)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union FLFADH_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} FLFADH;
#define		FLFADH		(*(volatile union FLFADH_T *) 0x0F00BA)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union PFCMD_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} PFCMD;
#define		PFCMD		(*(volatile union PFCMD_T *) 0x0F00C0)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union PFS_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} PFS;
#define		PFS		(*(volatile union PFS_T *) 0x0F00C1)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union FLRL_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} FLRL;
#define		FLRL		(*(volatile union FLRL_T *) 0x0F00C2)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union FLRH_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} FLRH;
#define		FLRH		(*(volatile union FLRH_T *) 0x0F00C4)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union FLWE_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} FLWE;
#define		FLWE		(*(volatile union FLWE_T *) 0x0F00C6)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union FLRE_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} FLRE;
#define		FLRE		(*(volatile union FLRE_T *) 0x0F00C7)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union FLTMS_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} FLTMS;
#define		FLTMS		(*(volatile union FLTMS_T *) 0x0F00C8)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union DFLMC_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} DFLMC;
#define		DFLMC		(*(volatile union DFLMC_T *) 0x0F00CA)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union FLMCL_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} FLMCL;
#define		FLMCL		(*(volatile union FLMCL_T *) 0x0F00CC)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union FLMCH_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} FLMCH;
#define		FLMCH		(*(volatile union FLMCH_T *) 0x0F00CE)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union FSCTL_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} FSCTL;
#define		FSCTL		(*(volatile union FSCTL_T *) 0x0F00CF)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union ICEADR_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} ICEADR;
#define		ICEADR		(*(volatile union ICEADR_T *) 0x0F00D0)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union ICEDAT_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} ICEDAT;
#define		ICEDAT		(*(volatile union ICEDAT_T *) 0x0F00D2)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union SPMCTRL_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} SPMCTRL;
#define		SPMCTRL		(*(volatile union SPMCTRL_T *) 0x0F00D8)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union SPOFR_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} SPOFR;
#define		SPOFR		(*(volatile union SPOFR_T *) 0x0F00DA)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union SPUFR_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} SPUFR;
#define		SPUFR		(*(volatile union SPUFR_T *) 0x0F00DC)
/*------------------------------------------------------------------------------------
  Peripheral enable register 0 
------------------------------------------------------------------------------------*/
typedef union PER0_T
{
	io_byte REG;
	struct
	{
		io_byte TAU0EN  :1;		/* (BIT)*/
		io_byte TAU1EN  :1;		/* (BIT)*/
		io_byte SAU0EN  :1;		/* (BIT)*/
		io_byte SAU1EN  :1;		/* (BIT)*/
		io_byte IICA0EN :1;		/* (BIT)*/
		io_byte ADCEN   :1;		/* (BIT)*/
		io_byte B6:1;
		io_byte RTCEN   :1;		/* (BIT)*/
	} BIT;
} PER0;
#define		PER0		(*(volatile union PER0_T *) 0x0F00F0)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union OSMC_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} OSMC;
#define		OSMC		(*(volatile union OSMC_T *) 0x0F00F3)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMC_T
{
	io_byte REG;
	struct
	{
		io_byte PAENB   :1;		/* (BIT)*/
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte WDVOL   :1;		/* (BIT)*/
	} BIT;
} RMC;
#define		RMC		(*(volatile union RMC_T *) 0x0F00F4)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPECTL_T
{
	io_byte REG;
	struct
	{
		io_byte RPEF    :1;		/* (BIT)*/
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte RPERDIS :1;		/* (BIT)*/
	} BIT;
} RPECTL;
#define		RPECTL		(*(volatile union RPECTL_T *) 0x0F00F5)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union BCDADJ_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} BCDADJ;
#define		BCDADJ		(*(volatile union BCDADJ_T *) 0x0F00FE)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union VECTCTRL_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} VECTCTRL;
#define		VECTCTRL		(*(volatile union VECTCTRL_T *) 0x0F00FF)
/*------------------------------------------------------------------------------------
  Serial status register 0 
------------------------------------------------------------------------------------*/
typedef union SSR00_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} SSR00;
#define		SSR00		(*(volatile union SSR00_T *) 0x0F0100)
/*------------------------------------------------------------------------------------
  Serial status register 0 
------------------------------------------------------------------------------------*/
typedef union SSR00L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} SSR00L;
#define		SSR00L		(*(volatile union SSR00L_T *) 0x0F0100)
/*------------------------------------------------------------------------------------
  Serial status register 0 
------------------------------------------------------------------------------------*/
typedef union SSR01_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} SSR01;
#define		SSR01		(*(volatile union SSR01_T *) 0x0F0102)
/*------------------------------------------------------------------------------------
  Serial status register 0 
------------------------------------------------------------------------------------*/
typedef union SSR01L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} SSR01L;
#define		SSR01L		(*(volatile union SSR01L_T *) 0x0F0102)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union SIR00_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} SIR00;
#define		SIR00		(*(volatile union SIR00_T *) 0x0F0104)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union SIR00L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} SIR00L;
#define		SIR00L		(*(volatile union SIR00L_T *) 0x0F0104)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union SIR01_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} SIR01;
#define		SIR01		(*(volatile union SIR01_T *) 0x0F0106)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union SIR01L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} SIR01L;
#define		SIR01L		(*(volatile union SIR01L_T *) 0x0F0106)
/*------------------------------------------------------------------------------------
  Serial mode register 00 
------------------------------------------------------------------------------------*/
typedef union SMR00_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} SMR00;
#define		SMR00		(*(volatile union SMR00_T *) 0x0F0108)
/*------------------------------------------------------------------------------------
  Serial mode register 01 
------------------------------------------------------------------------------------*/
typedef union SMR01_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} SMR01;
#define		SMR01		(*(volatile union SMR01_T *) 0x0F010A)
/*------------------------------------------------------------------------------------
  Serial communication setting register 00 
------------------------------------------------------------------------------------*/
typedef union SCR00_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} SCR00;
#define		SCR00		(*(volatile union SCR00_T *) 0x0F010C)
/*------------------------------------------------------------------------------------
  Serial communication setting register 01 
------------------------------------------------------------------------------------*/
typedef union SCR01_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} SCR01;
#define		SCR01		(*(volatile union SCR01_T *) 0x0F010E)
/*------------------------------------------------------------------------------------
  Serial channel enable status register 0 
------------------------------------------------------------------------------------*/
typedef union SE0_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} SE0;
#define		SE0		(*(volatile union SE0_T *) 0x0F0110)
/*------------------------------------------------------------------------------------
  Serial channel enable status register 0 
------------------------------------------------------------------------------------*/
typedef union SE0L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} SE0L;
#define		SE0L		(*(volatile union SE0L_T *) 0x0F0110)
/*------------------------------------------------------------------------------------
  Serial channel start register 0 
------------------------------------------------------------------------------------*/
typedef union SS0_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} SS0;
#define		SS0		(*(volatile union SS0_T *) 0x0F0112)
/*------------------------------------------------------------------------------------
  Serial channel start register 0 
------------------------------------------------------------------------------------*/
typedef union SS0L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} SS0L;
#define		SS0L		(*(volatile union SS0L_T *) 0x0F0112)
/*------------------------------------------------------------------------------------
  Serial channel stop register 0 
------------------------------------------------------------------------------------*/
typedef union ST0_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} ST0;
#define		ST0		(*(volatile union ST0_T *) 0x0F0114)
/*------------------------------------------------------------------------------------
  Serial channel stop register 0 
------------------------------------------------------------------------------------*/
typedef union ST0L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} ST0L;
#define		ST0L		(*(volatile union ST0L_T *) 0x0F0114)
/*------------------------------------------------------------------------------------
  Serial clock select register 0 
------------------------------------------------------------------------------------*/
typedef union SPS0_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} SPS0;
#define		SPS0		(*(volatile union SPS0_T *) 0x0F0116)
/*------------------------------------------------------------------------------------
  Serial clock select register 0 
------------------------------------------------------------------------------------*/
typedef union SPS0L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} SPS0L;
#define		SPS0L		(*(volatile union SPS0L_T *) 0x0F0116)
/*------------------------------------------------------------------------------------
  Serial output register 0 
------------------------------------------------------------------------------------*/
typedef union SO0_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} SO0;
#define		SO0		(*(volatile union SO0_T *) 0x0F0118)
/*------------------------------------------------------------------------------------
  Serial output enable register 0 
------------------------------------------------------------------------------------*/
typedef union SOE0_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} SOE0;
#define		SOE0		(*(volatile union SOE0_T *) 0x0F011A)
/*------------------------------------------------------------------------------------
  Serial output enable register 0 
------------------------------------------------------------------------------------*/
typedef union SOE0L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} SOE0L;
#define		SOE0L		(*(volatile union SOE0L_T *) 0x0F011A)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union EDR00_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} EDR00;
#define		EDR00		(*(volatile union EDR00_T *) 0x0F011C)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union EDR00L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} EDR00L;
#define		EDR00L		(*(volatile union EDR00L_T *) 0x0F011C)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union EDR01_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} EDR01;
#define		EDR01		(*(volatile union EDR01_T *) 0x0F011E)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union EDR01L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} EDR01L;
#define		EDR01L		(*(volatile union EDR01L_T *) 0x0F011E)
/*------------------------------------------------------------------------------------
  Serial output level register 0 
------------------------------------------------------------------------------------*/
typedef union SOL0_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} SOL0;
#define		SOL0		(*(volatile union SOL0_T *) 0x0F0120)
/*------------------------------------------------------------------------------------
  Serial output level register 0 
------------------------------------------------------------------------------------*/
typedef union SOL0L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} SOL0L;
#define		SOL0L		(*(volatile union SOL0L_T *) 0x0F0120)
/*------------------------------------------------------------------------------------
  Serial slave select enable register 0 
------------------------------------------------------------------------------------*/
typedef union SSE0_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} SSE0;
#define		SSE0		(*(volatile union SSE0_T *) 0x0F0122)
/*------------------------------------------------------------------------------------
  Serial slave select enable register 0 
------------------------------------------------------------------------------------*/
typedef union SSE0L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} SSE0L;
#define		SSE0L		(*(volatile union SSE0L_T *) 0x0F0122)
/*------------------------------------------------------------------------------------
  Serial status register 1 
------------------------------------------------------------------------------------*/
typedef union SSR10_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} SSR10;
#define		SSR10		(*(volatile union SSR10_T *) 0x0F0140)
/*------------------------------------------------------------------------------------
  Serial status register 1 
------------------------------------------------------------------------------------*/
typedef union SSR10L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} SSR10L;
#define		SSR10L		(*(volatile union SSR10L_T *) 0x0F0140)
/*------------------------------------------------------------------------------------
  Serial status register 1 
------------------------------------------------------------------------------------*/
typedef union SSR11_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} SSR11;
#define		SSR11		(*(volatile union SSR11_T *) 0x0F0142)
/*------------------------------------------------------------------------------------
  Serial status register 1 
------------------------------------------------------------------------------------*/
typedef union SSR11L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} SSR11L;
#define		SSR11L		(*(volatile union SSR11L_T *) 0x0F0142)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union SIR10_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} SIR10;
#define		SIR10		(*(volatile union SIR10_T *) 0x0F0144)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union SIR10L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} SIR10L;
#define		SIR10L		(*(volatile union SIR10L_T *) 0x0F0144)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union SIR11_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} SIR11;
#define		SIR11		(*(volatile union SIR11_T *) 0x0F0146)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union SIR11L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} SIR11L;
#define		SIR11L		(*(volatile union SIR11L_T *) 0x0F0146)
/*------------------------------------------------------------------------------------
  Serial mode register 10 
------------------------------------------------------------------------------------*/
typedef union SMR10_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} SMR10;
#define		SMR10		(*(volatile union SMR10_T *) 0x0F0148)
/*------------------------------------------------------------------------------------
  Serial mode register 11 
------------------------------------------------------------------------------------*/
typedef union SMR11_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} SMR11;
#define		SMR11		(*(volatile union SMR11_T *) 0x0F014A)
/*------------------------------------------------------------------------------------
  Serial communication setting register 10 
------------------------------------------------------------------------------------*/
typedef union SCR10_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} SCR10;
#define		SCR10		(*(volatile union SCR10_T *) 0x0F014C)
/*------------------------------------------------------------------------------------
  Serial communication setting register 11 
------------------------------------------------------------------------------------*/
typedef union SCR11_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} SCR11;
#define		SCR11		(*(volatile union SCR11_T *) 0x0F014E)
/*------------------------------------------------------------------------------------
  Serial channel enable status register 1 
------------------------------------------------------------------------------------*/
typedef union SE1_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} SE1;
#define		SE1		(*(volatile union SE1_T *) 0x0F0150)
/*------------------------------------------------------------------------------------
  Serial channel enable status register 1 
------------------------------------------------------------------------------------*/
typedef union SE1L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} SE1L;
#define		SE1L		(*(volatile union SE1L_T *) 0x0F0150)
/*------------------------------------------------------------------------------------
  Serial channel start register 1 
------------------------------------------------------------------------------------*/
typedef union SS1_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} SS1;
#define		SS1		(*(volatile union SS1_T *) 0x0F0152)
/*------------------------------------------------------------------------------------
  Serial channel start register 1 
------------------------------------------------------------------------------------*/
typedef union SS1L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} SS1L;
#define		SS1L		(*(volatile union SS1L_T *) 0x0F0152)
/*------------------------------------------------------------------------------------
  Serial channel stop register 1 
------------------------------------------------------------------------------------*/
typedef union ST1_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} ST1;
#define		ST1		(*(volatile union ST1_T *) 0x0F0154)
/*------------------------------------------------------------------------------------
  Serial channel stop register 1 
------------------------------------------------------------------------------------*/
typedef union ST1L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} ST1L;
#define		ST1L		(*(volatile union ST1L_T *) 0x0F0154)
/*------------------------------------------------------------------------------------
  Serial clock select register 1 
------------------------------------------------------------------------------------*/
typedef union SPS1_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} SPS1;
#define		SPS1		(*(volatile union SPS1_T *) 0x0F0156)
/*------------------------------------------------------------------------------------
  Serial clock select register 1 
------------------------------------------------------------------------------------*/
typedef union SPS1L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} SPS1L;
#define		SPS1L		(*(volatile union SPS1L_T *) 0x0F0156)
/*------------------------------------------------------------------------------------
  Serial output register 1 
------------------------------------------------------------------------------------*/
typedef union SO1_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} SO1;
#define		SO1		(*(volatile union SO1_T *) 0x0F0158)
/*------------------------------------------------------------------------------------
  Serial output enable register 1 
------------------------------------------------------------------------------------*/
typedef union SOE1_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} SOE1;
#define		SOE1		(*(volatile union SOE1_T *) 0x0F015A)
/*------------------------------------------------------------------------------------
  Serial output enable register 1 
------------------------------------------------------------------------------------*/
typedef union SOE1L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} SOE1L;
#define		SOE1L		(*(volatile union SOE1L_T *) 0x0F015A)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union EDR10_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} EDR10;
#define		EDR10		(*(volatile union EDR10_T *) 0x0F015C)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union EDR10L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} EDR10L;
#define		EDR10L		(*(volatile union EDR10L_T *) 0x0F015C)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union EDR11_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} EDR11;
#define		EDR11		(*(volatile union EDR11_T *) 0x0F015E)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union EDR11L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} EDR11L;
#define		EDR11L		(*(volatile union EDR11L_T *) 0x0F015E)
/*------------------------------------------------------------------------------------
  Serial output level register 1 
------------------------------------------------------------------------------------*/
typedef union SOL1_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} SOL1;
#define		SOL1		(*(volatile union SOL1_T *) 0x0F0160)
/*------------------------------------------------------------------------------------
  Serial output level register 1 
------------------------------------------------------------------------------------*/
typedef union SOL1L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} SOL1L;
#define		SOL1L		(*(volatile union SOL1L_T *) 0x0F0160)
/*------------------------------------------------------------------------------------
  Serial slave select enable register 1 
------------------------------------------------------------------------------------*/
typedef union SSE1_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} SSE1;
#define		SSE1		(*(volatile union SSE1_T *) 0x0F0162)
/*------------------------------------------------------------------------------------
  Serial slave select enable register 1 
------------------------------------------------------------------------------------*/
typedef union SSE1L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} SSE1L;
#define		SSE1L		(*(volatile union SSE1L_T *) 0x0F0162)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union TCR00_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} TCR00;
#define		TCR00		(*(volatile union TCR00_T *) 0x0F0180)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union TCR01_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} TCR01;
#define		TCR01		(*(volatile union TCR01_T *) 0x0F0182)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union TCR02_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} TCR02;
#define		TCR02		(*(volatile union TCR02_T *) 0x0F0184)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union TCR03_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} TCR03;
#define		TCR03		(*(volatile union TCR03_T *) 0x0F0186)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union TCR04_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} TCR04;
#define		TCR04		(*(volatile union TCR04_T *) 0x0F0188)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union TCR05_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} TCR05;
#define		TCR05		(*(volatile union TCR05_T *) 0x0F018A)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union TCR06_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} TCR06;
#define		TCR06		(*(volatile union TCR06_T *) 0x0F018C)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union TCR07_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} TCR07;
#define		TCR07		(*(volatile union TCR07_T *) 0x0F018E)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union TMR00_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} TMR00;
#define		TMR00		(*(volatile union TMR00_T *) 0x0F0190)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union TMR01_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} TMR01;
#define		TMR01		(*(volatile union TMR01_T *) 0x0F0192)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union TMR02_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} TMR02;
#define		TMR02		(*(volatile union TMR02_T *) 0x0F0194)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union TMR03_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} TMR03;
#define		TMR03		(*(volatile union TMR03_T *) 0x0F0196)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union TMR04_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} TMR04;
#define		TMR04		(*(volatile union TMR04_T *) 0x0F0198)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union TMR05_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} TMR05;
#define		TMR05		(*(volatile union TMR05_T *) 0x0F019A)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union TMR06_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} TMR06;
#define		TMR06		(*(volatile union TMR06_T *) 0x0F019C)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union TMR07_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} TMR07;
#define		TMR07		(*(volatile union TMR07_T *) 0x0F019E)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union TSR00_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} TSR00;
#define		TSR00		(*(volatile union TSR00_T *) 0x0F01A0)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union TSR00L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} TSR00L;
#define		TSR00L		(*(volatile union TSR00L_T *) 0x0F01A0)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union TSR01_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} TSR01;
#define		TSR01		(*(volatile union TSR01_T *) 0x0F01A2)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union TSR01L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} TSR01L;
#define		TSR01L		(*(volatile union TSR01L_T *) 0x0F01A2)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union TSR02_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} TSR02;
#define		TSR02		(*(volatile union TSR02_T *) 0x0F01A4)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union TSR02L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} TSR02L;
#define		TSR02L		(*(volatile union TSR02L_T *) 0x0F01A4)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union TSR03_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} TSR03;
#define		TSR03		(*(volatile union TSR03_T *) 0x0F01A6)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union TSR03L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} TSR03L;
#define		TSR03L		(*(volatile union TSR03L_T *) 0x0F01A6)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union TSR04_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} TSR04;
#define		TSR04		(*(volatile union TSR04_T *) 0x0F01A8)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union TSR04L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} TSR04L;
#define		TSR04L		(*(volatile union TSR04L_T *) 0x0F01A8)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union TSR05_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} TSR05;
#define		TSR05		(*(volatile union TSR05_T *) 0x0F01AA)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union TSR05L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} TSR05L;
#define		TSR05L		(*(volatile union TSR05L_T *) 0x0F01AA)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union TSR06_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} TSR06;
#define		TSR06		(*(volatile union TSR06_T *) 0x0F01AC)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union TSR06L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} TSR06L;
#define		TSR06L		(*(volatile union TSR06L_T *) 0x0F01AC)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union TSR07_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} TSR07;
#define		TSR07		(*(volatile union TSR07_T *) 0x0F01AE)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union TSR07L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} TSR07L;
#define		TSR07L		(*(volatile union TSR07L_T *) 0x0F01AE)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union TE0_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} TE0;
#define		TE0		(*(volatile union TE0_T *) 0x0F01B0)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union TE0L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} TE0L;
#define		TE0L		(*(volatile union TE0L_T *) 0x0F01B0)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union TS0_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} TS0;
#define		TS0		(*(volatile union TS0_T *) 0x0F01B2)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union TS0L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} TS0L;
#define		TS0L		(*(volatile union TS0L_T *) 0x0F01B2)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union TT0_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} TT0;
#define		TT0		(*(volatile union TT0_T *) 0x0F01B4)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union TT0L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} TT0L;
#define		TT0L		(*(volatile union TT0L_T *) 0x0F01B4)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union TPS0_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} TPS0;
#define		TPS0		(*(volatile union TPS0_T *) 0x0F01B6)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union TO0_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} TO0;
#define		TO0		(*(volatile union TO0_T *) 0x0F01B8)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union TO0L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} TO0L;
#define		TO0L		(*(volatile union TO0L_T *) 0x0F01B8)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union TOE0_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} TOE0;
#define		TOE0		(*(volatile union TOE0_T *) 0x0F01BA)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union TOE0L_T
{
	io_byte REG;
	struct
	{
		io_byte TOE0_0  :1;		/* (BIT)*/
		io_byte TOE0_1  :1;		/* (BIT)*/
		io_byte TOE0_2  :1;		/* (BIT)*/
		io_byte TOE0_3  :1;		/* (BIT)*/
		io_byte TOE0_4  :1;		/* (BIT)*/
		io_byte TOE0_5  :1;		/* (BIT)*/
		io_byte TOE0_6  :1;		/* (BIT)*/
		io_byte TOE0_7  :1;		/* (BIT)*/
	} BIT;
} TOE0L;
#define		TOE0L		(*(volatile union TOE0L_T *) 0x0F01BA)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union TOL0_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} TOL0;
#define		TOL0		(*(volatile union TOL0_T *) 0x0F01BC)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union TOL0L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} TOL0L;
#define		TOL0L		(*(volatile union TOL0L_T *) 0x0F01BC)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union TOM0_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} TOM0;
#define		TOM0		(*(volatile union TOM0_T *) 0x0F01BE)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union TOM0L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} TOM0L;
#define		TOM0L		(*(volatile union TOM0L_T *) 0x0F01BE)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union TCR10_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} TCR10;
#define		TCR10		(*(volatile union TCR10_T *) 0x0F01C0)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union TCR11_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} TCR11;
#define		TCR11		(*(volatile union TCR11_T *) 0x0F01C2)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union TCR12_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} TCR12;
#define		TCR12		(*(volatile union TCR12_T *) 0x0F01C4)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union TCR13_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} TCR13;
#define		TCR13		(*(volatile union TCR13_T *) 0x0F01C6)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union TCR14_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} TCR14;
#define		TCR14		(*(volatile union TCR14_T *) 0x0F01C8)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union TCR15_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} TCR15;
#define		TCR15		(*(volatile union TCR15_T *) 0x0F01CA)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union TCR16_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} TCR16;
#define		TCR16		(*(volatile union TCR16_T *) 0x0F01CC)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union TCR17_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} TCR17;
#define		TCR17		(*(volatile union TCR17_T *) 0x0F01CE)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union TMR10_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} TMR10;
#define		TMR10		(*(volatile union TMR10_T *) 0x0F01D0)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union TMR11_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} TMR11;
#define		TMR11		(*(volatile union TMR11_T *) 0x0F01D2)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union TMR12_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} TMR12;
#define		TMR12		(*(volatile union TMR12_T *) 0x0F01D4)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union TMR13_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} TMR13;
#define		TMR13		(*(volatile union TMR13_T *) 0x0F01D6)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union TMR14_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} TMR14;
#define		TMR14		(*(volatile union TMR14_T *) 0x0F01D8)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union TMR15_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} TMR15;
#define		TMR15		(*(volatile union TMR15_T *) 0x0F01DA)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union TMR16_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} TMR16;
#define		TMR16		(*(volatile union TMR16_T *) 0x0F01DC)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union TMR17_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} TMR17;
#define		TMR17		(*(volatile union TMR17_T *) 0x0F01DE)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union TSR10_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} TSR10;
#define		TSR10		(*(volatile union TSR10_T *) 0x0F01E0)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union TSR10L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} TSR10L;
#define		TSR10L		(*(volatile union TSR10L_T *) 0x0F01E0)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union TSR11_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} TSR11;
#define		TSR11		(*(volatile union TSR11_T *) 0x0F01E2)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union TSR11L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} TSR11L;
#define		TSR11L		(*(volatile union TSR11L_T *) 0x0F01E2)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union TSR12_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} TSR12;
#define		TSR12		(*(volatile union TSR12_T *) 0x0F01E4)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union TSR12L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} TSR12L;
#define		TSR12L		(*(volatile union TSR12L_T *) 0x0F01E4)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union TSR13_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} TSR13;
#define		TSR13		(*(volatile union TSR13_T *) 0x0F01E6)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union TSR13L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} TSR13L;
#define		TSR13L		(*(volatile union TSR13L_T *) 0x0F01E6)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union TSR14_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} TSR14;
#define		TSR14		(*(volatile union TSR14_T *) 0x0F01E8)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union TSR14L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} TSR14L;
#define		TSR14L		(*(volatile union TSR14L_T *) 0x0F01E8)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union TSR15_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} TSR15;
#define		TSR15		(*(volatile union TSR15_T *) 0x0F01EA)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union TSR15L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} TSR15L;
#define		TSR15L		(*(volatile union TSR15L_T *) 0x0F01EA)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union TSR16_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} TSR16;
#define		TSR16		(*(volatile union TSR16_T *) 0x0F01EC)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union TSR16L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} TSR16L;
#define		TSR16L		(*(volatile union TSR16L_T *) 0x0F01EC)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union TSR17_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} TSR17;
#define		TSR17		(*(volatile union TSR17_T *) 0x0F01EE)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union TSR17L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} TSR17L;
#define		TSR17L		(*(volatile union TSR17L_T *) 0x0F01EE)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union TE1_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} TE1;
#define		TE1		(*(volatile union TE1_T *) 0x0F01F0)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union TE1L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} TE1L;
#define		TE1L		(*(volatile union TE1L_T *) 0x0F01F0)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union TS1_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} TS1;
#define		TS1		(*(volatile union TS1_T *) 0x0F01F2)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union TS1L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} TS1L;
#define		TS1L		(*(volatile union TS1L_T *) 0x0F01F2)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union TT1_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} TT1;
#define		TT1		(*(volatile union TT1_T *) 0x0F01F4)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union TT1L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} TT1L;
#define		TT1L		(*(volatile union TT1L_T *) 0x0F01F4)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union TPS1_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} TPS1;
#define		TPS1		(*(volatile union TPS1_T *) 0x0F01F6)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union TO1_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} TO1;
#define		TO1		(*(volatile union TO1_T *) 0x0F01F8)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union TO1L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} TO1L;
#define		TO1L		(*(volatile union TO1L_T *) 0x0F01F8)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union TOE1_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} TOE1;
#define		TOE1		(*(volatile union TOE1_T *) 0x0F01FA)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union TOE1L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} TOE1L;
#define		TOE1L		(*(volatile union TOE1L_T *) 0x0F01FA)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union TOL1_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} TOL1;
#define		TOL1		(*(volatile union TOL1_T *) 0x0F01FC)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union TOL1L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} TOL1L;
#define		TOL1L		(*(volatile union TOL1L_T *) 0x0F01FC)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union TOM1_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} TOM1;
#define		TOM1		(*(volatile union TOM1_T *) 0x0F01FE)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union TOM1L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} TOM1L;
#define		TOM1L		(*(volatile union TOM1L_T *) 0x0F01FE)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union ERADR_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} ERADR;
#define		ERADR		(*(volatile union ERADR_T *) 0x0F0200)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union ECCIER_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} ECCIER;
#define		ECCIER		(*(volatile union ECCIER_T *) 0x0F0202)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union ECCER_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} ECCER;
#define		ECCER		(*(volatile union ECCER_T *) 0x0F0203)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union ECCTPR_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} ECCTPR;
#define		ECCTPR		(*(volatile union ECCTPR_T *) 0x0F0204)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union ECCTMDR_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} ECCTMDR;
#define		ECCTMDR		(*(volatile union ECCTMDR_T *) 0x0F0205)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union ECCDWRVR_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} ECCDWRVR;
#define		ECCDWRVR		(*(volatile union ECCDWRVR_T *) 0x0F0206)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMODR_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RMODR;
#define		RMODR		(*(volatile union RMODR_T *) 0x0F0208)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RTSTR_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RTSTR;
#define		RTSTR		(*(volatile union RTSTR_T *) 0x0F0209)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union WDTLIOTRM_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} WDTLIOTRM;
#define		WDTLIOTRM		(*(volatile union WDTLIOTRM_T *) 0x0F020C)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union PRDCTL_T
{
	io_byte REG;
	struct
	{
		io_byte PCANEN  :1;		/* (BIT)*/
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} PRDCTL;
#define		PRDCTL		(*(volatile union PRDCTL_T *) 0x0F020D)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union PSRSEL_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} PSRSEL;
#define		PSRSEL		(*(volatile union PSRSEL_T *) 0x0F0220)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union PSNZCNT0_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} PSNZCNT0;
#define		PSNZCNT0		(*(volatile union PSNZCNT0_T *) 0x0F0222)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union PSNZCNT1_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} PSNZCNT1;
#define		PSNZCNT1		(*(volatile union PSNZCNT1_T *) 0x0F0223)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union PSNZCNT2_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} PSNZCNT2;
#define		PSNZCNT2		(*(volatile union PSNZCNT2_T *) 0x0F0224)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union PSNZCNT3_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} PSNZCNT3;
#define		PSNZCNT3		(*(volatile union PSNZCNT3_T *) 0x0F0225)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union DAM2_T
{
	io_byte REG;
	struct
	{
		io_byte ANO0EN  :1;		/* (BIT)*/
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} DAM2;
#define		DAM2		(*(volatile union DAM2_T *) 0x0F0227)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union PWMDLY0_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} PWMDLY0;
#define		PWMDLY0		(*(volatile union PWMDLY0_T *) 0x0F0228)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union PWMDLY1_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} PWMDLY1;
#define		PWMDLY1		(*(volatile union PWMDLY1_T *) 0x0F022A)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union PWMDLY2_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} PWMDLY2;
#define		PWMDLY2		(*(volatile union PWMDLY2_T *) 0x0F022C)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union IICCTL00_T
{
	io_byte REG;
	struct
	{
		io_byte SPT0    :1;		/* (BIT)*/
		io_byte STT0    :1;		/* (BIT)*/
		io_byte ACKE0   :1;		/* (BIT)*/
		io_byte WTIM0   :1;		/* (BIT)*/
		io_byte SPIE0   :1;		/* (BIT)*/
		io_byte WREL0   :1;		/* (BIT)*/
		io_byte LREL0   :1;		/* (BIT)*/
		io_byte IICE0   :1;		/* (BIT)*/
	} BIT;
} IICCTL00;
#define		IICCTL00		(*(volatile union IICCTL00_T *) 0x0F0230)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union IICCTL01_T
{
	io_byte REG;
	struct
	{
		io_byte PRS0    :1;		/* (BIT)*/
		io_byte B1:1;
		io_byte DFC0    :1;		/* (BIT)*/
		io_byte SMC0    :1;		/* (BIT)*/
		io_byte DAD0    :1;		/* (BIT)*/
		io_byte CLD0    :1;		/* (BIT)*/
		io_byte B6:1;
		io_byte WUP0    :1;		/* (BIT)*/
	} BIT;
} IICCTL01;
#define		IICCTL01		(*(volatile union IICCTL01_T *) 0x0F0231)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union IICWL0_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} IICWL0;
#define		IICWL0		(*(volatile union IICWL0_T *) 0x0F0232)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union IICWH0_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} IICWH0;
#define		IICWH0		(*(volatile union IICWH0_T *) 0x0F0233)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union SVA0_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} SVA0;
#define		SVA0		(*(volatile union SVA0_T *) 0x0F0234)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union IICSE0_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} IICSE0;
#define		IICSE0		(*(volatile union IICSE0_T *) 0x0F0235)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union TRJCR0_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} TRJCR0;
#define		TRJCR0		(*(volatile union TRJCR0_T *) 0x0F0240)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union TRJIOC0_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} TRJIOC0;
#define		TRJIOC0		(*(volatile union TRJIOC0_T *) 0x0F0241)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union TRJMR0_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} TRJMR0;
#define		TRJMR0		(*(volatile union TRJMR0_T *) 0x0F0242)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union TRJISR0_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} TRJISR0;
#define		TRJISR0		(*(volatile union TRJISR0_T *) 0x0F0243)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union TRDELC_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} TRDELC;
#define		TRDELC		(*(volatile union TRDELC_T *) 0x0F0260)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union TRDSTR_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} TRDSTR;
#define		TRDSTR		(*(volatile union TRDSTR_T *) 0x0F0263)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union TRDMR_T
{
	io_byte REG;
	struct
	{
		io_byte TRDSYNC :1;		/* (BIT)*/
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte TRDBFC0 :1;		/* (BIT)*/
		io_byte TRDBFD0 :1;		/* (BIT)*/
		io_byte TRDBFC1 :1;		/* (BIT)*/
		io_byte TRDBFD1 :1;		/* (BIT)*/
	} BIT;
} TRDMR;
#define		TRDMR		(*(volatile union TRDMR_T *) 0x0F0264)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union TRDPMR_T
{
	io_byte REG;
	struct
	{
		io_byte TRDPWMB0:1;		/* (BIT)*/
		io_byte TRDPWMC0:1;		/* (BIT)*/
		io_byte TRDPWMD0:1;		/* (BIT)*/
		io_byte B3:1;
		io_byte TRDPWMB1:1;		/* (BIT)*/
		io_byte TRDPWMC1:1;		/* (BIT)*/
		io_byte TRDPWMD1:1;		/* (BIT)*/
		io_byte B7:1;
	} BIT;
} TRDPMR;
#define		TRDPMR		(*(volatile union TRDPMR_T *) 0x0F0265)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union TRDFCR_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} TRDFCR;
#define		TRDFCR		(*(volatile union TRDFCR_T *) 0x0F0266)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union TRDOER1_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} TRDOER1;
#define		TRDOER1		(*(volatile union TRDOER1_T *) 0x0F0267)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union TRDOER2_T
{
	io_byte REG;
	struct
	{
		io_byte TRDSHUTS:1;		/* (BIT)*/
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte TRDPTO  :1;		/* (BIT)*/
	} BIT;
} TRDOER2;
#define		TRDOER2		(*(volatile union TRDOER2_T *) 0x0F0268)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union TRDOCR_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} TRDOCR;
#define		TRDOCR		(*(volatile union TRDOCR_T *) 0x0F0269)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union TRDDF0_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} TRDDF0;
#define		TRDDF0		(*(volatile union TRDDF0_T *) 0x0F026A)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union TRDDF1_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} TRDDF1;
#define		TRDDF1		(*(volatile union TRDDF1_T *) 0x0F026B)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union TRDCR0_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} TRDCR0;
#define		TRDCR0		(*(volatile union TRDCR0_T *) 0x0F0270)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union TRDIORA0_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} TRDIORA0;
#define		TRDIORA0		(*(volatile union TRDIORA0_T *) 0x0F0271)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union TRDIORC0_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} TRDIORC0;
#define		TRDIORC0		(*(volatile union TRDIORC0_T *) 0x0F0272)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union TRDSR0_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} TRDSR0;
#define		TRDSR0		(*(volatile union TRDSR0_T *) 0x0F0273)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union TRDIER0_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} TRDIER0;
#define		TRDIER0		(*(volatile union TRDIER0_T *) 0x0F0274)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union TRDPOCR0_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} TRDPOCR0;
#define		TRDPOCR0		(*(volatile union TRDPOCR0_T *) 0x0F0275)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union TRD0_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} TRD0;
#define		TRD0		(*(volatile union TRD0_T *) 0x0F0276)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union TRDGRA0_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} TRDGRA0;
#define		TRDGRA0		(*(volatile union TRDGRA0_T *) 0x0F0278)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union TRDGRB0_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} TRDGRB0;
#define		TRDGRB0		(*(volatile union TRDGRB0_T *) 0x0F027A)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union TRDGRC0M_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} TRDGRC0M;
#define		TRDGRC0M		(*(volatile union TRDGRC0M_T *) 0x0F027C)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union TRDGRD0M_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} TRDGRD0M;
#define		TRDGRD0M		(*(volatile union TRDGRD0M_T *) 0x0F027E)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union TRDCR1_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} TRDCR1;
#define		TRDCR1		(*(volatile union TRDCR1_T *) 0x0F0280)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union TRDIORA1_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} TRDIORA1;
#define		TRDIORA1		(*(volatile union TRDIORA1_T *) 0x0F0281)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union TRDIORC1_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} TRDIORC1;
#define		TRDIORC1		(*(volatile union TRDIORC1_T *) 0x0F0282)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union TRDSR1_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} TRDSR1;
#define		TRDSR1		(*(volatile union TRDSR1_T *) 0x0F0283)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union TRDIER1_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} TRDIER1;
#define		TRDIER1		(*(volatile union TRDIER1_T *) 0x0F0284)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union TRDPOCR1_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} TRDPOCR1;
#define		TRDPOCR1		(*(volatile union TRDPOCR1_T *) 0x0F0285)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union TRD1_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} TRD1;
#define		TRD1		(*(volatile union TRD1_T *) 0x0F0286)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union TRDGRA1_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} TRDGRA1;
#define		TRDGRA1		(*(volatile union TRDGRA1_T *) 0x0F0288)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union TRDGRB1_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} TRDGRB1;
#define		TRDGRB1		(*(volatile union TRDGRB1_T *) 0x0F028A)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union TRDGRC1M_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} TRDGRC1M;
#define		TRDGRC1M		(*(volatile union TRDGRC1M_T *) 0x0F028C)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union TRDGRD1M_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} TRDGRD1M;
#define		TRDGRD1M		(*(volatile union TRDGRD1M_T *) 0x0F028E)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union CMPCTL_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte COE     :1;		/* (BIT)*/
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte HCMPON  :1;		/* (BIT)*/
	} BIT;
} CMPCTL;
#define		CMPCTL		(*(volatile union CMPCTL_T *) 0x0F02A0)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union CMPSEL_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte CPOE    :1;		/* (BIT)*/
		io_byte B7:1;
	} BIT;
} CMPSEL;
#define		CMPSEL		(*(volatile union CMPSEL_T *) 0x0F02A1)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union CMPMON_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} CMPMON;
#define		CMPMON		(*(volatile union CMPMON_T *) 0x0F02A2)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union CMPTST_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} CMPTST;
#define		CMPTST		(*(volatile union CMPTST_T *) 0x0F02A3)
/*------------------------------------------------------------------------------------
  Peripheral enable register 1 
------------------------------------------------------------------------------------*/
typedef union PER1_T
{
	io_byte REG;
	struct
	{
		io_byte TRJ0EN  :1;		/* (BIT)*/
		io_byte B1:1;
		io_byte B2:1;
		io_byte DTCEN   :1;		/* (BIT)*/
		io_byte TRD0EN  :1;		/* (BIT)*/
		io_byte CMPEN   :1;		/* (BIT)*/
		io_byte B6:1;
		io_byte DACEN   :1;		/* (BIT)*/
	} BIT;
} PER1;
#define		PER1		(*(volatile union PER1_T *) 0x0F02C0)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union PER2_T
{
	io_byte REG;
	struct
	{
		io_byte CAN0EN  :1;		/* (BIT)*/
		io_byte B1:1;
		io_byte LIN0EN  :1;		/* (BIT)*/
		io_byte LIN1EN  :1;		/* (BIT)*/
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} PER2;
#define		PER2		(*(volatile union PER2_T *) 0x0F02C1)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union CANCKSEL_T
{
	io_byte REG;
	struct
	{
		io_byte CAN0MCKE:1;		/* (BIT)*/
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} CANCKSEL;
#define		CANCKSEL		(*(volatile union CANCKSEL_T *) 0x0F02C2)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union LINCKSEL_T
{
	io_byte REG;
	struct
	{
		io_byte LIN0MCK :1;		/* (BIT)*/
		io_byte LIN1MCK :1;		/* (BIT)*/
		io_byte B2:1;
		io_byte B3:1;
		io_byte LIN0MCKE:1;		/* (BIT)*/
		io_byte LIN1MCKE:1;		/* (BIT)*/
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} LINCKSEL;
#define		LINCKSEL		(*(volatile union LINCKSEL_T *) 0x0F02C3)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union CKSEL_T
{
	io_byte REG;
	struct
	{
		io_byte SELLOSC :1;		/* (BIT)*/
		io_byte B1:1;
		io_byte TRD_CKSEL:1;		/* (BIT)*/
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte FMAINDIV:1;		/* (BIT)*/
		io_byte B7:1;
	} BIT;
} CKSEL;
#define		CKSEL		(*(volatile union CKSEL_T *) 0x0F02C4)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union PLLCTL_T
{
	io_byte REG;
	struct
	{
		io_byte PLLON   :1;		/* (BIT)*/
		io_byte PLLMUL  :1;		/* (BIT)*/
		io_byte SELPLL  :1;		/* (BIT)*/
		io_byte B3:1;
		io_byte PLLDIV0 :1;		/* (BIT)*/
		io_byte PLLDIV1 :1;		/* (BIT)*/
		io_byte LCKSEL0 :1;		/* (BIT)*/
		io_byte LCKSEL1 :1;		/* (BIT)*/
	} BIT;
} PLLCTL;
#define		PLLCTL		(*(volatile union PLLCTL_T *) 0x0F02C5)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union PLLSTS_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte SELPLLS :1;		/* (BIT)*/
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte LOCK    :1;		/* (BIT)*/
	} BIT;
} PLLSTS;
#define		PLLSTS		(*(volatile union PLLSTS_T *) 0x0F02C6)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union MDIV_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} MDIV;
#define		MDIV		(*(volatile union MDIV_T *) 0x0F02C7)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RTCCL_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RTCCL;
#define		RTCCL		(*(volatile union RTCCL_T *) 0x0F02C8)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union POCRES_T
{
	io_byte REG;
	struct
	{
		io_byte POCRES0 :1;		/* (BIT)*/
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte CLKRF   :1;		/* (BIT)*/
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} POCRES;
#define		POCRES		(*(volatile union POCRES_T *) 0x0F02C9)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union STPSTC_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte STPLV   :1;		/* (BIT)*/
		io_byte B5:1;
		io_byte B6:1;
		io_byte STPOEN  :1;		/* (BIT)*/
	} BIT;
} STPSTC;
#define		STPSTC		(*(volatile union STPSTC_T *) 0x0F02CA)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union TPGCSC_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte TWWDTSTP:1;		/* (BIT)*/
		io_byte TWDTLOSC:1;		/* (BIT)*/
		io_byte TCKSPLL :1;		/* (BIT)*/
	} BIT;
} TPGCSC;
#define		TPGCSC		(*(volatile union TPGCSC_T *) 0x0F02CB)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union CLMTES_T
{
	io_byte REG;
	struct
	{
		io_byte CK1MSK  :1;		/* (BIT)*/
		io_byte CK2MSK  :1;		/* (BIT)*/
		io_byte TCLKMB  :1;		/* (BIT)*/
		io_byte TLIOUSE :1;		/* (BIT)*/
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte TESEN   :1;		/* (BIT)*/
	} BIT;
} CLMTES;
#define		CLMTES		(*(volatile union CLMTES_T *) 0x0F02CC)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union HDTCCR0_T
{
	io_byte REG;
	struct
	{
		io_byte HMODE0  :1;		/* (BIT)*/
		io_byte HRPTSEL0:1;		/* (BIT)*/
		io_byte HSAMOD0 :1;		/* (BIT)*/
		io_byte HDAMOD0 :1;		/* (BIT)*/
		io_byte HCHNE0  :1;		/* (BIT)*/
		io_byte HRPTINT0:1;		/* (BIT)*/
		io_byte HSZ0    :1;		/* (BIT)*/
		io_byte B7:1;
	} BIT;
} HDTCCR0;
#define		HDTCCR0		(*(volatile union HDTCCR0_T *) 0x0F02D0)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union HDTCCT0_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} HDTCCT0;
#define		HDTCCT0		(*(volatile union HDTCCT0_T *) 0x0F02D2)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union HDTRLD0_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} HDTRLD0;
#define		HDTRLD0		(*(volatile union HDTRLD0_T *) 0x0F02D3)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union HDTSAR0_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} HDTSAR0;
#define		HDTSAR0		(*(volatile union HDTSAR0_T *) 0x0F02D4)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union HDTDAR0_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} HDTDAR0;
#define		HDTDAR0		(*(volatile union HDTDAR0_T *) 0x0F02D6)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union HDTCCR1_T
{
	io_byte REG;
	struct
	{
		io_byte HMODE1  :1;		/* (BIT)*/
		io_byte HRPTSEL1:1;		/* (BIT)*/
		io_byte HSAMOD1 :1;		/* (BIT)*/
		io_byte HDAMOD1 :1;		/* (BIT)*/
		io_byte HCHNE1  :1;		/* (BIT)*/
		io_byte HRPTINT1:1;		/* (BIT)*/
		io_byte HSZ1    :1;		/* (BIT)*/
		io_byte B7:1;
	} BIT;
} HDTCCR1;
#define		HDTCCR1		(*(volatile union HDTCCR1_T *) 0x0F02D8)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union HDTCCT1_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} HDTCCT1;
#define		HDTCCT1		(*(volatile union HDTCCT1_T *) 0x0F02DA)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union HDTRLD1_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} HDTRLD1;
#define		HDTRLD1		(*(volatile union HDTRLD1_T *) 0x0F02DB)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union HDTSAR1_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} HDTSAR1;
#define		HDTSAR1		(*(volatile union HDTSAR1_T *) 0x0F02DC)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union HDTDAR1_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} HDTDAR1;
#define		HDTDAR1		(*(volatile union HDTDAR1_T *) 0x0F02DE)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union DTCBAR_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} DTCBAR;
#define		DTCBAR		(*(volatile union DTCBAR_T *) 0x0F02E0)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union SELHS0_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} SELHS0;
#define		SELHS0		(*(volatile union SELHS0_T *) 0x0F02E1)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union SELHS1_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} SELHS1;
#define		SELHS1		(*(volatile union SELHS1_T *) 0x0F02E2)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union DTCEN0_T
{
	io_byte REG;
	struct
	{
		io_byte DTCEN00 :1;		/* (BIT)*/
		io_byte DTCEN01 :1;		/* (BIT)*/
		io_byte DTCEN02 :1;		/* (BIT)*/
		io_byte DTCEN03 :1;		/* (BIT)*/
		io_byte DTCEN04 :1;		/* (BIT)*/
		io_byte DTCEN05 :1;		/* (BIT)*/
		io_byte DTCEN06 :1;		/* (BIT)*/
		io_byte DTCEN07 :1;		/* (BIT)*/
	} BIT;
} DTCEN0;
#define		DTCEN0		(*(volatile union DTCEN0_T *) 0x0F02E8)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union DTCEN1_T
{
	io_byte REG;
	struct
	{
		io_byte DTCEN10 :1;		/* (BIT)*/
		io_byte DTCEN11 :1;		/* (BIT)*/
		io_byte DTCEN12 :1;		/* (BIT)*/
		io_byte DTCEN13 :1;		/* (BIT)*/
		io_byte DTCEN14 :1;		/* (BIT)*/
		io_byte DTCEN15 :1;		/* (BIT)*/
		io_byte DTCEN16 :1;		/* (BIT)*/
		io_byte DTCEN17 :1;		/* (BIT)*/
	} BIT;
} DTCEN1;
#define		DTCEN1		(*(volatile union DTCEN1_T *) 0x0F02E9)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union DTCEN2_T
{
	io_byte REG;
	struct
	{
		io_byte DTCEN20 :1;		/* (BIT)*/
		io_byte DTCEN21 :1;		/* (BIT)*/
		io_byte DTCEN22 :1;		/* (BIT)*/
		io_byte DTCEN23 :1;		/* (BIT)*/
		io_byte DTCEN24 :1;		/* (BIT)*/
		io_byte DTCEN25 :1;		/* (BIT)*/
		io_byte B6:1;
		io_byte DTCEN27 :1;		/* (BIT)*/
	} BIT;
} DTCEN2;
#define		DTCEN2		(*(volatile union DTCEN2_T *) 0x0F02EA)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union DTCEN3_T
{
	io_byte REG;
	struct
	{
		io_byte DTCEN30 :1;		/* (BIT)*/
		io_byte DTCEN31 :1;		/* (BIT)*/
		io_byte DTCEN32 :1;		/* (BIT)*/
		io_byte DTCEN33 :1;		/* (BIT)*/
		io_byte DTCEN34 :1;		/* (BIT)*/
		io_byte DTCEN35 :1;		/* (BIT)*/
		io_byte DTCEN36 :1;		/* (BIT)*/
		io_byte DTCEN37 :1;		/* (BIT)*/
	} BIT;
} DTCEN3;
#define		DTCEN3		(*(volatile union DTCEN3_T *) 0x0F02EB)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union DTCEN4_T
{
	io_byte REG;
	struct
	{
		io_byte DTCEN40 :1;		/* (BIT)*/
		io_byte DTCEN41 :1;		/* (BIT)*/
		io_byte DTCEN42 :1;		/* (BIT)*/
		io_byte DTCEN43 :1;		/* (BIT)*/
		io_byte DTCEN44 :1;		/* (BIT)*/
		io_byte DTCEN45 :1;		/* (BIT)*/
		io_byte DTCEN46 :1;		/* (BIT)*/
		io_byte DTCEN47 :1;		/* (BIT)*/
	} BIT;
} DTCEN4;
#define		DTCEN4		(*(volatile union DTCEN4_T *) 0x0F02EC)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union DTCEN5_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte DTCEN52 :1;		/* (BIT)*/
		io_byte DTCEN53 :1;		/* (BIT)*/
		io_byte DTCEN54 :1;		/* (BIT)*/
		io_byte DTCEN55 :1;		/* (BIT)*/
		io_byte DTCEN56 :1;		/* (BIT)*/
		io_byte DTCEN57 :1;		/* (BIT)*/
	} BIT;
} DTCEN5;
#define		DTCEN5		(*(volatile union DTCEN5_T *) 0x0F02ED)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union DTCEN6_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte DTCEN63 :1;		/* (BIT)*/
		io_byte DTCEN64 :1;		/* (BIT)*/
		io_byte DTCEN65 :1;		/* (BIT)*/
		io_byte DTCEN66 :1;		/* (BIT)*/
		io_byte DTCEN67 :1;		/* (BIT)*/
	} BIT;
} DTCEN6;
#define		DTCEN6		(*(volatile union DTCEN6_T *) 0x0F02EE)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union CRC0CTL_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte CRC0EN  :1;		/* (BIT)*/
	} BIT;
} CRC0CTL;
#define		CRC0CTL		(*(volatile union CRC0CTL_T *) 0x0F02F0)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union PGCRCL_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} PGCRCL;
#define		PGCRCL		(*(volatile union PGCRCL_T *) 0x0F02F2)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union CRCMD_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} CRCMD;
#define		CRCMD		(*(volatile union CRCMD_T *) 0x0F02F9)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union CRCD_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} CRCD;
#define		CRCD		(*(volatile union CRCD_T *) 0x0F02FA)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union C0CFGL_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} C0CFGL;
#define		C0CFGL		(*(volatile union C0CFGL_T *) 0x0F0300)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union C0CFGLL_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} C0CFGLL;
#define		C0CFGLL		(*(volatile union C0CFGLL_T *) 0x0F0300)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union C0CFGLH_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} C0CFGLH;
#define		C0CFGLH		(*(volatile union C0CFGLH_T *) 0x0F0301)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union C0CFGH_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} C0CFGH;
#define		C0CFGH		(*(volatile union C0CFGH_T *) 0x0F0302)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union C0CFGHL_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} C0CFGHL;
#define		C0CFGHL		(*(volatile union C0CFGHL_T *) 0x0F0302)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union C0CFGHH_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} C0CFGHH;
#define		C0CFGHH		(*(volatile union C0CFGHH_T *) 0x0F0303)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union C0CTRL_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} C0CTRL;
#define		C0CTRL		(*(volatile union C0CTRL_T *) 0x0F0304)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union C0CTRLL_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} C0CTRLL;
#define		C0CTRLL		(*(volatile union C0CTRLL_T *) 0x0F0304)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union C0CTRLH_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} C0CTRLH;
#define		C0CTRLH		(*(volatile union C0CTRLH_T *) 0x0F0305)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union C0CTRH_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} C0CTRH;
#define		C0CTRH		(*(volatile union C0CTRH_T *) 0x0F0306)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union C0CTRHL_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} C0CTRHL;
#define		C0CTRHL		(*(volatile union C0CTRHL_T *) 0x0F0306)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union C0CTRHH_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} C0CTRHH;
#define		C0CTRHH		(*(volatile union C0CTRHH_T *) 0x0F0307)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union C0STSL_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} C0STSL;
#define		C0STSL		(*(volatile union C0STSL_T *) 0x0F0308)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union C0STSLL_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} C0STSLL;
#define		C0STSLL		(*(volatile union C0STSLL_T *) 0x0F0308)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union C0STSLH_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} C0STSLH;
#define		C0STSLH		(*(volatile union C0STSLH_T *) 0x0F0309)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union C0STSH_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} C0STSH;
#define		C0STSH		(*(volatile union C0STSH_T *) 0x0F030A)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union C0STSHL_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} C0STSHL;
#define		C0STSHL		(*(volatile union C0STSHL_T *) 0x0F030A)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union C0STSHH_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} C0STSHH;
#define		C0STSHH		(*(volatile union C0STSHH_T *) 0x0F030B)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union C0ERFLL_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} C0ERFLL;
#define		C0ERFLL		(*(volatile union C0ERFLL_T *) 0x0F030C)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union C0ERFLLL_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} C0ERFLLL;
#define		C0ERFLLL		(*(volatile union C0ERFLLL_T *) 0x0F030C)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union C0ERFLLH_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} C0ERFLLH;
#define		C0ERFLLH		(*(volatile union C0ERFLLH_T *) 0x0F030D)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union C0ERFLH_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} C0ERFLH;
#define		C0ERFLH		(*(volatile union C0ERFLH_T *) 0x0F030E)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union C0ERFLHL_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} C0ERFLHL;
#define		C0ERFLHL		(*(volatile union C0ERFLHL_T *) 0x0F030E)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union C0ERFLHH_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} C0ERFLHH;
#define		C0ERFLHH		(*(volatile union C0ERFLHH_T *) 0x0F030F)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union GIPV_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} GIPV;
#define		GIPV		(*(volatile union GIPV_T *) 0x0F0320)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union GIPVL_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} GIPVL;
#define		GIPVL		(*(volatile union GIPVL_T *) 0x0F0320)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union GCFGL_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} GCFGL;
#define		GCFGL		(*(volatile union GCFGL_T *) 0x0F0322)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union GCFGLL_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} GCFGLL;
#define		GCFGLL		(*(volatile union GCFGLL_T *) 0x0F0322)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union GCFGLH_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} GCFGLH;
#define		GCFGLH		(*(volatile union GCFGLH_T *) 0x0F0323)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union GCFGH_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} GCFGH;
#define		GCFGH		(*(volatile union GCFGH_T *) 0x0F0324)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union GCFGHL_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} GCFGHL;
#define		GCFGHL		(*(volatile union GCFGHL_T *) 0x0F0324)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union GCFGHH_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} GCFGHH;
#define		GCFGHH		(*(volatile union GCFGHH_T *) 0x0F0325)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union GCTRL_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} GCTRL;
#define		GCTRL		(*(volatile union GCTRL_T *) 0x0F0326)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union GCTRLL_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} GCTRLL;
#define		GCTRLL		(*(volatile union GCTRLL_T *) 0x0F0326)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union GCTRLH_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} GCTRLH;
#define		GCTRLH		(*(volatile union GCTRLH_T *) 0x0F0327)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union GCTRH_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} GCTRH;
#define		GCTRH		(*(volatile union GCTRH_T *) 0x0F0328)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union GCTRHL_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} GCTRHL;
#define		GCTRHL		(*(volatile union GCTRHL_T *) 0x0F0328)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union GCTRHH_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} GCTRHH;
#define		GCTRHH		(*(volatile union GCTRHH_T *) 0x0F0329)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union GSTS_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} GSTS;
#define		GSTS		(*(volatile union GSTS_T *) 0x0F032A)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union GSTSL_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} GSTSL;
#define		GSTSL		(*(volatile union GSTSL_T *) 0x0F032A)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union GSTSH_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} GSTSH;
#define		GSTSH		(*(volatile union GSTSH_T *) 0x0F032B)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union GERFLL_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} GERFLL;
#define		GERFLL		(*(volatile union GERFLL_T *) 0x0F032C)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union GTSC_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} GTSC;
#define		GTSC		(*(volatile union GTSC_T *) 0x0F032E)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union GAFLCFG_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} GAFLCFG;
#define		GAFLCFG		(*(volatile union GAFLCFG_T *) 0x0F0330)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union GAFLCFGL_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} GAFLCFGL;
#define		GAFLCFGL		(*(volatile union GAFLCFGL_T *) 0x0F0330)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union GAFLCFGH_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} GAFLCFGH;
#define		GAFLCFGH		(*(volatile union GAFLCFGH_T *) 0x0F0331)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMNB_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} RMNB;
#define		RMNB		(*(volatile union RMNB_T *) 0x0F0332)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMNBL_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RMNBL;
#define		RMNBL		(*(volatile union RMNBL_T *) 0x0F0332)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMND0_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} RMND0;
#define		RMND0		(*(volatile union RMND0_T *) 0x0F0334)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMND0L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RMND0L;
#define		RMND0L		(*(volatile union RMND0L_T *) 0x0F0334)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMND0H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RMND0H;
#define		RMND0H		(*(volatile union RMND0H_T *) 0x0F0335)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RFCC0_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} RFCC0;
#define		RFCC0		(*(volatile union RFCC0_T *) 0x0F0338)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RFCC0L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RFCC0L;
#define		RFCC0L		(*(volatile union RFCC0L_T *) 0x0F0338)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RFCC0H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RFCC0H;
#define		RFCC0H		(*(volatile union RFCC0H_T *) 0x0F0339)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RFCC1_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} RFCC1;
#define		RFCC1		(*(volatile union RFCC1_T *) 0x0F033A)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RFCC1L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RFCC1L;
#define		RFCC1L		(*(volatile union RFCC1L_T *) 0x0F033A)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RFCC1H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RFCC1H;
#define		RFCC1H		(*(volatile union RFCC1H_T *) 0x0F033B)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RFSTS0_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} RFSTS0;
#define		RFSTS0		(*(volatile union RFSTS0_T *) 0x0F0340)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RFSTS0L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RFSTS0L;
#define		RFSTS0L		(*(volatile union RFSTS0L_T *) 0x0F0340)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RFSTS0H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RFSTS0H;
#define		RFSTS0H		(*(volatile union RFSTS0H_T *) 0x0F0341)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RFSTS1_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} RFSTS1;
#define		RFSTS1		(*(volatile union RFSTS1_T *) 0x0F0342)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RFSTS1L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RFSTS1L;
#define		RFSTS1L		(*(volatile union RFSTS1L_T *) 0x0F0342)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RFSTS1H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RFSTS1H;
#define		RFSTS1H		(*(volatile union RFSTS1H_T *) 0x0F0343)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RFPCTR0_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} RFPCTR0;
#define		RFPCTR0		(*(volatile union RFPCTR0_T *) 0x0F0348)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RFPCTR0L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RFPCTR0L;
#define		RFPCTR0L		(*(volatile union RFPCTR0L_T *) 0x0F0348)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RFPCTR0H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RFPCTR0H;
#define		RFPCTR0H		(*(volatile union RFPCTR0H_T *) 0x0F0349)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RFPCTR1_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} RFPCTR1;
#define		RFPCTR1		(*(volatile union RFPCTR1_T *) 0x0F034A)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RFPCTR1L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RFPCTR1L;
#define		RFPCTR1L		(*(volatile union RFPCTR1L_T *) 0x0F034A)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RFPCTR1H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RFPCTR1H;
#define		RFPCTR1H		(*(volatile union RFPCTR1H_T *) 0x0F034B)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union CFCCL0_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} CFCCL0;
#define		CFCCL0		(*(volatile union CFCCL0_T *) 0x0F0350)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union CFCCL0L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} CFCCL0L;
#define		CFCCL0L		(*(volatile union CFCCL0L_T *) 0x0F0350)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union CFCCL0H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} CFCCL0H;
#define		CFCCL0H		(*(volatile union CFCCL0H_T *) 0x0F0351)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union CFCCH0_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} CFCCH0;
#define		CFCCH0		(*(volatile union CFCCH0_T *) 0x0F0352)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union CFCCH0L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} CFCCH0L;
#define		CFCCH0L		(*(volatile union CFCCH0L_T *) 0x0F0352)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union CFCCH0H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} CFCCH0H;
#define		CFCCH0H		(*(volatile union CFCCH0H_T *) 0x0F0353)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union CFSTS0_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} CFSTS0;
#define		CFSTS0		(*(volatile union CFSTS0_T *) 0x0F0358)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union CFSTS0L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} CFSTS0L;
#define		CFSTS0L		(*(volatile union CFSTS0L_T *) 0x0F0358)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union CFSTS0H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} CFSTS0H;
#define		CFSTS0H		(*(volatile union CFSTS0H_T *) 0x0F0359)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union CFPCTR0_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} CFPCTR0;
#define		CFPCTR0		(*(volatile union CFPCTR0_T *) 0x0F035C)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union CFPCTR0L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} CFPCTR0L;
#define		CFPCTR0L		(*(volatile union CFPCTR0L_T *) 0x0F035C)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RFMSTS_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RFMSTS;
#define		RFMSTS		(*(volatile union RFMSTS_T *) 0x0F0360)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union CFMSTS_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} CFMSTS;
#define		CFMSTS		(*(volatile union CFMSTS_T *) 0x0F0361)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RFISTS_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RFISTS;
#define		RFISTS		(*(volatile union RFISTS_T *) 0x0F0362)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union CFISTS_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} CFISTS;
#define		CFISTS		(*(volatile union CFISTS_T *) 0x0F0363)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union TMC0_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} TMC0;
#define		TMC0		(*(volatile union TMC0_T *) 0x0F0364)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union TMC1_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} TMC1;
#define		TMC1		(*(volatile union TMC1_T *) 0x0F0365)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union TMC2_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} TMC2;
#define		TMC2		(*(volatile union TMC2_T *) 0x0F0366)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union TMC3_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} TMC3;
#define		TMC3		(*(volatile union TMC3_T *) 0x0F0367)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union TMSTS0_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} TMSTS0;
#define		TMSTS0		(*(volatile union TMSTS0_T *) 0x0F036C)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union TMSTS1_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} TMSTS1;
#define		TMSTS1		(*(volatile union TMSTS1_T *) 0x0F036D)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union TMSTS2_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} TMSTS2;
#define		TMSTS2		(*(volatile union TMSTS2_T *) 0x0F036E)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union TMSTS3_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} TMSTS3;
#define		TMSTS3		(*(volatile union TMSTS3_T *) 0x0F036F)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union TMTRSTS_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} TMTRSTS;
#define		TMTRSTS		(*(volatile union TMTRSTS_T *) 0x0F0374)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union TMTRSTSL_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} TMTRSTSL;
#define		TMTRSTSL		(*(volatile union TMTRSTSL_T *) 0x0F0374)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union TMTRSTSH_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} TMTRSTSH;
#define		TMTRSTSH		(*(volatile union TMTRSTSH_T *) 0x0F0375)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union TMTCSTS_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} TMTCSTS;
#define		TMTCSTS		(*(volatile union TMTCSTS_T *) 0x0F0376)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union TMTCSTSL_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} TMTCSTSL;
#define		TMTCSTSL		(*(volatile union TMTCSTSL_T *) 0x0F0376)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union TMTCSTSH_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} TMTCSTSH;
#define		TMTCSTSH		(*(volatile union TMTCSTSH_T *) 0x0F0377)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union TMTASTS_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} TMTASTS;
#define		TMTASTS		(*(volatile union TMTASTS_T *) 0x0F0378)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union TMTASTSL_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} TMTASTSL;
#define		TMTASTSL		(*(volatile union TMTASTSL_T *) 0x0F0378)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union TMTASTSH_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} TMTASTSH;
#define		TMTASTSH		(*(volatile union TMTASTSH_T *) 0x0F0379)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union TMIEC_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} TMIEC;
#define		TMIEC		(*(volatile union TMIEC_T *) 0x0F037A)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union TMIECL_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} TMIECL;
#define		TMIECL		(*(volatile union TMIECL_T *) 0x0F037A)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union TMIECH_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} TMIECH;
#define		TMIECH		(*(volatile union TMIECH_T *) 0x0F037B)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union THLCC0_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} THLCC0;
#define		THLCC0		(*(volatile union THLCC0_T *) 0x0F037C)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union THLCC0L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} THLCC0L;
#define		THLCC0L		(*(volatile union THLCC0L_T *) 0x0F037C)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union THLCC0H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} THLCC0H;
#define		THLCC0H		(*(volatile union THLCC0H_T *) 0x0F037D)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union THLSTS0_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} THLSTS0;
#define		THLSTS0		(*(volatile union THLSTS0_T *) 0x0F0380)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union THLSTS0L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} THLSTS0L;
#define		THLSTS0L		(*(volatile union THLSTS0L_T *) 0x0F0380)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union THLSTS0H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} THLSTS0H;
#define		THLSTS0H		(*(volatile union THLSTS0H_T *) 0x0F0381)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union THLPCTR0_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} THLPCTR0;
#define		THLPCTR0		(*(volatile union THLPCTR0_T *) 0x0F0384)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union THLPCTR0L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} THLPCTR0L;
#define		THLPCTR0L		(*(volatile union THLPCTR0L_T *) 0x0F0384)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union THLPCTR0H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} THLPCTR0H;
#define		THLPCTR0H		(*(volatile union THLPCTR0H_T *) 0x0F0385)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union GTINTSTS_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} GTINTSTS;
#define		GTINTSTS		(*(volatile union GTINTSTS_T *) 0x0F0388)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union GTINTSTSL_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} GTINTSTSL;
#define		GTINTSTSL		(*(volatile union GTINTSTSL_T *) 0x0F0388)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union GTINTSTSH_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} GTINTSTSH;
#define		GTINTSTSH		(*(volatile union GTINTSTSH_T *) 0x0F0389)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union GRWCR_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} GRWCR;
#define		GRWCR		(*(volatile union GRWCR_T *) 0x0F038A)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union GRWCRL_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} GRWCRL;
#define		GRWCRL		(*(volatile union GRWCRL_T *) 0x0F038A)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union GRWCRH_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} GRWCRH;
#define		GRWCRH		(*(volatile union GRWCRH_T *) 0x0F038B)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union GTSTCFG_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} GTSTCFG;
#define		GTSTCFG		(*(volatile union GTSTCFG_T *) 0x0F038C)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union GTSTCFGL_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} GTSTCFGL;
#define		GTSTCFGL		(*(volatile union GTSTCFGL_T *) 0x0F038C)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union GTSTCFGH_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} GTSTCFGH;
#define		GTSTCFGH		(*(volatile union GTSTCFGH_T *) 0x0F038D)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union GTSTCTRL_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} GTSTCTRL;
#define		GTSTCTRL		(*(volatile union GTSTCTRL_T *) 0x0F038E)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union GEIMCCL_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} GEIMCCL;
#define		GEIMCCL		(*(volatile union GEIMCCL_T *) 0x0F0390)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union GEIMCCLL_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} GEIMCCLL;
#define		GEIMCCLL		(*(volatile union GEIMCCLL_T *) 0x0F0390)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union GEIMCCLH_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} GEIMCCLH;
#define		GEIMCCLH		(*(volatile union GEIMCCLH_T *) 0x0F0391)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union GEIMCCH_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} GEIMCCH;
#define		GEIMCCH		(*(volatile union GEIMCCH_T *) 0x0F0392)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union GEIMCCHL_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} GEIMCCHL;
#define		GEIMCCHL		(*(volatile union GEIMCCHL_T *) 0x0F0392)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union GEIMCCHH_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} GEIMCCHH;
#define		GEIMCCHH		(*(volatile union GEIMCCHH_T *) 0x0F0393)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union GLOCKK_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} GLOCKK;
#define		GLOCKK		(*(volatile union GLOCKK_T *) 0x0F0394)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union GAFLIDL0_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} GAFLIDL0;
#define		GAFLIDL0		(*(volatile union GAFLIDL0_T *) 0x0F03A0)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMIDL0_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} RMIDL0;
#define		RMIDL0		(*(volatile union RMIDL0_T *) 0x0F03A0)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union GAFLIDL0L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} GAFLIDL0L;
#define		GAFLIDL0L		(*(volatile union GAFLIDL0L_T *) 0x0F03A0)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMIDL0L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RMIDL0L;
#define		RMIDL0L		(*(volatile union RMIDL0L_T *) 0x0F03A0)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union GAFLIDL0H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} GAFLIDL0H;
#define		GAFLIDL0H		(*(volatile union GAFLIDL0H_T *) 0x0F03A1)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMIDL0H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RMIDL0H;
#define		RMIDL0H		(*(volatile union RMIDL0H_T *) 0x0F03A1)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union GAFLIDH0_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} GAFLIDH0;
#define		GAFLIDH0		(*(volatile union GAFLIDH0_T *) 0x0F03A2)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMIDH0_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} RMIDH0;
#define		RMIDH0		(*(volatile union RMIDH0_T *) 0x0F03A2)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union GAFLIDH0L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} GAFLIDH0L;
#define		GAFLIDH0L		(*(volatile union GAFLIDH0L_T *) 0x0F03A2)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMIDH0L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RMIDH0L;
#define		RMIDH0L		(*(volatile union RMIDH0L_T *) 0x0F03A2)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union GAFLIDH0H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} GAFLIDH0H;
#define		GAFLIDH0H		(*(volatile union GAFLIDH0H_T *) 0x0F03A3)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMIDH0H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RMIDH0H;
#define		RMIDH0H		(*(volatile union RMIDH0H_T *) 0x0F03A3)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union GAFLML0_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} GAFLML0;
#define		GAFLML0		(*(volatile union GAFLML0_T *) 0x0F03A4)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMTS0_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} RMTS0;
#define		RMTS0		(*(volatile union RMTS0_T *) 0x0F03A4)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union GAFLML0L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} GAFLML0L;
#define		GAFLML0L		(*(volatile union GAFLML0L_T *) 0x0F03A4)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMTS0L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RMTS0L;
#define		RMTS0L		(*(volatile union RMTS0L_T *) 0x0F03A4)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union GAFLML0H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} GAFLML0H;
#define		GAFLML0H		(*(volatile union GAFLML0H_T *) 0x0F03A5)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMTS0H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RMTS0H;
#define		RMTS0H		(*(volatile union RMTS0H_T *) 0x0F03A5)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union GAFLMH0_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} GAFLMH0;
#define		GAFLMH0		(*(volatile union GAFLMH0_T *) 0x0F03A6)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMPTR0_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} RMPTR0;
#define		RMPTR0		(*(volatile union RMPTR0_T *) 0x0F03A6)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union GAFLMH0L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} GAFLMH0L;
#define		GAFLMH0L		(*(volatile union GAFLMH0L_T *) 0x0F03A6)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMPTR0L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RMPTR0L;
#define		RMPTR0L		(*(volatile union RMPTR0L_T *) 0x0F03A6)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union GAFLMH0H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} GAFLMH0H;
#define		GAFLMH0H		(*(volatile union GAFLMH0H_T *) 0x0F03A7)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMPTR0H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RMPTR0H;
#define		RMPTR0H		(*(volatile union RMPTR0H_T *) 0x0F03A7)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union GAFLPL0_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} GAFLPL0;
#define		GAFLPL0		(*(volatile union GAFLPL0_T *) 0x0F03A8)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMDF00_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} RMDF00;
#define		RMDF00		(*(volatile union RMDF00_T *) 0x0F03A8)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union GAFLPL0L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} GAFLPL0L;
#define		GAFLPL0L		(*(volatile union GAFLPL0L_T *) 0x0F03A8)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMDF00L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RMDF00L;
#define		RMDF00L		(*(volatile union RMDF00L_T *) 0x0F03A8)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union GAFLPL0H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} GAFLPL0H;
#define		GAFLPL0H		(*(volatile union GAFLPL0H_T *) 0x0F03A9)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMDF00H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RMDF00H;
#define		RMDF00H		(*(volatile union RMDF00H_T *) 0x0F03A9)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union GAFLPH0_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} GAFLPH0;
#define		GAFLPH0		(*(volatile union GAFLPH0_T *) 0x0F03AA)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMDF10_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} RMDF10;
#define		RMDF10		(*(volatile union RMDF10_T *) 0x0F03AA)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union GAFLPH0L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} GAFLPH0L;
#define		GAFLPH0L		(*(volatile union GAFLPH0L_T *) 0x0F03AA)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMDF10L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RMDF10L;
#define		RMDF10L		(*(volatile union RMDF10L_T *) 0x0F03AA)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union GAFLPH0H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} GAFLPH0H;
#define		GAFLPH0H		(*(volatile union GAFLPH0H_T *) 0x0F03AB)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMDF10H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RMDF10H;
#define		RMDF10H		(*(volatile union RMDF10H_T *) 0x0F03AB)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union GAFLIDL1_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} GAFLIDL1;
#define		GAFLIDL1		(*(volatile union GAFLIDL1_T *) 0x0F03AC)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMDF20_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} RMDF20;
#define		RMDF20		(*(volatile union RMDF20_T *) 0x0F03AC)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union GAFLIDL1L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} GAFLIDL1L;
#define		GAFLIDL1L		(*(volatile union GAFLIDL1L_T *) 0x0F03AC)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMDF20L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RMDF20L;
#define		RMDF20L		(*(volatile union RMDF20L_T *) 0x0F03AC)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union GAFLIDL1H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} GAFLIDL1H;
#define		GAFLIDL1H		(*(volatile union GAFLIDL1H_T *) 0x0F03AD)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMDF20H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RMDF20H;
#define		RMDF20H		(*(volatile union RMDF20H_T *) 0x0F03AD)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union GAFLIDH1_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} GAFLIDH1;
#define		GAFLIDH1		(*(volatile union GAFLIDH1_T *) 0x0F03AE)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMDF30_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} RMDF30;
#define		RMDF30		(*(volatile union RMDF30_T *) 0x0F03AE)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union GAFLIDH1L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} GAFLIDH1L;
#define		GAFLIDH1L		(*(volatile union GAFLIDH1L_T *) 0x0F03AE)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMDF30L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RMDF30L;
#define		RMDF30L		(*(volatile union RMDF30L_T *) 0x0F03AE)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union GAFLIDH1H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} GAFLIDH1H;
#define		GAFLIDH1H		(*(volatile union GAFLIDH1H_T *) 0x0F03AF)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMDF30H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RMDF30H;
#define		RMDF30H		(*(volatile union RMDF30H_T *) 0x0F03AF)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union GAFLML1_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} GAFLML1;
#define		GAFLML1		(*(volatile union GAFLML1_T *) 0x0F03B0)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMIDL1_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} RMIDL1;
#define		RMIDL1		(*(volatile union RMIDL1_T *) 0x0F03B0)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union GAFLML1L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} GAFLML1L;
#define		GAFLML1L		(*(volatile union GAFLML1L_T *) 0x0F03B0)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMIDL1L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RMIDL1L;
#define		RMIDL1L		(*(volatile union RMIDL1L_T *) 0x0F03B0)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union GAFLML1H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} GAFLML1H;
#define		GAFLML1H		(*(volatile union GAFLML1H_T *) 0x0F03B1)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMIDL1H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RMIDL1H;
#define		RMIDL1H		(*(volatile union RMIDL1H_T *) 0x0F03B1)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union GAFLMH1_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} GAFLMH1;
#define		GAFLMH1		(*(volatile union GAFLMH1_T *) 0x0F03B2)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMIDH1_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} RMIDH1;
#define		RMIDH1		(*(volatile union RMIDH1_T *) 0x0F03B2)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union GAFLMH1L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} GAFLMH1L;
#define		GAFLMH1L		(*(volatile union GAFLMH1L_T *) 0x0F03B2)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMIDH1L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RMIDH1L;
#define		RMIDH1L		(*(volatile union RMIDH1L_T *) 0x0F03B2)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union GAFLMH1H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} GAFLMH1H;
#define		GAFLMH1H		(*(volatile union GAFLMH1H_T *) 0x0F03B3)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMIDH1H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RMIDH1H;
#define		RMIDH1H		(*(volatile union RMIDH1H_T *) 0x0F03B3)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union GAFLPL1_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} GAFLPL1;
#define		GAFLPL1		(*(volatile union GAFLPL1_T *) 0x0F03B4)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMTS1_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} RMTS1;
#define		RMTS1		(*(volatile union RMTS1_T *) 0x0F03B4)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union GAFLPL1L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} GAFLPL1L;
#define		GAFLPL1L		(*(volatile union GAFLPL1L_T *) 0x0F03B4)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMTS1L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RMTS1L;
#define		RMTS1L		(*(volatile union RMTS1L_T *) 0x0F03B4)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union GAFLPL1H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} GAFLPL1H;
#define		GAFLPL1H		(*(volatile union GAFLPL1H_T *) 0x0F03B5)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMTS1H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RMTS1H;
#define		RMTS1H		(*(volatile union RMTS1H_T *) 0x0F03B5)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union GAFLPH1_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} GAFLPH1;
#define		GAFLPH1		(*(volatile union GAFLPH1_T *) 0x0F03B6)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMPTR1_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} RMPTR1;
#define		RMPTR1		(*(volatile union RMPTR1_T *) 0x0F03B6)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union GAFLPH1L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} GAFLPH1L;
#define		GAFLPH1L		(*(volatile union GAFLPH1L_T *) 0x0F03B6)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMPTR1L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RMPTR1L;
#define		RMPTR1L		(*(volatile union RMPTR1L_T *) 0x0F03B6)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union GAFLPH1H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} GAFLPH1H;
#define		GAFLPH1H		(*(volatile union GAFLPH1H_T *) 0x0F03B7)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMPTR1H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RMPTR1H;
#define		RMPTR1H		(*(volatile union RMPTR1H_T *) 0x0F03B7)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union GAFLIDL2_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} GAFLIDL2;
#define		GAFLIDL2		(*(volatile union GAFLIDL2_T *) 0x0F03B8)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMDF01_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} RMDF01;
#define		RMDF01		(*(volatile union RMDF01_T *) 0x0F03B8)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union GAFLIDL2L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} GAFLIDL2L;
#define		GAFLIDL2L		(*(volatile union GAFLIDL2L_T *) 0x0F03B8)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMDF01L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RMDF01L;
#define		RMDF01L		(*(volatile union RMDF01L_T *) 0x0F03B8)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union GAFLIDL2H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} GAFLIDL2H;
#define		GAFLIDL2H		(*(volatile union GAFLIDL2H_T *) 0x0F03B9)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMDF01H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RMDF01H;
#define		RMDF01H		(*(volatile union RMDF01H_T *) 0x0F03B9)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union GAFLIDH2_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} GAFLIDH2;
#define		GAFLIDH2		(*(volatile union GAFLIDH2_T *) 0x0F03BA)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMDF11_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} RMDF11;
#define		RMDF11		(*(volatile union RMDF11_T *) 0x0F03BA)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union GAFLIDH2L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} GAFLIDH2L;
#define		GAFLIDH2L		(*(volatile union GAFLIDH2L_T *) 0x0F03BA)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMDF11L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RMDF11L;
#define		RMDF11L		(*(volatile union RMDF11L_T *) 0x0F03BA)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union GAFLIDH2H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} GAFLIDH2H;
#define		GAFLIDH2H		(*(volatile union GAFLIDH2H_T *) 0x0F03BB)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMDF11H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RMDF11H;
#define		RMDF11H		(*(volatile union RMDF11H_T *) 0x0F03BB)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union GAFLML2_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} GAFLML2;
#define		GAFLML2		(*(volatile union GAFLML2_T *) 0x0F03BC)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMDF21_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} RMDF21;
#define		RMDF21		(*(volatile union RMDF21_T *) 0x0F03BC)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union GAFLML2L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} GAFLML2L;
#define		GAFLML2L		(*(volatile union GAFLML2L_T *) 0x0F03BC)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMDF21L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RMDF21L;
#define		RMDF21L		(*(volatile union RMDF21L_T *) 0x0F03BC)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union GAFLML2H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} GAFLML2H;
#define		GAFLML2H		(*(volatile union GAFLML2H_T *) 0x0F03BD)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMDF21H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RMDF21H;
#define		RMDF21H		(*(volatile union RMDF21H_T *) 0x0F03BD)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union GAFLMH2_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} GAFLMH2;
#define		GAFLMH2		(*(volatile union GAFLMH2_T *) 0x0F03BE)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMDF31_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} RMDF31;
#define		RMDF31		(*(volatile union RMDF31_T *) 0x0F03BE)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union GAFLMH2L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} GAFLMH2L;
#define		GAFLMH2L		(*(volatile union GAFLMH2L_T *) 0x0F03BE)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMDF31L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RMDF31L;
#define		RMDF31L		(*(volatile union RMDF31L_T *) 0x0F03BE)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union GAFLMH2H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} GAFLMH2H;
#define		GAFLMH2H		(*(volatile union GAFLMH2H_T *) 0x0F03BF)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMDF31H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RMDF31H;
#define		RMDF31H		(*(volatile union RMDF31H_T *) 0x0F03BF)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union GAFLPL2_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} GAFLPL2;
#define		GAFLPL2		(*(volatile union GAFLPL2_T *) 0x0F03C0)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMIDL2_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} RMIDL2;
#define		RMIDL2		(*(volatile union RMIDL2_T *) 0x0F03C0)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union GAFLPL2L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} GAFLPL2L;
#define		GAFLPL2L		(*(volatile union GAFLPL2L_T *) 0x0F03C0)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMIDL2L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RMIDL2L;
#define		RMIDL2L		(*(volatile union RMIDL2L_T *) 0x0F03C0)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union GAFLPL2H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} GAFLPL2H;
#define		GAFLPL2H		(*(volatile union GAFLPL2H_T *) 0x0F03C1)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMIDL2H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RMIDL2H;
#define		RMIDL2H		(*(volatile union RMIDL2H_T *) 0x0F03C1)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union GAFLPH2_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} GAFLPH2;
#define		GAFLPH2		(*(volatile union GAFLPH2_T *) 0x0F03C2)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMIDH2_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} RMIDH2;
#define		RMIDH2		(*(volatile union RMIDH2_T *) 0x0F03C2)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union GAFLPH2L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} GAFLPH2L;
#define		GAFLPH2L		(*(volatile union GAFLPH2L_T *) 0x0F03C2)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMIDH2L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RMIDH2L;
#define		RMIDH2L		(*(volatile union RMIDH2L_T *) 0x0F03C2)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union GAFLPH2H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} GAFLPH2H;
#define		GAFLPH2H		(*(volatile union GAFLPH2H_T *) 0x0F03C3)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMIDH2H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RMIDH2H;
#define		RMIDH2H		(*(volatile union RMIDH2H_T *) 0x0F03C3)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union GAFLIDL3_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} GAFLIDL3;
#define		GAFLIDL3		(*(volatile union GAFLIDL3_T *) 0x0F03C4)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMTS2_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} RMTS2;
#define		RMTS2		(*(volatile union RMTS2_T *) 0x0F03C4)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union GAFLIDL3L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} GAFLIDL3L;
#define		GAFLIDL3L		(*(volatile union GAFLIDL3L_T *) 0x0F03C4)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMTS2L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RMTS2L;
#define		RMTS2L		(*(volatile union RMTS2L_T *) 0x0F03C4)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union GAFLIDL3H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} GAFLIDL3H;
#define		GAFLIDL3H		(*(volatile union GAFLIDL3H_T *) 0x0F03C5)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMTS2H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RMTS2H;
#define		RMTS2H		(*(volatile union RMTS2H_T *) 0x0F03C5)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union GAFLIDH3_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} GAFLIDH3;
#define		GAFLIDH3		(*(volatile union GAFLIDH3_T *) 0x0F03C6)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMPTR2_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} RMPTR2;
#define		RMPTR2		(*(volatile union RMPTR2_T *) 0x0F03C6)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union GAFLIDH3L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} GAFLIDH3L;
#define		GAFLIDH3L		(*(volatile union GAFLIDH3L_T *) 0x0F03C6)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMPTR2L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RMPTR2L;
#define		RMPTR2L		(*(volatile union RMPTR2L_T *) 0x0F03C6)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union GAFLIDH3H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} GAFLIDH3H;
#define		GAFLIDH3H		(*(volatile union GAFLIDH3H_T *) 0x0F03C7)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMPTR2H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RMPTR2H;
#define		RMPTR2H		(*(volatile union RMPTR2H_T *) 0x0F03C7)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union GAFLML3_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} GAFLML3;
#define		GAFLML3		(*(volatile union GAFLML3_T *) 0x0F03C8)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMDF02_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} RMDF02;
#define		RMDF02		(*(volatile union RMDF02_T *) 0x0F03C8)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union GAFLML3L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} GAFLML3L;
#define		GAFLML3L		(*(volatile union GAFLML3L_T *) 0x0F03C8)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMDF02L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RMDF02L;
#define		RMDF02L		(*(volatile union RMDF02L_T *) 0x0F03C8)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union GAFLML3H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} GAFLML3H;
#define		GAFLML3H		(*(volatile union GAFLML3H_T *) 0x0F03C9)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMDF02H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RMDF02H;
#define		RMDF02H		(*(volatile union RMDF02H_T *) 0x0F03C9)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union GAFLMH3_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} GAFLMH3;
#define		GAFLMH3		(*(volatile union GAFLMH3_T *) 0x0F03CA)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMDF12_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} RMDF12;
#define		RMDF12		(*(volatile union RMDF12_T *) 0x0F03CA)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union GAFLMH3L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} GAFLMH3L;
#define		GAFLMH3L		(*(volatile union GAFLMH3L_T *) 0x0F03CA)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMDF12L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RMDF12L;
#define		RMDF12L		(*(volatile union RMDF12L_T *) 0x0F03CA)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union GAFLMH3H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} GAFLMH3H;
#define		GAFLMH3H		(*(volatile union GAFLMH3H_T *) 0x0F03CB)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMDF12H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RMDF12H;
#define		RMDF12H		(*(volatile union RMDF12H_T *) 0x0F03CB)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union GAFLPL3_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} GAFLPL3;
#define		GAFLPL3		(*(volatile union GAFLPL3_T *) 0x0F03CC)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMDF22_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} RMDF22;
#define		RMDF22		(*(volatile union RMDF22_T *) 0x0F03CC)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union GAFLPL3L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} GAFLPL3L;
#define		GAFLPL3L		(*(volatile union GAFLPL3L_T *) 0x0F03CC)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMDF22L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RMDF22L;
#define		RMDF22L		(*(volatile union RMDF22L_T *) 0x0F03CC)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union GAFLPL3H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} GAFLPL3H;
#define		GAFLPL3H		(*(volatile union GAFLPL3H_T *) 0x0F03CD)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMDF22H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RMDF22H;
#define		RMDF22H		(*(volatile union RMDF22H_T *) 0x0F03CD)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union GAFLPH3_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} GAFLPH3;
#define		GAFLPH3		(*(volatile union GAFLPH3_T *) 0x0F03CE)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMDF32_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} RMDF32;
#define		RMDF32		(*(volatile union RMDF32_T *) 0x0F03CE)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union GAFLPH3L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} GAFLPH3L;
#define		GAFLPH3L		(*(volatile union GAFLPH3L_T *) 0x0F03CE)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMDF32L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RMDF32L;
#define		RMDF32L		(*(volatile union RMDF32L_T *) 0x0F03CE)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union GAFLPH3H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} GAFLPH3H;
#define		GAFLPH3H		(*(volatile union GAFLPH3H_T *) 0x0F03CF)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMDF32H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RMDF32H;
#define		RMDF32H		(*(volatile union RMDF32H_T *) 0x0F03CF)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union GAFLIDL4_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} GAFLIDL4;
#define		GAFLIDL4		(*(volatile union GAFLIDL4_T *) 0x0F03D0)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMIDL3_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} RMIDL3;
#define		RMIDL3		(*(volatile union RMIDL3_T *) 0x0F03D0)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union GAFLIDL4L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} GAFLIDL4L;
#define		GAFLIDL4L		(*(volatile union GAFLIDL4L_T *) 0x0F03D0)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMIDL3L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RMIDL3L;
#define		RMIDL3L		(*(volatile union RMIDL3L_T *) 0x0F03D0)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union GAFLIDL4H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} GAFLIDL4H;
#define		GAFLIDL4H		(*(volatile union GAFLIDL4H_T *) 0x0F03D1)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMIDL3H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RMIDL3H;
#define		RMIDL3H		(*(volatile union RMIDL3H_T *) 0x0F03D1)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union GAFLIDH4_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} GAFLIDH4;
#define		GAFLIDH4		(*(volatile union GAFLIDH4_T *) 0x0F03D2)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMIDH3_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} RMIDH3;
#define		RMIDH3		(*(volatile union RMIDH3_T *) 0x0F03D2)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union GAFLIDH4L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} GAFLIDH4L;
#define		GAFLIDH4L		(*(volatile union GAFLIDH4L_T *) 0x0F03D2)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMIDH3L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RMIDH3L;
#define		RMIDH3L		(*(volatile union RMIDH3L_T *) 0x0F03D2)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union GAFLIDH4H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} GAFLIDH4H;
#define		GAFLIDH4H		(*(volatile union GAFLIDH4H_T *) 0x0F03D3)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMIDH3H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RMIDH3H;
#define		RMIDH3H		(*(volatile union RMIDH3H_T *) 0x0F03D3)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union GAFLML4_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} GAFLML4;
#define		GAFLML4		(*(volatile union GAFLML4_T *) 0x0F03D4)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMTS3_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} RMTS3;
#define		RMTS3		(*(volatile union RMTS3_T *) 0x0F03D4)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union GAFLML4L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} GAFLML4L;
#define		GAFLML4L		(*(volatile union GAFLML4L_T *) 0x0F03D4)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMTS3L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RMTS3L;
#define		RMTS3L		(*(volatile union RMTS3L_T *) 0x0F03D4)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union GAFLML4H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} GAFLML4H;
#define		GAFLML4H		(*(volatile union GAFLML4H_T *) 0x0F03D5)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMTS3H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RMTS3H;
#define		RMTS3H		(*(volatile union RMTS3H_T *) 0x0F03D5)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union GAFLMH4_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} GAFLMH4;
#define		GAFLMH4		(*(volatile union GAFLMH4_T *) 0x0F03D6)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMPTR3_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} RMPTR3;
#define		RMPTR3		(*(volatile union RMPTR3_T *) 0x0F03D6)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union GAFLMH4L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} GAFLMH4L;
#define		GAFLMH4L		(*(volatile union GAFLMH4L_T *) 0x0F03D6)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMPTR3L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RMPTR3L;
#define		RMPTR3L		(*(volatile union RMPTR3L_T *) 0x0F03D6)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union GAFLMH4H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} GAFLMH4H;
#define		GAFLMH4H		(*(volatile union GAFLMH4H_T *) 0x0F03D7)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMPTR3H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RMPTR3H;
#define		RMPTR3H		(*(volatile union RMPTR3H_T *) 0x0F03D7)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union GAFLPL4_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} GAFLPL4;
#define		GAFLPL4		(*(volatile union GAFLPL4_T *) 0x0F03D8)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMDF03_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} RMDF03;
#define		RMDF03		(*(volatile union RMDF03_T *) 0x0F03D8)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union GAFLPL4L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} GAFLPL4L;
#define		GAFLPL4L		(*(volatile union GAFLPL4L_T *) 0x0F03D8)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMDF03L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RMDF03L;
#define		RMDF03L		(*(volatile union RMDF03L_T *) 0x0F03D8)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union GAFLPL4H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} GAFLPL4H;
#define		GAFLPL4H		(*(volatile union GAFLPL4H_T *) 0x0F03D9)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMDF03H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RMDF03H;
#define		RMDF03H		(*(volatile union RMDF03H_T *) 0x0F03D9)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union GAFLPH4_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} GAFLPH4;
#define		GAFLPH4		(*(volatile union GAFLPH4_T *) 0x0F03DA)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMDF13_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} RMDF13;
#define		RMDF13		(*(volatile union RMDF13_T *) 0x0F03DA)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union GAFLPH4L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} GAFLPH4L;
#define		GAFLPH4L		(*(volatile union GAFLPH4L_T *) 0x0F03DA)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMDF13L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RMDF13L;
#define		RMDF13L		(*(volatile union RMDF13L_T *) 0x0F03DA)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union GAFLPH4H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} GAFLPH4H;
#define		GAFLPH4H		(*(volatile union GAFLPH4H_T *) 0x0F03DB)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMDF13H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RMDF13H;
#define		RMDF13H		(*(volatile union RMDF13H_T *) 0x0F03DB)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union GAFLIDL5_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} GAFLIDL5;
#define		GAFLIDL5		(*(volatile union GAFLIDL5_T *) 0x0F03DC)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMDF23_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} RMDF23;
#define		RMDF23		(*(volatile union RMDF23_T *) 0x0F03DC)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union GAFLIDL5L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} GAFLIDL5L;
#define		GAFLIDL5L		(*(volatile union GAFLIDL5L_T *) 0x0F03DC)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMDF23L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RMDF23L;
#define		RMDF23L		(*(volatile union RMDF23L_T *) 0x0F03DC)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union GAFLIDL5H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} GAFLIDL5H;
#define		GAFLIDL5H		(*(volatile union GAFLIDL5H_T *) 0x0F03DD)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMDF23H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RMDF23H;
#define		RMDF23H		(*(volatile union RMDF23H_T *) 0x0F03DD)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union GAFLIDH5_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} GAFLIDH5;
#define		GAFLIDH5		(*(volatile union GAFLIDH5_T *) 0x0F03DE)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMDF33_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} RMDF33;
#define		RMDF33		(*(volatile union RMDF33_T *) 0x0F03DE)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union GAFLIDH5L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} GAFLIDH5L;
#define		GAFLIDH5L		(*(volatile union GAFLIDH5L_T *) 0x0F03DE)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMDF33L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RMDF33L;
#define		RMDF33L		(*(volatile union RMDF33L_T *) 0x0F03DE)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union GAFLIDH5H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} GAFLIDH5H;
#define		GAFLIDH5H		(*(volatile union GAFLIDH5H_T *) 0x0F03DF)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMDF33H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RMDF33H;
#define		RMDF33H		(*(volatile union RMDF33H_T *) 0x0F03DF)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union GAFLML5_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} GAFLML5;
#define		GAFLML5		(*(volatile union GAFLML5_T *) 0x0F03E0)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMIDL4_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} RMIDL4;
#define		RMIDL4		(*(volatile union RMIDL4_T *) 0x0F03E0)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union GAFLML5L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} GAFLML5L;
#define		GAFLML5L		(*(volatile union GAFLML5L_T *) 0x0F03E0)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMIDL4L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RMIDL4L;
#define		RMIDL4L		(*(volatile union RMIDL4L_T *) 0x0F03E0)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union GAFLML5H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} GAFLML5H;
#define		GAFLML5H		(*(volatile union GAFLML5H_T *) 0x0F03E1)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMIDL4H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RMIDL4H;
#define		RMIDL4H		(*(volatile union RMIDL4H_T *) 0x0F03E1)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union GAFLMH5_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} GAFLMH5;
#define		GAFLMH5		(*(volatile union GAFLMH5_T *) 0x0F03E2)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMIDH4_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} RMIDH4;
#define		RMIDH4		(*(volatile union RMIDH4_T *) 0x0F03E2)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union GAFLMH5L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} GAFLMH5L;
#define		GAFLMH5L		(*(volatile union GAFLMH5L_T *) 0x0F03E2)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMIDH4L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RMIDH4L;
#define		RMIDH4L		(*(volatile union RMIDH4L_T *) 0x0F03E2)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union GAFLMH5H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} GAFLMH5H;
#define		GAFLMH5H		(*(volatile union GAFLMH5H_T *) 0x0F03E3)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMIDH4H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RMIDH4H;
#define		RMIDH4H		(*(volatile union RMIDH4H_T *) 0x0F03E3)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union GAFLPL5_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} GAFLPL5;
#define		GAFLPL5		(*(volatile union GAFLPL5_T *) 0x0F03E4)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMTS4_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} RMTS4;
#define		RMTS4		(*(volatile union RMTS4_T *) 0x0F03E4)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union GAFLPL5L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} GAFLPL5L;
#define		GAFLPL5L		(*(volatile union GAFLPL5L_T *) 0x0F03E4)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMTS4L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RMTS4L;
#define		RMTS4L		(*(volatile union RMTS4L_T *) 0x0F03E4)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union GAFLPL5H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} GAFLPL5H;
#define		GAFLPL5H		(*(volatile union GAFLPL5H_T *) 0x0F03E5)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMTS4H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RMTS4H;
#define		RMTS4H		(*(volatile union RMTS4H_T *) 0x0F03E5)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union GAFLPH5_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} GAFLPH5;
#define		GAFLPH5		(*(volatile union GAFLPH5_T *) 0x0F03E6)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMPTR4_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} RMPTR4;
#define		RMPTR4		(*(volatile union RMPTR4_T *) 0x0F03E6)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union GAFLPH5L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} GAFLPH5L;
#define		GAFLPH5L		(*(volatile union GAFLPH5L_T *) 0x0F03E6)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMPTR4L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RMPTR4L;
#define		RMPTR4L		(*(volatile union RMPTR4L_T *) 0x0F03E6)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union GAFLPH5H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} GAFLPH5H;
#define		GAFLPH5H		(*(volatile union GAFLPH5H_T *) 0x0F03E7)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMPTR4H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RMPTR4H;
#define		RMPTR4H		(*(volatile union RMPTR4H_T *) 0x0F03E7)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union GAFLIDL6_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} GAFLIDL6;
#define		GAFLIDL6		(*(volatile union GAFLIDL6_T *) 0x0F03E8)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMDF04_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} RMDF04;
#define		RMDF04		(*(volatile union RMDF04_T *) 0x0F03E8)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union GAFLIDL6L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} GAFLIDL6L;
#define		GAFLIDL6L		(*(volatile union GAFLIDL6L_T *) 0x0F03E8)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMDF04L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RMDF04L;
#define		RMDF04L		(*(volatile union RMDF04L_T *) 0x0F03E8)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union GAFLIDL6H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} GAFLIDL6H;
#define		GAFLIDL6H		(*(volatile union GAFLIDL6H_T *) 0x0F03E9)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMDF04H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RMDF04H;
#define		RMDF04H		(*(volatile union RMDF04H_T *) 0x0F03E9)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union GAFLIDH6_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} GAFLIDH6;
#define		GAFLIDH6		(*(volatile union GAFLIDH6_T *) 0x0F03EA)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMDF14_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} RMDF14;
#define		RMDF14		(*(volatile union RMDF14_T *) 0x0F03EA)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union GAFLIDH6L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} GAFLIDH6L;
#define		GAFLIDH6L		(*(volatile union GAFLIDH6L_T *) 0x0F03EA)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMDF14L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RMDF14L;
#define		RMDF14L		(*(volatile union RMDF14L_T *) 0x0F03EA)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union GAFLIDH6H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} GAFLIDH6H;
#define		GAFLIDH6H		(*(volatile union GAFLIDH6H_T *) 0x0F03EB)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMDF14H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RMDF14H;
#define		RMDF14H		(*(volatile union RMDF14H_T *) 0x0F03EB)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union GAFLML6_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} GAFLML6;
#define		GAFLML6		(*(volatile union GAFLML6_T *) 0x0F03EC)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMDF24_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} RMDF24;
#define		RMDF24		(*(volatile union RMDF24_T *) 0x0F03EC)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union GAFLML6L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} GAFLML6L;
#define		GAFLML6L		(*(volatile union GAFLML6L_T *) 0x0F03EC)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMDF24L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RMDF24L;
#define		RMDF24L		(*(volatile union RMDF24L_T *) 0x0F03EC)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union GAFLML6H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} GAFLML6H;
#define		GAFLML6H		(*(volatile union GAFLML6H_T *) 0x0F03ED)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMDF24H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RMDF24H;
#define		RMDF24H		(*(volatile union RMDF24H_T *) 0x0F03ED)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union GAFLMH6_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} GAFLMH6;
#define		GAFLMH6		(*(volatile union GAFLMH6_T *) 0x0F03EE)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMDF34_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} RMDF34;
#define		RMDF34		(*(volatile union RMDF34_T *) 0x0F03EE)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union GAFLMH6L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} GAFLMH6L;
#define		GAFLMH6L		(*(volatile union GAFLMH6L_T *) 0x0F03EE)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMDF34L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RMDF34L;
#define		RMDF34L		(*(volatile union RMDF34L_T *) 0x0F03EE)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union GAFLMH6H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} GAFLMH6H;
#define		GAFLMH6H		(*(volatile union GAFLMH6H_T *) 0x0F03EF)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMDF34H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RMDF34H;
#define		RMDF34H		(*(volatile union RMDF34H_T *) 0x0F03EF)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union GAFLPL6_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} GAFLPL6;
#define		GAFLPL6		(*(volatile union GAFLPL6_T *) 0x0F03F0)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMIDL5_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} RMIDL5;
#define		RMIDL5		(*(volatile union RMIDL5_T *) 0x0F03F0)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union GAFLPL6L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} GAFLPL6L;
#define		GAFLPL6L		(*(volatile union GAFLPL6L_T *) 0x0F03F0)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMIDL5L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RMIDL5L;
#define		RMIDL5L		(*(volatile union RMIDL5L_T *) 0x0F03F0)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union GAFLPL6H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} GAFLPL6H;
#define		GAFLPL6H		(*(volatile union GAFLPL6H_T *) 0x0F03F1)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMIDL5H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RMIDL5H;
#define		RMIDL5H		(*(volatile union RMIDL5H_T *) 0x0F03F1)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union GAFLPH6_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} GAFLPH6;
#define		GAFLPH6		(*(volatile union GAFLPH6_T *) 0x0F03F2)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMIDH5_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} RMIDH5;
#define		RMIDH5		(*(volatile union RMIDH5_T *) 0x0F03F2)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union GAFLPH6L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} GAFLPH6L;
#define		GAFLPH6L		(*(volatile union GAFLPH6L_T *) 0x0F03F2)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMIDH5L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RMIDH5L;
#define		RMIDH5L		(*(volatile union RMIDH5L_T *) 0x0F03F2)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union GAFLPH6H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} GAFLPH6H;
#define		GAFLPH6H		(*(volatile union GAFLPH6H_T *) 0x0F03F3)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMIDH5H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RMIDH5H;
#define		RMIDH5H		(*(volatile union RMIDH5H_T *) 0x0F03F3)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union GAFLIDL7_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} GAFLIDL7;
#define		GAFLIDL7		(*(volatile union GAFLIDL7_T *) 0x0F03F4)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMTS5_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} RMTS5;
#define		RMTS5		(*(volatile union RMTS5_T *) 0x0F03F4)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union GAFLIDL7L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} GAFLIDL7L;
#define		GAFLIDL7L		(*(volatile union GAFLIDL7L_T *) 0x0F03F4)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMTS5L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RMTS5L;
#define		RMTS5L		(*(volatile union RMTS5L_T *) 0x0F03F4)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union GAFLIDL7H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} GAFLIDL7H;
#define		GAFLIDL7H		(*(volatile union GAFLIDL7H_T *) 0x0F03F5)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMTS5H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RMTS5H;
#define		RMTS5H		(*(volatile union RMTS5H_T *) 0x0F03F5)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union GAFLIDH7_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} GAFLIDH7;
#define		GAFLIDH7		(*(volatile union GAFLIDH7_T *) 0x0F03F6)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMPTR5_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} RMPTR5;
#define		RMPTR5		(*(volatile union RMPTR5_T *) 0x0F03F6)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union GAFLIDH7L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} GAFLIDH7L;
#define		GAFLIDH7L		(*(volatile union GAFLIDH7L_T *) 0x0F03F6)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMPTR5L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RMPTR5L;
#define		RMPTR5L		(*(volatile union RMPTR5L_T *) 0x0F03F6)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union GAFLIDH7H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} GAFLIDH7H;
#define		GAFLIDH7H		(*(volatile union GAFLIDH7H_T *) 0x0F03F7)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMPTR5H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RMPTR5H;
#define		RMPTR5H		(*(volatile union RMPTR5H_T *) 0x0F03F7)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union GAFLML7_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} GAFLML7;
#define		GAFLML7		(*(volatile union GAFLML7_T *) 0x0F03F8)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMDF05_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} RMDF05;
#define		RMDF05		(*(volatile union RMDF05_T *) 0x0F03F8)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union GAFLML7L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} GAFLML7L;
#define		GAFLML7L		(*(volatile union GAFLML7L_T *) 0x0F03F8)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMDF05L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RMDF05L;
#define		RMDF05L		(*(volatile union RMDF05L_T *) 0x0F03F8)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union GAFLML7H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} GAFLML7H;
#define		GAFLML7H		(*(volatile union GAFLML7H_T *) 0x0F03F9)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMDF05H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RMDF05H;
#define		RMDF05H		(*(volatile union RMDF05H_T *) 0x0F03F9)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union GAFLMH7_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} GAFLMH7;
#define		GAFLMH7		(*(volatile union GAFLMH7_T *) 0x0F03FA)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMDF15_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} RMDF15;
#define		RMDF15		(*(volatile union RMDF15_T *) 0x0F03FA)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union GAFLMH7L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} GAFLMH7L;
#define		GAFLMH7L		(*(volatile union GAFLMH7L_T *) 0x0F03FA)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMDF15L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RMDF15L;
#define		RMDF15L		(*(volatile union RMDF15L_T *) 0x0F03FA)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union GAFLMH7H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} GAFLMH7H;
#define		GAFLMH7H		(*(volatile union GAFLMH7H_T *) 0x0F03FB)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMDF15H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RMDF15H;
#define		RMDF15H		(*(volatile union RMDF15H_T *) 0x0F03FB)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union GAFLPL7_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} GAFLPL7;
#define		GAFLPL7		(*(volatile union GAFLPL7_T *) 0x0F03FC)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMDF25_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} RMDF25;
#define		RMDF25		(*(volatile union RMDF25_T *) 0x0F03FC)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union GAFLPL7L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} GAFLPL7L;
#define		GAFLPL7L		(*(volatile union GAFLPL7L_T *) 0x0F03FC)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMDF25L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RMDF25L;
#define		RMDF25L		(*(volatile union RMDF25L_T *) 0x0F03FC)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union GAFLPL7H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} GAFLPL7H;
#define		GAFLPL7H		(*(volatile union GAFLPL7H_T *) 0x0F03FD)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMDF25H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RMDF25H;
#define		RMDF25H		(*(volatile union RMDF25H_T *) 0x0F03FD)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union GAFLPH7_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} GAFLPH7;
#define		GAFLPH7		(*(volatile union GAFLPH7_T *) 0x0F03FE)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMDF35_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} RMDF35;
#define		RMDF35		(*(volatile union RMDF35_T *) 0x0F03FE)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union GAFLPH7L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} GAFLPH7L;
#define		GAFLPH7L		(*(volatile union GAFLPH7L_T *) 0x0F03FE)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMDF35L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RMDF35L;
#define		RMDF35L		(*(volatile union RMDF35L_T *) 0x0F03FE)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union GAFLPH7H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} GAFLPH7H;
#define		GAFLPH7H		(*(volatile union GAFLPH7H_T *) 0x0F03FF)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMDF35H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RMDF35H;
#define		RMDF35H		(*(volatile union RMDF35H_T *) 0x0F03FF)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union GAFLIDL8_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} GAFLIDL8;
#define		GAFLIDL8		(*(volatile union GAFLIDL8_T *) 0x0F0400)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMIDL6_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} RMIDL6;
#define		RMIDL6		(*(volatile union RMIDL6_T *) 0x0F0400)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union GAFLIDL8L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} GAFLIDL8L;
#define		GAFLIDL8L		(*(volatile union GAFLIDL8L_T *) 0x0F0400)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMIDL6L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RMIDL6L;
#define		RMIDL6L		(*(volatile union RMIDL6L_T *) 0x0F0400)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union GAFLIDL8H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} GAFLIDL8H;
#define		GAFLIDL8H		(*(volatile union GAFLIDL8H_T *) 0x0F0401)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMIDL6H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RMIDL6H;
#define		RMIDL6H		(*(volatile union RMIDL6H_T *) 0x0F0401)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union GAFLIDH8_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} GAFLIDH8;
#define		GAFLIDH8		(*(volatile union GAFLIDH8_T *) 0x0F0402)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMIDH6_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} RMIDH6;
#define		RMIDH6		(*(volatile union RMIDH6_T *) 0x0F0402)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union GAFLIDH8L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} GAFLIDH8L;
#define		GAFLIDH8L		(*(volatile union GAFLIDH8L_T *) 0x0F0402)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMIDH6L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RMIDH6L;
#define		RMIDH6L		(*(volatile union RMIDH6L_T *) 0x0F0402)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union GAFLIDH8H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} GAFLIDH8H;
#define		GAFLIDH8H		(*(volatile union GAFLIDH8H_T *) 0x0F0403)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMIDH6H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RMIDH6H;
#define		RMIDH6H		(*(volatile union RMIDH6H_T *) 0x0F0403)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union GAFLML8_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} GAFLML8;
#define		GAFLML8		(*(volatile union GAFLML8_T *) 0x0F0404)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMTS6_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} RMTS6;
#define		RMTS6		(*(volatile union RMTS6_T *) 0x0F0404)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union GAFLML8L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} GAFLML8L;
#define		GAFLML8L		(*(volatile union GAFLML8L_T *) 0x0F0404)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMTS6L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RMTS6L;
#define		RMTS6L		(*(volatile union RMTS6L_T *) 0x0F0404)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union GAFLML8H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} GAFLML8H;
#define		GAFLML8H		(*(volatile union GAFLML8H_T *) 0x0F0405)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMTS6H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RMTS6H;
#define		RMTS6H		(*(volatile union RMTS6H_T *) 0x0F0405)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union GAFLMH8_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} GAFLMH8;
#define		GAFLMH8		(*(volatile union GAFLMH8_T *) 0x0F0406)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMPTR6_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} RMPTR6;
#define		RMPTR6		(*(volatile union RMPTR6_T *) 0x0F0406)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union GAFLMH8L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} GAFLMH8L;
#define		GAFLMH8L		(*(volatile union GAFLMH8L_T *) 0x0F0406)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMPTR6L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RMPTR6L;
#define		RMPTR6L		(*(volatile union RMPTR6L_T *) 0x0F0406)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union GAFLMH8H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} GAFLMH8H;
#define		GAFLMH8H		(*(volatile union GAFLMH8H_T *) 0x0F0407)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMPTR6H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RMPTR6H;
#define		RMPTR6H		(*(volatile union RMPTR6H_T *) 0x0F0407)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union GAFLPL8_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} GAFLPL8;
#define		GAFLPL8		(*(volatile union GAFLPL8_T *) 0x0F0408)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMDF06_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} RMDF06;
#define		RMDF06		(*(volatile union RMDF06_T *) 0x0F0408)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union GAFLPL8L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} GAFLPL8L;
#define		GAFLPL8L		(*(volatile union GAFLPL8L_T *) 0x0F0408)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMDF06L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RMDF06L;
#define		RMDF06L		(*(volatile union RMDF06L_T *) 0x0F0408)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union GAFLPL8H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} GAFLPL8H;
#define		GAFLPL8H		(*(volatile union GAFLPL8H_T *) 0x0F0409)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMDF06H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RMDF06H;
#define		RMDF06H		(*(volatile union RMDF06H_T *) 0x0F0409)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union GAFLPH8_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} GAFLPH8;
#define		GAFLPH8		(*(volatile union GAFLPH8_T *) 0x0F040A)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMDF16_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} RMDF16;
#define		RMDF16		(*(volatile union RMDF16_T *) 0x0F040A)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union GAFLPH8L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} GAFLPH8L;
#define		GAFLPH8L		(*(volatile union GAFLPH8L_T *) 0x0F040A)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMDF16L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RMDF16L;
#define		RMDF16L		(*(volatile union RMDF16L_T *) 0x0F040A)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union GAFLPH8H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} GAFLPH8H;
#define		GAFLPH8H		(*(volatile union GAFLPH8H_T *) 0x0F040B)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMDF16H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RMDF16H;
#define		RMDF16H		(*(volatile union RMDF16H_T *) 0x0F040B)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union GAFLIDL9_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} GAFLIDL9;
#define		GAFLIDL9		(*(volatile union GAFLIDL9_T *) 0x0F040C)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMDF26_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} RMDF26;
#define		RMDF26		(*(volatile union RMDF26_T *) 0x0F040C)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union GAFLIDL9L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} GAFLIDL9L;
#define		GAFLIDL9L		(*(volatile union GAFLIDL9L_T *) 0x0F040C)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMDF26L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RMDF26L;
#define		RMDF26L		(*(volatile union RMDF26L_T *) 0x0F040C)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union GAFLIDL9H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} GAFLIDL9H;
#define		GAFLIDL9H		(*(volatile union GAFLIDL9H_T *) 0x0F040D)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMDF26H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RMDF26H;
#define		RMDF26H		(*(volatile union RMDF26H_T *) 0x0F040D)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union GAFLIDH9_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} GAFLIDH9;
#define		GAFLIDH9		(*(volatile union GAFLIDH9_T *) 0x0F040E)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMDF36_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} RMDF36;
#define		RMDF36		(*(volatile union RMDF36_T *) 0x0F040E)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union GAFLIDH9L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} GAFLIDH9L;
#define		GAFLIDH9L		(*(volatile union GAFLIDH9L_T *) 0x0F040E)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMDF36L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RMDF36L;
#define		RMDF36L		(*(volatile union RMDF36L_T *) 0x0F040E)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union GAFLIDH9H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} GAFLIDH9H;
#define		GAFLIDH9H		(*(volatile union GAFLIDH9H_T *) 0x0F040F)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMDF36H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RMDF36H;
#define		RMDF36H		(*(volatile union RMDF36H_T *) 0x0F040F)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union GAFLML9_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} GAFLML9;
#define		GAFLML9		(*(volatile union GAFLML9_T *) 0x0F0410)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMIDL7_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} RMIDL7;
#define		RMIDL7		(*(volatile union RMIDL7_T *) 0x0F0410)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union GAFLML9L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} GAFLML9L;
#define		GAFLML9L		(*(volatile union GAFLML9L_T *) 0x0F0410)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMIDL7L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RMIDL7L;
#define		RMIDL7L		(*(volatile union RMIDL7L_T *) 0x0F0410)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union GAFLML9H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} GAFLML9H;
#define		GAFLML9H		(*(volatile union GAFLML9H_T *) 0x0F0411)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMIDL7H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RMIDL7H;
#define		RMIDL7H		(*(volatile union RMIDL7H_T *) 0x0F0411)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union GAFLMH9_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} GAFLMH9;
#define		GAFLMH9		(*(volatile union GAFLMH9_T *) 0x0F0412)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMIDH7_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} RMIDH7;
#define		RMIDH7		(*(volatile union RMIDH7_T *) 0x0F0412)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union GAFLMH9L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} GAFLMH9L;
#define		GAFLMH9L		(*(volatile union GAFLMH9L_T *) 0x0F0412)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMIDH7L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RMIDH7L;
#define		RMIDH7L		(*(volatile union RMIDH7L_T *) 0x0F0412)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union GAFLMH9H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} GAFLMH9H;
#define		GAFLMH9H		(*(volatile union GAFLMH9H_T *) 0x0F0413)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMIDH7H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RMIDH7H;
#define		RMIDH7H		(*(volatile union RMIDH7H_T *) 0x0F0413)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union GAFLPL9_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} GAFLPL9;
#define		GAFLPL9		(*(volatile union GAFLPL9_T *) 0x0F0414)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMTS7_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} RMTS7;
#define		RMTS7		(*(volatile union RMTS7_T *) 0x0F0414)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union GAFLPL9L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} GAFLPL9L;
#define		GAFLPL9L		(*(volatile union GAFLPL9L_T *) 0x0F0414)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMTS7L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RMTS7L;
#define		RMTS7L		(*(volatile union RMTS7L_T *) 0x0F0414)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union GAFLPL9H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} GAFLPL9H;
#define		GAFLPL9H		(*(volatile union GAFLPL9H_T *) 0x0F0415)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMTS7H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RMTS7H;
#define		RMTS7H		(*(volatile union RMTS7H_T *) 0x0F0415)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union GAFLPH9_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} GAFLPH9;
#define		GAFLPH9		(*(volatile union GAFLPH9_T *) 0x0F0416)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMPTR7_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} RMPTR7;
#define		RMPTR7		(*(volatile union RMPTR7_T *) 0x0F0416)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union GAFLPH9L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} GAFLPH9L;
#define		GAFLPH9L		(*(volatile union GAFLPH9L_T *) 0x0F0416)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMPTR7L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RMPTR7L;
#define		RMPTR7L		(*(volatile union RMPTR7L_T *) 0x0F0416)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union GAFLPH9H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} GAFLPH9H;
#define		GAFLPH9H		(*(volatile union GAFLPH9H_T *) 0x0F0417)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMPTR7H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RMPTR7H;
#define		RMPTR7H		(*(volatile union RMPTR7H_T *) 0x0F0417)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union GAFLIDL10_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} GAFLIDL10;
#define		GAFLIDL10		(*(volatile union GAFLIDL10_T *) 0x0F0418)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMDF07_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} RMDF07;
#define		RMDF07		(*(volatile union RMDF07_T *) 0x0F0418)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union GAFLIDL10L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} GAFLIDL10L;
#define		GAFLIDL10L		(*(volatile union GAFLIDL10L_T *) 0x0F0418)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMDF07L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RMDF07L;
#define		RMDF07L		(*(volatile union RMDF07L_T *) 0x0F0418)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union GAFLIDL10H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} GAFLIDL10H;
#define		GAFLIDL10H		(*(volatile union GAFLIDL10H_T *) 0x0F0419)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMDF07H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RMDF07H;
#define		RMDF07H		(*(volatile union RMDF07H_T *) 0x0F0419)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union GAFLIDH10_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} GAFLIDH10;
#define		GAFLIDH10		(*(volatile union GAFLIDH10_T *) 0x0F041A)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMDF17_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} RMDF17;
#define		RMDF17		(*(volatile union RMDF17_T *) 0x0F041A)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union GAFLIDH10L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} GAFLIDH10L;
#define		GAFLIDH10L		(*(volatile union GAFLIDH10L_T *) 0x0F041A)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMDF17L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RMDF17L;
#define		RMDF17L		(*(volatile union RMDF17L_T *) 0x0F041A)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union GAFLIDH10H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} GAFLIDH10H;
#define		GAFLIDH10H		(*(volatile union GAFLIDH10H_T *) 0x0F041B)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMDF17H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RMDF17H;
#define		RMDF17H		(*(volatile union RMDF17H_T *) 0x0F041B)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union GAFLML10_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} GAFLML10;
#define		GAFLML10		(*(volatile union GAFLML10_T *) 0x0F041C)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMDF27_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} RMDF27;
#define		RMDF27		(*(volatile union RMDF27_T *) 0x0F041C)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union GAFLML10L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} GAFLML10L;
#define		GAFLML10L		(*(volatile union GAFLML10L_T *) 0x0F041C)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMDF27L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RMDF27L;
#define		RMDF27L		(*(volatile union RMDF27L_T *) 0x0F041C)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union GAFLML10H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} GAFLML10H;
#define		GAFLML10H		(*(volatile union GAFLML10H_T *) 0x0F041D)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMDF27H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RMDF27H;
#define		RMDF27H		(*(volatile union RMDF27H_T *) 0x0F041D)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union GAFLMH10_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} GAFLMH10;
#define		GAFLMH10		(*(volatile union GAFLMH10_T *) 0x0F041E)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMDF37_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} RMDF37;
#define		RMDF37		(*(volatile union RMDF37_T *) 0x0F041E)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union GAFLMH10L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} GAFLMH10L;
#define		GAFLMH10L		(*(volatile union GAFLMH10L_T *) 0x0F041E)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMDF37L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RMDF37L;
#define		RMDF37L		(*(volatile union RMDF37L_T *) 0x0F041E)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union GAFLMH10H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} GAFLMH10H;
#define		GAFLMH10H		(*(volatile union GAFLMH10H_T *) 0x0F041F)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMDF37H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RMDF37H;
#define		RMDF37H		(*(volatile union RMDF37H_T *) 0x0F041F)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union GAFLPL10_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} GAFLPL10;
#define		GAFLPL10		(*(volatile union GAFLPL10_T *) 0x0F0420)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMIDL8_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} RMIDL8;
#define		RMIDL8		(*(volatile union RMIDL8_T *) 0x0F0420)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union GAFLPL10L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} GAFLPL10L;
#define		GAFLPL10L		(*(volatile union GAFLPL10L_T *) 0x0F0420)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMIDL8L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RMIDL8L;
#define		RMIDL8L		(*(volatile union RMIDL8L_T *) 0x0F0420)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union GAFLPL10H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} GAFLPL10H;
#define		GAFLPL10H		(*(volatile union GAFLPL10H_T *) 0x0F0421)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMIDL8H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RMIDL8H;
#define		RMIDL8H		(*(volatile union RMIDL8H_T *) 0x0F0421)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union GAFLPH10_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} GAFLPH10;
#define		GAFLPH10		(*(volatile union GAFLPH10_T *) 0x0F0422)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMIDH8_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} RMIDH8;
#define		RMIDH8		(*(volatile union RMIDH8_T *) 0x0F0422)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union GAFLPH10L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} GAFLPH10L;
#define		GAFLPH10L		(*(volatile union GAFLPH10L_T *) 0x0F0422)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMIDH8L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RMIDH8L;
#define		RMIDH8L		(*(volatile union RMIDH8L_T *) 0x0F0422)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union GAFLPH10H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} GAFLPH10H;
#define		GAFLPH10H		(*(volatile union GAFLPH10H_T *) 0x0F0423)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMIDH8H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RMIDH8H;
#define		RMIDH8H		(*(volatile union RMIDH8H_T *) 0x0F0423)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union GAFLIDL11_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} GAFLIDL11;
#define		GAFLIDL11		(*(volatile union GAFLIDL11_T *) 0x0F0424)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMTS8_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} RMTS8;
#define		RMTS8		(*(volatile union RMTS8_T *) 0x0F0424)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union GAFLIDL11L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} GAFLIDL11L;
#define		GAFLIDL11L		(*(volatile union GAFLIDL11L_T *) 0x0F0424)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMTS8L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RMTS8L;
#define		RMTS8L		(*(volatile union RMTS8L_T *) 0x0F0424)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union GAFLIDL11H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} GAFLIDL11H;
#define		GAFLIDL11H		(*(volatile union GAFLIDL11H_T *) 0x0F0425)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMTS8H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RMTS8H;
#define		RMTS8H		(*(volatile union RMTS8H_T *) 0x0F0425)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union GAFLIDH11_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} GAFLIDH11;
#define		GAFLIDH11		(*(volatile union GAFLIDH11_T *) 0x0F0426)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMPTR8_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} RMPTR8;
#define		RMPTR8		(*(volatile union RMPTR8_T *) 0x0F0426)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union GAFLIDH11L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} GAFLIDH11L;
#define		GAFLIDH11L		(*(volatile union GAFLIDH11L_T *) 0x0F0426)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMPTR8L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RMPTR8L;
#define		RMPTR8L		(*(volatile union RMPTR8L_T *) 0x0F0426)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union GAFLIDH11H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} GAFLIDH11H;
#define		GAFLIDH11H		(*(volatile union GAFLIDH11H_T *) 0x0F0427)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMPTR8H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RMPTR8H;
#define		RMPTR8H		(*(volatile union RMPTR8H_T *) 0x0F0427)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union GAFLML11_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} GAFLML11;
#define		GAFLML11		(*(volatile union GAFLML11_T *) 0x0F0428)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMDF08_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} RMDF08;
#define		RMDF08		(*(volatile union RMDF08_T *) 0x0F0428)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union GAFLML11L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} GAFLML11L;
#define		GAFLML11L		(*(volatile union GAFLML11L_T *) 0x0F0428)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMDF08L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RMDF08L;
#define		RMDF08L		(*(volatile union RMDF08L_T *) 0x0F0428)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union GAFLML11H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} GAFLML11H;
#define		GAFLML11H		(*(volatile union GAFLML11H_T *) 0x0F0429)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMDF08H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RMDF08H;
#define		RMDF08H		(*(volatile union RMDF08H_T *) 0x0F0429)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union GAFLMH11_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} GAFLMH11;
#define		GAFLMH11		(*(volatile union GAFLMH11_T *) 0x0F042A)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMDF18_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} RMDF18;
#define		RMDF18		(*(volatile union RMDF18_T *) 0x0F042A)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union GAFLMH11L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} GAFLMH11L;
#define		GAFLMH11L		(*(volatile union GAFLMH11L_T *) 0x0F042A)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMDF18L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RMDF18L;
#define		RMDF18L		(*(volatile union RMDF18L_T *) 0x0F042A)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union GAFLMH11H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} GAFLMH11H;
#define		GAFLMH11H		(*(volatile union GAFLMH11H_T *) 0x0F042B)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMDF18H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RMDF18H;
#define		RMDF18H		(*(volatile union RMDF18H_T *) 0x0F042B)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union GAFLPL11_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} GAFLPL11;
#define		GAFLPL11		(*(volatile union GAFLPL11_T *) 0x0F042C)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMDF28_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} RMDF28;
#define		RMDF28		(*(volatile union RMDF28_T *) 0x0F042C)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union GAFLPL11L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} GAFLPL11L;
#define		GAFLPL11L		(*(volatile union GAFLPL11L_T *) 0x0F042C)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMDF28L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RMDF28L;
#define		RMDF28L		(*(volatile union RMDF28L_T *) 0x0F042C)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union GAFLPL11H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} GAFLPL11H;
#define		GAFLPL11H		(*(volatile union GAFLPL11H_T *) 0x0F042D)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMDF28H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RMDF28H;
#define		RMDF28H		(*(volatile union RMDF28H_T *) 0x0F042D)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union GAFLPH11_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} GAFLPH11;
#define		GAFLPH11		(*(volatile union GAFLPH11_T *) 0x0F042E)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMDF38_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} RMDF38;
#define		RMDF38		(*(volatile union RMDF38_T *) 0x0F042E)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union GAFLPH11L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} GAFLPH11L;
#define		GAFLPH11L		(*(volatile union GAFLPH11L_T *) 0x0F042E)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMDF38L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RMDF38L;
#define		RMDF38L		(*(volatile union RMDF38L_T *) 0x0F042E)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union GAFLPH11H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} GAFLPH11H;
#define		GAFLPH11H		(*(volatile union GAFLPH11H_T *) 0x0F042F)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMDF38H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RMDF38H;
#define		RMDF38H		(*(volatile union RMDF38H_T *) 0x0F042F)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union GAFLIDL12_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} GAFLIDL12;
#define		GAFLIDL12		(*(volatile union GAFLIDL12_T *) 0x0F0430)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMIDL9_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} RMIDL9;
#define		RMIDL9		(*(volatile union RMIDL9_T *) 0x0F0430)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union GAFLIDL12L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} GAFLIDL12L;
#define		GAFLIDL12L		(*(volatile union GAFLIDL12L_T *) 0x0F0430)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMIDL9L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RMIDL9L;
#define		RMIDL9L		(*(volatile union RMIDL9L_T *) 0x0F0430)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union GAFLIDL12H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} GAFLIDL12H;
#define		GAFLIDL12H		(*(volatile union GAFLIDL12H_T *) 0x0F0431)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMIDL9H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RMIDL9H;
#define		RMIDL9H		(*(volatile union RMIDL9H_T *) 0x0F0431)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union GAFLIDH12_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} GAFLIDH12;
#define		GAFLIDH12		(*(volatile union GAFLIDH12_T *) 0x0F0432)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMIDH9_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} RMIDH9;
#define		RMIDH9		(*(volatile union RMIDH9_T *) 0x0F0432)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union GAFLIDH12L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} GAFLIDH12L;
#define		GAFLIDH12L		(*(volatile union GAFLIDH12L_T *) 0x0F0432)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMIDH9L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RMIDH9L;
#define		RMIDH9L		(*(volatile union RMIDH9L_T *) 0x0F0432)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union GAFLIDH12H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} GAFLIDH12H;
#define		GAFLIDH12H		(*(volatile union GAFLIDH12H_T *) 0x0F0433)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMIDH9H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RMIDH9H;
#define		RMIDH9H		(*(volatile union RMIDH9H_T *) 0x0F0433)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union GAFLML12_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} GAFLML12;
#define		GAFLML12		(*(volatile union GAFLML12_T *) 0x0F0434)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMTS9_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} RMTS9;
#define		RMTS9		(*(volatile union RMTS9_T *) 0x0F0434)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union GAFLML12L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} GAFLML12L;
#define		GAFLML12L		(*(volatile union GAFLML12L_T *) 0x0F0434)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMTS9L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RMTS9L;
#define		RMTS9L		(*(volatile union RMTS9L_T *) 0x0F0434)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union GAFLML12H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} GAFLML12H;
#define		GAFLML12H		(*(volatile union GAFLML12H_T *) 0x0F0435)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMTS9H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RMTS9H;
#define		RMTS9H		(*(volatile union RMTS9H_T *) 0x0F0435)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union GAFLMH12_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} GAFLMH12;
#define		GAFLMH12		(*(volatile union GAFLMH12_T *) 0x0F0436)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMPTR9_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} RMPTR9;
#define		RMPTR9		(*(volatile union RMPTR9_T *) 0x0F0436)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union GAFLMH12L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} GAFLMH12L;
#define		GAFLMH12L		(*(volatile union GAFLMH12L_T *) 0x0F0436)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMPTR9L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RMPTR9L;
#define		RMPTR9L		(*(volatile union RMPTR9L_T *) 0x0F0436)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union GAFLMH12H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} GAFLMH12H;
#define		GAFLMH12H		(*(volatile union GAFLMH12H_T *) 0x0F0437)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMPTR9H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RMPTR9H;
#define		RMPTR9H		(*(volatile union RMPTR9H_T *) 0x0F0437)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union GAFLPL12_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} GAFLPL12;
#define		GAFLPL12		(*(volatile union GAFLPL12_T *) 0x0F0438)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMDF09_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} RMDF09;
#define		RMDF09		(*(volatile union RMDF09_T *) 0x0F0438)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union GAFLPL12L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} GAFLPL12L;
#define		GAFLPL12L		(*(volatile union GAFLPL12L_T *) 0x0F0438)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMDF09L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RMDF09L;
#define		RMDF09L		(*(volatile union RMDF09L_T *) 0x0F0438)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union GAFLPL12H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} GAFLPL12H;
#define		GAFLPL12H		(*(volatile union GAFLPL12H_T *) 0x0F0439)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMDF09H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RMDF09H;
#define		RMDF09H		(*(volatile union RMDF09H_T *) 0x0F0439)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union GAFLPH12_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} GAFLPH12;
#define		GAFLPH12		(*(volatile union GAFLPH12_T *) 0x0F043A)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMDF19_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} RMDF19;
#define		RMDF19		(*(volatile union RMDF19_T *) 0x0F043A)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union GAFLPH12L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} GAFLPH12L;
#define		GAFLPH12L		(*(volatile union GAFLPH12L_T *) 0x0F043A)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMDF19L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RMDF19L;
#define		RMDF19L		(*(volatile union RMDF19L_T *) 0x0F043A)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union GAFLPH12H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} GAFLPH12H;
#define		GAFLPH12H		(*(volatile union GAFLPH12H_T *) 0x0F043B)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMDF19H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RMDF19H;
#define		RMDF19H		(*(volatile union RMDF19H_T *) 0x0F043B)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union GAFLIDL13_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} GAFLIDL13;
#define		GAFLIDL13		(*(volatile union GAFLIDL13_T *) 0x0F043C)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMDF29_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} RMDF29;
#define		RMDF29		(*(volatile union RMDF29_T *) 0x0F043C)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union GAFLIDL13L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} GAFLIDL13L;
#define		GAFLIDL13L		(*(volatile union GAFLIDL13L_T *) 0x0F043C)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMDF29L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RMDF29L;
#define		RMDF29L		(*(volatile union RMDF29L_T *) 0x0F043C)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union GAFLIDL13H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} GAFLIDL13H;
#define		GAFLIDL13H		(*(volatile union GAFLIDL13H_T *) 0x0F043D)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMDF29H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RMDF29H;
#define		RMDF29H		(*(volatile union RMDF29H_T *) 0x0F043D)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union GAFLIDH13_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} GAFLIDH13;
#define		GAFLIDH13		(*(volatile union GAFLIDH13_T *) 0x0F043E)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMDF39_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} RMDF39;
#define		RMDF39		(*(volatile union RMDF39_T *) 0x0F043E)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union GAFLIDH13L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} GAFLIDH13L;
#define		GAFLIDH13L		(*(volatile union GAFLIDH13L_T *) 0x0F043E)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMDF39L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RMDF39L;
#define		RMDF39L		(*(volatile union RMDF39L_T *) 0x0F043E)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union GAFLIDH13H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} GAFLIDH13H;
#define		GAFLIDH13H		(*(volatile union GAFLIDH13H_T *) 0x0F043F)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMDF39H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RMDF39H;
#define		RMDF39H		(*(volatile union RMDF39H_T *) 0x0F043F)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union GAFLML13_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} GAFLML13;
#define		GAFLML13		(*(volatile union GAFLML13_T *) 0x0F0440)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMIDL10_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} RMIDL10;
#define		RMIDL10		(*(volatile union RMIDL10_T *) 0x0F0440)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union GAFLML13L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} GAFLML13L;
#define		GAFLML13L		(*(volatile union GAFLML13L_T *) 0x0F0440)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMIDL10L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RMIDL10L;
#define		RMIDL10L		(*(volatile union RMIDL10L_T *) 0x0F0440)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union GAFLML13H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} GAFLML13H;
#define		GAFLML13H		(*(volatile union GAFLML13H_T *) 0x0F0441)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMIDL10H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RMIDL10H;
#define		RMIDL10H		(*(volatile union RMIDL10H_T *) 0x0F0441)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union GAFLMH13_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} GAFLMH13;
#define		GAFLMH13		(*(volatile union GAFLMH13_T *) 0x0F0442)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMIDH10_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} RMIDH10;
#define		RMIDH10		(*(volatile union RMIDH10_T *) 0x0F0442)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union GAFLMH13L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} GAFLMH13L;
#define		GAFLMH13L		(*(volatile union GAFLMH13L_T *) 0x0F0442)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMIDH10L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RMIDH10L;
#define		RMIDH10L		(*(volatile union RMIDH10L_T *) 0x0F0442)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union GAFLMH13H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} GAFLMH13H;
#define		GAFLMH13H		(*(volatile union GAFLMH13H_T *) 0x0F0443)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMIDH10H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RMIDH10H;
#define		RMIDH10H		(*(volatile union RMIDH10H_T *) 0x0F0443)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union GAFLPL13_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} GAFLPL13;
#define		GAFLPL13		(*(volatile union GAFLPL13_T *) 0x0F0444)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMTS10_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} RMTS10;
#define		RMTS10		(*(volatile union RMTS10_T *) 0x0F0444)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union GAFLPL13L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} GAFLPL13L;
#define		GAFLPL13L		(*(volatile union GAFLPL13L_T *) 0x0F0444)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMTS10L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RMTS10L;
#define		RMTS10L		(*(volatile union RMTS10L_T *) 0x0F0444)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union GAFLPL13H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} GAFLPL13H;
#define		GAFLPL13H		(*(volatile union GAFLPL13H_T *) 0x0F0445)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMTS10H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RMTS10H;
#define		RMTS10H		(*(volatile union RMTS10H_T *) 0x0F0445)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union GAFLPH13_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} GAFLPH13;
#define		GAFLPH13		(*(volatile union GAFLPH13_T *) 0x0F0446)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMPTR10_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} RMPTR10;
#define		RMPTR10		(*(volatile union RMPTR10_T *) 0x0F0446)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union GAFLPH13L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} GAFLPH13L;
#define		GAFLPH13L		(*(volatile union GAFLPH13L_T *) 0x0F0446)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMPTR10L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RMPTR10L;
#define		RMPTR10L		(*(volatile union RMPTR10L_T *) 0x0F0446)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union GAFLPH13H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} GAFLPH13H;
#define		GAFLPH13H		(*(volatile union GAFLPH13H_T *) 0x0F0447)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMPTR10H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RMPTR10H;
#define		RMPTR10H		(*(volatile union RMPTR10H_T *) 0x0F0447)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union GAFLIDL14_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} GAFLIDL14;
#define		GAFLIDL14		(*(volatile union GAFLIDL14_T *) 0x0F0448)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMDF010_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} RMDF010;
#define		RMDF010		(*(volatile union RMDF010_T *) 0x0F0448)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union GAFLIDL14L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} GAFLIDL14L;
#define		GAFLIDL14L		(*(volatile union GAFLIDL14L_T *) 0x0F0448)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMDF010L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RMDF010L;
#define		RMDF010L		(*(volatile union RMDF010L_T *) 0x0F0448)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union GAFLIDL14H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} GAFLIDL14H;
#define		GAFLIDL14H		(*(volatile union GAFLIDL14H_T *) 0x0F0449)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMDF010H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RMDF010H;
#define		RMDF010H		(*(volatile union RMDF010H_T *) 0x0F0449)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union GAFLIDH14_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} GAFLIDH14;
#define		GAFLIDH14		(*(volatile union GAFLIDH14_T *) 0x0F044A)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMDF110_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} RMDF110;
#define		RMDF110		(*(volatile union RMDF110_T *) 0x0F044A)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union GAFLIDH14L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} GAFLIDH14L;
#define		GAFLIDH14L		(*(volatile union GAFLIDH14L_T *) 0x0F044A)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMDF110L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RMDF110L;
#define		RMDF110L		(*(volatile union RMDF110L_T *) 0x0F044A)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union GAFLIDH14H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} GAFLIDH14H;
#define		GAFLIDH14H		(*(volatile union GAFLIDH14H_T *) 0x0F044B)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMDF110H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RMDF110H;
#define		RMDF110H		(*(volatile union RMDF110H_T *) 0x0F044B)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union GAFLML14_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} GAFLML14;
#define		GAFLML14		(*(volatile union GAFLML14_T *) 0x0F044C)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMDF210_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} RMDF210;
#define		RMDF210		(*(volatile union RMDF210_T *) 0x0F044C)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union GAFLML14L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} GAFLML14L;
#define		GAFLML14L		(*(volatile union GAFLML14L_T *) 0x0F044C)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMDF210L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RMDF210L;
#define		RMDF210L		(*(volatile union RMDF210L_T *) 0x0F044C)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union GAFLML14H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} GAFLML14H;
#define		GAFLML14H		(*(volatile union GAFLML14H_T *) 0x0F044D)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMDF210H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RMDF210H;
#define		RMDF210H		(*(volatile union RMDF210H_T *) 0x0F044D)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union GAFLMH14_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} GAFLMH14;
#define		GAFLMH14		(*(volatile union GAFLMH14_T *) 0x0F044E)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMDF310_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} RMDF310;
#define		RMDF310		(*(volatile union RMDF310_T *) 0x0F044E)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union GAFLMH14L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} GAFLMH14L;
#define		GAFLMH14L		(*(volatile union GAFLMH14L_T *) 0x0F044E)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMDF310L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RMDF310L;
#define		RMDF310L		(*(volatile union RMDF310L_T *) 0x0F044E)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union GAFLMH14H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} GAFLMH14H;
#define		GAFLMH14H		(*(volatile union GAFLMH14H_T *) 0x0F044F)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMDF310H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RMDF310H;
#define		RMDF310H		(*(volatile union RMDF310H_T *) 0x0F044F)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union GAFLPL14_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} GAFLPL14;
#define		GAFLPL14		(*(volatile union GAFLPL14_T *) 0x0F0450)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMIDL11_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} RMIDL11;
#define		RMIDL11		(*(volatile union RMIDL11_T *) 0x0F0450)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union GAFLPL14L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} GAFLPL14L;
#define		GAFLPL14L		(*(volatile union GAFLPL14L_T *) 0x0F0450)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMIDL11L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RMIDL11L;
#define		RMIDL11L		(*(volatile union RMIDL11L_T *) 0x0F0450)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union GAFLPL14H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} GAFLPL14H;
#define		GAFLPL14H		(*(volatile union GAFLPL14H_T *) 0x0F0451)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMIDL11H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RMIDL11H;
#define		RMIDL11H		(*(volatile union RMIDL11H_T *) 0x0F0451)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union GAFLPH14_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} GAFLPH14;
#define		GAFLPH14		(*(volatile union GAFLPH14_T *) 0x0F0452)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMIDH11_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} RMIDH11;
#define		RMIDH11		(*(volatile union RMIDH11_T *) 0x0F0452)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union GAFLPH14L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} GAFLPH14L;
#define		GAFLPH14L		(*(volatile union GAFLPH14L_T *) 0x0F0452)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMIDH11L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RMIDH11L;
#define		RMIDH11L		(*(volatile union RMIDH11L_T *) 0x0F0452)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union GAFLPH14H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} GAFLPH14H;
#define		GAFLPH14H		(*(volatile union GAFLPH14H_T *) 0x0F0453)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMIDH11H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RMIDH11H;
#define		RMIDH11H		(*(volatile union RMIDH11H_T *) 0x0F0453)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union GAFLIDL15_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} GAFLIDL15;
#define		GAFLIDL15		(*(volatile union GAFLIDL15_T *) 0x0F0454)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMTS11_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} RMTS11;
#define		RMTS11		(*(volatile union RMTS11_T *) 0x0F0454)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union GAFLIDL15L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} GAFLIDL15L;
#define		GAFLIDL15L		(*(volatile union GAFLIDL15L_T *) 0x0F0454)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMTS11L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RMTS11L;
#define		RMTS11L		(*(volatile union RMTS11L_T *) 0x0F0454)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union GAFLIDL15H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} GAFLIDL15H;
#define		GAFLIDL15H		(*(volatile union GAFLIDL15H_T *) 0x0F0455)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMTS11H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RMTS11H;
#define		RMTS11H		(*(volatile union RMTS11H_T *) 0x0F0455)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union GAFLIDH15_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} GAFLIDH15;
#define		GAFLIDH15		(*(volatile union GAFLIDH15_T *) 0x0F0456)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMPTR11_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} RMPTR11;
#define		RMPTR11		(*(volatile union RMPTR11_T *) 0x0F0456)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union GAFLIDH15L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} GAFLIDH15L;
#define		GAFLIDH15L		(*(volatile union GAFLIDH15L_T *) 0x0F0456)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMPTR11L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RMPTR11L;
#define		RMPTR11L		(*(volatile union RMPTR11L_T *) 0x0F0456)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union GAFLIDH15H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} GAFLIDH15H;
#define		GAFLIDH15H		(*(volatile union GAFLIDH15H_T *) 0x0F0457)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMPTR11H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RMPTR11H;
#define		RMPTR11H		(*(volatile union RMPTR11H_T *) 0x0F0457)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union GAFLML15_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} GAFLML15;
#define		GAFLML15		(*(volatile union GAFLML15_T *) 0x0F0458)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMDF011_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} RMDF011;
#define		RMDF011		(*(volatile union RMDF011_T *) 0x0F0458)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union GAFLML15L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} GAFLML15L;
#define		GAFLML15L		(*(volatile union GAFLML15L_T *) 0x0F0458)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMDF011L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RMDF011L;
#define		RMDF011L		(*(volatile union RMDF011L_T *) 0x0F0458)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union GAFLML15H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} GAFLML15H;
#define		GAFLML15H		(*(volatile union GAFLML15H_T *) 0x0F0459)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMDF011H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RMDF011H;
#define		RMDF011H		(*(volatile union RMDF011H_T *) 0x0F0459)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union GAFLMH15_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} GAFLMH15;
#define		GAFLMH15		(*(volatile union GAFLMH15_T *) 0x0F045A)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMDF111_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} RMDF111;
#define		RMDF111		(*(volatile union RMDF111_T *) 0x0F045A)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union GAFLMH15L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} GAFLMH15L;
#define		GAFLMH15L		(*(volatile union GAFLMH15L_T *) 0x0F045A)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMDF111L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RMDF111L;
#define		RMDF111L		(*(volatile union RMDF111L_T *) 0x0F045A)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union GAFLMH15H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} GAFLMH15H;
#define		GAFLMH15H		(*(volatile union GAFLMH15H_T *) 0x0F045B)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMDF111H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RMDF111H;
#define		RMDF111H		(*(volatile union RMDF111H_T *) 0x0F045B)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union GAFLPL15_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} GAFLPL15;
#define		GAFLPL15		(*(volatile union GAFLPL15_T *) 0x0F045C)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMDF211_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} RMDF211;
#define		RMDF211		(*(volatile union RMDF211_T *) 0x0F045C)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union GAFLPL15L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} GAFLPL15L;
#define		GAFLPL15L		(*(volatile union GAFLPL15L_T *) 0x0F045C)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMDF211L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RMDF211L;
#define		RMDF211L		(*(volatile union RMDF211L_T *) 0x0F045C)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union GAFLPL15H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} GAFLPL15H;
#define		GAFLPL15H		(*(volatile union GAFLPL15H_T *) 0x0F045D)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMDF211H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RMDF211H;
#define		RMDF211H		(*(volatile union RMDF211H_T *) 0x0F045D)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union GAFLPH15_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} GAFLPH15;
#define		GAFLPH15		(*(volatile union GAFLPH15_T *) 0x0F045E)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMDF311_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} RMDF311;
#define		RMDF311		(*(volatile union RMDF311_T *) 0x0F045E)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union GAFLPH15L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} GAFLPH15L;
#define		GAFLPH15L		(*(volatile union GAFLPH15L_T *) 0x0F045E)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMDF311L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RMDF311L;
#define		RMDF311L		(*(volatile union RMDF311L_T *) 0x0F045E)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union GAFLPH15H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} GAFLPH15H;
#define		GAFLPH15H		(*(volatile union GAFLPH15H_T *) 0x0F045F)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMDF311H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RMDF311H;
#define		RMDF311H		(*(volatile union RMDF311H_T *) 0x0F045F)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMIDL12_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} RMIDL12;
#define		RMIDL12		(*(volatile union RMIDL12_T *) 0x0F0460)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMIDL12L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RMIDL12L;
#define		RMIDL12L		(*(volatile union RMIDL12L_T *) 0x0F0460)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMIDL12H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RMIDL12H;
#define		RMIDL12H		(*(volatile union RMIDL12H_T *) 0x0F0461)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMIDH12_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} RMIDH12;
#define		RMIDH12		(*(volatile union RMIDH12_T *) 0x0F0462)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMIDH12L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RMIDH12L;
#define		RMIDH12L		(*(volatile union RMIDH12L_T *) 0x0F0462)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMIDH12H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RMIDH12H;
#define		RMIDH12H		(*(volatile union RMIDH12H_T *) 0x0F0463)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMTS12_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} RMTS12;
#define		RMTS12		(*(volatile union RMTS12_T *) 0x0F0464)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMTS12L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RMTS12L;
#define		RMTS12L		(*(volatile union RMTS12L_T *) 0x0F0464)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMTS12H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RMTS12H;
#define		RMTS12H		(*(volatile union RMTS12H_T *) 0x0F0465)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMPTR12_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} RMPTR12;
#define		RMPTR12		(*(volatile union RMPTR12_T *) 0x0F0466)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMPTR12L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RMPTR12L;
#define		RMPTR12L		(*(volatile union RMPTR12L_T *) 0x0F0466)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMPTR12H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RMPTR12H;
#define		RMPTR12H		(*(volatile union RMPTR12H_T *) 0x0F0467)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMDF012_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} RMDF012;
#define		RMDF012		(*(volatile union RMDF012_T *) 0x0F0468)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMDF012L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RMDF012L;
#define		RMDF012L		(*(volatile union RMDF012L_T *) 0x0F0468)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMDF012H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RMDF012H;
#define		RMDF012H		(*(volatile union RMDF012H_T *) 0x0F0469)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMDF112_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} RMDF112;
#define		RMDF112		(*(volatile union RMDF112_T *) 0x0F046A)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMDF112L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RMDF112L;
#define		RMDF112L		(*(volatile union RMDF112L_T *) 0x0F046A)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMDF112H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RMDF112H;
#define		RMDF112H		(*(volatile union RMDF112H_T *) 0x0F046B)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMDF212_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} RMDF212;
#define		RMDF212		(*(volatile union RMDF212_T *) 0x0F046C)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMDF212L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RMDF212L;
#define		RMDF212L		(*(volatile union RMDF212L_T *) 0x0F046C)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMDF212H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RMDF212H;
#define		RMDF212H		(*(volatile union RMDF212H_T *) 0x0F046D)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMDF312_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} RMDF312;
#define		RMDF312		(*(volatile union RMDF312_T *) 0x0F046E)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMDF312L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RMDF312L;
#define		RMDF312L		(*(volatile union RMDF312L_T *) 0x0F046E)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMDF312H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RMDF312H;
#define		RMDF312H		(*(volatile union RMDF312H_T *) 0x0F046F)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMIDL13_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} RMIDL13;
#define		RMIDL13		(*(volatile union RMIDL13_T *) 0x0F0470)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMIDL13L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RMIDL13L;
#define		RMIDL13L		(*(volatile union RMIDL13L_T *) 0x0F0470)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMIDL13H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RMIDL13H;
#define		RMIDL13H		(*(volatile union RMIDL13H_T *) 0x0F0471)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMIDH13_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} RMIDH13;
#define		RMIDH13		(*(volatile union RMIDH13_T *) 0x0F0472)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMIDH13L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RMIDH13L;
#define		RMIDH13L		(*(volatile union RMIDH13L_T *) 0x0F0472)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMIDH13H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RMIDH13H;
#define		RMIDH13H		(*(volatile union RMIDH13H_T *) 0x0F0473)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMTS13_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} RMTS13;
#define		RMTS13		(*(volatile union RMTS13_T *) 0x0F0474)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMTS13L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RMTS13L;
#define		RMTS13L		(*(volatile union RMTS13L_T *) 0x0F0474)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMTS13H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RMTS13H;
#define		RMTS13H		(*(volatile union RMTS13H_T *) 0x0F0475)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMPTR13_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} RMPTR13;
#define		RMPTR13		(*(volatile union RMPTR13_T *) 0x0F0476)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMPTR13L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RMPTR13L;
#define		RMPTR13L		(*(volatile union RMPTR13L_T *) 0x0F0476)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMPTR13H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RMPTR13H;
#define		RMPTR13H		(*(volatile union RMPTR13H_T *) 0x0F0477)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMDF013_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} RMDF013;
#define		RMDF013		(*(volatile union RMDF013_T *) 0x0F0478)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMDF013L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RMDF013L;
#define		RMDF013L		(*(volatile union RMDF013L_T *) 0x0F0478)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMDF013H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RMDF013H;
#define		RMDF013H		(*(volatile union RMDF013H_T *) 0x0F0479)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMDF113_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} RMDF113;
#define		RMDF113		(*(volatile union RMDF113_T *) 0x0F047A)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMDF113L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RMDF113L;
#define		RMDF113L		(*(volatile union RMDF113L_T *) 0x0F047A)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMDF113H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RMDF113H;
#define		RMDF113H		(*(volatile union RMDF113H_T *) 0x0F047B)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMDF213_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} RMDF213;
#define		RMDF213		(*(volatile union RMDF213_T *) 0x0F047C)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMDF213L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RMDF213L;
#define		RMDF213L		(*(volatile union RMDF213L_T *) 0x0F047C)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMDF213H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RMDF213H;
#define		RMDF213H		(*(volatile union RMDF213H_T *) 0x0F047D)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMDF313_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} RMDF313;
#define		RMDF313		(*(volatile union RMDF313_T *) 0x0F047E)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMDF313L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RMDF313L;
#define		RMDF313L		(*(volatile union RMDF313L_T *) 0x0F047E)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMDF313H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RMDF313H;
#define		RMDF313H		(*(volatile union RMDF313H_T *) 0x0F047F)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMIDL14_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} RMIDL14;
#define		RMIDL14		(*(volatile union RMIDL14_T *) 0x0F0480)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMIDL14L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RMIDL14L;
#define		RMIDL14L		(*(volatile union RMIDL14L_T *) 0x0F0480)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMIDL14H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RMIDL14H;
#define		RMIDL14H		(*(volatile union RMIDL14H_T *) 0x0F0481)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMIDH14_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} RMIDH14;
#define		RMIDH14		(*(volatile union RMIDH14_T *) 0x0F0482)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMIDH14L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RMIDH14L;
#define		RMIDH14L		(*(volatile union RMIDH14L_T *) 0x0F0482)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMIDH14H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RMIDH14H;
#define		RMIDH14H		(*(volatile union RMIDH14H_T *) 0x0F0483)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMTS14_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} RMTS14;
#define		RMTS14		(*(volatile union RMTS14_T *) 0x0F0484)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMTS14L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RMTS14L;
#define		RMTS14L		(*(volatile union RMTS14L_T *) 0x0F0484)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMTS14H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RMTS14H;
#define		RMTS14H		(*(volatile union RMTS14H_T *) 0x0F0485)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMPTR14_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} RMPTR14;
#define		RMPTR14		(*(volatile union RMPTR14_T *) 0x0F0486)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMPTR14L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RMPTR14L;
#define		RMPTR14L		(*(volatile union RMPTR14L_T *) 0x0F0486)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMPTR14H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RMPTR14H;
#define		RMPTR14H		(*(volatile union RMPTR14H_T *) 0x0F0487)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMDF014_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} RMDF014;
#define		RMDF014		(*(volatile union RMDF014_T *) 0x0F0488)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMDF014L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RMDF014L;
#define		RMDF014L		(*(volatile union RMDF014L_T *) 0x0F0488)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMDF014H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RMDF014H;
#define		RMDF014H		(*(volatile union RMDF014H_T *) 0x0F0489)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMDF114_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} RMDF114;
#define		RMDF114		(*(volatile union RMDF114_T *) 0x0F048A)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMDF114L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RMDF114L;
#define		RMDF114L		(*(volatile union RMDF114L_T *) 0x0F048A)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMDF114H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RMDF114H;
#define		RMDF114H		(*(volatile union RMDF114H_T *) 0x0F048B)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMDF214_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} RMDF214;
#define		RMDF214		(*(volatile union RMDF214_T *) 0x0F048C)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMDF214L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RMDF214L;
#define		RMDF214L		(*(volatile union RMDF214L_T *) 0x0F048C)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMDF214H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RMDF214H;
#define		RMDF214H		(*(volatile union RMDF214H_T *) 0x0F048D)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMDF314_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} RMDF314;
#define		RMDF314		(*(volatile union RMDF314_T *) 0x0F048E)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMDF314L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RMDF314L;
#define		RMDF314L		(*(volatile union RMDF314L_T *) 0x0F048E)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMDF314H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RMDF314H;
#define		RMDF314H		(*(volatile union RMDF314H_T *) 0x0F048F)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMIDL15_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} RMIDL15;
#define		RMIDL15		(*(volatile union RMIDL15_T *) 0x0F0490)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMIDL15L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RMIDL15L;
#define		RMIDL15L		(*(volatile union RMIDL15L_T *) 0x0F0490)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMIDL15H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RMIDL15H;
#define		RMIDL15H		(*(volatile union RMIDL15H_T *) 0x0F0491)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMIDH15_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} RMIDH15;
#define		RMIDH15		(*(volatile union RMIDH15_T *) 0x0F0492)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMIDH15L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RMIDH15L;
#define		RMIDH15L		(*(volatile union RMIDH15L_T *) 0x0F0492)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMIDH15H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RMIDH15H;
#define		RMIDH15H		(*(volatile union RMIDH15H_T *) 0x0F0493)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMTS15_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} RMTS15;
#define		RMTS15		(*(volatile union RMTS15_T *) 0x0F0494)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMTS15L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RMTS15L;
#define		RMTS15L		(*(volatile union RMTS15L_T *) 0x0F0494)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMTS15H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RMTS15H;
#define		RMTS15H		(*(volatile union RMTS15H_T *) 0x0F0495)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMPTR15_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} RMPTR15;
#define		RMPTR15		(*(volatile union RMPTR15_T *) 0x0F0496)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMPTR15L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RMPTR15L;
#define		RMPTR15L		(*(volatile union RMPTR15L_T *) 0x0F0496)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMPTR15H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RMPTR15H;
#define		RMPTR15H		(*(volatile union RMPTR15H_T *) 0x0F0497)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMDF015_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} RMDF015;
#define		RMDF015		(*(volatile union RMDF015_T *) 0x0F0498)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMDF015L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RMDF015L;
#define		RMDF015L		(*(volatile union RMDF015L_T *) 0x0F0498)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMDF015H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RMDF015H;
#define		RMDF015H		(*(volatile union RMDF015H_T *) 0x0F0499)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMDF115_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} RMDF115;
#define		RMDF115		(*(volatile union RMDF115_T *) 0x0F049A)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMDF115L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RMDF115L;
#define		RMDF115L		(*(volatile union RMDF115L_T *) 0x0F049A)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMDF115H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RMDF115H;
#define		RMDF115H		(*(volatile union RMDF115H_T *) 0x0F049B)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMDF215_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} RMDF215;
#define		RMDF215		(*(volatile union RMDF215_T *) 0x0F049C)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMDF215L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RMDF215L;
#define		RMDF215L		(*(volatile union RMDF215L_T *) 0x0F049C)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMDF215H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RMDF215H;
#define		RMDF215H		(*(volatile union RMDF215H_T *) 0x0F049D)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMDF315_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} RMDF315;
#define		RMDF315		(*(volatile union RMDF315_T *) 0x0F049E)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMDF315L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RMDF315L;
#define		RMDF315L		(*(volatile union RMDF315L_T *) 0x0F049E)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RMDF315H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RMDF315H;
#define		RMDF315H		(*(volatile union RMDF315H_T *) 0x0F049F)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC0_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} RPGACC0;
#define		RPGACC0		(*(volatile union RPGACC0_T *) 0x0F0580)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC0L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RPGACC0L;
#define		RPGACC0L		(*(volatile union RPGACC0L_T *) 0x0F0580)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC0H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RPGACC0H;
#define		RPGACC0H		(*(volatile union RPGACC0H_T *) 0x0F0581)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC1_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} RPGACC1;
#define		RPGACC1		(*(volatile union RPGACC1_T *) 0x0F0582)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC1L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RPGACC1L;
#define		RPGACC1L		(*(volatile union RPGACC1L_T *) 0x0F0582)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC1H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RPGACC1H;
#define		RPGACC1H		(*(volatile union RPGACC1H_T *) 0x0F0583)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC2_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} RPGACC2;
#define		RPGACC2		(*(volatile union RPGACC2_T *) 0x0F0584)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC2L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RPGACC2L;
#define		RPGACC2L		(*(volatile union RPGACC2L_T *) 0x0F0584)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC2H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RPGACC2H;
#define		RPGACC2H		(*(volatile union RPGACC2H_T *) 0x0F0585)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC3_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} RPGACC3;
#define		RPGACC3		(*(volatile union RPGACC3_T *) 0x0F0586)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC3L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RPGACC3L;
#define		RPGACC3L		(*(volatile union RPGACC3L_T *) 0x0F0586)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC3H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RPGACC3H;
#define		RPGACC3H		(*(volatile union RPGACC3H_T *) 0x0F0587)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC4_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} RPGACC4;
#define		RPGACC4		(*(volatile union RPGACC4_T *) 0x0F0588)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC4L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RPGACC4L;
#define		RPGACC4L		(*(volatile union RPGACC4L_T *) 0x0F0588)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC4H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RPGACC4H;
#define		RPGACC4H		(*(volatile union RPGACC4H_T *) 0x0F0589)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC5_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} RPGACC5;
#define		RPGACC5		(*(volatile union RPGACC5_T *) 0x0F058A)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC5L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RPGACC5L;
#define		RPGACC5L		(*(volatile union RPGACC5L_T *) 0x0F058A)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC5H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RPGACC5H;
#define		RPGACC5H		(*(volatile union RPGACC5H_T *) 0x0F058B)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC6_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} RPGACC6;
#define		RPGACC6		(*(volatile union RPGACC6_T *) 0x0F058C)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC6L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RPGACC6L;
#define		RPGACC6L		(*(volatile union RPGACC6L_T *) 0x0F058C)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC6H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RPGACC6H;
#define		RPGACC6H		(*(volatile union RPGACC6H_T *) 0x0F058D)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC7_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} RPGACC7;
#define		RPGACC7		(*(volatile union RPGACC7_T *) 0x0F058E)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC7L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RPGACC7L;
#define		RPGACC7L		(*(volatile union RPGACC7L_T *) 0x0F058E)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC7H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RPGACC7H;
#define		RPGACC7H		(*(volatile union RPGACC7H_T *) 0x0F058F)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC8_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} RPGACC8;
#define		RPGACC8		(*(volatile union RPGACC8_T *) 0x0F0590)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC8L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RPGACC8L;
#define		RPGACC8L		(*(volatile union RPGACC8L_T *) 0x0F0590)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC8H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RPGACC8H;
#define		RPGACC8H		(*(volatile union RPGACC8H_T *) 0x0F0591)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC9_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} RPGACC9;
#define		RPGACC9		(*(volatile union RPGACC9_T *) 0x0F0592)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC9L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RPGACC9L;
#define		RPGACC9L		(*(volatile union RPGACC9L_T *) 0x0F0592)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC9H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RPGACC9H;
#define		RPGACC9H		(*(volatile union RPGACC9H_T *) 0x0F0593)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC10_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} RPGACC10;
#define		RPGACC10		(*(volatile union RPGACC10_T *) 0x0F0594)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC10L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RPGACC10L;
#define		RPGACC10L		(*(volatile union RPGACC10L_T *) 0x0F0594)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC10H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RPGACC10H;
#define		RPGACC10H		(*(volatile union RPGACC10H_T *) 0x0F0595)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC11_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} RPGACC11;
#define		RPGACC11		(*(volatile union RPGACC11_T *) 0x0F0596)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC11L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RPGACC11L;
#define		RPGACC11L		(*(volatile union RPGACC11L_T *) 0x0F0596)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC11H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RPGACC11H;
#define		RPGACC11H		(*(volatile union RPGACC11H_T *) 0x0F0597)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC12_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} RPGACC12;
#define		RPGACC12		(*(volatile union RPGACC12_T *) 0x0F0598)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC12L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RPGACC12L;
#define		RPGACC12L		(*(volatile union RPGACC12L_T *) 0x0F0598)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC12H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RPGACC12H;
#define		RPGACC12H		(*(volatile union RPGACC12H_T *) 0x0F0599)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC13_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} RPGACC13;
#define		RPGACC13		(*(volatile union RPGACC13_T *) 0x0F059A)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC13L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RPGACC13L;
#define		RPGACC13L		(*(volatile union RPGACC13L_T *) 0x0F059A)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC13H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RPGACC13H;
#define		RPGACC13H		(*(volatile union RPGACC13H_T *) 0x0F059B)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC14_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} RPGACC14;
#define		RPGACC14		(*(volatile union RPGACC14_T *) 0x0F059C)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC14L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RPGACC14L;
#define		RPGACC14L		(*(volatile union RPGACC14L_T *) 0x0F059C)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC14H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RPGACC14H;
#define		RPGACC14H		(*(volatile union RPGACC14H_T *) 0x0F059D)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC15_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} RPGACC15;
#define		RPGACC15		(*(volatile union RPGACC15_T *) 0x0F059E)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC15L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RPGACC15L;
#define		RPGACC15L		(*(volatile union RPGACC15L_T *) 0x0F059E)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC15H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RPGACC15H;
#define		RPGACC15H		(*(volatile union RPGACC15H_T *) 0x0F059F)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RFIDL0_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} RFIDL0;
#define		RFIDL0		(*(volatile union RFIDL0_T *) 0x0F05A0)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC16_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} RPGACC16;
#define		RPGACC16		(*(volatile union RPGACC16_T *) 0x0F05A0)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RFIDL0L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RFIDL0L;
#define		RFIDL0L		(*(volatile union RFIDL0L_T *) 0x0F05A0)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC16L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RPGACC16L;
#define		RPGACC16L		(*(volatile union RPGACC16L_T *) 0x0F05A0)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RFIDL0H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RFIDL0H;
#define		RFIDL0H		(*(volatile union RFIDL0H_T *) 0x0F05A1)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC16H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RPGACC16H;
#define		RPGACC16H		(*(volatile union RPGACC16H_T *) 0x0F05A1)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RFIDH0_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} RFIDH0;
#define		RFIDH0		(*(volatile union RFIDH0_T *) 0x0F05A2)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC17_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} RPGACC17;
#define		RPGACC17		(*(volatile union RPGACC17_T *) 0x0F05A2)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RFIDH0L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RFIDH0L;
#define		RFIDH0L		(*(volatile union RFIDH0L_T *) 0x0F05A2)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC17L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RPGACC17L;
#define		RPGACC17L		(*(volatile union RPGACC17L_T *) 0x0F05A2)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RFIDH0H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RFIDH0H;
#define		RFIDH0H		(*(volatile union RFIDH0H_T *) 0x0F05A3)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC17H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RPGACC17H;
#define		RPGACC17H		(*(volatile union RPGACC17H_T *) 0x0F05A3)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RFTS0_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} RFTS0;
#define		RFTS0		(*(volatile union RFTS0_T *) 0x0F05A4)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC18_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} RPGACC18;
#define		RPGACC18		(*(volatile union RPGACC18_T *) 0x0F05A4)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RFTS0L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RFTS0L;
#define		RFTS0L		(*(volatile union RFTS0L_T *) 0x0F05A4)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC18L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RPGACC18L;
#define		RPGACC18L		(*(volatile union RPGACC18L_T *) 0x0F05A4)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RFTS0H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RFTS0H;
#define		RFTS0H		(*(volatile union RFTS0H_T *) 0x0F05A5)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC18H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RPGACC18H;
#define		RPGACC18H		(*(volatile union RPGACC18H_T *) 0x0F05A5)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RFPTR0_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} RFPTR0;
#define		RFPTR0		(*(volatile union RFPTR0_T *) 0x0F05A6)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC19_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} RPGACC19;
#define		RPGACC19		(*(volatile union RPGACC19_T *) 0x0F05A6)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RFPTR0L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RFPTR0L;
#define		RFPTR0L		(*(volatile union RFPTR0L_T *) 0x0F05A6)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC19L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RPGACC19L;
#define		RPGACC19L		(*(volatile union RPGACC19L_T *) 0x0F05A6)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RFPTR0H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RFPTR0H;
#define		RFPTR0H		(*(volatile union RFPTR0H_T *) 0x0F05A7)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC19H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RPGACC19H;
#define		RPGACC19H		(*(volatile union RPGACC19H_T *) 0x0F05A7)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RFDF00_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} RFDF00;
#define		RFDF00		(*(volatile union RFDF00_T *) 0x0F05A8)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC20_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} RPGACC20;
#define		RPGACC20		(*(volatile union RPGACC20_T *) 0x0F05A8)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RFDF00L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RFDF00L;
#define		RFDF00L		(*(volatile union RFDF00L_T *) 0x0F05A8)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC20L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RPGACC20L;
#define		RPGACC20L		(*(volatile union RPGACC20L_T *) 0x0F05A8)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RFDF00H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RFDF00H;
#define		RFDF00H		(*(volatile union RFDF00H_T *) 0x0F05A9)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC20H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RPGACC20H;
#define		RPGACC20H		(*(volatile union RPGACC20H_T *) 0x0F05A9)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RFDF10_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} RFDF10;
#define		RFDF10		(*(volatile union RFDF10_T *) 0x0F05AA)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC21_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} RPGACC21;
#define		RPGACC21		(*(volatile union RPGACC21_T *) 0x0F05AA)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RFDF10L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RFDF10L;
#define		RFDF10L		(*(volatile union RFDF10L_T *) 0x0F05AA)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC21L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RPGACC21L;
#define		RPGACC21L		(*(volatile union RPGACC21L_T *) 0x0F05AA)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RFDF10H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RFDF10H;
#define		RFDF10H		(*(volatile union RFDF10H_T *) 0x0F05AB)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC21H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RPGACC21H;
#define		RPGACC21H		(*(volatile union RPGACC21H_T *) 0x0F05AB)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RFDF20_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} RFDF20;
#define		RFDF20		(*(volatile union RFDF20_T *) 0x0F05AC)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC22_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} RPGACC22;
#define		RPGACC22		(*(volatile union RPGACC22_T *) 0x0F05AC)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RFDF20L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RFDF20L;
#define		RFDF20L		(*(volatile union RFDF20L_T *) 0x0F05AC)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC22L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RPGACC22L;
#define		RPGACC22L		(*(volatile union RPGACC22L_T *) 0x0F05AC)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RFDF20H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RFDF20H;
#define		RFDF20H		(*(volatile union RFDF20H_T *) 0x0F05AD)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC22H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RPGACC22H;
#define		RPGACC22H		(*(volatile union RPGACC22H_T *) 0x0F05AD)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RFDF30_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} RFDF30;
#define		RFDF30		(*(volatile union RFDF30_T *) 0x0F05AE)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC23_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} RPGACC23;
#define		RPGACC23		(*(volatile union RPGACC23_T *) 0x0F05AE)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RFDF30L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RFDF30L;
#define		RFDF30L		(*(volatile union RFDF30L_T *) 0x0F05AE)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC23L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RPGACC23L;
#define		RPGACC23L		(*(volatile union RPGACC23L_T *) 0x0F05AE)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RFDF30H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RFDF30H;
#define		RFDF30H		(*(volatile union RFDF30H_T *) 0x0F05AF)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC23H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RPGACC23H;
#define		RPGACC23H		(*(volatile union RPGACC23H_T *) 0x0F05AF)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RFIDL1_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} RFIDL1;
#define		RFIDL1		(*(volatile union RFIDL1_T *) 0x0F05B0)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC24_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} RPGACC24;
#define		RPGACC24		(*(volatile union RPGACC24_T *) 0x0F05B0)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RFIDL1L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RFIDL1L;
#define		RFIDL1L		(*(volatile union RFIDL1L_T *) 0x0F05B0)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC24L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RPGACC24L;
#define		RPGACC24L		(*(volatile union RPGACC24L_T *) 0x0F05B0)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RFIDL1H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RFIDL1H;
#define		RFIDL1H		(*(volatile union RFIDL1H_T *) 0x0F05B1)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC24H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RPGACC24H;
#define		RPGACC24H		(*(volatile union RPGACC24H_T *) 0x0F05B1)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RFIDH1_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} RFIDH1;
#define		RFIDH1		(*(volatile union RFIDH1_T *) 0x0F05B2)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC25_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} RPGACC25;
#define		RPGACC25		(*(volatile union RPGACC25_T *) 0x0F05B2)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RFIDH1L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RFIDH1L;
#define		RFIDH1L		(*(volatile union RFIDH1L_T *) 0x0F05B2)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC25L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RPGACC25L;
#define		RPGACC25L		(*(volatile union RPGACC25L_T *) 0x0F05B2)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RFIDH1H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RFIDH1H;
#define		RFIDH1H		(*(volatile union RFIDH1H_T *) 0x0F05B3)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC25H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RPGACC25H;
#define		RPGACC25H		(*(volatile union RPGACC25H_T *) 0x0F05B3)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RFTS1_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} RFTS1;
#define		RFTS1		(*(volatile union RFTS1_T *) 0x0F05B4)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC26_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} RPGACC26;
#define		RPGACC26		(*(volatile union RPGACC26_T *) 0x0F05B4)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RFTS1L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RFTS1L;
#define		RFTS1L		(*(volatile union RFTS1L_T *) 0x0F05B4)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC26L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RPGACC26L;
#define		RPGACC26L		(*(volatile union RPGACC26L_T *) 0x0F05B4)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RFTS1H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RFTS1H;
#define		RFTS1H		(*(volatile union RFTS1H_T *) 0x0F05B5)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC26H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RPGACC26H;
#define		RPGACC26H		(*(volatile union RPGACC26H_T *) 0x0F05B5)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RFPTR1_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} RFPTR1;
#define		RFPTR1		(*(volatile union RFPTR1_T *) 0x0F05B6)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC27_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} RPGACC27;
#define		RPGACC27		(*(volatile union RPGACC27_T *) 0x0F05B6)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RFPTR1L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RFPTR1L;
#define		RFPTR1L		(*(volatile union RFPTR1L_T *) 0x0F05B6)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC27L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RPGACC27L;
#define		RPGACC27L		(*(volatile union RPGACC27L_T *) 0x0F05B6)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RFPTR1H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RFPTR1H;
#define		RFPTR1H		(*(volatile union RFPTR1H_T *) 0x0F05B7)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC27H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RPGACC27H;
#define		RPGACC27H		(*(volatile union RPGACC27H_T *) 0x0F05B7)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RFDF01_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} RFDF01;
#define		RFDF01		(*(volatile union RFDF01_T *) 0x0F05B8)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC28_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} RPGACC28;
#define		RPGACC28		(*(volatile union RPGACC28_T *) 0x0F05B8)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RFDF01L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RFDF01L;
#define		RFDF01L		(*(volatile union RFDF01L_T *) 0x0F05B8)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC28L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RPGACC28L;
#define		RPGACC28L		(*(volatile union RPGACC28L_T *) 0x0F05B8)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RFDF01H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RFDF01H;
#define		RFDF01H		(*(volatile union RFDF01H_T *) 0x0F05B9)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC28H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RPGACC28H;
#define		RPGACC28H		(*(volatile union RPGACC28H_T *) 0x0F05B9)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RFDF11_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} RFDF11;
#define		RFDF11		(*(volatile union RFDF11_T *) 0x0F05BA)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC29_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} RPGACC29;
#define		RPGACC29		(*(volatile union RPGACC29_T *) 0x0F05BA)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RFDF11L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RFDF11L;
#define		RFDF11L		(*(volatile union RFDF11L_T *) 0x0F05BA)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC29L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RPGACC29L;
#define		RPGACC29L		(*(volatile union RPGACC29L_T *) 0x0F05BA)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RFDF11H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RFDF11H;
#define		RFDF11H		(*(volatile union RFDF11H_T *) 0x0F05BB)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC29H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RPGACC29H;
#define		RPGACC29H		(*(volatile union RPGACC29H_T *) 0x0F05BB)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RFDF21_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} RFDF21;
#define		RFDF21		(*(volatile union RFDF21_T *) 0x0F05BC)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC30_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} RPGACC30;
#define		RPGACC30		(*(volatile union RPGACC30_T *) 0x0F05BC)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RFDF21L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RFDF21L;
#define		RFDF21L		(*(volatile union RFDF21L_T *) 0x0F05BC)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC30L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RPGACC30L;
#define		RPGACC30L		(*(volatile union RPGACC30L_T *) 0x0F05BC)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RFDF21H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RFDF21H;
#define		RFDF21H		(*(volatile union RFDF21H_T *) 0x0F05BD)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC30H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RPGACC30H;
#define		RPGACC30H		(*(volatile union RPGACC30H_T *) 0x0F05BD)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RFDF31_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} RFDF31;
#define		RFDF31		(*(volatile union RFDF31_T *) 0x0F05BE)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC31_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} RPGACC31;
#define		RPGACC31		(*(volatile union RPGACC31_T *) 0x0F05BE)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RFDF31L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RFDF31L;
#define		RFDF31L		(*(volatile union RFDF31L_T *) 0x0F05BE)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC31L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RPGACC31L;
#define		RPGACC31L		(*(volatile union RPGACC31L_T *) 0x0F05BE)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RFDF31H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RFDF31H;
#define		RFDF31H		(*(volatile union RFDF31H_T *) 0x0F05BF)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC31H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RPGACC31H;
#define		RPGACC31H		(*(volatile union RPGACC31H_T *) 0x0F05BF)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC32_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} RPGACC32;
#define		RPGACC32		(*(volatile union RPGACC32_T *) 0x0F05C0)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC32L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RPGACC32L;
#define		RPGACC32L		(*(volatile union RPGACC32L_T *) 0x0F05C0)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC32H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RPGACC32H;
#define		RPGACC32H		(*(volatile union RPGACC32H_T *) 0x0F05C1)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC33_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} RPGACC33;
#define		RPGACC33		(*(volatile union RPGACC33_T *) 0x0F05C2)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC33L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RPGACC33L;
#define		RPGACC33L		(*(volatile union RPGACC33L_T *) 0x0F05C2)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC33H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RPGACC33H;
#define		RPGACC33H		(*(volatile union RPGACC33H_T *) 0x0F05C3)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC34_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} RPGACC34;
#define		RPGACC34		(*(volatile union RPGACC34_T *) 0x0F05C4)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC34L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RPGACC34L;
#define		RPGACC34L		(*(volatile union RPGACC34L_T *) 0x0F05C4)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC34H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RPGACC34H;
#define		RPGACC34H		(*(volatile union RPGACC34H_T *) 0x0F05C5)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC35_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} RPGACC35;
#define		RPGACC35		(*(volatile union RPGACC35_T *) 0x0F05C6)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC35L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RPGACC35L;
#define		RPGACC35L		(*(volatile union RPGACC35L_T *) 0x0F05C6)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC35H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RPGACC35H;
#define		RPGACC35H		(*(volatile union RPGACC35H_T *) 0x0F05C7)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC36_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} RPGACC36;
#define		RPGACC36		(*(volatile union RPGACC36_T *) 0x0F05C8)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC36L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RPGACC36L;
#define		RPGACC36L		(*(volatile union RPGACC36L_T *) 0x0F05C8)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC36H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RPGACC36H;
#define		RPGACC36H		(*(volatile union RPGACC36H_T *) 0x0F05C9)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC37_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} RPGACC37;
#define		RPGACC37		(*(volatile union RPGACC37_T *) 0x0F05CA)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC37L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RPGACC37L;
#define		RPGACC37L		(*(volatile union RPGACC37L_T *) 0x0F05CA)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC37H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RPGACC37H;
#define		RPGACC37H		(*(volatile union RPGACC37H_T *) 0x0F05CB)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC38_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} RPGACC38;
#define		RPGACC38		(*(volatile union RPGACC38_T *) 0x0F05CC)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC38L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RPGACC38L;
#define		RPGACC38L		(*(volatile union RPGACC38L_T *) 0x0F05CC)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC38H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RPGACC38H;
#define		RPGACC38H		(*(volatile union RPGACC38H_T *) 0x0F05CD)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC39_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} RPGACC39;
#define		RPGACC39		(*(volatile union RPGACC39_T *) 0x0F05CE)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC39L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RPGACC39L;
#define		RPGACC39L		(*(volatile union RPGACC39L_T *) 0x0F05CE)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC39H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RPGACC39H;
#define		RPGACC39H		(*(volatile union RPGACC39H_T *) 0x0F05CF)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC40_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} RPGACC40;
#define		RPGACC40		(*(volatile union RPGACC40_T *) 0x0F05D0)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC40L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RPGACC40L;
#define		RPGACC40L		(*(volatile union RPGACC40L_T *) 0x0F05D0)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC40H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RPGACC40H;
#define		RPGACC40H		(*(volatile union RPGACC40H_T *) 0x0F05D1)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC41_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} RPGACC41;
#define		RPGACC41		(*(volatile union RPGACC41_T *) 0x0F05D2)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC41L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RPGACC41L;
#define		RPGACC41L		(*(volatile union RPGACC41L_T *) 0x0F05D2)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC41H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RPGACC41H;
#define		RPGACC41H		(*(volatile union RPGACC41H_T *) 0x0F05D3)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC42_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} RPGACC42;
#define		RPGACC42		(*(volatile union RPGACC42_T *) 0x0F05D4)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC42L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RPGACC42L;
#define		RPGACC42L		(*(volatile union RPGACC42L_T *) 0x0F05D4)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC42H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RPGACC42H;
#define		RPGACC42H		(*(volatile union RPGACC42H_T *) 0x0F05D5)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC43_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} RPGACC43;
#define		RPGACC43		(*(volatile union RPGACC43_T *) 0x0F05D6)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC43L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RPGACC43L;
#define		RPGACC43L		(*(volatile union RPGACC43L_T *) 0x0F05D6)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC43H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RPGACC43H;
#define		RPGACC43H		(*(volatile union RPGACC43H_T *) 0x0F05D7)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC44_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} RPGACC44;
#define		RPGACC44		(*(volatile union RPGACC44_T *) 0x0F05D8)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC44L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RPGACC44L;
#define		RPGACC44L		(*(volatile union RPGACC44L_T *) 0x0F05D8)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC44H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RPGACC44H;
#define		RPGACC44H		(*(volatile union RPGACC44H_T *) 0x0F05D9)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC45_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} RPGACC45;
#define		RPGACC45		(*(volatile union RPGACC45_T *) 0x0F05DA)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC45L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RPGACC45L;
#define		RPGACC45L		(*(volatile union RPGACC45L_T *) 0x0F05DA)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC45H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RPGACC45H;
#define		RPGACC45H		(*(volatile union RPGACC45H_T *) 0x0F05DB)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC46_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} RPGACC46;
#define		RPGACC46		(*(volatile union RPGACC46_T *) 0x0F05DC)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC46L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RPGACC46L;
#define		RPGACC46L		(*(volatile union RPGACC46L_T *) 0x0F05DC)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC46H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RPGACC46H;
#define		RPGACC46H		(*(volatile union RPGACC46H_T *) 0x0F05DD)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC47_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} RPGACC47;
#define		RPGACC47		(*(volatile union RPGACC47_T *) 0x0F05DE)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC47L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RPGACC47L;
#define		RPGACC47L		(*(volatile union RPGACC47L_T *) 0x0F05DE)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC47H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RPGACC47H;
#define		RPGACC47H		(*(volatile union RPGACC47H_T *) 0x0F05DF)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union CFIDL0_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} CFIDL0;
#define		CFIDL0		(*(volatile union CFIDL0_T *) 0x0F05E0)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC48_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} RPGACC48;
#define		RPGACC48		(*(volatile union RPGACC48_T *) 0x0F05E0)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union CFIDL0L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} CFIDL0L;
#define		CFIDL0L		(*(volatile union CFIDL0L_T *) 0x0F05E0)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC48L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RPGACC48L;
#define		RPGACC48L		(*(volatile union RPGACC48L_T *) 0x0F05E0)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union CFIDL0H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} CFIDL0H;
#define		CFIDL0H		(*(volatile union CFIDL0H_T *) 0x0F05E1)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC48H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RPGACC48H;
#define		RPGACC48H		(*(volatile union RPGACC48H_T *) 0x0F05E1)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union CFIDH0_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} CFIDH0;
#define		CFIDH0		(*(volatile union CFIDH0_T *) 0x0F05E2)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC49_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} RPGACC49;
#define		RPGACC49		(*(volatile union RPGACC49_T *) 0x0F05E2)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union CFIDH0L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} CFIDH0L;
#define		CFIDH0L		(*(volatile union CFIDH0L_T *) 0x0F05E2)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC49L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RPGACC49L;
#define		RPGACC49L		(*(volatile union RPGACC49L_T *) 0x0F05E2)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union CFIDH0H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} CFIDH0H;
#define		CFIDH0H		(*(volatile union CFIDH0H_T *) 0x0F05E3)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC49H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RPGACC49H;
#define		RPGACC49H		(*(volatile union RPGACC49H_T *) 0x0F05E3)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union CFTS0_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} CFTS0;
#define		CFTS0		(*(volatile union CFTS0_T *) 0x0F05E4)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC50_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} RPGACC50;
#define		RPGACC50		(*(volatile union RPGACC50_T *) 0x0F05E4)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union CFTS0L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} CFTS0L;
#define		CFTS0L		(*(volatile union CFTS0L_T *) 0x0F05E4)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC50L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RPGACC50L;
#define		RPGACC50L		(*(volatile union RPGACC50L_T *) 0x0F05E4)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union CFTS0H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} CFTS0H;
#define		CFTS0H		(*(volatile union CFTS0H_T *) 0x0F05E5)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC50H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RPGACC50H;
#define		RPGACC50H		(*(volatile union RPGACC50H_T *) 0x0F05E5)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union CFPTR0_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} CFPTR0;
#define		CFPTR0		(*(volatile union CFPTR0_T *) 0x0F05E6)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC51_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} RPGACC51;
#define		RPGACC51		(*(volatile union RPGACC51_T *) 0x0F05E6)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union CFPTR0L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} CFPTR0L;
#define		CFPTR0L		(*(volatile union CFPTR0L_T *) 0x0F05E6)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC51L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RPGACC51L;
#define		RPGACC51L		(*(volatile union RPGACC51L_T *) 0x0F05E6)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union CFPTR0H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} CFPTR0H;
#define		CFPTR0H		(*(volatile union CFPTR0H_T *) 0x0F05E7)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC51H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RPGACC51H;
#define		RPGACC51H		(*(volatile union RPGACC51H_T *) 0x0F05E7)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union CFDF00_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} CFDF00;
#define		CFDF00		(*(volatile union CFDF00_T *) 0x0F05E8)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC52_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} RPGACC52;
#define		RPGACC52		(*(volatile union RPGACC52_T *) 0x0F05E8)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union CFDF00L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} CFDF00L;
#define		CFDF00L		(*(volatile union CFDF00L_T *) 0x0F05E8)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC52L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RPGACC52L;
#define		RPGACC52L		(*(volatile union RPGACC52L_T *) 0x0F05E8)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union CFDF00H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} CFDF00H;
#define		CFDF00H		(*(volatile union CFDF00H_T *) 0x0F05E9)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC52H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RPGACC52H;
#define		RPGACC52H		(*(volatile union RPGACC52H_T *) 0x0F05E9)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union CFDF10_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} CFDF10;
#define		CFDF10		(*(volatile union CFDF10_T *) 0x0F05EA)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC53_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} RPGACC53;
#define		RPGACC53		(*(volatile union RPGACC53_T *) 0x0F05EA)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union CFDF10L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} CFDF10L;
#define		CFDF10L		(*(volatile union CFDF10L_T *) 0x0F05EA)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC53L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RPGACC53L;
#define		RPGACC53L		(*(volatile union RPGACC53L_T *) 0x0F05EA)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union CFDF10H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} CFDF10H;
#define		CFDF10H		(*(volatile union CFDF10H_T *) 0x0F05EB)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC53H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RPGACC53H;
#define		RPGACC53H		(*(volatile union RPGACC53H_T *) 0x0F05EB)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union CFDF20_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} CFDF20;
#define		CFDF20		(*(volatile union CFDF20_T *) 0x0F05EC)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC54_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} RPGACC54;
#define		RPGACC54		(*(volatile union RPGACC54_T *) 0x0F05EC)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union CFDF20L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} CFDF20L;
#define		CFDF20L		(*(volatile union CFDF20L_T *) 0x0F05EC)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC54L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RPGACC54L;
#define		RPGACC54L		(*(volatile union RPGACC54L_T *) 0x0F05EC)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union CFDF20H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} CFDF20H;
#define		CFDF20H		(*(volatile union CFDF20H_T *) 0x0F05ED)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC54H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RPGACC54H;
#define		RPGACC54H		(*(volatile union RPGACC54H_T *) 0x0F05ED)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union CFDF30_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} CFDF30;
#define		CFDF30		(*(volatile union CFDF30_T *) 0x0F05EE)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC55_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} RPGACC55;
#define		RPGACC55		(*(volatile union RPGACC55_T *) 0x0F05EE)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union CFDF30L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} CFDF30L;
#define		CFDF30L		(*(volatile union CFDF30L_T *) 0x0F05EE)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC55L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RPGACC55L;
#define		RPGACC55L		(*(volatile union RPGACC55L_T *) 0x0F05EE)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union CFDF30H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} CFDF30H;
#define		CFDF30H		(*(volatile union CFDF30H_T *) 0x0F05EF)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC55H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RPGACC55H;
#define		RPGACC55H		(*(volatile union RPGACC55H_T *) 0x0F05EF)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC56_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} RPGACC56;
#define		RPGACC56		(*(volatile union RPGACC56_T *) 0x0F05F0)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC56L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RPGACC56L;
#define		RPGACC56L		(*(volatile union RPGACC56L_T *) 0x0F05F0)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC56H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RPGACC56H;
#define		RPGACC56H		(*(volatile union RPGACC56H_T *) 0x0F05F1)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC57_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} RPGACC57;
#define		RPGACC57		(*(volatile union RPGACC57_T *) 0x0F05F2)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC57L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RPGACC57L;
#define		RPGACC57L		(*(volatile union RPGACC57L_T *) 0x0F05F2)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC57H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RPGACC57H;
#define		RPGACC57H		(*(volatile union RPGACC57H_T *) 0x0F05F3)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC58_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} RPGACC58;
#define		RPGACC58		(*(volatile union RPGACC58_T *) 0x0F05F4)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC58L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RPGACC58L;
#define		RPGACC58L		(*(volatile union RPGACC58L_T *) 0x0F05F4)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC58H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RPGACC58H;
#define		RPGACC58H		(*(volatile union RPGACC58H_T *) 0x0F05F5)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC59_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} RPGACC59;
#define		RPGACC59		(*(volatile union RPGACC59_T *) 0x0F05F6)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC59L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RPGACC59L;
#define		RPGACC59L		(*(volatile union RPGACC59L_T *) 0x0F05F6)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC59H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RPGACC59H;
#define		RPGACC59H		(*(volatile union RPGACC59H_T *) 0x0F05F7)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC60_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} RPGACC60;
#define		RPGACC60		(*(volatile union RPGACC60_T *) 0x0F05F8)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC60L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RPGACC60L;
#define		RPGACC60L		(*(volatile union RPGACC60L_T *) 0x0F05F8)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC60H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RPGACC60H;
#define		RPGACC60H		(*(volatile union RPGACC60H_T *) 0x0F05F9)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC61_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} RPGACC61;
#define		RPGACC61		(*(volatile union RPGACC61_T *) 0x0F05FA)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC61L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RPGACC61L;
#define		RPGACC61L		(*(volatile union RPGACC61L_T *) 0x0F05FA)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC61H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RPGACC61H;
#define		RPGACC61H		(*(volatile union RPGACC61H_T *) 0x0F05FB)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC62_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} RPGACC62;
#define		RPGACC62		(*(volatile union RPGACC62_T *) 0x0F05FC)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC62L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RPGACC62L;
#define		RPGACC62L		(*(volatile union RPGACC62L_T *) 0x0F05FC)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC62H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RPGACC62H;
#define		RPGACC62H		(*(volatile union RPGACC62H_T *) 0x0F05FD)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC63_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} RPGACC63;
#define		RPGACC63		(*(volatile union RPGACC63_T *) 0x0F05FE)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC63L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RPGACC63L;
#define		RPGACC63L		(*(volatile union RPGACC63L_T *) 0x0F05FE)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC63H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RPGACC63H;
#define		RPGACC63H		(*(volatile union RPGACC63H_T *) 0x0F05FF)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC64_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} RPGACC64;
#define		RPGACC64		(*(volatile union RPGACC64_T *) 0x0F0600)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union TMIDL0_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} TMIDL0;
#define		TMIDL0		(*(volatile union TMIDL0_T *) 0x0F0600)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC64L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RPGACC64L;
#define		RPGACC64L		(*(volatile union RPGACC64L_T *) 0x0F0600)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union TMIDL0L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} TMIDL0L;
#define		TMIDL0L		(*(volatile union TMIDL0L_T *) 0x0F0600)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC64H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RPGACC64H;
#define		RPGACC64H		(*(volatile union RPGACC64H_T *) 0x0F0601)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union TMIDL0H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} TMIDL0H;
#define		TMIDL0H		(*(volatile union TMIDL0H_T *) 0x0F0601)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC65_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} RPGACC65;
#define		RPGACC65		(*(volatile union RPGACC65_T *) 0x0F0602)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union TMIDH0_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} TMIDH0;
#define		TMIDH0		(*(volatile union TMIDH0_T *) 0x0F0602)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC65L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RPGACC65L;
#define		RPGACC65L		(*(volatile union RPGACC65L_T *) 0x0F0602)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union TMIDH0L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} TMIDH0L;
#define		TMIDH0L		(*(volatile union TMIDH0L_T *) 0x0F0602)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC65H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RPGACC65H;
#define		RPGACC65H		(*(volatile union RPGACC65H_T *) 0x0F0603)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union TMIDH0H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} TMIDH0H;
#define		TMIDH0H		(*(volatile union TMIDH0H_T *) 0x0F0603)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC66_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} RPGACC66;
#define		RPGACC66		(*(volatile union RPGACC66_T *) 0x0F0604)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC66L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RPGACC66L;
#define		RPGACC66L		(*(volatile union RPGACC66L_T *) 0x0F0604)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC66H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RPGACC66H;
#define		RPGACC66H		(*(volatile union RPGACC66H_T *) 0x0F0605)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC67_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} RPGACC67;
#define		RPGACC67		(*(volatile union RPGACC67_T *) 0x0F0606)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union TMPTR0_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} TMPTR0;
#define		TMPTR0		(*(volatile union TMPTR0_T *) 0x0F0606)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC67L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RPGACC67L;
#define		RPGACC67L		(*(volatile union RPGACC67L_T *) 0x0F0606)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union TMPTR0L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} TMPTR0L;
#define		TMPTR0L		(*(volatile union TMPTR0L_T *) 0x0F0606)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC67H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RPGACC67H;
#define		RPGACC67H		(*(volatile union RPGACC67H_T *) 0x0F0607)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union TMPTR0H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} TMPTR0H;
#define		TMPTR0H		(*(volatile union TMPTR0H_T *) 0x0F0607)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC68_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} RPGACC68;
#define		RPGACC68		(*(volatile union RPGACC68_T *) 0x0F0608)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union TMDF00_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} TMDF00;
#define		TMDF00		(*(volatile union TMDF00_T *) 0x0F0608)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC68L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RPGACC68L;
#define		RPGACC68L		(*(volatile union RPGACC68L_T *) 0x0F0608)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union TMDF00L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} TMDF00L;
#define		TMDF00L		(*(volatile union TMDF00L_T *) 0x0F0608)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC68H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RPGACC68H;
#define		RPGACC68H		(*(volatile union RPGACC68H_T *) 0x0F0609)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union TMDF00H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} TMDF00H;
#define		TMDF00H		(*(volatile union TMDF00H_T *) 0x0F0609)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC69_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} RPGACC69;
#define		RPGACC69		(*(volatile union RPGACC69_T *) 0x0F060A)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union TMDF10_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} TMDF10;
#define		TMDF10		(*(volatile union TMDF10_T *) 0x0F060A)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC69L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RPGACC69L;
#define		RPGACC69L		(*(volatile union RPGACC69L_T *) 0x0F060A)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union TMDF10L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} TMDF10L;
#define		TMDF10L		(*(volatile union TMDF10L_T *) 0x0F060A)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC69H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RPGACC69H;
#define		RPGACC69H		(*(volatile union RPGACC69H_T *) 0x0F060B)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union TMDF10H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} TMDF10H;
#define		TMDF10H		(*(volatile union TMDF10H_T *) 0x0F060B)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC70_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} RPGACC70;
#define		RPGACC70		(*(volatile union RPGACC70_T *) 0x0F060C)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union TMDF20_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} TMDF20;
#define		TMDF20		(*(volatile union TMDF20_T *) 0x0F060C)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC70L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RPGACC70L;
#define		RPGACC70L		(*(volatile union RPGACC70L_T *) 0x0F060C)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union TMDF20L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} TMDF20L;
#define		TMDF20L		(*(volatile union TMDF20L_T *) 0x0F060C)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC70H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RPGACC70H;
#define		RPGACC70H		(*(volatile union RPGACC70H_T *) 0x0F060D)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union TMDF20H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} TMDF20H;
#define		TMDF20H		(*(volatile union TMDF20H_T *) 0x0F060D)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC71_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} RPGACC71;
#define		RPGACC71		(*(volatile union RPGACC71_T *) 0x0F060E)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union TMDF30_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} TMDF30;
#define		TMDF30		(*(volatile union TMDF30_T *) 0x0F060E)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC71L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RPGACC71L;
#define		RPGACC71L		(*(volatile union RPGACC71L_T *) 0x0F060E)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union TMDF30L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} TMDF30L;
#define		TMDF30L		(*(volatile union TMDF30L_T *) 0x0F060E)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC71H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RPGACC71H;
#define		RPGACC71H		(*(volatile union RPGACC71H_T *) 0x0F060F)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union TMDF30H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} TMDF30H;
#define		TMDF30H		(*(volatile union TMDF30H_T *) 0x0F060F)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC72_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} RPGACC72;
#define		RPGACC72		(*(volatile union RPGACC72_T *) 0x0F0610)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union TMIDL1_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} TMIDL1;
#define		TMIDL1		(*(volatile union TMIDL1_T *) 0x0F0610)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC72L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RPGACC72L;
#define		RPGACC72L		(*(volatile union RPGACC72L_T *) 0x0F0610)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union TMIDL1L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} TMIDL1L;
#define		TMIDL1L		(*(volatile union TMIDL1L_T *) 0x0F0610)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC72H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RPGACC72H;
#define		RPGACC72H		(*(volatile union RPGACC72H_T *) 0x0F0611)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union TMIDL1H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} TMIDL1H;
#define		TMIDL1H		(*(volatile union TMIDL1H_T *) 0x0F0611)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC73_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} RPGACC73;
#define		RPGACC73		(*(volatile union RPGACC73_T *) 0x0F0612)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union TMIDH1_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} TMIDH1;
#define		TMIDH1		(*(volatile union TMIDH1_T *) 0x0F0612)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC73L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RPGACC73L;
#define		RPGACC73L		(*(volatile union RPGACC73L_T *) 0x0F0612)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union TMIDH1L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} TMIDH1L;
#define		TMIDH1L		(*(volatile union TMIDH1L_T *) 0x0F0612)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC73H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RPGACC73H;
#define		RPGACC73H		(*(volatile union RPGACC73H_T *) 0x0F0613)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union TMIDH1H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} TMIDH1H;
#define		TMIDH1H		(*(volatile union TMIDH1H_T *) 0x0F0613)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC74_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} RPGACC74;
#define		RPGACC74		(*(volatile union RPGACC74_T *) 0x0F0614)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC74L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RPGACC74L;
#define		RPGACC74L		(*(volatile union RPGACC74L_T *) 0x0F0614)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC74H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RPGACC74H;
#define		RPGACC74H		(*(volatile union RPGACC74H_T *) 0x0F0615)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC75_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} RPGACC75;
#define		RPGACC75		(*(volatile union RPGACC75_T *) 0x0F0616)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union TMPTR1_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} TMPTR1;
#define		TMPTR1		(*(volatile union TMPTR1_T *) 0x0F0616)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC75L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RPGACC75L;
#define		RPGACC75L		(*(volatile union RPGACC75L_T *) 0x0F0616)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union TMPTR1L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} TMPTR1L;
#define		TMPTR1L		(*(volatile union TMPTR1L_T *) 0x0F0616)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC75H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RPGACC75H;
#define		RPGACC75H		(*(volatile union RPGACC75H_T *) 0x0F0617)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union TMPTR1H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} TMPTR1H;
#define		TMPTR1H		(*(volatile union TMPTR1H_T *) 0x0F0617)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC76_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} RPGACC76;
#define		RPGACC76		(*(volatile union RPGACC76_T *) 0x0F0618)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union TMDF01_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} TMDF01;
#define		TMDF01		(*(volatile union TMDF01_T *) 0x0F0618)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC76L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RPGACC76L;
#define		RPGACC76L		(*(volatile union RPGACC76L_T *) 0x0F0618)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union TMDF01L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} TMDF01L;
#define		TMDF01L		(*(volatile union TMDF01L_T *) 0x0F0618)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC76H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RPGACC76H;
#define		RPGACC76H		(*(volatile union RPGACC76H_T *) 0x0F0619)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union TMDF01H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} TMDF01H;
#define		TMDF01H		(*(volatile union TMDF01H_T *) 0x0F0619)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC77_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} RPGACC77;
#define		RPGACC77		(*(volatile union RPGACC77_T *) 0x0F061A)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union TMDF11_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} TMDF11;
#define		TMDF11		(*(volatile union TMDF11_T *) 0x0F061A)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC77L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RPGACC77L;
#define		RPGACC77L		(*(volatile union RPGACC77L_T *) 0x0F061A)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union TMDF11L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} TMDF11L;
#define		TMDF11L		(*(volatile union TMDF11L_T *) 0x0F061A)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC77H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RPGACC77H;
#define		RPGACC77H		(*(volatile union RPGACC77H_T *) 0x0F061B)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union TMDF11H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} TMDF11H;
#define		TMDF11H		(*(volatile union TMDF11H_T *) 0x0F061B)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC78_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} RPGACC78;
#define		RPGACC78		(*(volatile union RPGACC78_T *) 0x0F061C)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union TMDF21_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} TMDF21;
#define		TMDF21		(*(volatile union TMDF21_T *) 0x0F061C)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC78L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RPGACC78L;
#define		RPGACC78L		(*(volatile union RPGACC78L_T *) 0x0F061C)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union TMDF21L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} TMDF21L;
#define		TMDF21L		(*(volatile union TMDF21L_T *) 0x0F061C)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC78H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RPGACC78H;
#define		RPGACC78H		(*(volatile union RPGACC78H_T *) 0x0F061D)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union TMDF21H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} TMDF21H;
#define		TMDF21H		(*(volatile union TMDF21H_T *) 0x0F061D)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC79_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} RPGACC79;
#define		RPGACC79		(*(volatile union RPGACC79_T *) 0x0F061E)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union TMDF31_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} TMDF31;
#define		TMDF31		(*(volatile union TMDF31_T *) 0x0F061E)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC79L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RPGACC79L;
#define		RPGACC79L		(*(volatile union RPGACC79L_T *) 0x0F061E)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union TMDF31L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} TMDF31L;
#define		TMDF31L		(*(volatile union TMDF31L_T *) 0x0F061E)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC79H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RPGACC79H;
#define		RPGACC79H		(*(volatile union RPGACC79H_T *) 0x0F061F)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union TMDF31H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} TMDF31H;
#define		TMDF31H		(*(volatile union TMDF31H_T *) 0x0F061F)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC80_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} RPGACC80;
#define		RPGACC80		(*(volatile union RPGACC80_T *) 0x0F0620)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union TMIDL2_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} TMIDL2;
#define		TMIDL2		(*(volatile union TMIDL2_T *) 0x0F0620)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC80L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RPGACC80L;
#define		RPGACC80L		(*(volatile union RPGACC80L_T *) 0x0F0620)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union TMIDL2L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} TMIDL2L;
#define		TMIDL2L		(*(volatile union TMIDL2L_T *) 0x0F0620)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC80H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RPGACC80H;
#define		RPGACC80H		(*(volatile union RPGACC80H_T *) 0x0F0621)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union TMIDL2H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} TMIDL2H;
#define		TMIDL2H		(*(volatile union TMIDL2H_T *) 0x0F0621)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC81_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} RPGACC81;
#define		RPGACC81		(*(volatile union RPGACC81_T *) 0x0F0622)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union TMIDH2_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} TMIDH2;
#define		TMIDH2		(*(volatile union TMIDH2_T *) 0x0F0622)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC81L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RPGACC81L;
#define		RPGACC81L		(*(volatile union RPGACC81L_T *) 0x0F0622)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union TMIDH2L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} TMIDH2L;
#define		TMIDH2L		(*(volatile union TMIDH2L_T *) 0x0F0622)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC81H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RPGACC81H;
#define		RPGACC81H		(*(volatile union RPGACC81H_T *) 0x0F0623)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union TMIDH2H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} TMIDH2H;
#define		TMIDH2H		(*(volatile union TMIDH2H_T *) 0x0F0623)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC82_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} RPGACC82;
#define		RPGACC82		(*(volatile union RPGACC82_T *) 0x0F0624)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC82L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RPGACC82L;
#define		RPGACC82L		(*(volatile union RPGACC82L_T *) 0x0F0624)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC82H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RPGACC82H;
#define		RPGACC82H		(*(volatile union RPGACC82H_T *) 0x0F0625)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC83_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} RPGACC83;
#define		RPGACC83		(*(volatile union RPGACC83_T *) 0x0F0626)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union TMPTR2_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} TMPTR2;
#define		TMPTR2		(*(volatile union TMPTR2_T *) 0x0F0626)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC83L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RPGACC83L;
#define		RPGACC83L		(*(volatile union RPGACC83L_T *) 0x0F0626)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union TMPTR2L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} TMPTR2L;
#define		TMPTR2L		(*(volatile union TMPTR2L_T *) 0x0F0626)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC83H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RPGACC83H;
#define		RPGACC83H		(*(volatile union RPGACC83H_T *) 0x0F0627)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union TMPTR2H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} TMPTR2H;
#define		TMPTR2H		(*(volatile union TMPTR2H_T *) 0x0F0627)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC84_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} RPGACC84;
#define		RPGACC84		(*(volatile union RPGACC84_T *) 0x0F0628)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union TMDF02_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} TMDF02;
#define		TMDF02		(*(volatile union TMDF02_T *) 0x0F0628)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC84L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RPGACC84L;
#define		RPGACC84L		(*(volatile union RPGACC84L_T *) 0x0F0628)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union TMDF02L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} TMDF02L;
#define		TMDF02L		(*(volatile union TMDF02L_T *) 0x0F0628)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC84H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RPGACC84H;
#define		RPGACC84H		(*(volatile union RPGACC84H_T *) 0x0F0629)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union TMDF02H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} TMDF02H;
#define		TMDF02H		(*(volatile union TMDF02H_T *) 0x0F0629)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC85_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} RPGACC85;
#define		RPGACC85		(*(volatile union RPGACC85_T *) 0x0F062A)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union TMDF12_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} TMDF12;
#define		TMDF12		(*(volatile union TMDF12_T *) 0x0F062A)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC85L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RPGACC85L;
#define		RPGACC85L		(*(volatile union RPGACC85L_T *) 0x0F062A)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union TMDF12L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} TMDF12L;
#define		TMDF12L		(*(volatile union TMDF12L_T *) 0x0F062A)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC85H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RPGACC85H;
#define		RPGACC85H		(*(volatile union RPGACC85H_T *) 0x0F062B)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union TMDF12H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} TMDF12H;
#define		TMDF12H		(*(volatile union TMDF12H_T *) 0x0F062B)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC86_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} RPGACC86;
#define		RPGACC86		(*(volatile union RPGACC86_T *) 0x0F062C)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union TMDF22_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} TMDF22;
#define		TMDF22		(*(volatile union TMDF22_T *) 0x0F062C)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC86L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RPGACC86L;
#define		RPGACC86L		(*(volatile union RPGACC86L_T *) 0x0F062C)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union TMDF22L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} TMDF22L;
#define		TMDF22L		(*(volatile union TMDF22L_T *) 0x0F062C)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC86H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RPGACC86H;
#define		RPGACC86H		(*(volatile union RPGACC86H_T *) 0x0F062D)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union TMDF22H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} TMDF22H;
#define		TMDF22H		(*(volatile union TMDF22H_T *) 0x0F062D)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC87_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} RPGACC87;
#define		RPGACC87		(*(volatile union RPGACC87_T *) 0x0F062E)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union TMDF32_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} TMDF32;
#define		TMDF32		(*(volatile union TMDF32_T *) 0x0F062E)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC87L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RPGACC87L;
#define		RPGACC87L		(*(volatile union RPGACC87L_T *) 0x0F062E)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union TMDF32L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} TMDF32L;
#define		TMDF32L		(*(volatile union TMDF32L_T *) 0x0F062E)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC87H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RPGACC87H;
#define		RPGACC87H		(*(volatile union RPGACC87H_T *) 0x0F062F)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union TMDF32H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} TMDF32H;
#define		TMDF32H		(*(volatile union TMDF32H_T *) 0x0F062F)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC88_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} RPGACC88;
#define		RPGACC88		(*(volatile union RPGACC88_T *) 0x0F0630)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union TMIDL3_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} TMIDL3;
#define		TMIDL3		(*(volatile union TMIDL3_T *) 0x0F0630)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC88L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RPGACC88L;
#define		RPGACC88L		(*(volatile union RPGACC88L_T *) 0x0F0630)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union TMIDL3L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} TMIDL3L;
#define		TMIDL3L		(*(volatile union TMIDL3L_T *) 0x0F0630)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC88H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RPGACC88H;
#define		RPGACC88H		(*(volatile union RPGACC88H_T *) 0x0F0631)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union TMIDL3H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} TMIDL3H;
#define		TMIDL3H		(*(volatile union TMIDL3H_T *) 0x0F0631)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC89_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} RPGACC89;
#define		RPGACC89		(*(volatile union RPGACC89_T *) 0x0F0632)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union TMIDH3_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} TMIDH3;
#define		TMIDH3		(*(volatile union TMIDH3_T *) 0x0F0632)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC89L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RPGACC89L;
#define		RPGACC89L		(*(volatile union RPGACC89L_T *) 0x0F0632)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union TMIDH3L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} TMIDH3L;
#define		TMIDH3L		(*(volatile union TMIDH3L_T *) 0x0F0632)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC89H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RPGACC89H;
#define		RPGACC89H		(*(volatile union RPGACC89H_T *) 0x0F0633)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union TMIDH3H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} TMIDH3H;
#define		TMIDH3H		(*(volatile union TMIDH3H_T *) 0x0F0633)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC90_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} RPGACC90;
#define		RPGACC90		(*(volatile union RPGACC90_T *) 0x0F0634)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC90L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RPGACC90L;
#define		RPGACC90L		(*(volatile union RPGACC90L_T *) 0x0F0634)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC90H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RPGACC90H;
#define		RPGACC90H		(*(volatile union RPGACC90H_T *) 0x0F0635)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC91_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} RPGACC91;
#define		RPGACC91		(*(volatile union RPGACC91_T *) 0x0F0636)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union TMPTR3_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} TMPTR3;
#define		TMPTR3		(*(volatile union TMPTR3_T *) 0x0F0636)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC91L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RPGACC91L;
#define		RPGACC91L		(*(volatile union RPGACC91L_T *) 0x0F0636)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union TMPTR3L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} TMPTR3L;
#define		TMPTR3L		(*(volatile union TMPTR3L_T *) 0x0F0636)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC91H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RPGACC91H;
#define		RPGACC91H		(*(volatile union RPGACC91H_T *) 0x0F0637)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union TMPTR3H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} TMPTR3H;
#define		TMPTR3H		(*(volatile union TMPTR3H_T *) 0x0F0637)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC92_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} RPGACC92;
#define		RPGACC92		(*(volatile union RPGACC92_T *) 0x0F0638)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union TMDF03_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} TMDF03;
#define		TMDF03		(*(volatile union TMDF03_T *) 0x0F0638)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC92L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RPGACC92L;
#define		RPGACC92L		(*(volatile union RPGACC92L_T *) 0x0F0638)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union TMDF03L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} TMDF03L;
#define		TMDF03L		(*(volatile union TMDF03L_T *) 0x0F0638)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC92H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RPGACC92H;
#define		RPGACC92H		(*(volatile union RPGACC92H_T *) 0x0F0639)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union TMDF03H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} TMDF03H;
#define		TMDF03H		(*(volatile union TMDF03H_T *) 0x0F0639)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC93_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} RPGACC93;
#define		RPGACC93		(*(volatile union RPGACC93_T *) 0x0F063A)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union TMDF13_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} TMDF13;
#define		TMDF13		(*(volatile union TMDF13_T *) 0x0F063A)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC93L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RPGACC93L;
#define		RPGACC93L		(*(volatile union RPGACC93L_T *) 0x0F063A)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union TMDF13L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} TMDF13L;
#define		TMDF13L		(*(volatile union TMDF13L_T *) 0x0F063A)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC93H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RPGACC93H;
#define		RPGACC93H		(*(volatile union RPGACC93H_T *) 0x0F063B)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union TMDF13H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} TMDF13H;
#define		TMDF13H		(*(volatile union TMDF13H_T *) 0x0F063B)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC94_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} RPGACC94;
#define		RPGACC94		(*(volatile union RPGACC94_T *) 0x0F063C)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union TMDF23_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} TMDF23;
#define		TMDF23		(*(volatile union TMDF23_T *) 0x0F063C)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC94L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RPGACC94L;
#define		RPGACC94L		(*(volatile union RPGACC94L_T *) 0x0F063C)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union TMDF23L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} TMDF23L;
#define		TMDF23L		(*(volatile union TMDF23L_T *) 0x0F063C)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC94H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RPGACC94H;
#define		RPGACC94H		(*(volatile union RPGACC94H_T *) 0x0F063D)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union TMDF23H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} TMDF23H;
#define		TMDF23H		(*(volatile union TMDF23H_T *) 0x0F063D)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC95_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} RPGACC95;
#define		RPGACC95		(*(volatile union RPGACC95_T *) 0x0F063E)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union TMDF33_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} TMDF33;
#define		TMDF33		(*(volatile union TMDF33_T *) 0x0F063E)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC95L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RPGACC95L;
#define		RPGACC95L		(*(volatile union RPGACC95L_T *) 0x0F063E)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union TMDF33L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} TMDF33L;
#define		TMDF33L		(*(volatile union TMDF33L_T *) 0x0F063E)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC95H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RPGACC95H;
#define		RPGACC95H		(*(volatile union RPGACC95H_T *) 0x0F063F)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union TMDF33H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} TMDF33H;
#define		TMDF33H		(*(volatile union TMDF33H_T *) 0x0F063F)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC96_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} RPGACC96;
#define		RPGACC96		(*(volatile union RPGACC96_T *) 0x0F0640)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC96L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RPGACC96L;
#define		RPGACC96L		(*(volatile union RPGACC96L_T *) 0x0F0640)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC96H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RPGACC96H;
#define		RPGACC96H		(*(volatile union RPGACC96H_T *) 0x0F0641)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC97_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} RPGACC97;
#define		RPGACC97		(*(volatile union RPGACC97_T *) 0x0F0642)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC97L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RPGACC97L;
#define		RPGACC97L		(*(volatile union RPGACC97L_T *) 0x0F0642)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC97H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RPGACC97H;
#define		RPGACC97H		(*(volatile union RPGACC97H_T *) 0x0F0643)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC98_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} RPGACC98;
#define		RPGACC98		(*(volatile union RPGACC98_T *) 0x0F0644)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC98L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RPGACC98L;
#define		RPGACC98L		(*(volatile union RPGACC98L_T *) 0x0F0644)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC98H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RPGACC98H;
#define		RPGACC98H		(*(volatile union RPGACC98H_T *) 0x0F0645)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC99_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} RPGACC99;
#define		RPGACC99		(*(volatile union RPGACC99_T *) 0x0F0646)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC99L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RPGACC99L;
#define		RPGACC99L		(*(volatile union RPGACC99L_T *) 0x0F0646)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC99H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RPGACC99H;
#define		RPGACC99H		(*(volatile union RPGACC99H_T *) 0x0F0647)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC100_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} RPGACC100;
#define		RPGACC100		(*(volatile union RPGACC100_T *) 0x0F0648)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC100L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RPGACC100L;
#define		RPGACC100L		(*(volatile union RPGACC100L_T *) 0x0F0648)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC100H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RPGACC100H;
#define		RPGACC100H		(*(volatile union RPGACC100H_T *) 0x0F0649)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC101_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} RPGACC101;
#define		RPGACC101		(*(volatile union RPGACC101_T *) 0x0F064A)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC101L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RPGACC101L;
#define		RPGACC101L		(*(volatile union RPGACC101L_T *) 0x0F064A)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC101H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RPGACC101H;
#define		RPGACC101H		(*(volatile union RPGACC101H_T *) 0x0F064B)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC102_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} RPGACC102;
#define		RPGACC102		(*(volatile union RPGACC102_T *) 0x0F064C)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC102L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RPGACC102L;
#define		RPGACC102L		(*(volatile union RPGACC102L_T *) 0x0F064C)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC102H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RPGACC102H;
#define		RPGACC102H		(*(volatile union RPGACC102H_T *) 0x0F064D)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC103_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} RPGACC103;
#define		RPGACC103		(*(volatile union RPGACC103_T *) 0x0F064E)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC103L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RPGACC103L;
#define		RPGACC103L		(*(volatile union RPGACC103L_T *) 0x0F064E)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC103H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RPGACC103H;
#define		RPGACC103H		(*(volatile union RPGACC103H_T *) 0x0F064F)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC104_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} RPGACC104;
#define		RPGACC104		(*(volatile union RPGACC104_T *) 0x0F0650)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC104L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RPGACC104L;
#define		RPGACC104L		(*(volatile union RPGACC104L_T *) 0x0F0650)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC104H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RPGACC104H;
#define		RPGACC104H		(*(volatile union RPGACC104H_T *) 0x0F0651)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC105_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} RPGACC105;
#define		RPGACC105		(*(volatile union RPGACC105_T *) 0x0F0652)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC105L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RPGACC105L;
#define		RPGACC105L		(*(volatile union RPGACC105L_T *) 0x0F0652)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC105H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RPGACC105H;
#define		RPGACC105H		(*(volatile union RPGACC105H_T *) 0x0F0653)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC106_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} RPGACC106;
#define		RPGACC106		(*(volatile union RPGACC106_T *) 0x0F0654)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC106L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RPGACC106L;
#define		RPGACC106L		(*(volatile union RPGACC106L_T *) 0x0F0654)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC106H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RPGACC106H;
#define		RPGACC106H		(*(volatile union RPGACC106H_T *) 0x0F0655)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC107_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} RPGACC107;
#define		RPGACC107		(*(volatile union RPGACC107_T *) 0x0F0656)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC107L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RPGACC107L;
#define		RPGACC107L		(*(volatile union RPGACC107L_T *) 0x0F0656)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC107H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RPGACC107H;
#define		RPGACC107H		(*(volatile union RPGACC107H_T *) 0x0F0657)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC108_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} RPGACC108;
#define		RPGACC108		(*(volatile union RPGACC108_T *) 0x0F0658)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC108L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RPGACC108L;
#define		RPGACC108L		(*(volatile union RPGACC108L_T *) 0x0F0658)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC108H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RPGACC108H;
#define		RPGACC108H		(*(volatile union RPGACC108H_T *) 0x0F0659)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC109_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} RPGACC109;
#define		RPGACC109		(*(volatile union RPGACC109_T *) 0x0F065A)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC109L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RPGACC109L;
#define		RPGACC109L		(*(volatile union RPGACC109L_T *) 0x0F065A)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC109H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RPGACC109H;
#define		RPGACC109H		(*(volatile union RPGACC109H_T *) 0x0F065B)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC110_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} RPGACC110;
#define		RPGACC110		(*(volatile union RPGACC110_T *) 0x0F065C)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC110L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RPGACC110L;
#define		RPGACC110L		(*(volatile union RPGACC110L_T *) 0x0F065C)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC110H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RPGACC110H;
#define		RPGACC110H		(*(volatile union RPGACC110H_T *) 0x0F065D)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC111_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} RPGACC111;
#define		RPGACC111		(*(volatile union RPGACC111_T *) 0x0F065E)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC111L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RPGACC111L;
#define		RPGACC111L		(*(volatile union RPGACC111L_T *) 0x0F065E)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC111H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RPGACC111H;
#define		RPGACC111H		(*(volatile union RPGACC111H_T *) 0x0F065F)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC112_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} RPGACC112;
#define		RPGACC112		(*(volatile union RPGACC112_T *) 0x0F0660)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC112L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RPGACC112L;
#define		RPGACC112L		(*(volatile union RPGACC112L_T *) 0x0F0660)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC112H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RPGACC112H;
#define		RPGACC112H		(*(volatile union RPGACC112H_T *) 0x0F0661)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC113_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} RPGACC113;
#define		RPGACC113		(*(volatile union RPGACC113_T *) 0x0F0662)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC113L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RPGACC113L;
#define		RPGACC113L		(*(volatile union RPGACC113L_T *) 0x0F0662)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC113H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RPGACC113H;
#define		RPGACC113H		(*(volatile union RPGACC113H_T *) 0x0F0663)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC114_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} RPGACC114;
#define		RPGACC114		(*(volatile union RPGACC114_T *) 0x0F0664)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC114L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RPGACC114L;
#define		RPGACC114L		(*(volatile union RPGACC114L_T *) 0x0F0664)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC114H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RPGACC114H;
#define		RPGACC114H		(*(volatile union RPGACC114H_T *) 0x0F0665)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC115_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} RPGACC115;
#define		RPGACC115		(*(volatile union RPGACC115_T *) 0x0F0666)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC115L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RPGACC115L;
#define		RPGACC115L		(*(volatile union RPGACC115L_T *) 0x0F0666)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC115H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RPGACC115H;
#define		RPGACC115H		(*(volatile union RPGACC115H_T *) 0x0F0667)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC116_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} RPGACC116;
#define		RPGACC116		(*(volatile union RPGACC116_T *) 0x0F0668)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC116L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RPGACC116L;
#define		RPGACC116L		(*(volatile union RPGACC116L_T *) 0x0F0668)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC116H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RPGACC116H;
#define		RPGACC116H		(*(volatile union RPGACC116H_T *) 0x0F0669)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC117_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} RPGACC117;
#define		RPGACC117		(*(volatile union RPGACC117_T *) 0x0F066A)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC117L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RPGACC117L;
#define		RPGACC117L		(*(volatile union RPGACC117L_T *) 0x0F066A)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC117H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RPGACC117H;
#define		RPGACC117H		(*(volatile union RPGACC117H_T *) 0x0F066B)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC118_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} RPGACC118;
#define		RPGACC118		(*(volatile union RPGACC118_T *) 0x0F066C)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC118L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RPGACC118L;
#define		RPGACC118L		(*(volatile union RPGACC118L_T *) 0x0F066C)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC118H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RPGACC118H;
#define		RPGACC118H		(*(volatile union RPGACC118H_T *) 0x0F066D)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC119_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} RPGACC119;
#define		RPGACC119		(*(volatile union RPGACC119_T *) 0x0F066E)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC119L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RPGACC119L;
#define		RPGACC119L		(*(volatile union RPGACC119L_T *) 0x0F066E)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC119H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RPGACC119H;
#define		RPGACC119H		(*(volatile union RPGACC119H_T *) 0x0F066F)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC120_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} RPGACC120;
#define		RPGACC120		(*(volatile union RPGACC120_T *) 0x0F0670)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC120L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RPGACC120L;
#define		RPGACC120L		(*(volatile union RPGACC120L_T *) 0x0F0670)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC120H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RPGACC120H;
#define		RPGACC120H		(*(volatile union RPGACC120H_T *) 0x0F0671)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC121_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} RPGACC121;
#define		RPGACC121		(*(volatile union RPGACC121_T *) 0x0F0672)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC121L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RPGACC121L;
#define		RPGACC121L		(*(volatile union RPGACC121L_T *) 0x0F0672)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC121H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RPGACC121H;
#define		RPGACC121H		(*(volatile union RPGACC121H_T *) 0x0F0673)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC122_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} RPGACC122;
#define		RPGACC122		(*(volatile union RPGACC122_T *) 0x0F0674)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC122L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RPGACC122L;
#define		RPGACC122L		(*(volatile union RPGACC122L_T *) 0x0F0674)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC122H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RPGACC122H;
#define		RPGACC122H		(*(volatile union RPGACC122H_T *) 0x0F0675)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC123_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} RPGACC123;
#define		RPGACC123		(*(volatile union RPGACC123_T *) 0x0F0676)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC123L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RPGACC123L;
#define		RPGACC123L		(*(volatile union RPGACC123L_T *) 0x0F0676)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC123H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RPGACC123H;
#define		RPGACC123H		(*(volatile union RPGACC123H_T *) 0x0F0677)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC124_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} RPGACC124;
#define		RPGACC124		(*(volatile union RPGACC124_T *) 0x0F0678)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC124L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RPGACC124L;
#define		RPGACC124L		(*(volatile union RPGACC124L_T *) 0x0F0678)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC124H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RPGACC124H;
#define		RPGACC124H		(*(volatile union RPGACC124H_T *) 0x0F0679)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC125_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} RPGACC125;
#define		RPGACC125		(*(volatile union RPGACC125_T *) 0x0F067A)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC125L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RPGACC125L;
#define		RPGACC125L		(*(volatile union RPGACC125L_T *) 0x0F067A)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC125H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RPGACC125H;
#define		RPGACC125H		(*(volatile union RPGACC125H_T *) 0x0F067B)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC126_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} RPGACC126;
#define		RPGACC126		(*(volatile union RPGACC126_T *) 0x0F067C)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC126L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RPGACC126L;
#define		RPGACC126L		(*(volatile union RPGACC126L_T *) 0x0F067C)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC126H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RPGACC126H;
#define		RPGACC126H		(*(volatile union RPGACC126H_T *) 0x0F067D)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC127_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} RPGACC127;
#define		RPGACC127		(*(volatile union RPGACC127_T *) 0x0F067E)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC127L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RPGACC127L;
#define		RPGACC127L		(*(volatile union RPGACC127L_T *) 0x0F067E)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union RPGACC127H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} RPGACC127H;
#define		RPGACC127H		(*(volatile union RPGACC127H_T *) 0x0F067F)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union THLACC0_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} THLACC0;
#define		THLACC0		(*(volatile union THLACC0_T *) 0x0F0680)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union THLACC0L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} THLACC0L;
#define		THLACC0L		(*(volatile union THLACC0L_T *) 0x0F0680)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union THLACC0H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} THLACC0H;
#define		THLACC0H		(*(volatile union THLACC0H_T *) 0x0F0681)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union LWBR0_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} LWBR0;
#define		LWBR0		(*(volatile union LWBR0_T *) 0x0F06C1)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union LWBR1_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} LWBR1;
#define		LWBR1		(*(volatile union LWBR1_T *) 0x0F06C1)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union LBRP0_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} LBRP0;
#define		LBRP0		(*(volatile union LBRP0_T *) 0x0F06C2)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union LBRP1_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} LBRP1;
#define		LBRP1		(*(volatile union LBRP1_T *) 0x0F06C2)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union LBRP00_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} LBRP00;
#define		LBRP00		(*(volatile union LBRP00_T *) 0x0F06C2)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union LBRP10_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} LBRP10;
#define		LBRP10		(*(volatile union LBRP10_T *) 0x0F06C2)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union LBRP01_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} LBRP01;
#define		LBRP01		(*(volatile union LBRP01_T *) 0x0F06C3)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union LBRP11_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} LBRP11;
#define		LBRP11		(*(volatile union LBRP11_T *) 0x0F06C3)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union LSTC0_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} LSTC0;
#define		LSTC0		(*(volatile union LSTC0_T *) 0x0F06C4)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union LSTC1_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} LSTC1;
#define		LSTC1		(*(volatile union LSTC1_T *) 0x0F06C4)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union LUSC0_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} LUSC0;
#define		LUSC0		(*(volatile union LUSC0_T *) 0x0F06C5)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union LUSC1_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} LUSC1;
#define		LUSC1		(*(volatile union LUSC1_T *) 0x0F06C5)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union LMD0_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} LMD0;
#define		LMD0		(*(volatile union LMD0_T *) 0x0F06C8)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union LMD1_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} LMD1;
#define		LMD1		(*(volatile union LMD1_T *) 0x0F06C8)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union LBFC0_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} LBFC0;
#define		LBFC0		(*(volatile union LBFC0_T *) 0x0F06C9)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union LBFC1_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} LBFC1;
#define		LBFC1		(*(volatile union LBFC1_T *) 0x0F06C9)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union LSC0_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} LSC0;
#define		LSC0		(*(volatile union LSC0_T *) 0x0F06CA)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union LSC1_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} LSC1;
#define		LSC1		(*(volatile union LSC1_T *) 0x0F06CA)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union LWUP0_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} LWUP0;
#define		LWUP0		(*(volatile union LWUP0_T *) 0x0F06CB)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union LWUP1_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} LWUP1;
#define		LWUP1		(*(volatile union LWUP1_T *) 0x0F06CB)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union LIE0_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} LIE0;
#define		LIE0		(*(volatile union LIE0_T *) 0x0F06CC)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union LIE1_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} LIE1;
#define		LIE1		(*(volatile union LIE1_T *) 0x0F06CC)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union LEDE0_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} LEDE0;
#define		LEDE0		(*(volatile union LEDE0_T *) 0x0F06CD)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union LEDE1_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} LEDE1;
#define		LEDE1		(*(volatile union LEDE1_T *) 0x0F06CD)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union LCUC0_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} LCUC0;
#define		LCUC0		(*(volatile union LCUC0_T *) 0x0F06CE)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union LCUC1_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} LCUC1;
#define		LCUC1		(*(volatile union LCUC1_T *) 0x0F06CE)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union LTRC0_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} LTRC0;
#define		LTRC0		(*(volatile union LTRC0_T *) 0x0F06D0)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union LTRC1_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} LTRC1;
#define		LTRC1		(*(volatile union LTRC1_T *) 0x0F06D0)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union LMST0_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} LMST0;
#define		LMST0		(*(volatile union LMST0_T *) 0x0F06D1)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union LMST1_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} LMST1;
#define		LMST1		(*(volatile union LMST1_T *) 0x0F06D1)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union LST0_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} LST0;
#define		LST0		(*(volatile union LST0_T *) 0x0F06D2)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union LST1_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} LST1;
#define		LST1		(*(volatile union LST1_T *) 0x0F06D2)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union LEST0_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} LEST0;
#define		LEST0		(*(volatile union LEST0_T *) 0x0F06D3)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union LEST1_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} LEST1;
#define		LEST1		(*(volatile union LEST1_T *) 0x0F06D3)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union LDFC0_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} LDFC0;
#define		LDFC0		(*(volatile union LDFC0_T *) 0x0F06D4)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union LDFC1_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} LDFC1;
#define		LDFC1		(*(volatile union LDFC1_T *) 0x0F06D4)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union LIDB0_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} LIDB0;
#define		LIDB0		(*(volatile union LIDB0_T *) 0x0F06D5)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union LIDB1_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} LIDB1;
#define		LIDB1		(*(volatile union LIDB1_T *) 0x0F06D5)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union LCBR0_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} LCBR0;
#define		LCBR0		(*(volatile union LCBR0_T *) 0x0F06D6)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union LCBR1_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} LCBR1;
#define		LCBR1		(*(volatile union LCBR1_T *) 0x0F06D6)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union LUDB00_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} LUDB00;
#define		LUDB00		(*(volatile union LUDB00_T *) 0x0F06D7)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union LUDB10_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} LUDB10;
#define		LUDB10		(*(volatile union LUDB10_T *) 0x0F06D7)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union LDB01_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} LDB01;
#define		LDB01		(*(volatile union LDB01_T *) 0x0F06D8)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union LDB11_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} LDB11;
#define		LDB11		(*(volatile union LDB11_T *) 0x0F06D8)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union LDB02_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} LDB02;
#define		LDB02		(*(volatile union LDB02_T *) 0x0F06D9)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union LDB12_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} LDB12;
#define		LDB12		(*(volatile union LDB12_T *) 0x0F06D9)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union LDB03_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} LDB03;
#define		LDB03		(*(volatile union LDB03_T *) 0x0F06DA)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union LDB13_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} LDB13;
#define		LDB13		(*(volatile union LDB13_T *) 0x0F06DA)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union LDB04_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} LDB04;
#define		LDB04		(*(volatile union LDB04_T *) 0x0F06DB)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union LDB14_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} LDB14;
#define		LDB14		(*(volatile union LDB14_T *) 0x0F06DB)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union LDB05_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} LDB05;
#define		LDB05		(*(volatile union LDB05_T *) 0x0F06DC)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union LDB15_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} LDB15;
#define		LDB15		(*(volatile union LDB15_T *) 0x0F06DC)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union LDB06_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} LDB06;
#define		LDB06		(*(volatile union LDB06_T *) 0x0F06DD)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union LDB16_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} LDB16;
#define		LDB16		(*(volatile union LDB16_T *) 0x0F06DD)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union LDB07_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} LDB07;
#define		LDB07		(*(volatile union LDB07_T *) 0x0F06DE)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union LDB17_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} LDB17;
#define		LDB17		(*(volatile union LDB17_T *) 0x0F06DE)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union LDB08_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} LDB08;
#define		LDB08		(*(volatile union LDB08_T *) 0x0F06DF)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union LDB18_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} LDB18;
#define		LDB18		(*(volatile union LDB18_T *) 0x0F06DF)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union LUOER0_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} LUOER0;
#define		LUOER0		(*(volatile union LUOER0_T *) 0x0F06E0)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union LUOER1_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} LUOER1;
#define		LUOER1		(*(volatile union LUOER1_T *) 0x0F06E0)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union LUOR01_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} LUOR01;
#define		LUOR01		(*(volatile union LUOR01_T *) 0x0F06E1)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union LUOR11_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} LUOR11;
#define		LUOR11		(*(volatile union LUOR11_T *) 0x0F06E1)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union LUTDR0_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} LUTDR0;
#define		LUTDR0		(*(volatile union LUTDR0_T *) 0x0F06E4)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union LUTDR1_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} LUTDR1;
#define		LUTDR1		(*(volatile union LUTDR1_T *) 0x0F06E4)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union LUTDR0L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} LUTDR0L;
#define		LUTDR0L		(*(volatile union LUTDR0L_T *) 0x0F06E4)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union LUTDR1L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} LUTDR1L;
#define		LUTDR1L		(*(volatile union LUTDR1L_T *) 0x0F06E4)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union LUTDR0H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} LUTDR0H;
#define		LUTDR0H		(*(volatile union LUTDR0H_T *) 0x0F06E5)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union LUTDR1H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} LUTDR1H;
#define		LUTDR1H		(*(volatile union LUTDR1H_T *) 0x0F06E5)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union LURDR0_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} LURDR0;
#define		LURDR0		(*(volatile union LURDR0_T *) 0x0F06E6)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union LURDR1_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} LURDR1;
#define		LURDR1		(*(volatile union LURDR1_T *) 0x0F06E6)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union LURDR0L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} LURDR0L;
#define		LURDR0L		(*(volatile union LURDR0L_T *) 0x0F06E6)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union LURDR1L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} LURDR1L;
#define		LURDR1L		(*(volatile union LURDR1L_T *) 0x0F06E6)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union LURDR0H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} LURDR0H;
#define		LURDR0H		(*(volatile union LURDR0H_T *) 0x0F06E7)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union LURDR1H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} LURDR1H;
#define		LURDR1H		(*(volatile union LURDR1H_T *) 0x0F06E7)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union LUWTDR0_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} LUWTDR0;
#define		LUWTDR0		(*(volatile union LUWTDR0_T *) 0x0F06E8)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union LUWTDR1_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} LUWTDR1;
#define		LUWTDR1		(*(volatile union LUWTDR1_T *) 0x0F06E8)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union LUWTDR0L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} LUWTDR0L;
#define		LUWTDR0L		(*(volatile union LUWTDR0L_T *) 0x0F06E8)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union LUWTDR1L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} LUWTDR1L;
#define		LUWTDR1L		(*(volatile union LUWTDR1L_T *) 0x0F06E8)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union LUWTDR0H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} LUWTDR0H;
#define		LUWTDR0H		(*(volatile union LUWTDR0H_T *) 0x0F06E9)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union LUWTDR1H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} LUWTDR1H;
#define		LUWTDR1H		(*(volatile union LUWTDR1H_T *) 0x0F06E9)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union LURDE0_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} LURDE0;
#define		LURDE0		(*(volatile union LURDE0_T *) 0x0F06EA)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union LURDE1_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} LURDE1;
#define		LURDE1		(*(volatile union LURDE1_T *) 0x0F06EA)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union LURDE0L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} LURDE0L;
#define		LURDE0L		(*(volatile union LURDE0L_T *) 0x0F06EA)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union LURDE1L_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} LURDE1L;
#define		LURDE1L		(*(volatile union LURDE1L_T *) 0x0F06EA)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union LURDE0H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} LURDE0H;
#define		LURDE0H		(*(volatile union LURDE0H_T *) 0x0F06EB)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union LURDE1H_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} LURDE1H;
#define		LURDE1H		(*(volatile union LURDE1H_T *) 0x0F06EB)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union TRJ0_T
{
	io_word REG;
	struct
	{
		io_word B0:1;
		io_word B1:1;
		io_word B2:1;
		io_word B3:1;
		io_word B4:1;
		io_word B5:1;
		io_word B6:1;
		io_word B7:1;
		io_word B8:1;
		io_word B9:1;
		io_word B10:1;
		io_word B11:1;
		io_word B12:1;
		io_word B13:1;
		io_word B14:1;
		io_word B15:1;
	} BIT;
	struct
	{
		io_byte LOW;
		io_byte HIGH;
	} BYTE;
} TRJ0;
#define		TRJ0		(*(volatile union TRJ0_T *) 0x0F06F0)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union MONMOD1_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} MONMOD1;
#define		MONMOD1		(*(volatile union MONMOD1_T *) 0x0F0720)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union TRCMA_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} TRCMA;
#define		TRCMA		(*(volatile union TRCMA_T *) 0x0F0721)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union BRKMOD_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} BRKMOD;
#define		BRKMOD		(*(volatile union BRKMOD_T *) 0x0F0722)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union LDSTA_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} LDSTA;
#define		LDSTA		(*(volatile union LDSTA_T *) 0x0F0723)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union SECCHK_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} SECCHK;
#define		SECCHK		(*(volatile union SECCHK_T *) 0x0F0723)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union ELSELR00_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} ELSELR00;
#define		ELSELR00		(*(volatile union ELSELR00_T *) 0x0F0780)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union ELSELR01_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} ELSELR01;
#define		ELSELR01		(*(volatile union ELSELR01_T *) 0x0F0781)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union ELSELR02_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} ELSELR02;
#define		ELSELR02		(*(volatile union ELSELR02_T *) 0x0F0782)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union ELSELR03_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} ELSELR03;
#define		ELSELR03		(*(volatile union ELSELR03_T *) 0x0F0783)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union ELSELR04_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} ELSELR04;
#define		ELSELR04		(*(volatile union ELSELR04_T *) 0x0F0784)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union ELSELR05_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} ELSELR05;
#define		ELSELR05		(*(volatile union ELSELR05_T *) 0x0F0785)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union ELSELR06_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} ELSELR06;
#define		ELSELR06		(*(volatile union ELSELR06_T *) 0x0F0786)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union ELSELR07_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} ELSELR07;
#define		ELSELR07		(*(volatile union ELSELR07_T *) 0x0F0787)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union ELSELR08_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} ELSELR08;
#define		ELSELR08		(*(volatile union ELSELR08_T *) 0x0F0788)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union ELSELR09_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} ELSELR09;
#define		ELSELR09		(*(volatile union ELSELR09_T *) 0x0F0789)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union ELSELR10_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} ELSELR10;
#define		ELSELR10		(*(volatile union ELSELR10_T *) 0x0F078A)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union ELSELR11_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} ELSELR11;
#define		ELSELR11		(*(volatile union ELSELR11_T *) 0x0F078B)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union ELSELR12_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} ELSELR12;
#define		ELSELR12		(*(volatile union ELSELR12_T *) 0x0F078C)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union ELSELR13_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} ELSELR13;
#define		ELSELR13		(*(volatile union ELSELR13_T *) 0x0F078D)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union ELSELR14_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} ELSELR14;
#define		ELSELR14		(*(volatile union ELSELR14_T *) 0x0F078E)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union ELSELR15_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} ELSELR15;
#define		ELSELR15		(*(volatile union ELSELR15_T *) 0x0F078F)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union ELSELR16_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} ELSELR16;
#define		ELSELR16		(*(volatile union ELSELR16_T *) 0x0F0790)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union ELSELR17_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} ELSELR17;
#define		ELSELR17		(*(volatile union ELSELR17_T *) 0x0F0791)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union ELSELR18_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} ELSELR18;
#define		ELSELR18		(*(volatile union ELSELR18_T *) 0x0F0792)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union ELSELR19_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} ELSELR19;
#define		ELSELR19		(*(volatile union ELSELR19_T *) 0x0F0793)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union ELSELR20_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} ELSELR20;
#define		ELSELR20		(*(volatile union ELSELR20_T *) 0x0F0794)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union ELSELR21_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} ELSELR21;
#define		ELSELR21		(*(volatile union ELSELR21_T *) 0x0F0795)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union ELSELR22_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} ELSELR22;
#define		ELSELR22		(*(volatile union ELSELR22_T *) 0x0F0796)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union ELSELR23_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} ELSELR23;
#define		ELSELR23		(*(volatile union ELSELR23_T *) 0x0F0797)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union ELSELR24_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} ELSELR24;
#define		ELSELR24		(*(volatile union ELSELR24_T *) 0x0F0798)
/*------------------------------------------------------------------------------------
  unknown 
------------------------------------------------------------------------------------*/
typedef union ELSELR25_T
{
	io_byte REG;
	struct
	{
		io_byte B0:1;
		io_byte B1:1;
		io_byte B2:1;
		io_byte B3:1;
		io_byte B4:1;
		io_byte B5:1;
		io_byte B6:1;
		io_byte B7:1;
	} BIT;
} ELSELR25;
#define		ELSELR25		(*(volatile union ELSELR25_T *) 0x0F0799)


/*------------------------------------------------------------------------------------
  definitiond for unilib
------------------------------------------------------------------------------------*/
#define P0_PIO 0xFF00
#define P0_DIR 0xFF20
#define P0_PEN 0x0030
#define P1_PIO 0xFF01
#define P1_DIR 0xFF21
#define P1_PEN 0x0031
#define P2_PIO 0xFFFF
#define P2_DIR 0xFFFF
#define P2_PEN 0xFFFF
#define P3_PIO 0xFF03
#define P3_DIR 0xFF23
#define P3_PEN 0x0033
#define P4_PIO 0xFF04
#define P4_DIR 0xFF24
#define P4_PEN 0x0034
#define P5_PIO 0xFFFF
#define P5_DIR 0xFFFF
#define P5_PEN 0xFFFF
#define P6_PIO 0xFF06
#define P6_DIR 0xFF26
#define P6_PEN 0x0036
#define P7_PIO 0xFF07
#define P7_DIR 0xFF27
#define P7_PEN 0x0037
#define P8_PIO 0xFF08
#define P8_DIR 0xFF28
#define P8_PEN 0xFFFF
#define P9_PIO 0xFF09
#define P9_DIR 0xFF29
#define P9_PEN 0xFFFF
#define P10_PIO 0xFFFF
#define P10_DIR 0xFFFF
#define P10_PEN 0xFFFF
#define P11_PIO 0xFFFF
#define P11_DIR 0xFFFF
#define P11_PEN 0xFFFF
#define P12_PIO 0xFF0C
#define P12_DIR 0xFF2C
#define P12_PEN 0x003C
#define P13_PIO 0xFF0D
#define P13_DIR 0xFFFF
#define P13_PEN 0xFFFF
#define P14_PIO 0xFF0E
#define P14_DIR 0xFF2E
#define P14_PEN 0x003E
#define P15_PIO 0xFFFF
#define P15_DIR 0xFFFF
#define P15_PEN 0xFFFF
#define PORT_0 0
#define PORT_1 1
#define PORT_3 3
#define PORT_4 4
#define PORT_6 6
#define PORT_7 7
#define PORT_8 8
#define PORT_9 9
#define PORT_12 12
#define PORT_13 13
#define PORT_14 14
#define UART0 1
#define UART0_PORT PORT_1
#define UART0_RXD_PIN 6
#define UART0_TXD_PIN 5
#define UART1 1
#define UART1_PORT PORT_1
#define UART1_RXD_PIN 1
#define UART1_TXD_PIN 2
#define I2C0 1
#define I2C0_PORT PORT_1
#define I2C0_SCL_PIN 7
#define I2C0_SDA_PIN 6
#define SPI0 1
#define SPI0_SCK_PORT PORT_1
#define SPI0_SCK_PIN 7
#define SPI0_SI_PORT PORT_1
#define SPI0_SI_PIN 6
#define SPI0_SO_PORT PORT_1
#define SPI0_SO_PIN 5
#define SPI0_SS_PORT PORT_3
#define SPI0_SS_PIN 0
#define SPI1 1
#define SPI1_SCK_PORT PORT_1
#define SPI1_SCK_PIN 0
#define SPI1_SI_PORT PORT_1
#define SPI1_SI_PIN 1
#define SPI1_SO_PORT PORT_1
#define SPI1_SO_PIN 2
#define ADC 1
#define ADC_CH0_PORT PORT_3
#define ADC_CH1_PORT PORT_3
#define ADC_CH2_PORT PORT_8
#define ADC_CH3_PORT PORT_8
#define ADC_CH4_PORT PORT_8
#define ADC_CH5_PORT PORT_8
#define ADC_CH6_PORT PORT_8
#define ADC_CH7_PORT PORT_8
#define ADC_CH0_PIN 3
#define ADC_CH1_PIN 4
#define ADC_CH2_PIN 0
#define ADC_CH3_PIN 1
#define ADC_CH4_PIN 2
#define ADC_CH5_PIN 3
#define ADC_CH6_PIN 4
#define ADC_CH7_PIN 5
#define UNILIB_PAUSE_MS 111
#define CLOCKSYS 1
#define RAMSIZE 0x5000

#endif /* _IOHEADER **/
